<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla controllerform library
jimport('joomla.application.component.controllerform');

class bagridControllerbagrid extends JControllerForm
{
    public function getModel($name = '', $prefix = '', $config = array('ignore_request' => true))
	{
		return parent::getModel($name, $prefix, array('ignore_request' => false));
	}
    
    public function save($key = null, $urlVar = null)
    {
        $data = $this->input->post->get('jform', array(), 'array');
        $model = $this->getModel();
        $table = $model->getTable();
        $url = $table->getKeyName();
        parent::save($key = $data['id'], $urlVar = $url);
    }
    
    public function edit($key = null, $urlVar = null )
    {
        if (!JFactory::getUser()->authorise('core.edit', 'com_bagrid')) {
            $this->setRedirect('index.php?option=com_bagrid', JText::_('JERROR_ALERTNOAUTHOR'), 'error');
            return false;
        }
        $cid = $this->input->post->get('cid', array(), 'array');
        if (empty($cid)) {
            $cid[0] = $this->input->get('id');
        }
        $url = JUri::root(). 'index.php?option=com_bagrid&view=editor&tmpl=component&id=' .$cid[0];
        $this->setRedirect($url);
    }
    
    public function updateTags()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('*')
            ->from('#__bagrid_tags');
        $db->setQuery($query);
        $tags = $db->loadObjectList();
        $tags = json_encode($tags);
        echo new JResponseJson(true, $tags);
        exit;
    }

    public function getPageTags()
    {
        $db = JFactory::getDbo();
        $id = $_POST['page_id'];
        $query = $db->getQuery(true);
        $query->select('tag_id')
            ->from('#__bagrid_tags_map')
            ->where('`page_id` = '.$id);
        $db->setQuery($query);
        $ids = $db->loadObjectList();
        $tags = array();
        foreach ($ids as $id) {
            $query = $db->getQuery(true);
            $query->select('*')
                ->from('#__bagrid_tags')
                ->where('`id` = '.$id->tag_id);
            $db->setQuery($query);
            $tags[] = $db->loadObject();
        }
        $tags = json_encode($tags);
        echo new JResponseJson(true, $tags);
        exit;
    }

    public function updateParams()
    {
        $input = JFactory::getApplication()->input;
        $model = $this->getModel();
        $table = $model->getTable();
        $id = $input->get('ba_id');
        if (isset($_POST['meta_tags'])) {
            $tags = $_POST['meta_tags'];
        } else {
            $tags = array();
        }
        $theme = $input->get('theme_list');
        $title = $_POST['page_title'];
        $metaTitle = $_POST['page_meta_title'];
        $alias = $_POST['page_alias'];
        $alt = $_POST['image_alt'];
        $text = $_POST['intro_text'];
        $desc = $_POST['page_meta_description'];
        $keyWords = $_POST['page_meta_keywords'];
        $category = $_POST['page_category'];
        $access = $_POST['access'];
        $date = $_POST['published_on'];
        $img = $_POST['intro_image'];
        $language = $_POST['language'];
        $table->load($id);
        $table->bind(array(
            'title' =>$title, 'meta_title' => $metaTitle, 'created' => $date,
            'meta_description' => $desc, 'meta_keywords' =>$keyWords,
            'theme' => $theme, 'page_alias' => $alias, 'page_access' => $access,
            'image_alt' => $alt, 'intro_text' => $text, 'page_category' => $category,
            'intro_image' => $img, 'language' => $language
            ));
        if (!$table->check()) {
            $this->setRedirect('index.php?option=com_bagrid', JText::_('ANOTHER_ALIAS'), 'error');
            return false;
        }
        $table->store();
        $bagridTags = $model->getTable('Tags', 'BagridTable');
        $map = $model->getTable('TagsMap', 'BagridTable');
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id, tag_id')
            ->from('#__bagrid_tags_map')
            ->where('`page_id` = '. $id);
        $db->setQuery($query);
        $items = $db->loadObjectList();
        foreach ($items as $item) {
            if (!in_array($item->tag_id, $tags)) {
                $map->delete($item->id);
            }
        }
        foreach ($tags as $tag) {
            if (!empty($tag)) {
                if (strpos($tag, 'new$') !== false) {
                    $tag = substr($tag, 4);
                    $bagridTags->reset();
                    $bagridTags->bind(array('id' => 0, 'title' => $tag));
                    $bagridTags->store();
                    $tag = $bagridTags->id;
                    $map->reset();
                    $map->bind(array('id' => 0, 'page_id' => $id, 'tag_id' => $tag));
                    $map->store();
                } else {
                    $query = $db->getQuery(true);
                    $query->select('id')
                        ->from('#__bagrid_tags_map')
                        ->where('`page_id` = '.$id)
                        ->where('`tag_id` = '.$tag);
                    $db->setQuery($query);
                    $item = $db->loadResult();
                    if (empty($item)) {
                        $map->reset();
                        $map->bind(array('id' => 0, 'page_id' => $id, 'tag_id' => $tag));
                        $map->store();
                    }
                }
            }
        }
        $this->setRedirect('index.php?option=com_bagrid', JText::_('JLIB_APPLICATION_SAVE_SUCCESS'));
    }
}