<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

jimport('joomla.application.component.controlleradmin');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class bagridControllerBagrids extends JControllerAdmin
{
    public function getModel($name = 'bagrid', $prefix = 'bagridModel', $config = array()) 
    {
        $model = parent::getModel($name, $prefix, array('ignore_request' => true));
        return $model;
    }
    
    public function duplicate()
    {
        $pks = $this->input->getVar('cid', array(), 'post', 'array');
        $model = $this->getModel();
        $model->duplicate($pks);
        $this->setMessage(JText::plural('BAGRID_DUPLICATED', count($pks)));
        $this->setRedirect('index.php?option=com_bagrid&view=bagrids');
    }
    
    public function updateGrid()
    {
        $target = 'http://www.balbooa.com/updates/bagrid/pkg_Gridbox.zip';
        $config = JFactory::getConfig();
        $path = $config->get('tmp_path') . '/pkg_Gridbox.zip';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $target);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSLVERSION, 3);
        $data = curl_exec($ch);
        curl_close($ch);
        $file = fopen($path, "w+");
        fputs($file, $data);
        fclose($file);
        JArchive::extract($path, $config->get('tmp_path') . '/pkg_Gridbox');
        $installer = JInstaller::getInstance();
        $result = $installer->update($config->get('tmp_path') . '/pkg_Gridbox');
        JFile::delete($path);
        JFolder::delete( $config->get('tmp_path') . '/pkg_Gridbox' );
        $verion = bagridHelper::aboutUs();
        if ($result) {
            echo new JResponseJson($result, $verion->version);
        } else {
            echo new JResponseJson($result, '', true);
        }
        jexit();
    }
    
    public function exportXML()
    {
        $db = JFactory::getDbo();
        $export = $_POST['export_id'];
        $export = explode(';', $export);
        $menu_export = $_POST['export_menu'];
        $themes = array();
        $model = $this->getModel();
        $table = $model->getTable();
        $doc = new DOMDocument('1.0');
        $doc->formatOutput = true;
        $root = $doc->createElement('gridbox');
        $root = $doc->appendChild($root);
        $pages = $doc->createElement('pages');
        $pages = $root->appendChild($pages);
        $themeElement = $doc->createElement('themes');
        $themeElement = $root->appendChild($themeElement);
        $libElement = $doc->createElement('libraries');
        $libElement = $root->appendChild($libElement);
        $menuElement = $doc->createElement('mainmenu');
        $menuElement = $root->appendChild($menuElement);
        $com_baforms = $doc->createElement('com_baforms');
        $com_baforms = $root->appendChild($com_baforms);
        $params = array();
        $library = array();
        $main_menu = array();
        $forms = array();
        foreach ($export as $id) {
            $table->load($id);
            if (!in_array($table->theme, $themes)) {
                $query = $db->getQuery(true);
                $query->select('params, title')
                    ->from('`#__template_styles`')
                    ->where('`id` = ' .$db->Quote($table->theme));
                $db->setQuery($query);
                $params[$table->theme] = $db->loadObject();
                $themes[] = $table->theme;
            }
            $table->params = str_replace(JUri::root(), '', $table->params);
            $library = bagridHelper::getGlobal($table->params, $library);
            $forms = bagridHelper::getBaforms($table->params, $forms);
            $page = $doc->createElement('page');
            $page = $pages->appendChild($page);
            $title = $doc->createElement('id');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->id);
            $data = $title->appendChild($data);
            $title = $doc->createElement('title');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->title);
            $data = $title->appendChild($data);
            $title = $doc->createElement('page_alias');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->page_alias);
            $data = $title->appendChild($data);
            $title = $doc->createElement('theme');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->theme);
            $data = $title->appendChild($data);
            $title = $doc->createElement('meta_title');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->meta_title);
            $data = $title->appendChild($data);
            $title = $doc->createElement('meta_description');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->meta_description);
            $data = $title->appendChild($data);
            $title = $doc->createElement('meta_keywords');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->meta_keywords);
            $data = $title->appendChild($data);
            $title = $doc->createElement('published');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->published);
            $data = $title->appendChild($data);
            $title = $doc->createElement('params');
            $title = $page->appendChild($title);
            $data = $doc->createTextNode($table->params);
            $data = $title->appendChild($data);
        }
        foreach ($params as $key => $param) {
            $param->params = str_replace(JUri::root(), '', $param->params);
            $library = bagridHelper::getGlobal($param->params, $library);
            if ($menu_export === 'export') {
                $main_menu = bagridHelper::getMainMenu($param->params, $main_menu);
            }
            $forms = bagridHelper::getBaforms($param->params, $forms);
            $theme = $doc->createElement('theme');
            $theme = $themeElement->appendChild($theme);
            $title = $doc->createElement('id');
            $title = $theme->appendChild($title);
            $data = $doc->createTextNode($key);
            $data = $title->appendChild($data);
            $title = $doc->createElement('title');
            $title = $theme->appendChild($title);
            $data = $doc->createTextNode($param->title);
            $data = $title->appendChild($data);
            $title = $doc->createElement('params');
            $title = $theme->appendChild($title);
            $data = $doc->createTextNode($param->params);
            $data = $title->appendChild($data);
        }
        foreach ($library as $key => $lib) {
            $lib->item = str_replace(JUri::root(), '', $lib->item);
            $theme = $doc->createElement('library');
            $theme = $libElement->appendChild($theme);
            $title = $doc->createElement('id');
            $title = $theme->appendChild($title);
            $data = $doc->createTextNode($key);
            $data = $title->appendChild($data);
            $title = $doc->createElement('item');
            $title = $theme->appendChild($title);
            $data = $doc->createTextNode($lib->item);
            $data = $title->appendChild($data);
            $title = $doc->createElement('title');
            $title = $theme->appendChild($title);
            $data = $doc->createTextNode($lib->title);
            $data = $title->appendChild($data);
            $title = $doc->createElement('type');
            $title = $theme->appendChild($title);
            $data = $doc->createTextNode($lib->type);
            $data = $title->appendChild($data);
        }
        if ($menu_export === 'export') {
            foreach ($main_menu as $value) {
                $theme = $doc->createElement('main_menu');
                $theme = $menuElement->appendChild($theme);
                foreach ($value as $key => $menu) {
                    $menu = json_encode($menu);
                    $title = $doc->createElement($key);
                    $title = $theme->appendChild($title);
                    $data = $doc->createTextNode($menu);
                    $data = $title->appendChild($data);
                }
            }
        }
        foreach ($forms as $value) {
            $theme = $doc->createElement('baform');
            $theme = $com_baforms->appendChild($theme);
            foreach ($value as $key => $form) {
                $form = json_encode($form);
                $title = $doc->createElement($key);
                $title = $theme->appendChild($title);
                $data = $doc->createTextNode($form);
                $data = $title->appendChild($data);
            }
        }
        $file =  '/tmp/gridbox.xml';
        $bytes = $doc->save(JPATH_ROOT.$file); 
        if ($bytes) {
            echo new JResponseJson(true, JPATH_ROOT.$file);
        } else {
            echo new JResponseJson(false, '', true);
        }
        jexit();
    }
    
    public function doanload()
    {
        $file = $_GET['file'];
        if (file_exists($file)) {
            header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename='.basename($file));
            header('Expires: 0');
            header('Cache-Control: must-revalidate');
            header('Pragma: public');
            header('Content-Length: ' . filesize($file));
            readfile($file);
            exit;
        }
    }    
}