<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

jimport('joomla.application.component.controlleradmin');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class bagridControllerThemes extends JControllerAdmin
{
    public function getModel($name = 'theme', $prefix = 'bagridModel', $config = array()) 
    {
        $model = parent::getModel($name, $prefix, array('ignore_request' => true));
        return $model;
    }
    
    public function delete()
    {
        $cid = JFactory::getApplication()->input->get('cid', array(), 'array');
        $model = $this->getModel();
        $flag = true;
        foreach ($cid as $id) {
            $table = $model->getTable();
            $table->load($id);
            if ($table->home * 1 == 1) {
                $flag = false;
            }
        }
        if ($flag) {
            parent::delete();
        } else {
            $redirect = 'index.php?option=com_bagrid&view=themes';
            $this->setRedirect($redirect, JText::_('CANT_DELETE_DEFAULT_THEME'), 'error');
        }
    }
    
    public function duplicate()
    {
        $pks = $this->input->getVar('cid', array(), 'post', 'array');
        $model = $this->getModel();
        $model->duplicate($pks);
        $this->setMessage(JText::plural('BAGRID_DUPLICATED', count($pks)));
        $this->setRedirect('index.php?option=com_bagrid&view=bagrids&view=themes');
    }

    public function addNewTheme($xml, $flag)
    {
        $model = $this->getModel();
        $themes = array();
        $libraries = array();
        $libPlug = array();
        $main_menu = array();
        $modules_menu = array();
        $deeper = array();
        $pages = array();
        $plugins = array();
        $forms = array();
        $baforms_items = array();
        $db = JFactory::getDbo();
        $query = 'SHOW TABLES LIKE '.$db->quote('%baforms_forms');
        $db->setQuery($query);
        $result = $db->loadResult();
        if (!empty($result)) {
            foreach ($xml->com_baforms->baform as $key => $baform) {
                $form = json_decode($baform->forms);
                if (empty($form)) {
                   continue;
                }
                $items = json_decode($baform->items);
                $columns = json_decode($baform->columns);
                $fId = $form->id;
                $form->id = 0;
                $db->insertObject('#__baforms_forms', $form);
                $forms[$fId] = $db->insertid();
                foreach ($items as $item) {
                    $iId = $item->id;
                    $item->id = 0;
                    $item->form_id = $forms[$fId];
                    $db->insertObject('#__baforms_items', $item);
                    $baforms_items[$iId] = $db->insertid();
                }
                foreach ($columns as $column) {
                    $column->id = 0;
                    $column->form_id = $forms[$fId];
                    $db->insertObject('#__baforms_columns', $column);
                }
                $query = $db->getQuery(true)
                    ->select('email_letter, reply_body')
                    ->from('#__baforms_forms')
                    ->where('`id` = '.$fId);
                $db->setQuery($query);
                $letter = $db->loadObject();
                $regex = '/\[item=+(.*?)\]/i';
                preg_match_all($regex, $letter->email_letter, $matches, PREG_SET_ORDER);
                foreach ($matches as $match) {
                    $iId = $match[1];
                    $letter->email_letter = str_replace('[item='.$iId.']', '[item='.$baforms_items[$iId].']', $letter->email_letter);
                }
                $regex = '/\[field ID=+(.*?)\]/i';
                preg_match_all($regex, $letter->reply_body, $matches, PREG_SET_ORDER);
                foreach ($matches as $match) {
                    $iId = $match[1];
                    $letter->reply_body = str_replace('[field ID='.$iId.']', '[field ID='.$baforms_items[$iId].']', $letter->reply_body);
                }
                $form->id = $forms[$fId];
                $form->email_letter = $letter->email_letter;
                $form->reply_body = $letter->reply_body;
                $db->updateObject('#__baforms_forms', $form, 'id');
            }
        }
        foreach ($xml->mainmenu->main_menu as $mainmenu) {
            $module = json_decode($mainmenu->module);
            $module_menu = json_decode($mainmenu->module_menu);
            $asset = json_decode($mainmenu->asset);
            $menu = json_decode($mainmenu->menu);
            $menu->menutype = $this->getNewMenuType($menu->menutype, '');
            $menu->id = 0;
            $menu_items = json_decode($mainmenu->menu_items);
            $modules_menu[$module->id] = '';
            $query = $db->getQuery(true);
            $query->select("extension_id");
            $query->from("#__extensions");
            $query->where("type=" .$db->quote('component'))
                ->where('element=' .$db->quote('com_bagrid'));
            $db->setQuery($query);
            $com_id = $db->loadResult();
            $query = $db->getQuery(true);
            $query->select('id')
                ->from('#__assets')
                ->where('`name` = ' .$db->quote('com_modules'));
            $db->setQuery($query);
            $asset->parent_id = $db->loadResult();
            $old_id = $module->id;
            $module->id = 0;
            $module->params = json_decode($module->params);
            $module->params->menutype = $menu->menutype;
            $module->params = json_encode($module->params);
            $db->insertObject('#__modules', $module);
            $mod_id = $db->insertid();
            $modules_menu[$old_id] = $mod_id;
            $module_menu->moduleid = $mod_id;
            $query = $db->getQuery(true);
            $query->select('COUNT(moduleid)')
                ->where('`moduleid` = '.$mod_id)
                ->from('`#__modules_menu`');
            $db->setQuery($query);
            $c = $db->loadResult();
            if (empty($c)) {
                $db->insertObject('#__modules_menu', $module_menu);
            }
            $asset->id = 0;
            $asset->name = 'com_modules.module.'. $mod_id;
            $db->insertObject('#__assets', $asset);
            $obj = new stdClass();
            $obj->id = $mod_id;
            $obj->asset_id = $db->insertid();
            $db->updateObject('#__modules', $obj, 'id');
            $db->insertObject('#__menu_types', $menu);
            foreach ($menu_items as $item) {
                if ($item->published == 1 || $item->published == 0) {
                    $id = $item->id;
                    $item->id = 0;
                    $item->menutype = $menu->menutype;
                    $item->component_id = $com_id;
                    $item->template_style_id = 0;
                    $item->home = 0;
                    $menu_table = $model->getTable($type = 'Menu', $prefix = 'bagridTable', array());
                    $array = array('menutype' => $menu->menutype, 'title' => $item->title,
                                    'path' => $item->path, 'link' => $item->link, 'type' => $item->type,
                                    'level' => $item->level,
                                    'component_id' => $com_id, 'access' => $item->access,
                                    'template_style_id' => 0, 'language' => '*', 'params' => $item->params,
                                    'alias' => $this->getNewMenuAlias($item->alias, ''));
                    $menu_table->bind($array);
                    $menu_table->store();
                    $obj = new stdClass();
                    $obj->id = $menu_table->id;
                    $obj->level = $item->level;
                    $obj->published = $item->published;
                    $db->updateObject('#__menu', $obj, 'id');
                    $main_menu[$id] = $menu_table->id;
                    if ($item->parent_id > 1) {
                        $deeper[$menu_table->id] = $item->parent_id;
                        $obj = new stdClass();
                        $obj->id = $menu_table->id;
                        $obj->lft = $item->lft;
                        $obj->rgt = $item->rgt;
                        $db->updateObject('#__menu', $obj, 'id');
                    } else {
                        $obj = new stdClass();
                        $obj->id = $menu_table->id;
                        $obj->parent_id = 1;
                        $obj->lft = $item->lft;
                        $obj->rgt = $item->rgt;
                        $db->updateObject('#__menu', $obj, 'id');
                    }
                }                
            }
            foreach ($deeper as $key => $deep) {
                $obj = new stdClass();
                $obj->id = $key;
                $obj->parent_id = $main_menu[$deep];
                $db->updateObject('#__menu', $obj, 'id');
            }
        }
        foreach ($xml->libraries->library as $lib) {
            $table = $model->getTable('Library', 'bagridTable');
            $table->bind(array('item' => (string)$lib->item,
                               'title' => (string)$lib->title,
                               'type' => (string)$lib->type,
                               'global_item' => 'true'));
            $table->store();
            if ((string)$lib->type == 'section') {
                $params = str_replace('[section='.(string)$lib->id.']', '[section='.$table->id.']', (string)$lib->item);
                $libPlug[$table->id] = $params;
            } else {
                $params = str_replace('[plugin='.(string)$lib->id.']', '[plugin='.$table->id.']', (string)$lib->item);
                $libPlug[$table->id] = $params;
            }
            $id = $table->id;
            $table->reset();
            $table->load($id);
            $table->bind(array('item' => $params));
            $table->store();
            $libraries[(string)$lib->id] = $table->id;
        }
        foreach ($libPlug as $key => $lib) {
            $regex = '/\[plugin=+(.*?)\]/i';
            preg_match_all($regex, $lib, $matches, PREG_SET_ORDER);
            if ($matches) {
                foreach ($matches as $match) {
                    if (array_key_exists($match[1], $libraries)) {
                        $lib = str_replace('[plugin='.$match[1].']', '[plugin='.$libraries[$match[1]].']', $lib);
                        $table->reset();
                        $table->load($key);
                        $table->bind(array('item' => $lib));
                        $table->store();
                    }
                }
            }
            $regex = '/\[forms ID=+(.*?)\]/i';
            preg_match_all($regex, $lib, $matches, PREG_SET_ORDER);
            if ($matches) {
                foreach ($matches as $match) {
                    if (array_key_exists($match[1], $forms)) {
                        $lib = str_replace('[forms ID='.$match[1].']', '[forms ID='.$forms[$match[1]].']', $lib);
                        $lib = str_replace('data-form="'.$match[1].'"', 'data-form="'.$forms[$match[1]].'"', $lib);
                        $lib = str_replace('data-form=\"'.$match[1].'\"', 'data-form=\"'.$forms[$match[1]].'\"', $lib);
                        $table->reset();
                        $table->load($key);
                        $table->bind(array('item' => $lib));
                        $table->store();
                    }
                }
            }

        }
        foreach ($xml->themes->theme as $theme) {
            $table = $model->getTable();
            $params = (string)$theme->params;
            $regex = '/\[plugin=+(.*?)\]/i';
            preg_match_all($regex, $params, $matches, PREG_SET_ORDER);
            if ($matches) {
                foreach ($matches as $match) {
                    if (array_key_exists($match[1], $libraries)) {
                        $params = str_replace('[plugin='.$match[1].']', '[plugin='.$libraries[$match[1]].']', $params);
                    }
                }
            }
            $regex = '/\[section=+(.*?)\]/i';
            preg_match_all($regex, $params, $matches, PREG_SET_ORDER);
            if ($matches) {
                foreach ($matches as $match) {
                    if (array_key_exists($match[1], $libraries)) {
                        $params = str_replace('[section='.$match[1].']', '[section='.$libraries[$match[1]].']', $params);
                    }
                }
            }
            $regex = '/\[main_menu=+(.*?)\]/i';
            preg_match_all($regex, $params, $matches, PREG_SET_ORDER);
            if ($matches) {
                foreach ($matches as $index => $match) {
                    $params = str_replace('data-main-menu="'.$match[1].'"', 'data-main-menu="'.$modules_menu[$match[1]].'"', $params);
                    $params = str_replace('data-main-menu=\"'.$match[1].'\"', 'data-main-menu=\"'.$modules_menu[$match[1]].'\"', $params);
                    $params = str_replace("[main_menu=".$match[1]."]", "[main_menu=".$modules_menu[$match[1]]."]", $params);
                }
            }
            $params = $this->checkBaforms($params, $forms);
            $table->bind(array('title' => (string)$theme->title, 'params' => $params,
                               'home' => 0, 'client_id' => 0, 'template' => 'gridboxcore'));
            $table->store();
            $themes[(string)$theme->id] = $table->id;
            if ($flag) {
                $plugins = $this->checkPlugins($plugins, $table->params);
            }
        }
        foreach ($xml->pages->page as $page) {
            $table = JTable::getInstance('Bagrids', 'bagridTable');
            $params = (string)$page->params;
            $regex = '/\[plugin=+(.*?)\]/i';
            preg_match_all($regex, $params, $matches, PREG_SET_ORDER);
            if ($matches) {
                foreach ($matches as $match) {
                    if (array_key_exists($match[1], $libraries)) {
                        $params = str_replace('[plugin='.$match[1].']', '[plugin='.$libraries[$match[1]].']', $params);
                    }
                }
            }
            $regex = '/\[section=+(.*?)\]/i';
            preg_match_all($regex, $params, $matches, PREG_SET_ORDER);
            if ($matches) {
                foreach ($matches as $match) {
                    if (array_key_exists($match[1], $libraries)) {
                        $params = str_replace('[section='.$match[1].']', '[section='.$libraries[$match[1]].']', $params);
                    }
                }
            }
            $params = $this->checkBaforms($params, $forms);
            $page_alias = $this->getNewPageAlias((string)$page->page_alias, '');
            $table->bind(array('title' => (string)$page->title, 'meta_title' => (string)$page->meta_title,
                               'meta_description' => (string)$page->meta_description,
                               'meta_keywords' => (string)$page->meta_keywords, 'page_alias' => $page_alias,
                               'published' => (string)$page->published, 'params' => $params,
                               'theme' => $themes[(string)$page->theme]));
            $table->store();
            $pages[(string)$page->id] = $table->id;
            if ($flag) {
                $plugins = $this->checkPlugins($plugins, $table->params);
            }
        }
        foreach ($main_menu as $key => $value) {
            $menu_table->load($value);
            $link = $menu_table->link;
            $link = explode('id=', $link);
            $id = end($link);
            if (isset($pages[$id]) && !empty($link[0])) {
                $link = $link[0].'id='.$pages[$id];
            } else {
                $link = '';
            }
            $menu_table->bind(array('link' => $link));
            $menu_table->store();
        }
        $this->rebuild();
        if ($flag) {
            $this->updatePlugins($plugins);
        }
    }

    public function checkBaforms($body, $forms)
    {
        $regex = '/\[forms ID=+(.*?)\]/i';
        preg_match_all($regex, $body, $matches, PREG_SET_ORDER);
        if ($matches) {
            foreach ($matches as $match) {
                if (array_key_exists($match[1], $forms)) {
                    $body = str_replace('[forms ID='.$match[1].']', '[forms ID='.$forms[$match[1]].']', $body);
                    $body = str_replace('data-form="'.$match[1].'"', 'data-form="'.$forms[$match[1]].'"', $body);
                    $body = str_replace('data-form=\"'.$match[1].'\"', 'data-form=\"'.$forms[$match[1]].'\"', $body);
                }
            }
        }

        return $body;
    }

    public function rebuild()
    {
        // Initialiase variables.
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $model = $this->getModel();
        $table = $model->getTable($type = 'Menu', $prefix = 'bagridTable', array());

        try
        {
            $rebuildResult = $table->rebuild();
        }
        catch (Exception $e)
        {
            $this->setError($e->getMessage());

            return false;
        }

        if (!$rebuildResult)
        {
            $this->setError($table->getError());

            return false;
        }

        $query->select('id, params')
            ->from('#__menu')
            ->where('params NOT LIKE ' . $db->quote('{%'))
            ->where('params <> ' . $db->quote(''));
        $db->setQuery($query);

        try
        {
            $items = $db->loadObjectList();
        }
        catch (RuntimeException $e)
        {
            return JError::raiseWarning(500, $e->getMessage());
        }

        foreach ($items as &$item)
        {
            $registry = new Registry;
            $registry->loadString($item->params);
            $params = (string) $registry;

            $query->clear();
            $query->update('#__menu')
                ->set('params = ' . $db->quote($params))
                ->where('id = ' . $item->id);

            try
            {
                $db->setQuery($query)->execute();
            }
            catch (RuntimeException $e)
            {
                return JError::raiseWarning(500, $e->getMessage());
            }

            unset($registry);
        }
        $model->cleanCache();

        return true;
    }
    
    public function uploadTheme()
    {
        $input = JFactory::getApplication()->input;
        $items = $input->files->get('ba-files', '', 'array');
        $redirect = 'index.php?option=com_bagrid&view=themes';
        foreach($items as $item) {
            $ext = strtolower(JFile::getExt($item['name']));
            if ($ext == 'xml') {
                $name = JPATH_ROOT. '/tmp/' .$item['name'];
                if(!JFile::upload( $item['tmp_name'], $name)) {
                    $this->setRedirect($redirect, JText::_('UPLOAD_ERROR'), 'error');
                    return false;
                }
            } else  {
                $this->setRedirect($redirect, JText::_('UPLOAD_ERROR'), 'error');
                return false;
            }
        }
        $xml = simplexml_load_file($name);
        $this->addNewTheme($xml, false);
        $this->setRedirect($redirect, JText::_('SUCCESS_UPLOAD'));
        return true;
    }

    public function downloadTheme()
    {
        $name = $_POST['theme_url'];
        $curl = bagridHelper::getContentsCurl($name);
        $xml = simplexml_load_string($curl);
        $this->addNewTheme($xml, true);
        echo new JResponseJson(true, '');
        exit;
    }

    public function getNewMenuType($type, $orig)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('COUNT(id)')
            ->from('#__menu_types')
            ->where('`menutype` = '.$db->quote($type));
        $db->setQuery($query);
        $n = $db->loadResult();
        if (!empty($n)) {
            if (empty($orig)) {
                $type = JString::increment($type);
            } else {
                $type = JString::increment($orig);
            }
            $orig = $type;
            $type = JFilterOutput::stringURLSafe($type);
            $type = $this->getNewMenuType($type, $orig);
        }

        return $type;
    }

    public function getNewPageAlias($type, $orig)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('COUNT(id)')
            ->from('#__bagrid_bagrids')
            ->where('`page_alias` = '.$db->quote($type));
        $db->setQuery($query);
        $n = $db->loadResult();
        if (!empty($n)) {
            if (empty($orig)) {
                $type = JString::increment($type);
            } else {
                $type = JString::increment($orig);
            }
            $orig = $type;
            $type = JFilterOutput::stringURLSafe($type);
            $type = $this->getNewMenuAlias($type, $orig);
        }
        return $type;
    }

    public function getNewMenuAlias($type, $orig)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('COUNT(id)')
            ->from('#__menu')
            ->where('`alias` = '.$db->quote($type));
        $db->setQuery($query);
        $n = $db->loadResult();
        if (!empty($n)) {
            if (empty($orig)) {
                $type = JString::increment($type);
            } else {
                $type = JString::increment($orig);
            }
            $orig = $type;
            $type = JFilterOutput::stringURLSafe($type);
            $type = $this->getNewMenuAlias($type, $orig);
        }
        return $type;
    }
    
    protected function checkPlugins($array, $params)
    {
        if (strpos($params, 'ba-item-map')) {
            if (!in_array('ba-map', $array)) {
                $array[] = 'ba-map';
            }
        }
        if (strpos($params, 'ba-item-slider')) {
            if (!in_array('ba-slider', $array)) {
                $array[] = 'ba-slider';
            }
        }
        if (strpos($params, 'ba-item-tabs')) {
            if (!in_array('ba-tabs', $array)) {
                $array[] = 'ba-tabs';
            }
        }
        if (strpos($params, 'ba-item-accordion')) {
            if (!in_array('ba-accordion', $array)) {
                $array[] = 'ba-accordion';
            }
        }
        if (strpos($params, 'ba-item-countdown')) {
            if (!in_array('ba-countdown', $array)) {
                $array[] = 'ba-countdown';
            }
        }
        if (strpos($params, 'zmdi zmdi')) {
            if (!in_array('ba-icon', $array)) {
                $array[] = 'ba-icon';
            }
        }
        if (strpos($params, 'ba-item-ba-scroll-to-top')) {
            if (!in_array('ba-ba-scroll-to-top', $array)) {
                $array[] = 'ba-ba-scroll-to-top';
            }
        }
        if (strpos($params, 'ba-item-ba-scroll-to')) {
            if (!in_array('ba-ba-scroll-to', $array)) {
                $array[] = 'ba-ba-scroll-to';
            }
        }
        if (strpos($params, 'ba-item-counter')) {
            if (!in_array('ba-counter', $array)) {
                $array[] = 'ba-counter';
            }
        }
        if (strpos($params, 'ba-item-disqus')) {
            if (!in_array('ba-disqus', $array)) {
                $array[] = 'ba-disqus';
            }
        }
        if (strpos($params, 'ba-item-custom-html')) {
            if (!in_array('ba-custom-html', $array)) {
                $array[] = 'ba-custom-html';
            }
        }
        return $array;
    }
    
    private function updatePlugins($plugins)
    {
        if (count($plugins) > 0) {
            foreach ($plugins as $plugin) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote($plugin));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $url = 'http://www.balbooa.com/updates/bagrid/plugins/plugins.xml';
                    $curl = bagridHelper::getContentsCurl($url);
                    $xml = simplexml_load_string($curl);
                    foreach ($xml->plugins->plugin as $new) {
                        if (trim((string)$new->title) == $plugin) {
                            $query = $db->getQuery(true);
                            $columns = array(
                                'title', 
                                'image', 
                                'joomla_constant'
                            );
                            $values = array(
                                $db->Quote(trim((string)$new->title)), 
                                $db->Quote(trim((string)$new->image)), 
                                $db->Quote(trim((string)$new->joomla_constant))
                            );
                            $query->insert($db->quoteName('#__bagrid_plugins'))
                                ->columns($db->quoteName($columns))
                                ->values(implode(',', $values));
                            $db->setQuery($query)
                                ->execute();
                        }
                    }
                }
            }
        }
    }
    
}