<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla controllerform library
jimport('joomla.application.component.controllerform');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class bagridControllerUploader extends JControllerForm
{
    
    public function addFolder()
    {
        $location = $this->getDir();
        $dir = $location[0];
        $redirect = $location[1];
        $input = JFactory::getApplication()->input;
        $nfolder = $input->get('new-folder', '', 'string');
        if (JFolder::create($dir.'/'.$nfolder)) {
            $this->setRedirect($redirect, JText::_('FOLDER_IS_CREATED'));
            return true;
        } else {
            $this->setRedirect($redirect, JText::_('FOLDER_IS_NOT_CREATED'), 'error');
            return false;
        }
    }
    
    public function getDir()
    {
        $redirect = 'index.php?option=com_bagallery&view=uploader&tmpl=component';
        $dir = JPATH_ROOT. '/images';
        $input = JFactory::getApplication()->input;
        $folder = $input->get('current-dir', '', 'string');
        $layout = $input->get('layout', '', 'string');
        if (!empty($folder)) {
            $dir = $folder;
            $redirect .= '&folder=' .$dir;
        }
        if (!empty($layout)) {
            $redirect .= '&layout=' .$layout;
        }
        $array = array ($dir, $redirect);
        return $array;
        
    }
    
    public function delete()
    {
        $location = $this->getDir();
        $dir = $location[0];
        $redirect = $location[1];
        $input = JFactory::getApplication()->input;
        $items = $input->get('ba-rm', '', 'array');
        foreach ($items as $item) {
            if ($item != '') {
                if (JFolder::exists($dir. '/' .$item)) {
                    if(!JFolder::delete($dir. '/' .$item)) {
                        $this->setRedirect($redirect, JText::_('DELETE_FOLDER_ERROR'), 'error');
                        return false;
                    }
                }
                if (JFile::exists($dir. '/' .$item)) {
                    if(!JFile::delete($dir. '/' .$item)){
                        $this->setRedirect($redirect, JText::_('DELETE_FILE_ERROR'), 'error');
                        return false;
                    }
                }
            }
        }
        $this->setRedirect($redirect, JText::_('SUCCESS_DELETE'));
        return true;
    }
    
    public function upload()
    {
        $location = $this->getDir();
        $dir = $location[0];
        $redirect = $location[1];
        $model = $this->getModel();
        $input = JFactory::getApplication()->input;
        $items = $input->files->get('ba-files', '', 'array');
        foreach($items as $item) {
            $ext = strtolower(JFile::getExt($item['name']));
            $flag = $model->checkExt($ext);
            if ($flag) {
                $name = $dir. '/' .$item['name'];
                if(!JFile::upload( $item['tmp_name'], $name)) {
                    $this->setRedirect($redirect, JText::_('UPLOAD_ERROR'), 'error');
                    return false;
                }
            } else {
                $this->setRedirect($redirect, JText::_('INVALID_EXT'), 'error');
                return false;
            }
        }
        $this->setRedirect($redirect, JText::_('SUCCESS_UPLOAD'));
        return true;
    }
}