ALTER TABLE `#__template_styles` CHANGE `params` `params` MEDIUMTEXT;

DROP TABLE IF EXISTS `#__bagrid_bagrids`;
CREATE TABLE `#__bagrid_bagrids` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `title` varchar(255) NOT NULL,
    `theme` varchar(255) NOT NULL,
    `meta_title` varchar(255) NOT NULL,
    `meta_description` text NOT NULL,
    `meta_keywords` text NOT NULL,
    `published` tinyint(1) NOT NULL DEFAULT 1,
    `params` mediumtext NOT NULL,
    `intro_image` varchar(255) NOT NULL,
    `page_alias` varchar(255) NOT NULL,
    `page_category` varchar(255) NOT NULL,
    `page_access` int(11) NOT NULL DEFAULT 1,
    `image_alt` varchar(255) NOT NULL,
    `intro_text` mediumtext NOT NULL,
    `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
    `hits` int(11) NOT NULL DEFAULT 0,
    `language` varchar(255) NOT NULL DEFAULT '*',
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__bagrid_fonts`;
CREATE TABLE `#__bagrid_fonts` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `font` varchar(255) NOT NULL,
    `styles` varchar(255) NOT NULL,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__bagrid_plugins`;
CREATE TABLE `#__bagrid_plugins` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `title` varchar(255) NOT NULL,
    `image` varchar(255) NOT NULL,
    `joomla_constant` varchar(255) NOT NULL,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__bagrid_library`;
CREATE TABLE `#__bagrid_library` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `title` varchar(255) NOT NULL,
    `item` mediumtext NOT NULL,
    `type` varchar(255) NOT NULL DEFAULT 'section',
    `global_item` varchar(255) NOT NULL,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__bagrid_categories`;
CREATE TABLE `#__bagrid_categories` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `title` varchar(255) NOT NULL,
    `alias` varchar(255) NOT NULL,
    `published` tinyint(1) NOT NULL DEFAULT 1,
    `access` tinyint(1) NOT NULL DEFAULT 1,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__bagrid_tags`;
CREATE TABLE `#__bagrid_tags` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `title` varchar(255) NOT NULL,
    `hits` int(11) NOT NULL DEFAULT 0,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__bagrid_tags_map`;
CREATE TABLE `#__bagrid_tags_map` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `tag_id` int(11) NOT NULL,
    `page_id` int(11) NOT NULL,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__bagrid_api`;
CREATE TABLE `#__bagrid_api` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `service` varchar(255) NOT NULL,
    `key` varchar(255) NOT NULL,
    PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__bagrid_api` (`service`, `key`) VALUES
('google_maps', '');

INSERT INTO `#__bagrid_plugins` (`title`, `image`, `joomla_constant`) VALUES
('ba-image', 'zmdi-wallpaper', 'PAGE_ELEMENT_IMAGE'),
('ba-text', 'zmdi-format-size', 'PAGE_ELEMENT_TEXT'),
('ba-button', 'zmdi-crop-7-5', 'PAGE_ELEMENT_BUTTON');

INSERT INTO `#__bagrid_fonts` (`font`, `styles`) VALUES
('Abel', 400),
('Alegreya', 700),
('Alice', 400),
('Amatic+SC', 700),
('Dancing+Script', 700),
('Dosis', 400),
('Droid+Serif', 400),
('EB+Garamond', 400),
('Grand+Hotel', 400),
('Josefin+Sans', 700),
('Lato', 300),
('Medula+One', 400),
('Montserrat', 400),
('Open+Sans', 400),
('Oswald', 700),
('Playfair+Display', 900),
('Raleway', 200),
('Roboto', 300),
('Roboto', 400),
('Roboto', 700);