<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die; 

jimport('joomla.application.component.modeladmin');

class bagridModelCategory extends JModelAdmin
{
    public function getTable($type = 'Categories', $prefix = 'BagridTable', $config = array())
    {
        return JTable::getInstance($type, $prefix, $config);
    }
    
    public function save($data)
    {
        $title = $_POST['ba_title'];
        $alias = $_POST['ba_alias'];
        $id = $_POST['category_id'];
        $access = $_POST['access'];
        $table = $this->getTable();
        $table->load($id);
        $table->bind(array('id' => $id, 'title' => $title, 'alias' => $alias, 'access' => $access));
        if (!$table->check()) {
            return false;
        }
        $table->store();
        return true;
    }

    public function getForm($data = array(), $loadData = true)
    {
        $form = $this->loadForm(
            $this->option . '.bagrid', 'bagrid', array('control' => 'jform', 'load_data' => $loadData)
        );
        
        if (empty($form))
        {
            return false;
        }
 
        return $form;
    }
    
    protected function getNewTitle($title)
	{
        $table = $this->getTable();
        while ($table->load(array('title' => $title)))
		{
			$title = JString::increment($title);
		}

		return $title;
	}

    protected function getNewAlias($alias)
    {
        $table = $this->getTable();
        while ($table->load(array('alias' => $alias)))
        {
            $alias = JString::increment($alias);
        }

        return $alias;
    }
    
    public function duplicate(&$pks)
    {
        $db = $this->getDbo();
        foreach ($pks as $pk) {
            $table = $this->getTable();
            $table->load($pk, true);
            $table->id = 0;
            $table->title = $this->getNewTitle($table->title);
            $table->alias = $this->getNewAlias($table->alias);
            $table->published = 0;
            $table->store();
        }
    }
}