<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die; 

jimport('joomla.application.component.modeladmin');

class bagridModelTheme extends JModelAdmin
{
    public function getTable($type = 'Style', $prefix = 'TemplatesTable', $config = array())
    {
        return JTable::getInstance($type, $prefix, $config);
    }

    public function cleanCache($group = null, $client_id = 0)
    {
        parent::cleanCache('com_modules');
        parent::cleanCache('mod_menu');
    }
    
    public function getForm($data = array(), $loadData = true)
    {
        $form = $this->loadForm(
            $this->option . '.bagrid', 'bagrid', array('control' => 'jform', 'load_data' => $loadData)
        );
        
        if (empty($form))
        {
            return false;
        }
 
        return $form;
    }
    
    protected function getNewTitle($title)
	{
        $table = $this->getTable();
        while ($table->load(array('title' => $title)))
		{
			$title = JString::increment($title);
		}

		return $title;
	}
    
    public function duplicate(&$pks)
    {
        $db = $this->getDbo();
        foreach ($pks as $pk) {
            $table = $this->getTable();
            $table->load($pk, true);
            $table->id = 0;
            $table->title = $this->getNewTitle($table->title);
            $table->home = 0;
            $table->store();
        }
    }
}