<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla view library
jimport('joomla.application.component.view');
jimport( 'joomla.form.form' );

class bagridViewbagrids extends JViewLegacy
{
    protected $items;
    protected $pagination;
    protected $state;
    protected $about;
    protected $template;
    protected $themes;
    protected $form;
    protected $categories = array();
    protected $tags;
    protected $access = array();
    
    public function display($tpl = null) 
    {
        $this->form = JForm::getInstance('bagrid', JPATH_COMPONENT.'/models/forms/bagrid.xml');
        $this->items = $this->get('Items');
        $this->items = $this->getThemeName($this->items);
        $this->getCategoryName();
        $this->pagination = $this->get('Pagination');
        $this->state = $this->get('State');
        $this->themes = $this->get('Themes');
        $this->about = bagridHelper::aboutUs();
        $this->template = bagridHelper::getTemplate();
        $this->addToolBar();
        bagridHelper::addSubmenu('bagrids');
        $this->sidebar = JHtmlSidebar::render();
        $this->getTags();
        $this->getAccess();
        foreach ($this->items as &$item)
        {
            $item->order_up = true;
            $item->order_dn = true;
        }
        parent::display($tpl);
    }

    protected function getCategoryName()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id, title')
            ->from('#__bagrid_categories');
        $db->setQuery($query);
        $array = $db->loadObjectList();
        foreach ($array as $value) {
            $this->categories[$value->id] = $value->title;
        }
    }

    protected function getAccess()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id, title')
            ->from('#__viewlevels');
        $db->setQuery($query);
        $array = $db->loadObjectList();
        foreach ($array as $value) {
            $this->access[$value->id] = $value->title;
        }
    }

    protected function getTags()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('*')
            ->from('#__bagrid_tags');
        $db->setQuery($query);
        $this->tags = $db->loadObjectList();
    }
    
    protected function getThemeName($items)
    {
        $db = JFactory::getDbo();
        foreach ($items as $item) {
            $query = $db->getQuery(true);
            $query->select('`title`')
                ->from('#__template_styles')
                ->where('`id` = '.$db->quote($item->theme));
            $db->setQuery($query);
            $item->themeName = $db->loadResult();
        }
        
        return $items;
    }
    
    protected function addToolBar ()
    {
        JToolBarHelper::title(JText::_('BAGRID_TITLE'), 'cube');
        if (JFactory::getUser()->authorise('core.create', 'com_bagrid')) {
            JToolBarHelper::addNew('bagrid.add');
        }
        if (JFactory::getUser()->authorise('core.duplicate', 'com_bagrid')) {
            JToolBarHelper::custom('bagrids.duplicate', 'copy.png', 'copy_f2.png', 'JTOOLBAR_DUPLICATE', true);
        }
        if (JFactory::getUser()->authorise('core.edit.state', 'com_bagrid')) {
            JToolbarHelper::publish('bagrids.publish', 'JTOOLBAR_PUBLISH', true);
            JToolbarHelper::unpublish('bagrids.unpublish', 'JTOOLBAR_UNPUBLISH', true);
        }
        if (JFactory::getUser()->authorise('core.delete', 'com_bagrid')) {
            if ($this->state->get('filter.state') == -2) {
                JToolBarHelper::deleteList('', 'bagrids.delete');
            } else {
                JToolbarHelper::trash('bagrids.trash');
            }
        }
        if (JFactory::getUser()->authorise('core.admin', 'com_bagrid') || JFactory::getUser()->authorise('core.options', 'com_bagrid')) {
            JToolBarHelper::preferences('com_bagrid');
        }
    }
    
    protected function getSortFields()
    {
        return array(
            'published' => JText::_('JSTATUS'),
            'title' => JText::_('JGLOBAL_TITLE'),
            'theme' => JText::_('THEME'),
            'page_category' => JText::_('CATEGORY'),
            'id' => JText::_('JGRID_HEADING_ID')
        );
    }
}