<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;
// load tooltip behavior
JHtml::_('behavior.tooltip');
$sortFields = $this->getSortFields();
$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn  = $this->escape($this->state->get('list.direction'));
$user = JFactory::getUser();
$checkUpdate = bagridHelper::checkUpdate($this->about->version);
?>
<link rel="stylesheet" href="components/com_bagrid/assets/css/ba-admin.css" type="text/css"/>
<script src="components/com_bagrid/assets/js/ba-admin.js" type="text/javascript"></script>
<script type="text/javascript">
    var str = "<div class='btn-wrapper' id='toolbar-about'>";
    str += "<button value='About' class='btn btn-small'><span class='icon-bookmark'>";
    str += "</span><?php echo JText::_('ABOUT') ?></button></div>";
    jQuery('#toolbar').append(str);
    jQuery('#toolbar-new button, #toolbar-edit button').removeAttr('onclick');
    jQuery('#toolbar-new button').addClass('category-new');
    jQuery('#toolbar-edit button').addClass('category-edit');
</script>
<form action="<?php echo JRoute::_('index.php?option=com_bagrid&view=categories'); ?>"
      enctype="multipart/form-data" method="post" name="adminForm" id="adminForm">
    <div id="about-dialog" class="ba-modal-md modal hide" style="display:none">
        <div class="modal-header">
            <a class="close" data-dismiss="modal">x</a>
            <h3><?php echo JText::_('ABOUT') ?></h3>
        </div>
        <div class="modal-body">
            <div id="form-about">
                <label><?php echo JText::_('WEBSITE') ?>:</label>
                <a target="_blank" href="<?php echo $this->about->authorUrl; ?>">www.balbooa.com</a><br>
                <label><?php echo JText::_('LICENSE') ?>:</label>
                GNU Public License version 2.0. <br>
                <label><?php echo JText::_('COPYRIGHT') ?>:</label>
                © 2016 Balbooa All Rights Reserved. <br>
                <label><?php echo JText::_('EMAIL') ?>:</label>
                <?php echo $this->about->authorEmail; ?><br>
                <label><?php echo JText::_('VERSION') ?>:</label>
                <span class="update"> <?php echo $this->about->version; ?>
                </span>
                <br>
            </div>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="error-dialog" class="ba-modal-sm modal hide" style="display:none">
        <div class="modal-body">
            <p class="not-selected"><?php echo JText::_('PAGE_NOT_SELECTED'); ?></p>
            <p class="many-selected"><?php echo JText::_('TOO_MANY_SELECTED'); ?></p>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="title-modal" class="ba-modal-md modal ba-modal-dialog hide" style="display: none;">
        <div class="modal-header">
            <h3 class="ba-modal-header"><?php echo JText::_('ENTER_CATEGORY_TITLE'); ?></h3>
        </div>
        <div class="modal-body">
            <label><?php echo JText::_('CATEGORY_TITLE'); ?></label>
            <input name="ba_title" type="text" class="ba-title"><br>
            <label><?php echo JText::_('ALIAS'); ?></label>
            <input name="ba_alias" type="text" class="ba-alias"><br>
            <input type="hidden" name="category_id" class="category-id">
            <label>
                <?php echo JText::_('ACCESS'); ?>
            </label>
            <?php echo $this->form->getInput('access'); ?>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn-primary apply-category"><?php echo JText::_('APPLY') ?></a>
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="update-dialog" class="modal hide" style="display:none">
        <div class="modal-header">
            <h3><?php echo JText::_('ACCOUNT_LOGIN') ?></h3>
        </div>
        <div class="modal-body">
            <div id="form-update">
                
            </div>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div class="row-fluid">
        <div class="span2" id="j-sidebar-container">
            <?php echo $this->sidebar; ?>
        </div>
        <div class="span10" id="j-main-container">
            <div id="filter-bar">
                <label for="filter_search" class="element-invisible">
                    <?php echo JText::_('SEARCH_FORM?') ?>
                </label>
                <input type="text" name="filter_search" id="filter_search"
                       value="<?php echo $this->escape($this->state->get('filter.search')); ?>"
                       placeholder="<?php echo JText::_('SEARCH') ?>">
                <button type="submit" class="ba-btn " 
                        >
                    <i class="icon-search"></i>
                </button>
                <button type="button" class="ba-btn" onclick="document.id('filter_search').value='';this.form.submit();">
                    <i class="icon-remove"></i>
                </button>
            </div>
            <div class="clearfix"></div>
            <div>
                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th width="1%">
                                <input type="checkbox" name="checkall-toggle" value=""
                                       title="<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
                            </th>
                            <th width="1%" class="nowrap center">
                                <?php echo JText::_('JSTATUS'); ?>
                            </th>
                            <th>
                                <?php echo JText::_('CATEGORY'); ?>
                            </th>
                            <th>
                                <?php echo JText::_('ACCESS'); ?>
                            </th>
                            <th width="1%">
                                <?php echo JText::_('ID'); ?>
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                       <?php foreach ($this->items as $i => $item) : 
                                $canChange = $user->authorise('core.edit.state', 'com_bagrid'); ?>
                        <tr>
                            <td data-alias="<?php echo $item->alias; ?>">
                                <?php echo JHtml::_('grid.id', $i, $item->id); ?>
                            </td>
                            <td class="center">
                                <?php echo JHtml::_('jgrid.published', $item->published, $i, 'categories.', $canChange); ?>
                            </td>
                            <td class="title-cell">
                                <a href="#" class="category-edit-item">
                                    <?php echo $item->title; ?>
                                </a>
                            </td>
                            <td class="access-cell" data-access="<?php echo $item->access; ?>">
                                <?php echo $this->access[$item->access]; ?>
                            </td>
                            <td>
                                <?php echo $item->id; ?>
                            </td>
                        </tr>
                        <?php endforeach; ?>
                    </tbody>
                    <tfoot>
                        <tr>
                            <td colspan="5">
                                <?php echo $this->pagination->getListFooter(); ?>
                            </td>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <div>
                <input type="hidden" name="task" value="" />
                <input type="hidden" name="boxchecked" value="0" />
                <?php echo JHtml::_('form.token'); ?>
            </div>
        </div>
    </div>
</form>