<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla view library
jimport('joomla.application.component.view');

class bagridViewCategories extends JViewLegacy
{
    protected $items;
    protected $state;
    protected $about;
    protected $form;
    protected $access = array();
    
    public function display($tpl = null) 
    {
        $this->items = $this->get('Items');
        $this->pagination = $this->get('Pagination');
        $this->state = $this->get('State');
        $this->about = bagridHelper::aboutUs();
        $this->form = JForm::getInstance('bagrid', JPATH_COMPONENT.'/models/forms/bagrid.xml');
        $this->getAccess();
        $this->addToolBar();
        bagridHelper::addSubmenu('categories');
        $this->sidebar = JHtmlSidebar::render();
       	foreach ($this->items as &$item)
        {
            $item->order_up = true;
            $item->order_dn = true;
        }
        
        // Display the template
        parent::display($tpl);
    }

    protected function getAccess()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id, title')
            ->from('#__viewlevels');
        $db->setQuery($query);
        $array = $db->loadObjectList();
        foreach ($array as $value) {
            $this->access[$value->id] = $value->title;
        }
    }
    
    protected function addToolBar ()
	{
        JToolBarHelper::title(JText::_('GRIDBOX_MANAGER_CATEGORIES'), 'cube');
        if (JFactory::getUser()->authorise('core.create', 'com_bagrid')) {
            JToolBarHelper::addNew('categories.add');
        }
        if (JFactory::getUser()->authorise('core.edit', 'com_bagrid')) {
            JToolBarHelper::editList('categories.edit');
        }
        if (JFactory::getUser()->authorise('core.edit.state', 'com_bagrid')) {
            JToolbarHelper::publish('categories.publish', 'JTOOLBAR_PUBLISH', true);
            JToolbarHelper::unpublish('categories.unpublish', 'JTOOLBAR_UNPUBLISH', true);
        }
        if (JFactory::getUser()->authorise('core.delete', 'com_bagrid')) {
            JToolBarHelper::deleteList('', 'categories.delete');
        }
        if (JFactory::getUser()->authorise('core.admin', 'com_bagrid') || JFactory::getUser()->authorise('core.options', 'com_bagrid')) {
            JToolBarHelper::preferences('com_bagrid');
        }
    }
    
    protected function getSortFields()
	{
		return array(
            'title' => JText::_('JGLOBAL_TITLE'),
			'id' => JText::_('JGRID_HEADING_ID')
		);
	}
}