<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;
// load tooltip behavior
JHtml::_('behavior.tooltip');
$sortFields = $this->getSortFields();
$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn  = $this->escape($this->state->get('list.direction'));
$user = JFactory::getUser();
?>
<link rel="stylesheet" href="components/com_bagrid/assets/css/ba-admin.css" type="text/css"/>
<script src="components/com_bagrid/assets/js/ba-admin.js" type="text/javascript"></script>
<script type="text/javascript">
    var str = "<div class='btn-wrapper' id='toolbar-about'>";
    str += "<button value='About' class='btn btn-small'><span class='icon-bookmark'>";
    str += "</span><?php echo JText::_('ABOUT') ?></button></div>";
    jQuery('#toolbar').append(str);
</script>
<form action="<?php echo JRoute::_('index.php?option=com_bagrid&view=themes'); ?>" enctype="multipart/form-data" method="post" name="adminForm" id="adminForm">
    <div id="about-dialog" class="ba-modal-md modal hide" style="display:none">
        <div class="modal-header">
            <a class="close" data-dismiss="modal">x</a>
            <h3><?php echo JText::_('ABOUT') ?></h3>
        </div>
        <div class="modal-body">
            <div id="form-about">
                <label><?php echo JText::_('WEBSITE') ?>:</label>
                <a target="_blank" href="<?php echo $this->about->authorUrl; ?>">www.balbooa.com</a><br>
                <label><?php echo JText::_('LICENSE') ?>:</label>
                GNU Public License version 2.0. <br>
                <label><?php echo JText::_('COPYRIGHT') ?>:</label>
                © 2015 Balbooa All Rights Reserved. <br>
                <label><?php echo JText::_('EMAIL') ?>:</label>
                <?php echo $this->about->authorEmail; ?><br>
                <label><?php echo JText::_('VERSION') ?>:</label>
                <span class="update"> <?php echo $this->about->version; ?>
                </span>
                <br>
            </div>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="update-dialog" class="modal hide" style="display:none">
        <div class="modal-header">
            <h3><?php echo JText::_('ACCOUNT_LOGIN') ?></h3>
        </div>
        <div class="modal-body">
            <div id="form-update">
                
            </div>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="error-dialog" class="ba-modal-sm modal hide" style="display:none">
        <div class="modal-body">
            <p class="not-selected"><?php echo JText::_('THEME_NOT_SELECTED'); ?></p>
            <p class="many-selected"><?php echo JText::_('TOO_MANY_THEMES_SELECTED'); ?></p>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="upload-dialog" class="modal hide" style="display:none">
        <div class="modal-header">
            <h3><?php echo JText::_('UPLOAD_THEME') ?></h3>
        </div>
        <div class="modal-body">
            <ul class="nav nav-tabs">
                <li class="active"><a href="#themes-gallery" data-toggle="tab"><?php echo JText::_('THEMES') ?></a></li>
                <li><a href="#import-theme" data-toggle="tab"><?php echo JText::_('IMPORT') ?></a></li>
            </ul>
            <div class="tab-content">
                <div class="row-fluid tab-pane fade in active" id="themes-gallery">
                    
                </div>
                <div class="row-fluid tab-pane" id="import-theme">
                    <input type="file" name="ba-files[]">
                    <input type="button" class="ba-btn-primary" value="<?php echo JText::_('UPLOAD') ?>" onclick="Joomla.submitbutton('themes.uploadTheme')">
                </div>
            </div>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="theme-edit-dialog" class="ba-modal-md modal hide" style="display:none">
        <div class="modal-header">
            <h3><?php echo JText::_('THEME_SETTINGS') ?></h3>
        </div>
        <div class="modal-body">
            <label><?php echo JText::_('NAME') ?></label>
            <input type="text" class="theme-name">
            <label><?php echo JText::_('DEFAULT_THEME') ?></label>
            <input type="checkbox" class="theme-default">
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn-primary theme-apply" ><?php echo JText::_('APPLY') ?></a>
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div class="row-fluid">
        <div class="span2" id="j-sidebar-container">
            <?php echo $this->sidebar; ?>
        </div>
        <div class="span10" id="j-main-container">
            <div id="filter-bar">
                <label for="filter_search" class="element-invisible">
                    <?php echo JText::_('SEARCH_FORM?') ?>
                </label>
                <input type="text" name="filter_search" id="filter_search"
                       value="<?php echo $this->escape($this->state->get('filter.search')); ?>"
                       placeholder="<?php echo JText::_('SEARCH') ?>">
                <button type="submit" class="ba-btn " 
                        >
                    <i class="icon-search"></i>
                </button>
                <button type="button" class="ba-btn" onclick="document.id('filter_search').value='';this.form.submit();">
                    <i class="icon-remove"></i>
                </button>
                <?php if (JFactory::getUser()->authorise('core.edit', 'com_bagrid')) { ?>
                    <div class="btn-group pull-right">
                        <input type="button" class="ba-btn-primary theme-upload-new" value="<?php echo JText::_('UPLOAD_THEME'); ?>">
                    </div>
                    <div class="btn-group pull-right">
                        <input type="button" class="ba-btn theme-edit" value="<?php echo JText::_('SETTINGS'); ?>">
                    </div>
                <?php } ?>
            </div>
            <div class="clearfix"></div>
            <div class="theme-grid">
                <?php foreach ($this->items as $i => $item) : ?>
                <label>
                    <img src="<?php echo $item->image; ?>">
                    <?php echo JHtml::_('grid.id', $i, $item->id); ?>
                    <p data-default="<?php echo $item->home; ?>"><?php echo $item->title; ?></p>
                    <?php if ($item->home == 1) { ?>
                    <i class="icon-star"></i>
                    <?php } ?>
                </label>
                <?php endforeach; ?>
            </div>
            <div class="pagination-footer">
                <?php echo $this->pagination->getListFooter(); ?>
            </div>
            <div>
                <input type="hidden" name="task" value="" />
                <input type="hidden" name="boxchecked" value="0" />
                <?php echo JHtml::_('form.token'); ?>
            </div>
        </div>
    </div>
</form>