<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla view library
jimport('joomla.application.component.view');

class bagridViewthemes extends JViewLegacy
{
    protected $items;
    
    protected $state;
    
    protected $about;
    /**
     * View display method
     * @return void
     */
    public function display($tpl = null) 
    {
        $this->items = $this->get('Items');
        foreach ($this->items as $key => $item) {
            if (empty($item->params)) {
                $item->params = '{}';
            }
            $params = json_decode($item->params);
            if (!isset($params->image)) {
                $params->image = 'components/com_bagrid/assets/images/default-theme.png';
            }
            unset($this->items[$key]->params);
            $this->items[$key]->image = $params->image;
        }
        $this->pagination = $this->get('Pagination');
        $this->state = $this->get('State');
        $this->about = bagridHelper::aboutUs();
        // Set the toolbar
        $this->addToolBar();
        bagridHelper::addSubmenu('themes');
        $this->sidebar = JHtmlSidebar::render();
       	foreach ($this->items as &$item)
        {
            $item->order_up = true;
            $item->order_dn = true;
        }
        
        // Display the template
        parent::display($tpl);
    }
    
    protected function addToolBar ()
	{
        JToolBarHelper::title(JText::_('GRIDBOX_MANAGER_THEMES'), 'cube');
        if (JFactory::getUser()->authorise('core.duplicate', 'com_bagrid')) {
            JToolBarHelper::custom('themes.duplicate', 'copy.png', 'copy_f2.png', 'JTOOLBAR_DUPLICATE', true);
        }
        if (JFactory::getUser()->authorise('core.delete', 'com_bagrid')) {
            JToolBarHelper::deleteList('', 'themes.delete');
        }
        if (JFactory::getUser()->authorise('core.admin', 'com_bagrid') || JFactory::getUser()->authorise('core.options', 'com_bagrid')) {
            JToolBarHelper::preferences('com_bagrid');
        }
    }
    
    protected function getSortFields()
	{
		return array(
            'title' => JText::_('JGLOBAL_TITLE'),
			'id' => JText::_('JGRID_HEADING_ID')
		);
	}
}