<?php
/**
 * @package     Joomla.Site
 * @subpackage  Templates.protostar
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

$app = JFactory::getApplication();
$doc = JFactory::getDocument();
$user = JFactory::getUser();
$this->language = $doc->language;
$this->direction = $doc->direction;

// Getting params from template
$params = $app->getTemplate(true)->params;
$this->params = $params;

JLoader::register('bagridHelper', JPATH_ROOT . '/components/com_bagrid/helpers/bagrid.php');

?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>">
<head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />
    <title><?php echo $this->title; ?> <?php echo htmlspecialchars($this->error->getMessage(), ENT_QUOTES, 'UTF-8'); ?></title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/css/gridboxcore.css" type="text/css" />
    <?php // If Right-to-Left ?>
    <?php if ($this->direction == 'rtl') : ?>
        <link rel="stylesheet" href="<?php echo $this->baseurl; ?>/media/jui/css/bootstrap-rtl.css" type="text/css" />
    <?php endif; ?>
    <link href="<?php echo $this->baseurl; ?>/templates/<?php echo $this->template; ?>/favicon.ico" rel="shortcut icon" type="image/vnd.microsoft.icon" />
    <?php include_once('style.php'); ?>
</head>
<body>
    <div class="body ">
        <div class="container<?php echo ($this->params->get('fluidContainer') ? '-fluid' : ''); ?>">
                <div id="content" class="error">
                    <h1><?php echo $this->error->getCode(); ?></h1> 
                    <p><?php echo htmlspecialchars($this->error->getMessage(), ENT_QUOTES, 'UTF-8');?></p>
                    <?php if (JModuleHelper::getModule('search')) : ?>
                        <?php echo $doc->getBuffer('module', 'search'); ?>
                    <?php endif; ?>
                    <p><a href="<?php echo $this->baseurl; ?>/index.php" class="btn"><?php echo JText::_('JERROR_LAYOUT_HOME_PAGE'); ?></a></p>
                </div>
        </div>
    </div>
</body>
</html>
