<?php
/**
* @package   Gridbox template
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

$app = JFactory::getApplication();
$doc = JFactory::getDocument();
$menu = $app->getMenu()->getActive();
$pageclass = '';
if (is_object($menu)) {
    $pageclass = $menu->params->get('pageclass_sfx');
}
JHtml::_('bootstrap.framework');
JLoader::register('bagridHelper', JPATH_ROOT . '/components/com_bagrid/helpers/bagrid.php');
if ($app->input->get('option') == 'com_bagrid') {
    $bagridId = $app->input->get('id');
    $this->params = bagridHelper::checkParams($bagridId, $this->params);
}
$params = $this->params->get('params');
$footer = $this->params->get('footer');
$header = $this->params->get('header');
$logo = new stdClass();
if (isset($params->logo)) {
    $logo = $params->logo;
} else {
    $logo->link = JUri::root();
    $logo->img = JUri::root().'components/com_bagrid/assets/images/gridbox.png';
    $logo->alt = '';
    $logo->width = 75;
}
$type = 'classic';
$fixed = '';
if (isset($params->navigation)) {
    $type = $params->navigation->nav->type;
    if ($params->navigation->nav->fixed) {
        $fixed = $params->navigation->nav->fixed;
    }
}
$header = bagridHelper::checkheaderSection($header, $logo, $type);
$footer = bagridHelper::checkMOdules($footer);
$header = bagridHelper::checkMOdules($header);
bagridHelper::checkMoreScripts($footer);
bagridHelper::checkMoreScripts($header);
$suffix = '';
$headerSuffix = '';
$footerSuffix = '';
$container = 'ba-container-fluid';
$view = ($app->input->getCmd('view', ''));
if (isset($params->favicon)) {
    bagridHelper::reCreateFavicon($params->favicon);
}
if (isset($params->headerJs) && $view != 'bagrid') {
    $doc->addScriptDeclaration($params->headerJs);
}
if (isset($params->container)) {
    $container = $params->container;
}
if (isset($params->headerSuffix)) {
    $headerSuffix = $params->headerSuffix;
}
if (isset($params->footerSuffix)) {
    $footerSuffix = $params->footerSuffix;
}
if (isset($params->custom)) {
    if (isset($params->custom->suffix)) {
        $suffix = $params->custom->suffix;
    }
}

// Detecting Active Variables
$option = $app->input->getCmd('option', '');
// Add JavaScript Frameworks
if ($view != 'bagrid') {
    $doc->addScript($this->baseurl . '/templates/' . $this->template . '/js/gridboxcore.js');
} else {
    $doc->addScriptDeclaration("
        (function($)
        {
            $(document).ready(function() {
                $('.open-menu').click(function() {
                    $('.main-menu').addClass('visible-menu').removeClass('hide-menu');
                });
                $('.close-menu').click(function() {
                    $('.main-menu').addClass('hide-menu').removeClass('visible-menu');
                });
                $('.sidebar-menu .main-menu li.deeper.parent').on('mouseenter', function(){
                    var coord = this.getBoundingClientRect();
                    $(this).find('> .nav-child').css({
                        'top' : coord.top*1 - 1 +'px',
                        'left' : coord.right+'px'
                    })
                });
            });
        })(jQuery);        
    ");
}
// Add Stylesheets
$doc->addStyleSheet('https://cdnjs.cloudflare.com/ajax/libs/material-design-iconic-font/2.2.0/css/material-design-iconic-font.min.css');
$doc->addStyleSheet($this->baseurl . '/templates/' . $this->template . '/css/gridboxcore.css');
$doc->addStyleSheet('//fonts.googleapis.com/css?family=Roboto:700,300,500');
bagridHelper::checkCustom();
?>

<!DOCTYPE html>
<html prefix="og: http://ogp.me/ns#" xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <jdoc:include type="head" />
    <?php if ($this->direction == 'rtl') : ?>
        <link rel="stylesheet" href="<?php echo $this->baseurl; ?>/media/jui/css/bootstrap-rtl.css" type="text/css" />
    <?php endif; ?>
    <?php include_once('style.php'); ?>
</head>
<body class="<?php echo $option. ' ' .$suffix. ' ' .htmlspecialchars($pageclass); ?>">
    <?php if (isset($params->bodyJs) && $view != 'bagrid') { ?>
    <script type="text/javascript">
        <?php echo $params->bodyJs; ?>
    </script>
    <?php } ?>
    <?php 
    if (isset($params->background)) {
        if (isset ($params->background->type)) {
            if ($params->background->type == 'video') {
    ?>
    <div class="ba-video-background<?php echo isset($params->background->videoImage) ? ' ba-responsive-video-image' : ''; ?> global-video-bg"
         <?php echo isset($params->background->videoImage) ? 'style="background-image: url('.$params->background->videoImage.');"' : ''; ?>
         >
        <div id="ba-video-background"></div>
        <input type="hidden" value="<?php echo $params->background->id.';'.
        $params->background->mute. ';' .$params->background->start. ';'.
        $params->background->quality; ?>">
    </div>
    <?php
            }
        }
    }
    ?>
    <header class="header<?php echo ' '.$fixed.' '.$headerSuffix. ' '.$type; ?>">
        <?php echo $header; ?>
    </header>
    <div class="body"> 
        
        <?php if ($this->countModules('top-a') || $this->countModules('top-b') || $this->countModules('top-c') || $this->countModules('top-d')) : ?>
            <div class="row-fluid container top">
                <div class="span3">
                    <jdoc:include type="modules" name="top-a" style="none" />
                </div>
                <div class="span3">
                    <jdoc:include type="modules" name="top-b" style="none" />
                </div>
                <div class="span3">
                    <jdoc:include type="modules" name="top-c" style="none" />
                </div>
                 <div class="span3">
                    <jdoc:include type="modules" name="top-d" style="none" />
                </div>
            </div>
        <?php endif; ?>

        <?php if ($this->countModules('feature-a') || $this->countModules('feature-b') || $this->countModules('feature-c')) : ?>
            <div class="row-fluid container feature-top">
                <div class="span4">
                    <jdoc:include type="modules" name="feature-a" style="none" />
                </div>
                <div class="span4">
                    <jdoc:include type="modules" name="feature-b" style="none" />
                </div>
                <div class="span4">
                    <jdoc:include type="modules" name="feature-c" style="none" />
                </div>
            </div>
        <?php endif; ?>

        <?php if ($this->countModules('showcase-a') || $this->countModules('showcase-b')) : ?>
            <div class="row-fluid container showcase-top">
                <div class="span6">
                    <jdoc:include type="modules" name="showcase-a" style="none" />
                </div>
                <div class="span6">
                    <jdoc:include type="modules" name="showcase-b" style="none" />
                </div>
            </div>
        <?php endif; ?>

        <?php if ($this->countModules('breadcrumbs')) : ?>
            <div class="row-fluid container">
                <div class="span12">
                    <div class="breadcrumbs">
                        <jdoc:include type="modules" name="breadcrumbs" style="none" />
                    </div>
                </div>
            </div>
        <?php endif; ?>

        <div class="row-fluid container main-body <?php echo $container; ?>">
            <?php if ($this->countModules('sidebar-a')): ?>
                <div class="sidebar-left span3">
                    <jdoc:include type="modules" name="sidebar-a" style="xhtml" />
                </div>
            <?php endif; ?>

            <div class="<?php if ($this->countModules('sidebar-a') && $this->countModules('sidebar-b')) {print('span6');} else if ($this->countModules('sidebar-a') xor $this->countModules('sidebar-b')) {print('span9');} else {print('span12');} ?>">
                <jdoc:include type="message"/>
                <jdoc:include type="component"/>
            </div>

            <?php if ($this->countModules('sidebar-b')): ?>
                <div class="sidebar-right span3">
                    <jdoc:include type="modules" name="sidebar-b" style="xhtml" />
                </div>
            <?php endif; ?>
        </div>

        <?php if ($this->countModules('banner-a') || $this->countModules('banner-b') || $this->countModules('banner-c')) : ?>
            <div class="row-fluid container feature-bottom">
                <div class="span4">
                    <jdoc:include type="modules" name="banner-a" style="none" />
                </div>
                <div class="span4">
                    <jdoc:include type="modules" name="banner-b" style="none" />
                </div>
                <div class="span4">
                    <jdoc:include type="modules" name="banner-c" style="none" />
                </div>
            </div>
        <?php endif; ?>

        <?php if ($this->countModules('box-a') || $this->countModules('box-b') || $this->countModules('box-c') || $this->countModules('box-d')) : ?>
            <div class="row-fluid container bottom">
                <div class="span3">
                    <jdoc:include type="modules" name="box-a" style="none" />
                </div>
                <div class="span3">
                    <jdoc:include type="modules" name="box-b" style="none" />
                </div>
                <div class="span3">
                    <jdoc:include type="modules" name="box-c" style="none" />
                </div>
                 <div class="span3">
                    <jdoc:include type="modules" name="box-d" style="none" />
                </div>
            </div>
        <?php endif; ?>

        <?php if ($this->countModules('bottom-a') || $this->countModules('bottom-b')) : ?>
            <div class="row-fluid container showcase-bottom">
                <div class="span6">
                    <jdoc:include type="modules" name="bottom-a" style="none" />
                </div>
                <div class="span6">
                    <jdoc:include type="modules" name="bottom-b" style="none" />
                </div>
            </div>
        <?php endif; ?>
    </div>
    <footer class="footer <?php echo $footerSuffix; ?>">
        <?php echo $footer; ?>
    </footer>
    <?php if ($this->countModules('debug')) : ?>
    <jdoc:include type="modules" name="debug" style="none" />
    <?php endif; ?>
    <p style="text-align: center; font-size: 12px; font-style: italic;">
        <a href="http://www.balbooa.com/gridbox">Gridbox Joomla Page Builder</a> makes it easy. Balbooa.com
    </p>
</body>
</html>