/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/


jQuery(document).on('ready', function(){
    
    var view = 'screen',
        params;

    function checkLetter(letter)
    {
        if (!letter) {
            letter = 0;
        }

        return letter;
    }
    
    function rgba2hex(rgb)
    {
        var parts = rgb.toLowerCase().match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/),
            hex = '#',
            part,
            color = new Array();
        if (parts) {
            for ( var i = 1; i <= 3; i++ ) {
                part = parseInt(parts[i]).toString(16);
                if (part.length < 2) {
                    part = '0'+part;
                }
                hex += part;
            }
            if (!parts[4]) {
                parts[4] = 1;
            }
            color.push(hex);
            color.push(parts[4]);
            
            return color;
        } else {
            color.push(rgb);
            color.push(1);
            
            return color;
        }
    }
    
    function sendData()
    {
        var iframe = jQuery('.editor-iframe')[0].contentWindow;
        iframe.postMessage(JSON.stringify(params), "*");
    }

    window.addEventListener("message", function(event){
        if (event.origin == location.origin) {
            if (event.data == 'preloader') {
                jQuery('.preloader').removeClass('ba-hide').addClass('ba-preloader-slide');
            } else if (event.data == 'preloaderReady') {
                jQuery('.preloader').addClass('ba-hide').removeClass('ba-preloader-slide');
            } else if (event.data != view && !jQuery.isNumeric(event.data)) {
                if (event.data == 'screen') {
                    view = event.data;
                    jQuery('.editor-iframe').addClass('responsive-out');
                    setTimeout(function(){
                        jQuery('.editor-iframe').removeClass('responsive-out');
                        jQuery('.editor-iframe').removeClass('tablet').removeClass('mobile').css('width', '100%');
                        jQuery('.editor-iframe').addClass('responsive-in');
                        setTimeout(function(){
                            jQuery('.editor-iframe').removeClass('responsive-in');
                        }, 500);
                        jQuery('.editor-iframe').css('width', '100%').removeClass('mobile').removeClass('tablet');
                    }, 500)
                    jQuery('.global-configuration').addClass('ba-responsive-close').removeClass('ba-responsive-fade');
                    setTimeout(function(){
                        jQuery('.global-configuration').removeClass('ba-responsive-close')
                    }, 500)
                } else if (event.data == 'tablet') {
                    view = event.data;
                    jQuery('.editor-iframe').addClass('responsive-out');
                    setTimeout(function(){
                        jQuery('.editor-iframe').removeClass('responsive-out');
                        jQuery('.editor-iframe').removeClass('mobile').width(768);
                        jQuery('.editor-iframe').addClass('tablet').addClass('responsive-in');
                        setTimeout(function(){
                            jQuery('.editor-iframe').removeClass('responsive-in');
                        }, 500);
                    }, 500)
                    jQuery('.global-configuration').addClass('ba-responsive-fade');
                    jQuery('.nav-global ~ a').hide().removeClass('ba-active-options');
                    jQuery('.nav-global').show().addClass('ba-active-options');
                    jQuery('.ba-in').removeClass('ba-in');
                    jQuery('.ba-fade').removeClass('ba-fade');
                    jQuery('.ba-out').removeClass('ba-out');
                    jQuery('.global-options').addClass('ba-in');
                } else if (event.data == 'mobile') {
                    view = event.data;
                    jQuery('.editor-iframe').addClass('responsive-out');
                    setTimeout(function(){
                        jQuery('.editor-iframe').removeClass('responsive-out');
                        jQuery('.editor-iframe').removeClass('tablet').width(480);
                        jQuery('.editor-iframe').addClass('mobile').addClass('responsive-in');
                        setTimeout(function(){
                            jQuery('.editor-iframe').removeClass('responsive-in');
                        }, 500);
                    }, 500)
                    jQuery('.global-configuration').addClass('ba-responsive-fade');
                    jQuery('.nav-global ~ a').hide().removeClass('ba-active-options');
                    jQuery('.nav-global').show().addClass('ba-active-options');
                    jQuery('.ba-in').removeClass('ba-in');
                    jQuery('.ba-fade').removeClass('ba-fade');
                    jQuery('.ba-out').removeClass('ba-out');
                    jQuery('.global-options').addClass('ba-in');
                } else {
                    params = JSON.parse(event.data);
                    jQuery('.preloader').addClass('ba-hide').removeClass('ba-preloader-slide');
                    jQuery('.nav-global ~ a').hide().removeClass('ba-active-options');
                    jQuery('.nav-global').show().addClass('ba-active-options');
                    jQuery('.ba-in').removeClass('ba-in');
                    jQuery('.ba-fade').removeClass('ba-fade');
                    jQuery('.ba-out').removeClass('ba-out');
                    jQuery('.global-options').addClass('ba-in');
                }
            } else if (jQuery.isNumeric(event.data)) {
                window.history.pushState(null, null, location.href+event.data);
            }
        }
    }, false);
    jQuery('.bagrid-save').on('click', function(){
        var iframe = jQuery('.editor-iframe')[0].contentWindow;
        iframe.postMessage('savePage', "*");
    });
    jQuery('.navigation-options').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-navigation-options').addClass('ba-in');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-navigation').show().addClass('ba-active-options');
    });
    jQuery('.nav-menu-general').on('click', function(){
        var color = params.tablet.layout;
        color = rgba2hex(color);
        jQuery('.layout-bg-color').minicolors('value', color[0]);
        jQuery('.layout-bg-color').minicolors('opacity', color[1]);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.nav-general-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-layout').show().addClass('ba-active-options');
    });
    jQuery('.layout-bg-color').minicolors({
        opacity: true,
        change: function(hex, opacity) {
            var rgba = jQuery(this).minicolors('rgbaString');
            params.tablet.layout = rgba;
            sendData();
        }
    });
    jQuery('.nav-menu').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-nav-menu-options').addClass('ba-in');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-nav-menu').show().addClass('ba-active-options');
    });
    jQuery('.nav-menu-typography').on('click', function(){
        var size = params.tablet.navFont.size,
            letter = checkLetter(params.tablet.navFont.letter),
            line = params.tablet.navFont.line,
            color = params.tablet.navFont.color;
        color = rgba2hex(color);
        jQuery('.nav-font-color').minicolors('value', color[0]);
        jQuery('.nav-font-color').minicolors('opacity', color[1]);
        jQuery('.nav-font-size').val(size);
        jQuery('.nav-font-size-number').val(size);
        jQuery('.nav-letter-spacing').val(letter);
        jQuery('.nav-letter-spacing-number').val(letter);
        jQuery('.nav-line-height').val(line);
        jQuery('.nav-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.nav-typography-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-nav-typography').show().addClass('ba-active-options');
    });
    jQuery('.nav-font-color').minicolors({
        opacity: true,
        change: function(hex, opacity) {
            var rgba = jQuery(this).minicolors('rgbaString');
            params.tablet.navFont.color = rgba;
            sendData();
        }
    });
    jQuery('.nav-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params.tablet.navFont.size = inputValue;
            sendData();
            jQuery('.nav-font-size-number').val(inputValue);
        }, 12);
        jQuery('.nav-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.nav-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params.tablet.navFont.size = value;
        sendData();
        jQuery('.nav-font-size').val(value);
    });
    jQuery('.nav-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params.tablet.navFont.letter = inputValue;
            sendData();
            jQuery('.nav-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.nav-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.nav-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params.tablet.navFont.letter = value;
        sendData();
        jQuery('.nav-letter-spacing').val(value);
    });
    jQuery('.nav-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params.tablet.navFont.line = inputValue;
            sendData();
            jQuery('.nav-line-height-number').val(inputValue);
        }, 12);
        jQuery('.nav-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.nav-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params.tablet.navFont.line = value;
        sendData();
        jQuery('.nav-line-height').val(value);
    });
    jQuery('.nav-menu-active').on('click', function(){
        var bg = params.tablet.navActive.bg,
            color = params.tablet.navActive.color;
        bg = rgba2hex(bg);
        color = rgba2hex(color);
        jQuery('.nav-active-bg-color').minicolors('value', bg[0]);
        jQuery('.nav-active-bg-color').minicolors('opacity', bg[1]);
        jQuery('.nav-active-color').minicolors('value', color[0]);
        jQuery('.nav-active-color').minicolors('opacity', color[1]);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.nav-active-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-active').show().addClass('ba-active-options');
    });
    jQuery('.nav-active-bg-color').minicolors({
        opacity: true,
        change: function(hex, opacity) {
            var rgba = jQuery(this).minicolors('rgbaString');
            params.tablet.navActive.bg = rgba;
            sendData();
        }
    });
    jQuery('.nav-active-color').minicolors({
        opacity: true,
        change: function(hex, opacity) {
            var rgba = jQuery(this).minicolors('rgbaString');
            params.tablet.navActive.color = rgba;
            sendData();
        }
    });
    jQuery('.sub-menu').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-sub-menu-options').addClass('ba-in');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-sub-menu').show().addClass('ba-active-options');
    });
    jQuery('.sub-menu-typography').on('click', function(){
        var size = params.tablet.subFont.size,
            letter = checkLetter(params.tablet.subFont.letter),
            line = params.tablet.subFont.line,
            color = params.tablet.subFont.color;
        color = rgba2hex(color);
        jQuery('.sub-font-color').minicolors('value', color[0]);
        jQuery('.sub-font-color').minicolors('opacity', color[1]);
        jQuery('.sub-font-size').val(size);
        jQuery('.sub-font-size-number').val(size);
        jQuery('.sub-letter-spacing').val(letter);
        jQuery('.sub-letter-spacing-number').val(letter);
        jQuery('.sub-line-height').val(line);
        jQuery('.sub-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.sub-typography-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-nav-typography').show().addClass('ba-active-options');
    });
    jQuery('.sub-font-color').minicolors({
        opacity: true,
        change: function(hex, opacity) {
            var rgba = jQuery(this).minicolors('rgbaString');
            params.tablet.subFont.color = rgba;
            sendData();
        }
    });
    jQuery('.sub-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params.tablet.subFont.size = inputValue;
            sendData();
            jQuery('.sub-font-size-number').val(inputValue);
        }, 12);
        jQuery('.sub-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.sub-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params.tablet.subFont.size = value;
        sendData();
        jQuery('.sub-font-size').val(value);
    });
    jQuery('.sub-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params.tablet.subFont.letter = inputValue;
            sendData();
            jQuery('.sub-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.sub-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.sub-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params.tablet.subFont.letter = value;
        sendData();
        jQuery('.sub-letter-spacing').val(value);
    });
    jQuery('.sub-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params.tablet.subFont.line = inputValue;
            sendData();
            jQuery('.sub-line-height-number').val(inputValue);
        }, 12);
        jQuery('.sub-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.sub-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params.tablet.subFont.line = value;
        sendData();
        jQuery('.sub-line-height').val(value);
    });
    jQuery('.nav-global').on('click', function(){
        jQuery('.global-configuration .ba-fade').removeClass('ba-fade');
        jQuery('.ba-in').removeClass('ba-in');
        jQuery('.ba-out').removeClass('ba-out');
        jQuery('.global-options').addClass('ba-in');
        jQuery('.global-nav a').hide();
        jQuery('.global-nav .nav-global').show();
        jQuery('.global-nav .nav-global').addClass('ba-active-options');
    });
    jQuery('.nav-navigation').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-navigation-options').addClass('ba-in');
        jQuery('.global-configuration .ba-fade').removeClass('ba-fade');
        jQuery(this).find(' ~ a').hide();
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-navigation').addClass('ba-active-options');
    });
    jQuery('.nav-nav-menu').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.global-configuration .ba-fade').removeClass('ba-fade');
        jQuery('.ba-nav-menu-options').addClass('ba-in');
        jQuery(this).find(' ~ a').hide();
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-nav-menu').addClass('ba-active-options');
    });
    jQuery('.nav-sub-menu').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.global-configuration .ba-fade').removeClass('ba-fade');
        jQuery('.ba-sub-menu-options').addClass('ba-in');
        jQuery(this).find(' ~ a').hide();
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-sub-menu').addClass('ba-active-options');
    });
    jQuery('.body-options').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-body-options').addClass('ba-in');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-body').show().addClass('ba-active-options');
    });
    jQuery('.nav-body').on('click', function(){
        jQuery('.global-configuration .ba-fade').removeClass('ba-fade');
        jQuery('.ba-in').addClass('ba-out').removeClass('ba-in')
        jQuery('.ba-body-options').addClass('ba-in');
        jQuery(this).find(' ~ a').hide();
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-body').show().addClass('ba-active-options');
    });
    jQuery('.typography-options').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-options').addClass('ba-in');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography').show().addClass('ba-active-options');
    });
    jQuery('.typography-body').on('click', function(){
        var size = params[view].bodyp.size,
            line = params[view].bodyp.line,
            letter = checkLetter(params[view].bodyp.letter),
            align = params[view].bodyp.align;
        jQuery('.body-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.body-letter-spacing').val(letter);
        jQuery('.body-letter-spacing-number').val(letter);
        jQuery('.body-font-size').val(size);
        jQuery('.body-font-size-number').val(size);
        jQuery('.body-line-height').val(line);
        jQuery('.body-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-body-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-body').show().addClass('ba-active-options');
    });
    jQuery('.body-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].bodyp.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.body-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyp.size = inputValue;
            sendData();
            jQuery('.body-font-size-number').val(inputValue);
        }, 12);
        jQuery('.body-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.body-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyp.size = value;
        sendData();
        jQuery('.body-font-size').val(value);
    });
    jQuery('.body-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyp.letter = inputValue;
            sendData();
            jQuery('.body-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.body-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.body-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyp.letter = value;
        sendData();
        jQuery('.body-letter-spacing').val(value);
    });
    jQuery('.body-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyp.line = inputValue;
            sendData();
            jQuery('.body-line-height-number').val(inputValue);
        }, 12);
        jQuery('.body-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.body-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyp.line = value;
        sendData();
        jQuery('.body-line-height').val(value);
    });
    jQuery('.typography-h1').on('click', function(){
        var size = params[view].bodyh1.size,
            line = params[view].bodyh1.line,
            letter = checkLetter(params[view].bodyh1.letter),
            align = params[view].bodyh1.align;
        jQuery('.h1-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.h1-letter-spacing').val(letter);
        jQuery('.h1-letter-spacing-number').val(letter);
        jQuery('.h1-font-size').val(size);
        jQuery('.h1-font-size-number').val(size);
        jQuery('.h1-line-height').val(line);
        jQuery('.h1-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-h1-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h1').show().addClass('ba-active-options');
    });
    jQuery('.h1-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].bodyh1.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.h1-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh1.size = inputValue;
            sendData();
            jQuery('.h1-font-size-number').val(inputValue);
        }, 12);
        jQuery('.h1-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h1-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh1.size = value;
        sendData();
        jQuery('.h1-font-size').val(value);
    });
    jQuery('.h1-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh1.letter = inputValue;
            sendData();
            jQuery('.h1-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.h1-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h1-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh1.letter = value;
        sendData();
        jQuery('.h1-letter-spacing').val(value);
    });
    jQuery('.h1-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh1.line = inputValue;
            sendData();
            jQuery('.h1-line-height-number').val(inputValue);
        }, 12);
        jQuery('.h1-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h1-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh1.line = value;
        sendData();
        jQuery('.h1-line-height').val(value);
    });
    jQuery('.typography-h2').on('click', function(){
        var size = params[view].bodyh2.size,
            line = params[view].bodyh2.line,
            letter = checkLetter(params[view].bodyh2.letter),
            align = params[view].bodyh2.align;
        jQuery('.h2-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.h2-font-size').val(size);
        jQuery('.h2-font-size-number').val(size);
        jQuery('.h2-letter-spacing').val(letter);
        jQuery('.h2-letter-spacing-number').val(letter);
        jQuery('.h2-line-height').val(line);
        jQuery('.h2-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-h2-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h2').show().addClass('ba-active-options');
    });
    jQuery('.h2-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].bodyh2.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.h2-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh2.size = inputValue;
            sendData();
            jQuery('.h2-font-size-number').val(inputValue);
        }, 12);
        jQuery('.h2-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h2-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh2.size = value;
        sendData();
        jQuery('.h2-font-size').val(value);
    });
    jQuery('.h2-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh2.letter = inputValue;
            sendData();
            jQuery('.h2-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.h2-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h2-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh2.letter = value;
        sendData();
        jQuery('.h2-letter-spacing').val(value);
    });
    jQuery('.h2-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh2.line = inputValue;
            sendData();
            jQuery('.h2-line-height-number').val(inputValue);
        }, 12);
        jQuery('.h2-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h2-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh2.line = value;
        sendData();
        jQuery('.h2-line-height').val(value);
    });
    jQuery('.typography-h3').on('click', function(){
        var size = params[view].bodyh3.size,
            line = params[view].bodyh3.line,
            letter = checkLetter(params[view].bodyh3.letter),
            align = params[view].bodyh3.align;
        jQuery('.h3-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.h3-font-size').val(size);
        jQuery('.h3-font-size-number').val(size);
        jQuery('.h3-letter-spacing').val(letter);
        jQuery('.h3-letter-spacing-number').val(letter);
        jQuery('.h3-line-height').val(line);
        jQuery('.h3-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-h3-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h3').show().addClass('ba-active-options');
    });
    jQuery('.h3-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].bodyh3.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.h3-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh3.size = inputValue;
            sendData();
            jQuery('.h3-font-size-number').val(inputValue);
        }, 12);
        jQuery('.h3-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h3-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh3.size = value;
        sendData();
        jQuery('.h3-font-size').val(value);
    });
    jQuery('.h3-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh3.letter = inputValue;
            sendData();
            jQuery('.h3-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.h3-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h3-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh3.letter = value;
        sendData();
        jQuery('.h3-letter-spacing').val(value);
    });
    jQuery('.h3-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh3.line = inputValue;
            sendData();
            jQuery('.h3-line-height-number').val(inputValue);
        }, 12);
        jQuery('.h3-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h3-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh3.line = value;
        sendData();
        jQuery('.h3-line-height').val(value);
    });
    jQuery('.typography-h4').on('click', function(){
        var size = params[view].bodyh4.size,
            line = params[view].bodyh4.line,
            letter = checkLetter(params[view].bodyh4.letter),
            align = params[view].bodyh4.align;
        jQuery('.h4-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.h4-letter-spacing').val(letter);
        jQuery('.h4-letter-spacing-number').val(letter);
        jQuery('.h4-font-size').val(size);
        jQuery('.h4-font-size-number').val(size);
        jQuery('.h4-line-height').val(line);
        jQuery('.h4-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-h4-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h4').show().addClass('ba-active-options');
    });
    jQuery('.h4-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].bodyh4.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.h4-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh4.size = inputValue;
            sendData();
            jQuery('.h4-font-size-number').val(inputValue);
        }, 12);
        jQuery('.h4-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h4-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh4.size = value;
        sendData();
        jQuery('.h4-font-size').val(value);
    });
    jQuery('.h4-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh4.letter = inputValue;
            sendData();
            jQuery('.h4-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.h4-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h4-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh4.letter = value;
        sendData();
        jQuery('.h4-letter-spacing').val(value);
    });
    jQuery('.h4-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh4.line = inputValue;
            sendData();
            jQuery('.h4-line-height-number').val(inputValue);
        }, 12);
        jQuery('.h4-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h4-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh4.line = value;
        sendData();
        jQuery('.h4-line-height').val(value);
    });
    jQuery('.typography-h5').on('click', function(){
        var size = params[view].bodyh5.size,
            line = params[view].bodyh5.line,
            letter = checkLetter(params[view].bodyh5.letter),
            align = params[view].bodyh5.align;
        jQuery('.h5-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.h5-font-size').val(size);
        jQuery('.h5-font-size-number').val(size);
        jQuery('.h5-letter-spacing').val(letter);
        jQuery('.h5-letter-spacing-number').val(letter);
        jQuery('.h5-line-height').val(line);
        jQuery('.h5-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-h5-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h5').show().addClass('ba-active-options');
    });
    jQuery('.h5-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].bodyh5.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.h5-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh5.size = inputValue;
            sendData();
            jQuery('.h5-font-size-number').val(inputValue);
        }, 12);
        jQuery('.h5-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h5-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh5.size = value;
        sendData();
        jQuery('.h5-font-size').val(value);
    });
    jQuery('.h5-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh5.letter = inputValue;
            sendData();
            jQuery('.h5-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.h5-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h5-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh5.letter = value;
        sendData();
        jQuery('.h5-letter-spacing').val(value);
    });
    jQuery('.h5-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh5.line = inputValue;
            sendData();
            jQuery('.h5-line-height-number').val(inputValue);
        }, 12);
        jQuery('.h5-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h5-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh5.line = value;
        sendData();
        jQuery('.h5-line-height').val(value);
    });
    jQuery('.typography-h6').on('click', function(){
        var size = params[view].bodyh6.size,
            line = params[view].bodyh6.line,
            letter = checkLetter(params[view].bodyh6.letter),
            align = params[view].bodyh6.align;
        jQuery('.h6-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.h6-letter-spacing').val(letter);
        jQuery('.h6-letter-spacing-number').val(letter);
        jQuery('.h6-font-size').val(size);
        jQuery('.h6-font-size-number').val(size);
        jQuery('.h6-line-height').val(line);
        jQuery('.h6-line-height-number').val(line);
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-h6-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h6').show().addClass('ba-active-options');
    });
    jQuery('.h6-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].bodyh6.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.h6-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh6.size = inputValue;
            sendData();
            jQuery('.h6-font-size-number').val(inputValue);
        }, 12);
        jQuery('.h6-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h6-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh6.size = value;
        sendData();
        jQuery('.h6-font-size').val(value);
    });
    jQuery('.h6-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh6.letter = inputValue;
            sendData();
            jQuery('.h6-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.h6-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h6-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh6.letter = value;
        sendData();
        jQuery('.h6-letter-spacing').val(value);
    });
    jQuery('.h6-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].bodyh6.line = inputValue;
            sendData();
            jQuery('.h6-line-height-number').val(inputValue);
        }, 12);
        jQuery('.h6-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.h6-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].bodyh6.line = value;
        sendData();
        jQuery('.h6-line-height').val(value);
    });
    jQuery('.nav-typography').on('click', function(){
        jQuery('.global-configuration .ba-fade').removeClass('ba-fade');
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-typography-options').addClass('ba-in');
        jQuery(this).find(' ~ a').hide();
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography').show().addClass('ba-active-options');
    });
    jQuery('.footer-options').on('click', function(){
        jQuery('.ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.ba-footer-options').addClass('ba-in');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-footer').show().addClass('ba-active-options');
    });
    jQuery('.nav-footer').on('click', function(){
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.global-configuration .ba-fade').removeClass('ba-fade');
        jQuery('.ba-footer-options').addClass('ba-in');
        jQuery(this).find(' ~ a').hide();
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-footer').show().addClass('ba-active-options');
    });
    jQuery('.footer-typography').on('click', function(){
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.footer-typography-options').addClass('ba-in');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-footer-typography').show().addClass('ba-active-options');
    });
    jQuery('.nav-footer-typography').on('click', function(){
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.global-configuration .ba-fade').removeClass('ba-fade');
        jQuery('.footer-typography-options').addClass('ba-in');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery(this).find(' ~ a').hide();
        jQuery('.global-nav .nav-footer-typography').addClass('ba-active-options');
    });
    jQuery('.footer-typography-p').on('click', function(){
        var size = params[view].footerp.size,
            line = params[view].footerp.line,
            letter = checkLetter(params[view].footerp.letter),
            align = params[view].footerp.align;
        jQuery('.footer-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.footer-font-size').val(size);
        jQuery('.footer-font-size-number').val(size);
        jQuery('.footer-letter-spacing').val(letter);
        jQuery('.footer-letter-spacing-number').val(letter);
        jQuery('.footer-line-height').val(line);
        jQuery('.footer-line-height-number').val(line);
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.footer-typography-p-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-body').show().addClass('ba-active-options');
    });
    jQuery('.footer-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].footerp.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.footer-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerp.size = inputValue;
            sendData();
            jQuery('.footer-font-size-number').val(inputValue);
        }, 12);
        jQuery('.footer-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerp.size = value;
        sendData();
        jQuery('.footer-font-size').val(value);
    });
    jQuery('.footer-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerp.letter = inputValue;
            sendData();
            jQuery('.footer-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.footer-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerp.letter = value;
        sendData();
        jQuery('.footer-letter-spacing').val(value);
    });
    jQuery('.footer-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerp.line = inputValue;
            sendData();
            jQuery('.footer-line-height-number').val(inputValue);
        }, 12);
        jQuery('.footer-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerp.line = value;
        sendData();
        jQuery('.footer-line-height').val(value);
    });
    jQuery('.footer-typography-h1').on('click', function(){
        var size = params[view].footerh1.size,
            line = params[view].footerh1.line,
            letter = checkLetter(params[view].footerh1.letter),
            align = params[view].footerh1.align;
        jQuery('.footer-h1-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.footer-h1-font-size').val(size);
        jQuery('.footer-h1-font-size-number').val(size);
        jQuery('.footer-h1-letter-spacing').val(letter);
        jQuery('.footer-h1-letter-spacing-number').val(letter);
        jQuery('.footer-h1-line-height').val(line);
        jQuery('.footer-h1-line-height-number').val(line);
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.footer-typography-h1-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h1').show().addClass('ba-active-options');
    });
    jQuery('.footer-h1-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].footerh1.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.footer-h1-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh1.size = inputValue;
            sendData();
            jQuery('.footer-h1-font-size-number').val(inputValue);
        }, 12);
        jQuery('.footer-h1-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h1-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh1.size = value;
        sendData();
        jQuery('.footer-h1-font-size').val(value);
    });
    jQuery('.footer-h1-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh1.letter = inputValue;
            sendData();
            jQuery('.footer-h1-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.footer-h1-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h1-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh1.letter = value;
        sendData();
        jQuery('.footer-h1-letter-spacing').val(value);
    });
    jQuery('.footer-h1-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh1.line = inputValue;
            sendData();
            jQuery('.footer-h1-line-height-number').val(inputValue);
        }, 12);
        jQuery('.footer-h1-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h1-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh1.line = value;
        sendData();
        jQuery('.footer-h1-line-height').val(value);
    });
    jQuery('.footer-typography-h2').on('click', function(){
        var size = params[view].footerh2.size,
            line = params[view].footerh2.line,
            letter = checkLetter(params[view].footerh2.letter),
            align = params[view].footerh2.align;
        jQuery('.footer-h2-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.footer-h2-font-size').val(size);
        jQuery('.footer-h2-font-size-number').val(size);
        jQuery('.footer-h2-letter-spacing').val(letter);
        jQuery('.footer-h2-letter-spacing-number').val(letter);
        jQuery('.footer-h2-line-height').val(line);
        jQuery('.footer-h2-line-height-number').val(line);
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.footer-typography-h2-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h2').show().addClass('ba-active-options');
    });
    jQuery('.footer-h2-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].footerh2.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.footer-h2-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh2.size = inputValue;
            sendData();
            jQuery('.footer-h2-font-size-number').val(inputValue);
        }, 12);
        jQuery('.footer-h2-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h2-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh2.size = value;
        sendData();
        jQuery('.footer-h2-font-size').val(value);
    });
    jQuery('.footer-h2-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh2.letter = inputValue;
            sendData();
            jQuery('.footer-h2-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.footer-h2-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h2-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh2.letter = value;
        sendData();
        jQuery('.footer-h2-letter-spacing').val(value);
    });
    jQuery('.footer-h2-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh2.line = inputValue;
            sendData();
            jQuery('.footer-h2-line-height-number').val(inputValue);
        }, 12);
        jQuery('.footer-h2-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h2-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh2.line = value;
        sendData();
        jQuery('.footer-h2-line-height').val(value);
    });
    jQuery('.footer-typography-h3').on('click', function(){
        var size = params[view].footerh3.size,
            line = params[view].footerh3.line,
            letter = checkLetter(params[view].footerh3.letter),
            align = params[view].footerh3.align;
        jQuery('.footer-h3-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.footer-h3-font-size').val(size);
        jQuery('.footer-h3-font-size-number').val(size);
        jQuery('.footer-h3-letter-spacing').val(letter);
        jQuery('.footer-h3-letter-spacing-number').val(letter);
        jQuery('.footer-h3-line-height').val(line);
        jQuery('.footer-h3-line-height-number').val(line);
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.footer-typography-h3-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h3').show().addClass('ba-active-options');
    });
    jQuery('.footer-h3-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].footerh3.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.footer-h3-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh3.size = inputValue;
            sendData();
            jQuery('.footer-h3-font-size-number').val(inputValue);
        }, 12);
        jQuery('.footer-h3-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h3-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh3.size = value;
        sendData();
        jQuery('.footer-h3-font-size').val(value);
    });
    jQuery('.footer-h3-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh3.letter = inputValue;
            sendData();
            jQuery('.footer-h3-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.footer-h3-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h3-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh3.letter = value;
        sendData();
        jQuery('.footer-h3-letter-spacing').val(value);
    });
    jQuery('.footer-h3-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh3.line = inputValue;
            sendData();
            jQuery('.footer-h3-line-height-number').val(inputValue);
        }, 12);
        jQuery('.footer-h3-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h3-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh3.line = value;
        sendData();
        jQuery('.footer-h3-line-height').val(value);
    });
    jQuery('.footer-typography-h4').on('click', function(){
        var size = params[view].footerh4.size,
            line = params[view].footerh4.line,
            letter = checkLetter(params[view].footerh4.letter),
            align = params[view].footerh4.align;
        jQuery('.footer-h4-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.footer-h4-font-size').val(size);
        jQuery('.footer-h4-font-size-number').val(size);
        jQuery('.footer-h4-letter-spacing').val(letter);
        jQuery('.footer-h4-letter-spacing-number').val(letter);
        jQuery('.footer-h4-line-height').val(line);
        jQuery('.footer-h4-line-height-number').val(line);
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.footer-typography-h4-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h4').show().addClass('ba-active-options');
    });
    jQuery('.footer-h4-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].footerh4.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.footer-h4-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh4.size = inputValue;
            sendData();
            jQuery('.footer-h4-font-size-number').val(inputValue);
        }, 12);
        jQuery('.footer-h4-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h4-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh4.size = value;
        sendData();
        jQuery('.footer-h4-font-size').val(value);
    });
    jQuery('.footer-h4-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh4.letter = inputValue;
            sendData();
            jQuery('.footer-h4-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.footer-h4-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h4-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh4.letter = value;
        sendData();
        jQuery('.footer-h4-letter-spacing').val(value);
    });
    jQuery('.footer-h4-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh4.line = inputValue;
            sendData();
            jQuery('.footer-h4-line-height-number').val(inputValue);
        }, 12);
        jQuery('.footer-h4-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h4-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh4.line = value;
        sendData();
        jQuery('.footer-h4-line-height').val(value);
    });
    jQuery('.footer-typography-h5').on('click', function(){
        var size = params[view].footerh5.size,
            line = params[view].footerh5.line,
            letter = checkLetter(params[view].footerh5.letter),
            align = params[view].footerh5.align;
        jQuery('.footer-h5-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.footer-h5-font-size').val(size);
        jQuery('.footer-h5-font-size-number').val(size);
        jQuery('.footer-h5-letter-spacing').val(letter);
        jQuery('.footer-h5-letter-spacing-number').val(letter);
        jQuery('.footer-h5-line-height').val(line);
        jQuery('.footer-h5-line-height-number').val(line);
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.footer-typography-h5-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h5').show().addClass('ba-active-options');
    });
    jQuery('.footer-h5-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].footerh5.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.footer-h5-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh5.size = inputValue;
            sendData();
            jQuery('.footer-h5-font-size-number').val(inputValue);
        }, 12);
        jQuery('.footer-h5-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h5-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh5.size = value;
        sendData();
        jQuery('.footer-h5-font-size').val(value);
    });
    jQuery('.footer-h5-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh5.letter = inputValue;
            sendData();
            jQuery('.footer-h5-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.footer-h5-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h5-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh5.letter = value;
        sendData();
        jQuery('.footer-h5-letter-spacing').val(value);
    });
    jQuery('.footer-h5-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh5.line = inputValue;
            sendData();
            jQuery('.footer-h5-line-height-number').val(inputValue);
        }, 12);
        jQuery('.footer-h5-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h5-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh5.line = value;
        sendData();
        jQuery('.footer-h5-line-height').val(value);
    });
    jQuery('.footer-typography-h6').on('click', function(){
        var size = params[view].footerh6.size,
            line = params[view].footerh6.line,
            letter = checkLetter(params[view].footerh6.letter),
            align = params[view].footerh6.align;
        jQuery('.footer-h6-text-align').each(function(){
            if (jQuery(this).val() == align) {
                jQuery(this).closest('label').addClass('active');
            } else {
                jQuery(this).closest('label').removeClass('active');
            }
        });
        jQuery('.footer-h6-font-size').val(size);
        jQuery('.footer-h6-font-size-number').val(size);
        jQuery('.footer-h6-letter-spacing').val(letter);
        jQuery('.footer-h6-letter-spacing-number').val(letter);
        jQuery('.footer-h6-line-height').val(line);
        jQuery('.footer-h6-line-height-number').val(line);
        jQuery('.global-configuration .ba-in').removeClass('ba-in').addClass('ba-out');
        jQuery('.footer-typography-h6-options').addClass('ba-fade');
        jQuery('.ba-active-options').removeClass('ba-active-options');
        jQuery('.global-nav .nav-typography-h6').show().addClass('ba-active-options');
    });
    jQuery('.footer-h6-text-align').on('click', function(){
        var value = jQuery(this).val();
        params[view].footerh6.align = value;
        sendData();
        jQuery(this).closest('.btn-alignment-options').find('.active').removeClass('active');
        jQuery(this).closest('label').addClass('active');
    });
    jQuery('.footer-h6-font-size').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh6.size = inputValue;
            sendData();
            jQuery('.footer-h6-font-size-number').val(inputValue);
        }, 12);
        jQuery('.footer-h6-font-size').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h6-font-size-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh6.size = value;
        sendData();
        jQuery('.footer-h6-font-size').val(value);
    });
    jQuery('.footer-h6-letter-spacing').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh6.letter = inputValue;
            sendData();
            jQuery('.footer-h6-letter-spacing-number').val(inputValue);
        }, 12);
        jQuery('.footer-h6-letter-spacing').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h6-letter-spacing-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh6.letter = value;
        sendData();
        jQuery('.footer-h6-letter-spacing').val(value);
    });
    jQuery('.footer-h6-line-height').on('mousedown', function(){
        var input = jQuery(this),
            inputValue = '';
        var interval = setInterval(function(){
            inputValue = input.val();
            params[view].footerh6.line = inputValue;
            sendData();
            jQuery('.footer-h6-line-height-number').val(inputValue);
        }, 12);
        jQuery('.footer-h6-line-height').on('mouseup', function(){
            clearInterval(interval);
        });
    });
    jQuery('.footer-h6-line-height-number').on('click keyup', function(){
        var value = jQuery(this).val();
        params[view].footerh6.line = value;
        sendData();
        jQuery('.footer-h6-line-height').val(value);
    });
});