/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQuery(document).ready(function(){
    
    var selectMode = '';
    checkMode();
    
    function listener(event) {
        if (event.origin != 'https://www.youtube.com') {
            selectMode = event.data;
        }
    }
    
    if (window.addEventListener) {
        window.addEventListener("message", function(event){
            listener(event);
        });
    }
    jQuery('#show-upload').on('click', function(){
        var target = jQuery('#upload-control');
        if (target.prop('style').cssText != '') {
            target.removeAttr('style');
            jQuery('#folder-control').hide();
        } else {
            target.attr('style', 'display:none');
        }
    });
    jQuery('#show-folder').on('click', function(){
        var target = jQuery('#folder-control');
        if (target.prop('style').cssText != '') {
            target.removeAttr('style');
            jQuery('#upload-control').hide();
        } else {
            target.attr('style', 'display:none');
        }
    });
    jQuery('#add-folder-action').on('click', function(){
        var task = '&task=uploader.addfolder';
        var form = jQuery('#adminForm');
        var action = form.attr('action');
        action = action+task;
        form.attr('action', action);
        form.submit();
    });
    jQuery('#delete-action').on('click', function(){
        var task = '&task=uploader.delete';
        var form = jQuery('#adminForm');
        var action = form.attr('action');
        action = action+task;
        form.attr('action', action);
        form.submit();
    });
    jQuery('#upload-action').on('click', function(){
        var task = '&task=uploader.upload';
        var form = jQuery('#adminForm');
        var action = form.attr('action');
        action = action+task;
        form.attr('action', action);
        form.submit();
    });
    jQuery('.ba-images').each(function(){
        jQuery(this).find('td').each(function(){
            var value = jQuery(this).find('.select-item').val();
            if (!value) {
                jQuery(this).on('click', function(){
                    checkMode();
                    if (!selectMode) {
                        jQuery('.select-item').removeAttr('checked');
                    }
                    if (jQuery(this).parent().find('.select-item').prop('checked')) {
                        jQuery(this).parent().find('.select-item').removeAttr('checked');
                    } else {
                        jQuery(this).parent().find('.select-item').attr('checked', true);
                    }
                });
            }
        });
        jQuery(this).find('.ba-preview').on('click', function(){
            checkMode();
            if (!selectMode) {
                jQuery('.select-item').removeAttr('checked');
            }
            if (jQuery(this).parent().find('.select-item').prop('checked')) {
                jQuery(this).parent().find('.select-item').removeAttr('checked');
            } else {
                jQuery(this).parent().find('.select-item').attr('checked', true);
            }
        });
    });
    jQuery('.select-item').on('click', function(){
        checkMode();
        if (!selectMode) {
            if (jQuery(this).prop('checked')) {
                var flag = true;
            } else {
                var flag = false;
            }
            jQuery('.select-item').removeAttr('checked');
            if (flag) {
                jQuery(this).attr('checked', true);
            }
        }
    });
    
    function checkMode()
    {
        var parentDisplay = window.parent.document.getElementById('slides-upload-modal').style.display,
            caption = window.parent.document.getElementById('slides-caption-modal').style.display,
            parentShow = window.parent.document.getElementsByClassName('slideset-slides-options')[0];
        if ((parentDisplay != 'none' || jQuery(parentShow).hasClass('ba-fade')) && caption == 'none') {
            selectMode = 'ba_slides';
        } else {
            selectMode = '';
        }
    }
    
    function sendMessage()
    {
        var msg = [];
        jQuery('.select-item').each(function(){
            if (jQuery(this).prop('checked')) {
                var value = jQuery(this).parent().find('.ba-obj').val();
                if (value) {
                    var item = {};
                    value = value.split('|||');
                    for(var i = 0; i<value.length ; i++) {
                        if (value[i] != '') {
                            var val = value[i].split('-_-');
                            item[val[0]] = val[1];
                        }
                    }
                }
                if (!selectMode) {
                    msg = item.url;
                    return false;
                } else {
                    msg.push(item.url);
                }
            }
        });
        selectMode = '';
        window.parent.postMessage(msg, "*");
    }
    
    jQuery('#ba-apply').on('click', function(){
        sendMessage();
    });
    
    jQuery('#ba-close').on('click', function(){
        var msg = '';
        window.parent.postMessage(msg, "*");
    });
}); 
