<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla controllerform library
jimport('joomla.application.component.controllerform');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class bagridControllerUploader extends JControllerForm
{
    
    public function addFolder()
    {
        $location = $this->getDir();
        $dir = $location[0];
        $redirect = $location[1];
        $input = JFactory::getApplication()->input;
        $nfolder = $input->get('new-folder', '', 'string');
        if ($nfolder != '') {
            if (JFolder::create($dir.'/'.$nfolder)) {
                $this->setRedirect($redirect, JText::_('FOLDER_IS_CREATED'));
                return true;
            } else {
                $this->setRedirect($redirect, JText::_('UNABLE_TO_CREATE_DIRECTORY'), 'error');
                return false;
            }
        } else {
            $this->setRedirect($redirect, JText::_('UNABLE_TO_CREATE_DIRECTORY'), 'error');
            return false;
        }
    }
    
    public function getDir()
    {
        $redirect = 'index.php?option=com_bagrid&view=uploader&tmpl=component';
        $dir = JPATH_ROOT. '/images';
        $input = JFactory::getApplication()->input;
        $folder = $input->get('current-dir', '', 'string');
        $layout = $input->get('layout', '', 'string');
        if (!empty($folder)) {
            $dir = $folder;
            $redirect .= '&folder=' .$dir;
        }
        if (!empty($layout)) {
            $redirect .= '&layout=' .$layout;
        }
        $array = array ($dir, $redirect);
        return $array;
        
    }
    
    public function delete()
    {
        $location = $this->getDir();
        $dir = $location[0];
        $redirect = $location[1];
        $input = JFactory::getApplication()->input;
        $items = $input->get('ba-rm', '', 'array');
        foreach ($items as $item) {
            if ($item != '') {
                if (JFolder::exists($dir. '/' .$item)) {
                    if(!JFolder::delete($dir. '/' .$item)) {
                        $this->setRedirect($redirect, JText::_('DELETE_FOLDER_ERROR'), 'error');
                        return false;
                    }
                }
                if (JFile::exists($dir. '/' .$item)) {
                    if(!JFile::delete($dir. '/' .$item)){
                        $this->setRedirect($redirect, JText::_('DELETE_FILE_ERROR'), 'error');
                        return false;
                    }
                }
            }
        }
        $this->setRedirect($redirect, JText::_('SUCCESS_DELETE'));
        return true;
    }
    
    public function upload()
    {
        $location = $this->getDir();
        $dir = $location[0];
        $redirect = $location[1];
        $model = $this->getModel();
        $input = JFactory::getApplication()->input;
        $items = $input->files->get('ba-files', '', 'array');
        foreach($items as $item) {
            $ext = strtolower(JFile::getExt($item['name']));
            $flag = $model->checkExt($ext);
            if ($flag) {
                $name = $dir. '/' .$item['name'];
                if(!JFile::upload( $item['tmp_name'], $name)) {
                    $this->setRedirect($redirect, JText::_('UPLOAD_ERROR'), 'error');
                    return false;
                }
            } else {
                $this->setRedirect($redirect, JText::_('UNABLE_TO_UPLOAD_FILE'), 'error');
                return false;
            }
        }
        $this->setRedirect($redirect, JText::_('SUCCESS_UPLOAD'));
        return true;
    }

    public function showImage()
    {
        $dir = $_GET['image'];
        $ext = strtolower(JFile::getExt($dir));
        $target = $_GET['target'];
        $imageCreate = $this->imageCreate($ext);
        $imageSave = $this->imageSave($ext);
        Header("Content-type: image/".$ext);
        $offset = 60 * 60 * 24 * 90;
        $ExpStr = "Expires: " . gmdate("D, d M Y H:i:s", time() + $offset) . " GMT";
        header($ExpStr);
         if (!$im = $imageCreate($dir)) {
            $f = fopen($dir, "r");
            fpassthru($f);
            fclose($f);
        } else {
            $width = imagesx($im);
            $height = imagesy($im);
            $ratio = $width / $height;
            if ($width > $height) {
                $w = $target;
                $h = $target / $ratio;
            } else {
                $h = $target;
                $w = $target * $ratio;
            }
            $out = imagecreatetruecolor($w, $h);
            if ($ext == 'png') {
                imagealphablending($out, false);
                imagesavealpha($out, true);
                $transparent = imagecolorallocatealpha($out, 255, 255, 255, 127);
                imagefilledrectangle($out, 0, 0, $w, $h, $transparent);
            }
            imagecopyresampled($out, $im, 0, 0, 0, 0, $w, $h, $width, $height);
            $imageSave($out);
            imagedestroy($im);
            imagedestroy($out);
        }
        exit;
    }

    public function imageSave($type) {
        switch ($type) {
            case 'jpeg':
                $imageSave = 'imagejpeg';
                break;

            case 'png':
                $imageSave = 'imagepng';
                break;

            case 'bmp':
                $imageSave = 'imagebmp';
                break;

            case 'gif':
                $imageSave = 'imagegif';
                break;

            case 'vnd.wap.wbmp':
                $imageSave = 'imagewbmp';
                break;

            case 'xbm':
                $imageSave = 'imagexbm';
                break;

            default:
                $imageSave = 'imagejpeg';
        }

        return $imageSave;
    }

    public function imageCreate($type) {
        switch ($type) {
            case 'jpeg':
            case 'jpg':
                $imageCreate = 'imagecreatefromjpeg';
                break;

            case 'png':
                $imageCreate = 'imagecreatefrompng';
                break;

            case 'bmp':
                $imageCreate = 'imagecreatefrombmp';
                break;

            case 'gif':
                $imageCreate = 'imagecreatefromgif';
                break;

            case 'vnd.wap.wbmp':
                $imageCreate = 'imagecreatefromwbmp';
                break;

            case 'xbm':
                $imageCreate = 'imagecreatefromxbm';
                break;

            default:
                $imageCreate = 'imagecreatefromjpeg';
        }
        return $imageCreate;
    }
}