<?php
/**
* @package   BaGridbox
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');
use Joomla\Registry\Registry;

abstract class bagridHelper
{

    public static function getMapsKey()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('`key`')
            ->from('`#__bagrid_api`')
            ->where('`service` = '.$db->quote('google_maps'));
        $db->setQuery($query);
        $key = $db->loadResult();
        return $key;
    }

    public static function getPageNavigation($id, $categories)
    {
        $items = array();
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('`created`')
            ->from('#__bagrid_bagrids')
            ->where('`id` = '. $id);
        $db->setQuery($query);
        $date = $db->loadResult();
        $now = JFactory::getDate();
        $nowDate = $db->quote($now->toSql());
        if (empty($categories)) {
            $query = $db->getQuery(true)
                ->select('id, title, intro_image, created')
                ->from('#__bagrid_bagrids')
                ->where('`created` <= ' .$db->Quote($date))
                ->where('`created` <= ' .$nowDate)
                ->where('`id` <> ' .$id)
                ->order('created DESC');
            $db->setQuery($query, 0, 1);
            $prev = $db->loadObject();
            $query = $db->getQuery(true)
                ->select('id, title, intro_image, created')
                ->from('#__bagrid_bagrids')
                ->where('`created` >= ' .$db->Quote($date))
                ->where('`created` <= ' .$nowDate)
                ->where('`id` <> ' .$id)
                ->order('created DESC');
            $db->setQuery($query, 0, 1);
            $next = $db->loadObject();
            $items['prev'] = $prev;
            $items['next'] = $next;
        } else {
            $categories = explode(',', $categories);
            $prev = array();
            $next = array();
            foreach ($categories as $category) {
                $query = $db->getQuery(true)
                    ->select('id, title, intro_image, created')
                    ->from('#__bagrid_bagrids')
                    ->where('`created` <= ' .$db->Quote($date))
                    ->where('`created` <= ' .$nowDate)
                    ->where('`page_category` = '. $category)
                    ->where('`id` <> ' .$id)
                    ->order('created DESC');
                $db->setQuery($query, 0, 1);
                $prev[] = $db->loadObject();
                $query = $db->getQuery(true)
                    ->select('id, title, intro_image, created')
                    ->from('#__bagrid_bagrids')
                    ->where('`created` >= ' .$db->Quote($date))
                    ->where('`created` <= ' .$nowDate)
                    ->where('`page_category` = '. $category)
                    ->where('`id` <> ' .$id)
                    ->order('created DESC');
                $db->setQuery($query, 0, 1);
                $next[] = $db->loadObject();
            }
            usort($next, function($a , $b){
                if (strtotime($a->created) == strtotime($b->created)) {
                    return 0;
                }
                return (strtotime($a->created) < strtotime($b->created)) ? -1 : 1;
            });
            usort($prev, function($a , $b){
                if (strtotime($a->created) == strtotime($b->created)) {
                    return 0;
                }
                return (strtotime($a->created) > strtotime($b->created)) ? -1 : 1;
            });
            $items['prev'] = $prev[0];
            $items['next'] = $next[0];
        }
        
        
        return $items;
    }

    public static function getBlog($body)
    {
        $regex = '/\[blog options=+(.*?)\]/i';
        preg_match_all($regex, $body, $blogs, PREG_SET_ORDER);
        $regex = '/\[blog-paginator\]/i';
        preg_match_all($regex, $body, $paginator, PREG_SET_ORDER);
        foreach ($blogs as $key => $blog) {
            $options = explode(';', $blog[1]);
            $start = 0;
            $limit = $options[1];
            if (isset($_POST['ba_blog_page'])) {
                $page = $_POST['ba_blog_page'];
                $start = $page * $limit;
                $limit = $start + $limit * 1;
            }
            $items = self::getBlogPosts($options[0], $start, $limit);
            $post = '';
            foreach ($items as $item) {
                $url = 'index.php?view=page&id='.$item->id;
                if (!empty($item->page_category)) {
                    $item->category = self::getCategoryTitle($item->page_category);
                    $url .= '&category='.$item->page_category;
                } else {
                    $item->category = '';
                }
                $url = JRoute::_($url);
                $post .= '<div class="ba-blog-item"><div class="ba-blog-post"';
                    if ($options[12] == 'cover' && !empty($item->intro_image) && $options[3] == 1) {
                        $post .= ' style="background-image: url('.$item->intro_image.');';
                    }
                    $post .= '">';
                    if (!empty($item->intro_image) && $options[3] == 1 && $options[12] != 'cover') {
                        $post .= '<div class="ba-blog-image"';
                        if ($options[12] != 'masonry') {
                            $post .= ' style="background-image: url(';
                            $post .= $item->intro_image.'); height: '.$options[11];
                            $post .= 'px;"';
                        }
                        $post .= '>';
                        if ($options[12] == 'masonry') {
                            $post .= '<img src="'.$item->intro_image.'" alt="'.$item->image_alt.'">';
                        }
                        $post .= '<a href="'.$url.'"></a></div>';
                    }
                    $post .= '<div class="ba-blog-content">';
                    if ($options[4] == 1) {
                        $post .= '<h2 class="ba-blog-title">';
                        $post .= '<a href="'.$url.'">';
                        $post .= $item->title.'</a></h2>';
                    }
                    if ($options[5] == 1) {
                        $post .= '<div class="ba-blog-info">';
                        $post .= '<p class="ba-blog-data">';
                        $post .= $item->date.'</p>';
                        if (!empty($item->category)) {
                            $post .= '<p class="ba-blog-category">';
                            $post .= $item->category.'</p>';
                        }
                        $post .= '</div></div>';
                    }
                    if (!empty($item->intro_text) && $options[6] == 1) {
                        $post .= '<p class="ba-blog-intro-text">'.$item->intro_text.'</p>';
                    }
                    if ($options[7] == 1) {
                        $post .= '<div class="ba-blog-btn"><a href="'.$url;
                        $post .= '" class="ba-btn-transition">'.$options[8].'</a></div>';
                    }
                    $post .= '</div></div>';
            }
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $date = JFactory::getDate();
            $nowDate = $db->quote($date->toSql());
            $query->select('COUNT(*)')
                ->from('#__bagrid_bagrids')
                ->where('`published` = 1')
                ->where('`created` <= ' .$nowDate);
            if ($options[0] > 0 ) {
                $query->where('`page_category` = ' . $category);
            }
            $db->setQuery($query);
            $result = $db->loadResult();
            $pages = ceil($result / $options[1]);
            $pagination = '';
            if ($pages > 1) {
                $input = JFactory::getApplication()->input;
                $id = $input->get('id');
                $url = JRoute::_('index.php?view=page&id='.$id);
                $pagination = '<form action="'.$url.'" method="post">';
                $pagination .= '<input type="hidden" name="ba_blog_page">';
                if (isset($page) && $options[2] == 'standard') {
                    $prev = $page - 1;
                    $pagination .= '<a class="newer-posts" data-page="'.$prev.'">';
                    $pagination .= $options[9].'</a>';
                    if ($page < $pages) {
                        $next = $page * 1 + 1;
                        $pagination .= '<a class="older-posts" data-page="'.$next;
                        $pagination .= '">'.$options[10].'</a>';
                    }
                } else {
                    if ($options[2] == 'standard') {
                        $pagination .= '<a class="older-posts" data-page="1">'.$options[10].'</a>';
                    } else {
                        $pagination .= '<a class="load-posts" data-page="1">'.$options[10].'</a>';
                    }
                }
                $pagination .= '</form>';
                if ($options[2] != 'standard') {
                    $items = self::getBlogPosts($options[0], $limit, $result);
                    foreach ($items as $item) {
                        $url = 'index.php?view=page&id='.$item->id;
                        if (!empty($item->page_category)) {
                            $item->category = self::getCategoryTitle($item->page_category);
                            $url .= '&category='.$item->page_category;
                        } else {
                            $item->category = '';
                        }
                        $url = JRoute::_($url);
                        $post .= '<div class="ba-blog-item hidden-post"><div class="ba-blog-post"';
                            $post .= '">';
                            if (!empty($item->intro_image) && $options[3] == 1 && $options[12] != 'cover') {
                                $post .= '<div class="ba-blog-image"';
                                if ($options[12] != 'masonry') {
                                    $post .= ' style="height: '.$options[11];
                                    $post .= 'px;"';
                                }
                                $post .= '>';
                                $post .= '<a href="'.$url.'"></a></div>';
                            }
                            $post .= '<div class="ba-blog-content">';
                            if ($options[4] == 1) {
                                $post .= '<h2 class="ba-blog-title">';
                                $post .= '<a href="'.$url.'">';
                                $post .= $item->title.'</a></h2>';
                            }
                            if ($options[5] == 1) {
                                $post .= '<div class="ba-blog-info">';
                                $post .= '<p class="ba-blog-data">';
                                $post .= $item->date.'</p>';
                                if (!empty($item->category)) {
                                    $post .= '<p class="ba-blog-category">';
                                    $post .= $item->category.'</p>';
                                }
                                $post .= '</div>';
                            }
                            if (!empty($item->intro_text) && $options[6] == 1) {
                                $post .= '<p class="ba-blog-intro-text">'.$item->intro_text.'</p>';
                            }
                            if ($options[7] == 1) {
                                $post .= '<div class="ba-blog-btn"><a href="'.$url;
                                $post .= '" class="ba-btn-transition">'.$options[8].'</a></div>';
                            }
                            $post .= '</div></div></post>';
                    }
                }
            }
            $body = @preg_replace("|\[blog options=".$blog[1]."\]|", $post, $body, 1);
            $body = @preg_replace("|\[blog-paginator\]|", $pagination, $body, 1);
        }
        return $body;
    }

    public static function getCategoryList($pks)
    {
        $db = JFactory::getDbo();
        if (empty($pks)) {
            $query = $db->getQuery(true);
            $query->select('title, id');
            $query->from($db->quoteName('#__bagrid_categories'));
            $query->where($db->quoteName('published').' = 1');
            $query->order('title ASC');
            $db->setQuery($query);
            $items = $db->loadObjectList();
            foreach ($items as $item) {
                $query = $db->getQuery(true);
                $query->select('COUNT(*)')
                    ->from($db->quoteName('#__bagrid_bagrids'))
                    ->where('`page_category` = ' .$item->id);
                $db->setQuery($query);
                $item->count = $db->loadResult();
            }
            return $items;
        }
        $pks = explode(',', $pks);
        $category =  array();
        foreach ($pks as $id) {
            $query = $db->getQuery(true);
            $query->select('title, id')
                ->from($db->quoteName('#__bagrid_categories'))
                ->where($db->quoteName('published').' = 1')
                ->where('`id` = '.$id)
                ->order('title ASC');
            $db->setQuery($query);
            $items = $db->loadObjectList();
            foreach ($items as $item) {
                $query = $db->getQuery(true);
                $query->select('COUNT(*)')
                    ->from($db->quoteName('#__bagrid_bagrids'))
                    ->where('`page_category` = ' .$item->id);
                $db->setQuery($query);
                $item->count = $db->loadResult();
                $category[] = $item;
            }
        }
        
        return $category;
    }

    public static function getPageTags($id)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('tag_id')
            ->from('#__bagrid_tags_map')
            ->where('`page_id` = ' . $id);
        $db->setQuery($query);
        $items = $db->loadObjectList();
        $tags = array();
        foreach ($items as $item) {
            $query = $db->getQuery(true);
            $query->select('*')
                ->from('#__bagrid_tags')
                ->where('`id` = '.$item->tag_id);
            $db->setQuery($query);
            $tags[] = $db->loadObject();
        }
        if (empty($tags)){
            $tags = JText::_('EMPTY_PAGE_TAGS');
        }
        return $tags;
    }

    public static function checkCategory($id)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('published')
            ->from('#__bagrid_categories')
            ->where('`id` = ' .$id);
        $db->setQuery($query);
        $result = $db->loadResult();
        if ($result * 1 == 1) {
            return true;
        } else {
            return false;
        }
    }

    public static function getCategoryTitle($id)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('title')
            ->from('#__bagrid_categories')
            ->where('`id` = ' .$id);
        $db->setQuery($query);
        $item = $db->loadResult();
        return $item;
    }

    public static function getBlogPosts($category, $start, $limit)
    {
        if ($category * 1 == 0 || self::checkCategory($category)) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $date = JFactory::getDate();
            $nowDate = $db->quote($date->toSql());
            $query->select('title, intro_text, intro_image, image_alt, page_category,
                            DATE_FORMAT(created,"%M %d, %Y") as date, id ')
                ->from('#__bagrid_bagrids')
                ->where('`published` = 1')
                ->where('`language` in (' . $db->quote(JFactory::getLanguage()->getTag()). ',' .$db->quote('*'). ')')
                ->where('`created` <= ' .$nowDate);
            if ($category > 0 ) {
                $query->where('`page_category` = ' . $category);
            }
            $query->order('created DESC');
            $db->setQuery($query, $start, $limit);
            $items = $db->loadObjectList();
            return $items;
        } else {
            return array();
        }
        
    }

    public static function checkMoreScripts($html)
    {
        $doc = JFactory::getDocument();
        if ($doc->getTitle() != 'Gridbox Editor') {
            $animation = array('bounceIn', 'bounceInLeft', 'bounceInRight',
                               'bounceInUp', 'fadeIn', 'fadeInLeft',
                               'fadeInRight', 'fadeInUp', 'zoomIn');
            $n = count($animation);
            for ($i = 0; $i < $n; $i++) {
                if (strpos($html, $animation[$i])) {
                    $doc->addStyleSheet(JURI::root() . 'components/com_bagrid/libraries/animation/css/animate.css');
                    $doc->addScript(JURI::root() . 'components/com_bagrid/libraries/animation/js/viewportchecker.js');
                    break;
                }
            }
            if (strpos($html, 'ba-grid-map')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-map'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (!empty($id)) {
                    $key = self::getMapsKey();
                    $doc->addScript('https://maps.googleapis.com/maps/api/js?key='.$key);
                } else {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-map").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-slider')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-slider'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (!empty($id)) {
                    $doc->addStyleSheet(JURI::root() . 'components/com_bagrid/libraries/slider/css/animation.css');
                    $doc->addStyleSheet(JURI::root() . 'components/com_bagrid/libraries/animation/css/animate.css');
                    $doc->addScript(JUri::root() . 'components/com_bagrid/libraries/slider/js/ba_slider.js');
                } else {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-slider").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-accordion')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-accordion'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-accordion").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-tabs')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-tabs'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-tabs").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-countdown')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-countdown'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-countdown").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-icon')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-icon'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-icon").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-scroll-to-top')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-scroll-to-top'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-scroll-to-top").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-scroll-to')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-scroll-to'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-scroll-to").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-custom-html')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-custom-html'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-custom-html").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-disqus')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-disqus'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-disqus").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-counter')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-counter'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (!empty($id)) {
                    $doc->addScript(JUri::root() . 'components/com_bagrid/libraries/counter/js/ba_counter.js');
                } else {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-counter").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-slideset')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-slideset'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (!empty($id)) {
                    $doc->addStyleSheet(JURI::root() . 'components/com_bagrid/libraries/slideset/css/animation.css');
                    $doc->addScript(JUri::root() . 'components/com_bagrid/libraries/slideset/js/ba_slideset.js');
                } else {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-slideset").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-overlay-section')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-overlay-section'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (empty($id)) {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-overlay-section").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-social')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-social'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (!empty($id)) {
                    $doc->addScript(JUri::root() . 'components/com_bagrid/libraries/social/js/ba_social.js');
                } else {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-social").remove();
                         });'
                    );
                }
            }
            if (strpos($html, 'ba-item-weather')) {
                $db = JFactory::getDbo();
                $query = $db->getQuery(true);
                $query->select('id')
                    ->from('#__bagrid_plugins')
                    ->where('`title` = ' .$db->Quote('ba-weather'));
                $db->setQuery($query);
                $id = $db->loadResult();
                if (!empty($id)) {
                    $doc->addScript(JUri::root() . 'components/com_bagrid/libraries/weather/js/ba_weather.js');
                    $doc->addStyleSheet('https://cdnjs.cloudflare.com/ajax/libs/weather-icons/2.0.9/css/weather-icons.min.css');
                } else {
                    $doc->addScriptDeclaration(
                        'jQuery(document).ready(function(){
                            jQuery(".ba-item-weather").remove();
                         });'
                    );
                }
            }
        }
    }

    public static function getMainMenu(){
        $db = JFactory::getDBO();
        $query = $db->getQuery(true)
            ->select('id')
            ->from('#__modules')
            ->where('client_id = 0')
            ->where('published = 1')
            ->where('position = '.$db->quote('main-menu'))
            ->where('module = '.$db->quote('mod_menu'));
        $db->setQuery($query);
        $menu = $db->loadResult();
        if (empty($menu)) {
            $query = $db->getQuery(true)
                ->select('id')
                ->from('#__modules')
                ->where('client_id = 0')
                ->where('published = 1')
                ->where('module = '.$db->quote('mod_menu'));
            $db->setQuery($query);
            $menu = $db->loadResult();
        }
        return $menu;
    }

    public static function checkheaderSection($header, $logo, $type)
    {
        if (strlen($header) == 0) {
            $menu = self::getMainMenu();
            if ($type == 'sidebar-menu') {
                $header = '<div class="ba-wrapper"><div class="ba-section row-fluid" style="padding: 10px;';
                $header .= ' margin: 0px; border-right-width: 1px; border-right-style: solid; border-right-color:';
                $header .= ' rgb(243, 243, 243); background: rgb(255, 255, 255);">';
                $header .= '<div class="ba-edit-item"><a class="icon-grid ba-add-column">';
                $header .= '</a><a class="icon-pencil-2 section-workspace"></a></div><div class="ba-section-items';
                $header .= ' ui-sortable"><div class="ba-row-wrapper"><div class="ba-row row-fluid" style="';
                $header .= 'padding:20px 20px 20px 20px; margin:10px 0 10px 0"><div class="span3 ba-grid-column';
                $header .= ' ui-sortable item-entry" style="margin-top: 0px; margin-bottom: 50px;"><div class="';
                $header .= 'ba-edit-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 ';
                $header .= 'column-workspace"></a></div><input type="hidden" class="column-options" value="';
                $header .= ';;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;0;0;0;0;50;;;0;rgba(0, 0, 0, 0.5)">';
                $header .= '<span class="ba-right-resize"></span><div class="ba-item-logo logo ba-item" ';
                $header .= 'style="text-align: center;"><a href="'.$logo->link.'"><img src="' .$logo->img;
                $header .= '" style="width: '.$logo->width.'px;" alt="'.$logo->alt.'"></a><input type="hidden" value="0;0;;';
                $header .= 'center" class="ba-logo-options"><div class="ba-edit-item"><a class="ba-sort-icon icon-move';
                $header .= ' ui-sortable-handle"></a><a class="icon-pencil-2 ba-edit-logo"></a></div></div></div>';
                $header .= '<div class="span9 ba-grid-column item-entry ui-sortable"><div class="ba-edit-item">';
                $header .= '<a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace"></a>';
                $header .= '</div><input type="hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-';
                $header .= 'column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><div class="ba-item-main-menu ba-item"';
                $header .= ' style="margin-top: 0px; margin-bottom: 0px;"><div class="logo"><a href="'.$logo->link;
                $header .= '"><img src="' .$logo->img. '" alt="'.$logo->alt.'" style="width:'.$logo->width;
                $header .= 'px;"></a></div><div class="';
                $header .= 'main-menu" data-main-menu="'.$menu.'"><div class="close-menu"><i class="zmdi zmdi';
                $header .= '-close"></i></div>[main_menu='.$menu.']</div><div class="open-menu"><i class="zmdi';
                $header .= ' zmdi-menu"></i></div><div class="ba-edit-item"><a class="ba-sort-icon icon-move ';
                $header .= 'ui-sortable-handle"></a><a class="icon-pencil-2 ba-edit-main-menu"></a></div><input';
                $header .= ' type="hidden" value="0;0;" class="ba-main-menu-options"></div></div><input type="hidden"';
                $header .= ' class="row-options" value="1;;;;0;0;0;0;20;20;20;20;10;10;;fixed;;1;1;;720;show-color-row;';
                $header .= '1;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a class="ba-sort-icon icon-move ';
                $header .= 'ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace"></a><a class="icon-menu"></a>';
                $header .= '<div class="ba-hidden-menu"><a class="icon-copy"></a><a class="icon-trash delete-row"></a>';
                $header .= '</div></div></div></div></div><input type="hidden" class="ba-options" value="1;0;0;';
                $header .= 'rgba(255, 255, 255, 1);;;1;rgba(243, 243, 243, 1);0;1;0;0;10;10;10;10;0;0;;;fixed;;1;';
                $header .= '1;;720;show-color;;0;rgba(0, 0, 0, 0.5)"></div></div>';
            } else if ($type == 'modern') {
                $header = '<div class="ba-wrapper"><div class="ba-section row-fluid" style="padding: 0px; margin: 0px;';
                $header .= ' border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb(243, 243, ';
                $header .= '243); background: rgb(255, 255, 255);"><div class="';
                $header .= 'ba-edit-item"><a class="icon-grid ba-add-column"></a><a class="icon-';
                $header .= 'pencil-2 section-workspace"></a></div><div class="ba-section-items ui-sortable"><div ';
                $header .= 'class="ba-row-wrapper ba-container"><div class="ba-row row-fluid ba-no-gutter" style="';
                $header .= 'padding: 10px 20px; margin: 10px 0px;"><div class="span4 ba-grid-column ui-sortable ';
                $header .= 'item-entry"><div class="ba-edit-item"><a class="icon-plus-2 ba-add-item"></a><a ';
                $header .= 'class="icon-pencil-2 column-workspace"></a></div><input type="hidden" class="column';
                $header .= '-options" value=";;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba';
                $header .= '(0, 0, 0, 0.5)"><span class="ba-right-resize"></span><div class="ba-item-main-menu';
                $header .= ' ba-item" data-main-menu="1" style="margin-top: 15px; margin-bottom: 0px; position:';
                $header .= ' relative; left: 0px; top: 0px;"><div class="logo"><a href=';
                $header .= '"'.$logo->link.'"><img src="' .$logo->img. '" ';
                $header .= 'alt="'.$logo->alt.'" style="width:'.$logo->width.'px;"></a></div><div class="main-menu" ';
                $header .= 'data-main-menu="'.$menu.'"><div class="close-menu"><i class="zmdi zmdi-close"';
                $header .= '></i></div>[main_menu='.$menu.']</div><div class="open-menu"><i class="zmdi zmdi-menu"></i></div>';
                $header .= '<div class="ba-edit-item"><a class="ba-sort-icon icon-move ui-sortable-handle">';
                $header .= '</a><a class="icon-pencil-2 ba-edit-main-menu"></a></div><input type="hidden" ';
                $header .= 'value="15;0;" class="ba-main-menu-options"></div></div><div class="span4 ba-grid-column';
                $header .= ' ui-sortable item-entry"><div class="ba-edit-item"><a class="icon-plus-2 ba-add-item"';
                $header .= '></a><a class="icon-pencil-2 column-workspace"></a></div><input type="hidden" ';
                $header .= 'class="column-options" value=";;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;0;';
                $header .= '0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><span class="ba-right-resize"></span><div class="';
                $header .= 'ba-item-logo logo ba-item" style="text-align: center; position: relative; left: ';
                $header .= '0px; top: 0px;"><a href="'.$logo->link.'"><img src="' .$logo->img. '"';
                $header .= ' style="width: '.$logo->width.'px;" alt="'.$logo->alt;
                $header .= '"></a><input type="hidden" value="0;0;;center" class="';
                $header .= 'ba-logo-options"><div class="ba-edit-item"><a class="ba-sort-icon icon-move ui-';
                $header .= 'sortable-handle"></a><a class="icon-pencil-2 ba-edit-logo"></a></div></div></div>';
                $header .= '<div class="span4 ba-grid-column ui-sortable"><div class="ba-edit-item"><a class="';
                $header .= 'icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace"></a></div>';
                $header .= '<input type="hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-';
                $header .= 'column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"></div><input type="hidden" ';
                $header .= 'class="row-options" value="0;;;;0;0;0;0;10;20;10;20;10;10;;fixed;;1;1;;720;show-';
                $header .= 'color-row;0;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a class="ba-sort-';
                $header .= 'icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace"></a>';
                $header .= '<a class="icon-menu"></a><div class="ba-hidden-menu"><a class="icon-copy"></a><a ';
                $header .= 'class="icon-trash delete-row"></a></div></div></div></div></div><input type="hidden"';
                $header .= ' class="ba-options" value="1;0;0;rgba(255, 255, 255, 1);;;1;rgba(243, 243, 243, 1);0;';
                $header .= '0;1;0;0;0;0;0;0;0;;;fixed;;1;1;;720;show-color;;0;rgba(0, 0, 0, 0.5)"></div></div>';
            } else if ($type == 'shop') {
                $header = '<div class="ba-wrapper"><div class="ba-section row-fluid" style="padding: 0px; margin: ';
                $header .= '0px; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb(243,';
                $header .= ' 243, 243); background: rgb(255, 255, 255);"><div class="';
                $header .= 'ba-edit-item"><a class="icon-grid ba-add-column"></a><a class="';
                $header .= 'icon-pencil-2 section-workspace"></a></div><div class="ba-section-items ui-sortable">';
                $header .= '<div class="ba-row-wrapper"><div class="ba-row row-fluid" style="padding: 20px; margin:';
                $header .= ' 0px; background: rgb(2, 173, 234);"><div class="span6 ba-grid-column ui-sortable"><div ';
                $header .= 'class="ba-edit-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 ';
                $header .= 'column-workspace"></a></div><input type="hidden" class="column-options" value=";;fixed';
                $header .= ';;1;1;;720;show-color-column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><span class="';
                $header .= 'ba-right-resize"></span></div><div class="span6 ba-grid-column ui-sortable"><div class="';
                $header .= 'ba-edit-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-';
                $header .= 'workspace"></a></div><input type="hidden" class="column-options" value=";;fixed;;1;1;';
                $header .= ';720;show-color-column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"></div><input type="';
                $header .= 'hidden" class="row-options" value="1;rgba(2, 173, 234, 1);;;0;0;0;0;20;20;20;20;0;0;;';
                $header .= 'fixed;;1;1;;720;show-color-row;1;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item">';
                $header .= '<a class="ba-sort-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2 row-';
                $header .= 'workspace"></a><a class="icon-menu"></a><div class="ba-hidden-menu"><a class="icon-copy';
                $header .= '"></a><a class="icon-trash delete-row"></a></div></div></div></div><div class="ba-row-';
                $header .= 'wrapper"><div class="ba-row row-fluid" style="padding: 20px 20px 40px; margin: 10px 0px';
                $header .= ' 0px; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb(243,';
                $header .= ' 243, 243);"><div class="span12 ba-grid-column ui-sortable item-entry"><div class="ba-';
                $header .= 'edit-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace';
                $header .= '"></a></div><input type="hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-';
                $header .= 'column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><div class="ba-item-logo logo ba-item"';
                $header .= ' style="text-align: center; position: relative; left: 0px; top: 0px;"><a ';
                $header .= 'href="'.$logo->link.'"><img src="' .$logo->img. '" style="';
                $header .= 'width: '.$logo->width.'px;" alt="'.$logo->alt;
                $header .= '"></a><input type="hidden" value="0;0;;center" class="ba-logo-options';
                $header .= '"><div class="ba-edit-item"><a class="ba-sort-icon icon-move ui-sortable-handle"></a>';
                $header .= '<a class="icon-pencil-2 ba-edit-logo"></a></div></div></div><input type="hidden" class="';
                $header .= 'row-options" value="1;;;rgba(243, 243, 243, 1);0;0;1;0;20;20;40;20;10;0;;fixed;;1;1;;';
                $header .= '720;show-color-row;1;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a class="ba-';
                $header .= 'sort-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace">';
                $header .= '</a><a class="icon-menu"></a><div class="ba-hidden-menu"><a class="icon-copy"></a>';
                $header .= '<a class="icon-trash delete-row"></a></div></div></div></div><div class="ba-row-wrapper';
                $header .= ' ba-container"><div class="ba-row row-fluid" style="padding: 20px; margin: 0px;"><div ';
                $header .= 'class="span9 ba-grid-column ui-sortable item-entry" style="margin-top: 0px; margin-';
                $header .= 'bottom: 0px;"><div class="ba-edit-item"><a class="icon-plus-2 ba-add-item"></a>';
                $header .= '<a class="icon-pencil-2 column-workspace"></a></div><input type="hidden" ';
                $header .= 'class="column-options" value=";;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;0;0;0;0;';
                $header .= '0;;;0;rgba(0, 0, 0, 0.5)"><span class="ba-right-resize"></span><div class="ba-item-';
                $header .= 'main-menu ba-item" data-main-menu="1" style="margin-top: 0px; margin-bottom: 0px; ';
                $header .= 'position: relative; left: 0px; top: 0px;"><div class="logo"><a href=';
                $header .= '"'.$logo->link.'"><img src="' .$logo->img. '" alt="'.$logo->alt.'"';
                $header .= ' style="width:'.$logo->width.'px;"></a></div><div class="main-menu" ';
                $header .= 'data-main-menu="'.$menu.'"><div class="close-menu"><i class="zmdi zmdi-close">';
                $header .= '</i></div>[main_menu='.$menu.']</div><div class="open-menu"><i class="zmdi ';
                $header .= 'zmdi-menu"></i></div><div class="ba-edit-item"><a class="ba-sort-icon ';
                $header .= 'icon-move ui-sortable-handle"></a><a class="icon-pencil-2 ba-edit-main-menu';
                $header .= '"></a></div><input type="hidden" value="0;0;" class="ba-main-menu-options">';
                $header .= '</div></div><div class="span3 ba-grid-column ui-sortable"><div class="ba-edit-item';
                $header .= '"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace">';
                $header .= '</a></div><input type="hidden" class="column-options" value=";;fixed;;1;1;;720;';
                $header .= 'show-color-column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"></div><input ';
                $header .= 'type="hidden" class="row-options" value="0;;;;0;0;0;0;20;20;20;20;0;0;;fixed;;';
                $header .= '1;1;;720;show-color-row;1;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item">';
                $header .= '<a class="ba-sort-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2';
                $header .= ' row-workspace"></a><a class="icon-menu"></a><div class="ba-hidden-menu">';
                $header .= '<a class="icon-copy"></a><a class="icon-trash delete-row"></a></div></div>';
                $header .= '</div></div></div><input type="hidden" class="ba-options" value="1;0;0;';
                $header .= 'rgba(255, 255, 255, 1);;;1;rgba(243, 243, 243, 1);0;0;1;0;0;0;0;0;0;0;;;';
                $header .= 'fixed;;1;1;;720;show-color;;0;rgba(0, 0, 0, 0.5)"></div></div>';
            } else if ($type == 'business') {
                $header = '<div class="ba-wrapper"><div class="ba-section row-fluid" style="padding: 0px; margin: 0px;';
                $header .= ' border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb(243, 243,';
                $header .= ' 243); background: rgb(255, 255, 255);"><div class="';
                $header .= 'ba-edit-item"><a class="icon-grid ba-add-column"></a><a class="icon-';
                $header .= 'pencil-2 section-workspace"></a></div><div class="ba-section-items ui-sortable"><div ';
                $header .= 'class="ba-row-wrapper"><div class="ba-row row-fluid" style="padding: 20px; margin: ';
                $header .= '0px 0px 10px; background: rgb(2, 173, 234);"><div class="span9 ba-grid-column ui-sortable';
                $header .= '"><div class="ba-edit-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2';
                $header .= ' column-workspace"></a></div><input type="hidden" class="column-options" value=";;fixed;;';
                $header .= '1;1;;720;show-color-column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><span class="';
                $header .= 'ba-right-resize"></span></div><div class="span3 ba-grid-column ui-sortable"><div class="';
                $header .= 'ba-edit-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace';
                $header .= '"></a></div><input type="hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-';
                $header .= 'column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"></div><input type="hidden" class="';
                $header .= 'row-options" value="1;rgba(2, 173, 234, 1);;;0;0;0;0;20;20;20;20;0;10;;fixed;;1;1;;720;show';
                $header .= '-color-row;1;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a class="ba-sort-icon ';
                $header .= 'icon-move ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace"></a><a class="';
                $header .= 'icon-menu"></a><div class="ba-hidden-menu"><a class="icon-copy"></a><a class="icon-trash';
                $header .= ' delete-row"></a></div></div></div></div><div class="ba-row-wrapper ba-container"><div ';
                $header .= 'class="ba-row row-fluid" style="padding: 10px; margin: 10px 0px;"><div class="span3 ba-';
                $header .= 'grid-column ui-sortable item-entry"><div class="ba-edit-item"><a class="icon-plus-2 ';
                $header .= 'ba-add-item"></a><a class="icon-pencil-2 column-workspace"></a></div><input type="';
                $header .= 'hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;0;0';
                $header .= ';0;0;0;;;0;rgba(0, 0, 0, 0.5)"><span class="ba-right-resize"></span><div class="ba-item-';
                $header .= 'logo logo ba-item" style="text-align:left;"><a href="'.$logo->link.'">';
                $header .= '<img src="' .$logo->img. '" style="width: '.$logo->width;
                $header .= 'px;" alt="'.$logo->alt.'"></a><input type="hidden"';
                $header .= ' value="0;0;;left" class="ba-logo-options"><div class="ba-edit-item"><a class="ba-sort';
                $header .= '-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2 ba-edit-logo"></a></div>';
                $header .= '</div></div><div class="span9 ba-grid-column item-entry ui-sortable"><div class="ba-edit';
                $header .= '-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace">';
                $header .= '</a></div><input type="hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-';
                $header .= 'column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><div class="ba-item-main-menu ba-item"';
                $header .= ' data-main-menu="1" style="margin-top: 15px; margin-bottom: 0px;"><div class="logo">';
                $header .= '<a href="'.$logo->link.'"><img src="' .$logo->img. '" alt="'.$logo->alt.'" ';
                $header .= 'style="width:'.$logo->width.'px;"></a></div><div class="main-menu" data-main-menu="'.$menu.'">';
                $header .= '<div class="close-menu"><i class="zmdi zmdi-close"></i></div>[main_menu='.$menu.']';
                $header .= '</div><div class="open-menu"><i class="zmdi zmdi-menu"></i></div><div ';
                $header .= 'class="ba-edit-item"><a class="ba-sort-icon icon-move ui-sortable-handle">';
                $header .= '</a><a class="icon-pencil-2 ba-edit-main-menu"></a></div><input type="hidden"';
                $header .= ' value="15;0;" class="ba-main-menu-options"></div></div><input type="hidden" ';
                $header .= 'class="row-options" value="0;;;;0;0;0;0;10;10;10;10;10;10;;fixed;;1;1;;720;';
                $header .= 'show-color-row;1;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a class="';
                $header .= 'ba-sort-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace';
                $header .= '"></a><a class="icon-menu"></a><div class="ba-hidden-menu"><a class="icon-copy">';
                $header .= '</a><a class="icon-trash delete-row"></a></div></div></div></div></div><input type';
                $header .= '="hidden" class="ba-options" value="1;0;0;rgba(255, 255, 255, 1);;;1;rgba(243, 243,';
                $header .= ' 243, 1);0;0;1;0;0;0;0;0;0;0;;;fixed;;1;1;;720;show-color;;0;rgba(0, 0, 0, 0.5)"></div></div>';
            } else if ($type == 'boxed') {
                $header = '<div class="ba-wrapper ba-container"><div class="ba-section row-fluid" style="padding:';
                $header .= ' 0px; margin: 40px 0px 0px; border: 1px solid rgb(243, 243, 243); background: rgb(255,';
                $header .= ' 255, 255);"><div class="ba-edit-item"><a class="icon-grid ba-add-column"></a><a ';
                $header .= 'class="icon-pencil-2 section-workspace"></a></div><div class="ba-section-items ';
                $header .= 'ui-sortable"><div class="ba-row-wrapper ba-container"><div class="ba-row ';
                $header .= 'row-fluid" style="padding: 10px; margin: 10px 0px;"><div class="span3 ';
                $header .= 'ba-grid-column ui-sortable item-entry"><div class="ba-edit-item"><a class="';
                $header .= 'icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace"></a>';
                $header .= '</div><input type="hidden" class="column-options" value=";;fixed;;1;1;;720;';
                $header .= 'show-color-column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><span class="';
                $header .= 'ba-right-resize"></span><div class="ba-item-logo logo ba-item" style="text-';
                $header .= 'align: center;"><a href="'.$logo->link.'"><img src="' .$logo->img. '"';
                $header .= ' style="width: '.$logo->width.'px;" alt="'.$logo->alt;
                $header .= '"></a><input type="hidden" value="0;0;;center"';
                $header .= ' class="ba-logo-options"><div class="ba-edit-item"><a class="ba-sort-icon';
                $header .= ' icon-move ui-sortable-handle"></a><a class="icon-pencil-2 ba-edit-logo">';
                $header .= '</a></div></div></div><div class="span9 ba-grid-column item-entry ';
                $header .= 'ui-sortable"><div class="ba-edit-item"><a class="icon-plus-2 ba-add-item"';
                $header .= '></a><a class="icon-pencil-2 column-workspace"></a></div><input type="hidden"';
                $header .= ' class="column-options" value=";;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;';
                $header .= '0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><div class="ba-item-main-menu ba-item" ';
                $header .= 'data-main-menu="1" style="margin-top: 15px; margin-bottom: 0px;">';
                $header .= '<div class="logo"><a href="'.$logo->link.'"><img src=';
                $header .= '"' .$logo->img. '" alt="'.$logo->alt.'" style="width:'.$logo->width;
                $header .= 'px;"></a></div><div class="';
                $header .= 'main-menu" data-main-menu="'.$menu.'"><div class="close-menu"><i class="zmdi ';
                $header .= 'zmdi-close"></i></div>[main_menu='.$menu.']</div><div class="open-menu"><i ';
                $header .= 'class="zmdi zmdi-menu"></i></div><div class="ba-edit-item"><a class="';
                $header .= 'ba-sort-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2';
                $header .= ' ba-edit-main-menu"></a></div><input type="hidden" value="15;0;" class="';
                $header .= 'ba-main-menu-options"></div></div><input type="hidden" class="row-options"';
                $header .= ' value="0;;;;0;0;0;0;10;10;10;10;10;10;;fixed;;1;1;;720;show-color-row;1;;0';
                $header .= ';0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a class="ba-sort-icon icon-move';
                $header .= ' ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace"></a><a class="';
                $header .= 'icon-menu"></a><div class="ba-hidden-menu"><a class="icon-copy"></a><a class="';
                $header .= 'icon-trash delete-row"></a></div></div></div></div></div><input type="hidden" ';
                $header .= 'class="ba-options" value="0;0;0;rgba(255, 255, 255, 1);;;1;rgba(243, 243, 243,';
                $header .= ' 1);1;1;1;1;0;0;0;0;40;0;;;fixed;;1;1;;720;show-color;;0;rgba(0, 0, 0, 0.5)"></div></div>';
            } else if ($type == 'magazine') {
                $header = '<div class="ba-wrapper"><div class="ba-section row-fluid" style="padding: 0px; margin: 0px; ';
                $header .= 'border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb(243, 243, 243)';
                $header .= '; background: rgb(255, 255, 255);"><div class="ba-edit-item">';
                $header .= '<a class="icon-grid ba-add-column"></a><a class="icon-pencil-2 ';
                $header .= 'section-workspace"></a></div><div class="ba-section-items ui-sortable"><div class="ba-row-';
                $header .= 'wrapper"><div class="ba-row row-fluid" style="padding: 20px; margin: 0px 0px 10px; background:';
                $header .= ' rgb(2, 173, 234);"><div class="span6 ba-grid-column ui-sortable"><div class="ba-edit-item">';
                $header .= '<a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace"></a></div>';
                $header .= '<input type="hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-column;0;';
                $header .= '0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><span class="ba-right-resize"></span></div>';
                $header .= '<div class="span6 ba-grid-column ui-sortable"><div class="ba-edit-item"><a class="icon-';
                $header .= 'plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace"></a></div><input type="';
                $header .= 'hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;0;';
                $header .= '0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"></div><input type="hidden" class="row-options" value="';
                $header .= '1;rgba(2, 173, 234, 1);;;0;0;0;0;20;20;20;20;0;10;;fixed;;1;1;;720;show-color-row;1;;';
                $header .= '0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a class="ba-sort-icon icon-move ';
                $header .= 'ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace"></a><a class="icon-menu"';
                $header .= '></a><div class="ba-hidden-menu"><a class="icon-copy"></a><a class="icon-trash ';
                $header .= 'delete-row"></a></div></div></div></div><div class="ba-row-wrapper ba-container">';
                $header .= '<div class="ba-row row-fluid" style="padding:20px 20px 20px 20px; margin:10px 0 ';
                $header .= '10px 0"><div class="span12 ba-grid-column ui-sortable item-entry"><div class="';
                $header .= 'ba-edit-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 ';
                $header .= 'column-workspace"></a></div><input type="hidden" class="column-options" value="';
                $header .= ';;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)';
                $header .= '"><div class="ba-item-logo logo ba-item" style="text-align: center; position: ';
                $header .= 'relative; left: 0px; top: 0px;"><a href="'.$logo->link.'">';
                $header .= '<img src="' .$logo->img. '" style="width: '.$logo->width;
                $header .= 'px;" alt="'.$logo->alt.'"></a><input type="';
                $header .= 'hidden" value="0;0;;center" class="ba-logo-options"><div class="ba-edit-item">';
                $header .= '<a class="ba-sort-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2';
                $header .= ' ba-edit-logo"></a></div></div><div class="ba-item-main-menu ba-item" ';
                $header .= 'data-main-menu="1" style="margin-top: 15px; margin-bottom: 0px; position:';
                $header .= ' relative; left: 0px; top: 0px;"><div class="logo"><a href="'.$logo->link.'';
                $header .= '"><img src="' .$logo->img. '" alt="'.$logo->alt.'" style="width:';
                $header .= $logo->width.'px;"></a></div><div ';
                $header .= 'class="main-menu" data-main-menu="'.$menu.'"><div class="close-menu"><i ';
                $header .= 'class="zmdi zmdi-close"></i></div>[main_menu='.$menu.']</div><div class="';
                $header .= 'open-menu"><i class="zmdi zmdi-menu"></i></div><div class="ba-edit-item';
                $header .= '"><a class="ba-sort-icon icon-move ui-sortable-handle"></a><a class="';
                $header .= 'icon-pencil-2 ba-edit-main-menu"></a></div><input type="hidden" value="';
                $header .= '15;0;" class="ba-main-menu-options"></div></div><input type="hidden"';
                $header .= ' class="row-options" value="0;;;;0;0;0;0;20;20;20;20;10;10;;fixed;;1';
                $header .= ';1;;720;show-color-row;1;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit';
                $header .= '-item"><a class="ba-sort-icon icon-move ui-sortable-handle"></a><a ';
                $header .= 'class="icon-pencil-2 row-workspace"></a><a class="icon-menu"></a>';
                $header .= '<div class="ba-hidden-menu"><a class="icon-copy"></a><a class="icon';
                $header .= '-trash delete-row"></a></div></div></div></div></div><input type="';
                $header .= 'hidden" class="ba-options" value="1;0;0;rgba(255, 255, 255, 1);;;1;rgba(243, 243, 243, 1)';
                $header .= ';0;0;1;0;0;0;0;0;0;0;;;fixed;;1;1;;720;show-color;;0;rgba(0, 0, 0, 0.5)"></div></div>';
            } else if ($type == 'creative') {
                $header = '<div class="ba-wrapper"><div class="ba-section row-fluid" style="padding: 0px; margin: 0px;';
                $header .= ' border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb';
                $header .= '(243, 243, 243); background: rgb(255, 255, 255);"><div class="';
                $header .= 'ba-edit-item"><a class="icon-grid ba-add-column"></a><a ';
                $header .= 'class="icon-pencil-2 section-workspace"></a></div><div class="ba-section-items ui-sortable"';
                $header .= '><div class="ba-row-wrapper ba-container"><div class="ba-row row-fluid" style="padding:20px ';
                $header .= '20px 20px 20px; margin:10px 0 10px 0"><div class="span12 ba-grid-column ui-sortable item-entry';
                $header .= '"><div class="ba-edit-item"><a class="icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 ';
                $header .= 'column-workspace"></a></div><input type="hidden" class="column-options" value=";;fixed;;1;1;';
                $header .= ';720;show-color-column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><div class="ba-item-logo';
                $header .= ' logo ba-item" style="text-align: center; position: relative; left: 0px; top: 0px;"><a ';
                $header .= 'href="'.$logo->link.'"><img src="' .$logo->img. '" style="width: ';
                $header .= $logo->width.'px;" alt="'.$logo->alt.'"></a><input type="hidden" value="0;0;;center" class="';
                $header .= 'ba-logo-options"><div class="ba-edit-item"><a class="ba-sort-icon icon-move ';
                $header .= 'ui-sortable-handle"></a><a class="icon-pencil-2 ba-edit-logo"></a></div></div>';
                $header .= '<div class="ba-item-main-menu ba-item" data-main-menu="1" style="margin-top: 15px;';
                $header .= ' margin-bottom: 0px; position: relative; left: 0px; top: 0px;"><div class="logo">';
                $header .= '<a href="'.$logo->link.'"><img src="' .$logo->img. '" alt="'.$logo->alt.'" ';
                $header .= 'style="width:'.$logo->width. 'px;"></a></div><div class="main-menu" data-main-menu="'.$menu.'">';
                $header .= '<div class="close-menu"><i class="zmdi zmdi-close"></i></div>[main_menu='.$menu.']';
                $header .= '</div><div class="open-menu"><i class="zmdi zmdi-menu"></i></div><div class="';
                $header .= 'ba-edit-item"><a class="ba-sort-icon icon-move ui-sortable-handle"></a><a class="';
                $header .= 'icon-pencil-2 ba-edit-main-menu"></a></div><input type="hidden" value="15;0;" ';
                $header .= 'class="ba-main-menu-options"></div></div><input type="hidden" class="row-options"';
                $header .= ' value="0;;;;0;0;0;0;20;20;20;20;10;10;;fixed;;1;1;;720;show-color-row;1;;0;0;';
                $header .= 'rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a class="ba-sort-icon icon-move ';
                $header .= 'ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace"></a><a class="';
                $header .= 'icon-menu"></a><div class="ba-hidden-menu"><a class="icon-copy"></a><a class="';
                $header .= 'icon-trash delete-row"></a></div></div></div></div></div><input type="hidden"';
                $header .= ' class="ba-options" value="1;0;0;rgba(255, 255, 255, 1);;;1;rgba(243, 243, 243, 1);0;0;1;0;0;0;0;0;0';
                $header .= ';0;;;fixed;;1;1;;720;show-color;;0;rgba(0, 0, 0, 0.5)"></div></div>';
            } else {
                $header = '<div class="ba-wrapper"><div class="ba-section row-fluid" style="padding: 0px; margin: 0px; ';
                $header .= 'border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgb(243, 243, 243);';
                $header .= '"><div class="ba-edit-item"><a class="icon-grid ba-add-column"></a><a class="icon-pencil-2 ';
                $header .= 'section-workspace"></a></div><div class="ba-section-items ui-sortable"><div class="ba-row-wrapper';
                $header .= ' ba-container"><div class="ba-row row-fluid" style="padding: 10px; margin: 10px 0px;"><div ';
                $header .= 'class="span3 ba-grid-column ui-sortable item-entry"><div class="ba-edit-item"><a class="';
                $header .= 'icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace"></a></div><input ';
                $header .= 'type="hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-column;0;0;0;0;;0;';
                $header .= '0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><span class="ba-right-resize"></span><div class="ba-item-logo';
                $header .= ' logo ba-item" style="text-align:left;"><a href="'.$logo->link.'">';
                $header .= '<img src="' .$logo->img. '" style="width: '.$logo->width. 'px;" alt="';
                $header .= $logo->alt.'"></a><input type="hidden" ';
                $header .= 'value="0;0;;left" class="ba-logo-options"><div class="ba-edit-item"><a class="ba-sort-icon';
                $header .= ' icon-move ui-sortable-handle"></a><a class="icon-pencil-2 ba-edit-logo"></a></div></div></div>';
                $header .= '<div class="span9 ba-grid-column item-entry ui-sortable"><div class="ba-edit-item"><a class="';
                $header .= 'icon-plus-2 ba-add-item"></a><a class="icon-pencil-2 column-workspace"></a></div>';
                $header .= '<input type="hidden" class="column-options" value=";;fixed;;1;1;;720;show-color-';
                $header .= 'column;0;0;0;0;;0;0;0;0;0;0;;;0;rgba(0, 0, 0, 0.5)"><div class="ba-item-main-menu ba-item';
                $header .= ' " data-main-menu="1" style="margin-top: 15px; margin-bottom: 0px;"><div class="';
                $header .= 'logo"><a href="'.$logo->link.'"><img src="' .$logo->img. '" alt="'.$logo->alt.'" ';
                $header .= 'style="width:'.$logo->width. 'px;"></a></div><div class="main-menu" data-main-menu="'.$menu.'">';
                $header .= '<div class="close-menu"><i class="zmdi zmdi-close"></i></div>[main_menu='.$menu.']</div>';
                $header .= '<div class="open-menu"><i class="zmdi zmdi-menu"></i></div><div class="ba-edit-item">';
                $header .= '<a class="ba-sort-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2 ';
                $header .= 'ba-edit-main-menu"></a></div><input type="hidden" value="15;0;" class="ba-main-menu-options"';
                $header .= '></div></div><input type="hidden" class="row-options" value="0;;;;0;0;0;0;10;10;10;10;10;10;';
                $header .= ';fixed;;1;1;;720;show-color-row;1;;0;0;rgba(0, 0, 0, 0.5)"><div class="ba-edit-item"><a ';
                $header .= 'class="ba-sort-icon icon-move ui-sortable-handle"></a><a class="icon-pencil-2 row-workspace">';
                $header .= '</a><a class="icon-menu"></a><div class="ba-hidden-menu"><a class="icon-copy"></a><a ';
                $header .= 'class="icon-trash delete-row"></a></div></div></div></div></div><input type="hidden" ';
                $header .= 'class="ba-options" value="1;0;0;;;;1;rgba(243, 243, 243, 1);0;0;1;0;0;0;0;0;0;0;;;';
                $header .= 'fixed;;1;1;;720;show-color;;0;rgba(0, 0, 0, 0.5)"></div></div>';
            }            
        }
        return $header;
    }
    
    public static function checkCustom()
    {
        $doc = JFactory::getDocument();
        $file = JPATH_ROOT. '/templates/gridboxcore/css/custom.css';
        if (JFile::exists($file)) {
            $doc->addStyleSheet(JUri::root() . '/templates/gridboxcore/css/custom.css');
        }
        $file = JPATH_ROOT. '/templates/gridboxcore/css/template.css';
        if (JFile::exists($file)) {
            $doc->addStyleSheet(JUri::root() . '/templates/gridboxcore/css/template.css');
        }
    }
    
    public static function checkParams($id, $params)
    {
        if (!empty($id)) {
            $id = self::getTheme($id);
            $params = self::getThemeParams($id, $params);
        }
        return $params;
    }
    
    protected static function getThemeParams($id, $oldParams)
    {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true)
            ->select('params')
            ->from('#__template_styles')
            ->where('`id`=' .$db->Quote($id));
        $db->setQuery($query);
        $params = $db->loadResult($query);
        if (!empty($params)) {
            $obj = new Registry;
            $obj->loadString($params);
        } else {
            $obj = $oldParams;
        }
        
        return $obj;
    }
    
    protected static function getTheme($id)
    {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true)
            ->select('theme')
            ->from('#__bagrid_bagrids')
            ->where('`id` = ' .$db->Quote($id));
        $db->setQuery($query);
        $theme = $db->loadResult($id);
        
        return $theme;
    }
    
    public static function reCreateFavicon($path)
    {
        $pos = strpos($path, 'images');
        if ($pos > 0) {
            $path = (substr($path, $pos));
        }
        if (JFile::exists(JPATH_ROOT.'/'.$path)) {
            JFile::delete(JPATH_ROOT. '/templates/gridboxcore/favicon.ico');
            JFile::copy(JPATH_ROOT.'/'.$path, JPATH_ROOT. '/templates/gridboxcore/favicon.ico');
        }
    }
    
    public static function checkSection($body)
    {
        $regex = '/\[section=+(.*?)\]/i';
        preg_match_all($regex, $body, $matches, PREG_SET_ORDER);
        if ($matches) {
            foreach ($matches as $index => $match) {
                $pos = strpos($body, $match[0]);
                $pos = $pos - 2;
                if ($pos < 0) {
                    $pos = 0;
                }
                if ($body[$pos] != '=') {
                    $id = $match[1];
                    $db = JFactory::getDBO();
                    $query = $db->getQuery(true)
                        ->select('item')
                        ->from('#__bagrid_library')
                        ->where('`id` = ' .$db->quote($id));
                    $db->setQuery($query);
                    $result = $db->loadResult();
                    if (empty($result)) {
                        $result = '';
                    }
                    $body = @preg_replace("|\[section=".$id."\]|", $result, $body);
                }
            }
        }
        $regex = '/\[plugin=+(.*?)\]/i';
        preg_match_all($regex, $body, $matches, PREG_SET_ORDER);
        if ($matches) {
            foreach ($matches as $index => $match) {
                $pos = strpos($body, $match[0]);
                $pos = $pos - 2;
                if ($pos < 0) {
                    $pos = 0;
                }
                if ($body[$pos] != '=') {
                    $id = $match[1];
                    $db = JFactory::getDBO();
                    $query = $db->getQuery(true)
                        ->select('item')
                        ->from('#__bagrid_library')
                        ->where('`id` = ' .$db->quote($id));
                    $db->setQuery($query);
                    $result = $db->loadResult();
                    if (empty($result)) {
                        $result = '';
                    }
                    $body = @preg_replace("|\[plugin=".$id."\]|", $result, $body);
                }
            }
        }
        
        return $body;
    }
    
    public static function checkMOdules($body)
    {
        $body = self::checkSection($body);
        $regex = '/\[module=+(.*?)\]/i';
        preg_match_all($regex, $body, $matches, PREG_SET_ORDER);
        if ($matches) {
            foreach ($matches as $index => $match) {
                $module = $match[1];
                if (isset($module)) {
                    $db = JFactory::getDBO();
                    $query = $db->getQuery(true)
                        ->select('m.*')
                        ->from('#__modules AS m')
                        ->where('m.client_id = 0')
                        ->where('m.published = 1')
                        ->where('m.title = ' . $db->quote($module));
                    $query->order('m.ordering');
                    $db->setQuery($query);
                    $module = $db->loadObject();
                    $document = JFactory::getDocument();
                    $document->_type = 'html';
                    $renderer = $document->loadRenderer('module');
                    $html = $renderer->render($module);
                    $body = @preg_replace("|\[module=".$match[1]."\]|", $html, $body, 1);
                }
            }
        }
        $regex = '/\[main_menu=+(.*?)\]/i';
        preg_match_all($regex, $body, $matches, PREG_SET_ORDER);
        if ($matches) {
            foreach ($matches as $index => $match) {
                $module = $match[1];
                if (isset($module)) {
                    $db = JFactory::getDBO();
                    $query = $db->getQuery(true)
                        ->select('m.*')
                        ->from('#__modules AS m')
                        ->where('m.client_id = 0')
                        ->where('m.published = 1')
                        ->where('m.module = '.$db->quote('mod_menu'))
                        ->where('m.id = ' . $db->quote($module));
                    $query->order('m.ordering');
                    $db->setQuery($query);
                    $module = $db->loadObject();                    
                    if (empty($module)) {
                        $module = self::getMainMenu();
                        $body = str_replace('data-main-menu="'.$match[1].'"', 'data-main-menu="'.$module.'"', $body);
                        $body = str_replace("[main_menu=".$match[1]."]", "[main_menu=".$module."]", $body);
                        $match[1] = $module;
                        $query = $db->getQuery(true)
                            ->select('m.*')
                            ->from('#__modules AS m')
                            ->where('m.client_id = 0')
                            ->where('m.published = 1')
                            ->where('m.module = '.$db->quote('mod_menu'))
                            ->where('m.id = ' . $db->quote($module));
                        $query->order('m.ordering');
                        $db->setQuery($query);
                        $module = $db->loadObject();

                    }
                    $document = JFactory::getDocument();
                    $document->_type = 'html';
                    $renderer = $document->loadRenderer('module');
                    $html = $renderer->render($module);
                    $body = @preg_replace("|\[main_menu=".$match[1]."\]|", $html, $body, 1);
                }
            }
        }
        $body = self::addPageTags($body);
        $body = self::addTagCloud($body);
        $body = self::addCategoryList($body);

        $body = self::restoreImages($body);
        return $body;
    }

    public static function restoreImages($body)
    {
        $pos = 0;
        $root = JUri::root(true);
        $len = strlen($root);
        $pos = strpos($body, '/images/', $pos);
        while ($pos !== false) {
            $start = substr($body, 0, $pos);
            if ($start[$pos - 1] == '(' || $start[$pos - 1] == '"') {
                $end = substr($body, $pos);
                $body = $start.$root.$end;
                $pos = strpos($body, '/images/', $pos+10+$len);
            } else {
                $pos = strpos($body, '/images/', $pos+10);
            }            
        }
        
        return $body;
    }

    public static function addCategoryList($body)
    {
        $regex = '/\[category-list options=+(.*?)\]/i';
        preg_match_all($regex, $body, $clouds, PREG_SET_ORDER);
        foreach ($clouds as $key => $cloud) {
            $options = explode(';', $cloud[1]);
            $items = self::getCategoryList($options[0]);
            $str = '<ul>';
            foreach ($items as $key => $item) {
                $str .= '<li class="ba-cat-item"><a href="index.php?option=com_bagrid';
                $str .= '&view=search&category='.$item->id.'" class="ba-btn-transition">';
                $str .= $item->title.'</a>';
                if ($options[1] == 1) {
                    $str .= '<span class="ba-cat-count ba-btn-transition">'.$item->count.'</span>';
                }
                $str .= '</li>';
            }
            $str .= '</ul>';
            $body = @preg_replace("|\[category-list options=".$cloud[1]."\]|", $str, $body, 1);
        }
        return $body;
    }

    public static function addTagCloud($body)
    {
        $regex = '/\[tag-cloud options=+(.*?)\]/i';
        preg_match_all($regex, $body, $clouds, PREG_SET_ORDER);
        foreach ($clouds as $key => $cloud) {
            $options = explode(';', $cloud[1]);
            $items = self::getTagCloud($options[0], $options[1]);
            $str = '';
            foreach ($items as $key => $item) {
                $str .= '<a href="index.php?option=com_bagrid&view=search&page_tag=';
                $str .= $item->id.'" class="ba-btn-transition">'.$item->title.'</a>';
            }
            $body = @preg_replace("|\[tag-cloud options=".$cloud[1]."\]|", $str, $body, 1);
        }
        return $body;
    }

    public static function getTagCloud($order, $limit)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('DISTINCT a.*');
        $query->from($db->quoteName('#__bagrid_tags', 'a'));
        $query->select($db->quoteName('b.tag_id'));
        $query->leftJoin(
            $db->quoteName('#__bagrid_tags_map', 'b')
                . ' ON '
                . $db->quoteName('b.tag_id')
                . ' = ' 
                . $db->quoteName('a.id')
        );
        $query->order($order.' ASC');
        $db->setQuery($query, 0, $limit);
        $items = $db->loadObjectList();
        return $items;
    }

    public static function addPageTags($body)
    {
        $input = JFactory::getApplication()->input;
        $id = $input->get('id');
        $option = $input->get('option');
        if (empty($id)) {
            $id = 0;
        }
        if ($option == 'com_bagrid') {
            $tags = self::getPageTags($id);
        } else {
            $tags = '';
        }
        $str = '';
        if (is_array($tags)) {
            foreach ($tags as $tag) {
                $str .= '<a href="'.JUri::root().'index.php?option=com_bagrid&view=search&page_tag=';
                $str .= $tag->id. '">' .$tag->title. '</a>';
            }
        } else {
            $str = '<p>'.$tags.'</p>';
        }
        $body = str_replace('[set_page_tags]', $str, $body);

        return $body;
    }
}