/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

!function ($) {
	var ba_counter = function (element, options) {
        this.parent = $(element);
        this.item = ((navigator.userAgent.toLowerCase().indexOf('webkit') != -1) ? 'body' : 'html');
        this.options = options;
        this.interval;
        this.numbers = new Array();
        this.n = 100;
        this.number = $(element).text();
        this.flag = true;
        this.wHeight = $(window).height();
        this.top = Math.round(this.parent.offset().top ) + 100;
        this.bottom = this.top + (this.parent.height());                    
    }
    
    ba_counter.prototype = {
        init : function (event) {
        	var numbers = [],
            	cels = this.options.time / 100,
                ind = this.options.ind;
            for (var i = cels; i >= 1; i--) {
            	var newNum = parseInt(this.number / cels * i);
            	this.numbers.unshift(newNum);
            }
            this.parent.text('0');
            this.check();
            $(window).on('load scroll.ba_counter'+ind+' touchmove.ba_counter'+ind, $.proxy(this.check, this));
        },
        delete : function(){
            if (this.interval) {
                clearInterval(this.interval);
            }
            this.interval = null;
            $(window).off('scroll.ba_counter'+this.options.ind+' touchmove.ba_counter'+this.options.ind);
        },
        count : function(){
        	this.parent.text(this.numbers.shift());
        	this.n += 100;
        	if (this.n > this.options.time) {
        		this.delete();
        	}
        },
        check : function(){
        	var top = $(this.item).scrollTop(),
            	bottom = (top + this.wHeight);
            if ((this.top < bottom) && (this.bottom > top)){
                if (this.flag) {
                    this.interval = setInterval($.proxy(this.count, this), 100);
            		this.flag = false;
            	}
            }
        }
    }
    
    $.fn.ba_counter = function (option) {
        return this.each(function () {
            $.fn.ba_counter.defaults.ind += 1;
            var $this = $(this),
                data = $this.data('ba_counter'),
                options = $.extend({}, $.fn.ba_counter.defaults, typeof option == 'object' && option);
            if (!data) {
                $this.data('ba_counter', (data = new ba_counter(this, options)));
            }
            if (option == 'delete') {
                data.delete('ba_counter');
                $this.removeData();
            } else {
                data.init();
            }
        });
    }
    
    $.fn.ba_counter.defaults = {
        time : 1500,
        ind : 0
    }
    
    $.fn.ba_counter.Constructor = ba_counter;
}(window.jQ ? window.jQ : window.jQuery);
