/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

function showInline()
{
    sel = window.getSelection();
    var html = sel.toString(),
        rangeStart = sel.getRangeAt(0).startContainer,
        textAlign;
    if (jQ.trim(html) != '') {
        currentItem = jQ(this).closest('.ba-item-text');
        var range = sel.getRangeAt(0).cloneRange();
        range.collapse(true);
        var rect = range.getClientRects()[0],
            inlineY = rect.top + window.pageYOffset,
            tag = jQ(rangeStart).parentsUntil('.content-text'),
            tagName = tag[tag.length-1].localName,
            tagFlag = false,
            start = sel.getRangeAt(0).startContainer,
            end = sel.getRangeAt(0).endContainer,
            srtong = findTag(start, end, 'strong')
            italic = findTag(start, end, 'em'),
            link = findTag(start, end, 'a');
        if (link.length === 0) {
            jQ('.inline-link').removeClass('active');
        } else {
            jQ('.inline-link').addClass('active');
        }
        if (italic.length === 0) {
            jQ('.inline-font-style').removeClass('active');
        } else {
            jQ('.inline-font-style').addClass('active');
        }
        if (srtong.length === 0) {
            jQ('.inline-weight').removeClass('active');
        } else {
            jQ('.inline-weight').addClass('active');
        }
        if (tagName == 'ul') {
            jQ('.inline-list').addClass('active');
        } else {
            jQ('.inline-list').removeClass('active');
        }
        jQ('.inline-tag option').each(function(){
            if (this.value == tagName) {
                jQ(this).attr('selected', true);
                tagFlag = true;
            } else {
                jQ(this).attr('selected', false);
            }
        });
        textAlign = tag[0].style.textAlign;
        if (textAlign == '') {
            textAlign = 'left'
        }
        jQ('.inline-text-align').each(function(){
            if (jQ(this).attr('data-value') == textAlign) {
                jQ(this).addClass('active');
            } else {
                jQ(this).removeClass('active');
            }
        });
        inlineEditArea = jQ(this);
        jQ('.ba-inline-edit-area').show();
        jQ('.inline-link-area').hide();
        jQ('.ba-inline-editor')[0].style.top = '';
        jQ('.ba-inline-editor')[0].style.left = '';
        jQ('.ba-inline-editor').addClass('inline-visible');
        var width = jQ('.ba-inline-editor').innerWidth()/2,
            height = jQ('.ba-inline-editor').height(),
            left,
            docWidth = jQ(document).innerWidth();
        left = inlineX*1-width*1;
        if (left < 0) {
            left = 5
        }
        if (docWidth - (left + width*2) < 0) {
            left = docWidth - width*2 - 16;
        }
        jQ('.ba-inline-editor').css({
            'top' : inlineY*1-height*1 - 25+'px',
            'left' : left+'px'
        });
    } else {
        jQ('.ba-inline-editor').removeClass('inline-visible');
    }
}

function findTag(start, end, tagName)
{
    var sParent = jQ(start).parentsUntil('.content-text'),
        eParent = jQ(end).parentsUntil('.content-text'),
        sLen = sParent.length,
        eLen = eParent.length,
        general,
        linkArray = new Array(),
        flag = false,
        newEnd = end,
        newStart = start;
    for (var i = 0; i < sLen; i++) {
        if (sParent[i].localName == tagName) {
            if (jQ.inArray(sParent[i], linkArray) < 0) {
                linkArray.push(sParent[i])
            }
        }
    }
    for (var i = 0; i < eLen; i++) {
        if (eParent[i].localName == tagName) {
            if (jQ.inArray(eParent[i], linkArray) < 0) {
                linkArray.push(eParent[i])
            }
        }
    }
    for (var i = 0; i < sLen; i++) {
        if (!flag) {
            for (var j = 0; j < eLen; j++) {
                if (sParent[i] == eParent[j]) {
                    general = sParent[i];
                    flag = true;
                    break;
                }
            }
        } else {
            flag = true;
            break;
        }
    }
    if (!general) {
        general = jQ(start).closest('.content-text')[0];
    }
    for (var i = 0; i < eLen; i++) {
        var list = eParent[i].childNodes,
            len = list.length;
        if (eParent[i] != general) {
            for (var j = 0; j < len; j++) {
                if (list[j] == newEnd) {
                    newEnd = eParent[i];
                    break;
                }
                if (list[j].localName == tagName && jQ.inArray(list[j], linkArray) < 0) {
                    linkArray.push(list[j]);
                }
                jQ(list[j]).find(tagName).each(function(ind, el){
                    if (jQ.inArray(el, linkArray) < 0) {
                        linkArray.push(el);
                    }
                });
            }
        }
    }
    for (var i = 0; i < sLen; i++) {
        var list = sParent[i].childNodes,
            len = list.length;
        flag = false;
        for (var j = 0; j < len; j++) {
            if (list[j] == end) {
                break;
            }
            if (flag && list[j] != end) {
                if (list[j].localName == tagName && jQ.inArray(list[j], linkArray) < 0) {
                    linkArray.push(list[j]);
                }
                jQ(list[j]).find(tagName).each(function(ind, el){
                    if (jQ.inArray(el, linkArray) < 0) {
                        linkArray.push(el);
                    }
                });
            }
            if (list[j] == newStart) {
                newStart = sParent[i];
                flag = true;
            }
        }
    }
    var list = general.children,
        len = list.length,
        array = [],
        allow = false;
    for (var i = 0; i < len; i++) {
        if (list[i] == newEnd) {
            break;
        }
        if (allow) {
            array.push(list[i])
        }
        if (list[i] == newStart) {
            allow = true;
        }
    }
    len = array.length;
    for (var i = 0; i < len; i++) {
        jQ(array[i]).find(tagName).each(function(ind, el){
            if (jQ.inArray(el, linkArray) < 0) {
                linkArray.push(el)
            }
        });
    }
    return linkArray;
}
 
jQ(document).ready(function(){
    var eventInline = jQ.Event('inlineAction'),
        preListTag,
        inlineStart,
        inlineEnd,
        inlineStartOffset,
        inlineEndOffset;
    
    function recreateRange(start, startOffset, end, endOffset)
    {
        var rng = document.createRange();
        rng.setStart(start, startOffset);
        rng.setEnd(end, endOffset);
        sel.removeAllRanges();
        sel.addRange(rng);
    }
    
    function addInlineLink(inlineHref, inlineTarget)
    {
        var range = sel.getRangeAt(0),
            start = range.startContainer,
            end = range.endContainer,
            endOffset = range.endOffset,
            startOffset = range.startOffset;
        if (start.parentNode == end.parentNode) {
            var str,
                textNode,
                element;
            if (start == end && startOffset === 0 && start.data.length === endOffset) {
                element = createLink(inlineHref, inlineTarget);
                element.appendChild(start);
                range.insertNode(element);
            } else if (start == end && startOffset === 0) {
                var textData = start.data;
                str = textData.substring(0, endOffset);
                textNode = document.createTextNode(str);
                element = createLink(inlineHref, inlineTarget);
                element.appendChild(textNode);
                range.insertNode(element);
                var next = element.nextSibling;
                next.data = textData.substring(endOffset);
                start = end = textNode;
            } else if (start == end && start.data.length === endOffset) {
                var textData = start.data;
                str = textData.substring(startOffset);
                textNode = document.createTextNode(str);
                element = createLink(inlineHref, inlineTarget);
                element.appendChild(textNode);
                var next = start.nextSibling;
                start.parentNode.insertBefore(element, next);
                element.previousSibling.data = textData.substring(0, startOffset);
                start = end = textNode;
                startOffset = 0;
                endOffset = textNode.data.length;
            } else if (start == end) {
                var textData = start.data;
                str = textData.substring(startOffset, endOffset);
                textNode = document.createTextNode(str);
                element = createLink(inlineHref, inlineTarget);
                element.appendChild(textNode);
                start.parentNode.insertBefore(element, start);
                str = textData.substring(0, startOffset);
                var prevText = document.createTextNode(str);
                start.parentNode.insertBefore(prevText, element);
                start.data = textData.substring(endOffset);
                start = end = textNode;
                startOffset = 0;
                endOffset = textNode.data.length
            } else {
                if (start.nextSibling == end && startOffset === 0 && endOffset === end.data.length) {
                    str = start.data+end.data;
                    textNode = document.createTextNode(str);
                    element = createLink(inlineHref, inlineTarget);
                    element.appendChild(textNode);
                    start.parentNode.insertBefore(element, start);
                    start.parentNode.removeChild(start);
                    end.parentNode.removeChild(end);
                    start = end = textNode;
                    startOffset = 0;
                    endOffset = textNode.data.length;
                } else if (start.nextSibling == end && startOffset === 0) {
                    str = start.data+end.data.substring(0, endOffset);
                    textNode = document.createTextNode(str);
                    element = createLink(inlineHref, inlineTarget);
                    element.appendChild(textNode);
                    start.parentNode.insertBefore(element, start);
                    start.parentNode.removeChild(start);
                    end.data = end.data.substring(endOffset);
                    start = end = textNode;
                    startOffset = 0;
                    endOffset = textNode.data.length;
                } else if (start.nextSibling == end && endOffset === end.data.length) {
                    str = start.data.substring(startOffset)+end.data;
                    textNode = document.createTextNode(str);
                    element = createLink(inlineHref, inlineTarget);
                    element.appendChild(textNode);
                    start.parentNode.insertBefore(element, end);
                    start.parentNode.removeChild(end);
                    start.data = start.data.substring(0, startOffset);
                    start = end = textNode;
                    startOffset = 0;
                    endOffset = textNode.data.length;
                } else if (start.nextSibling == end) {
                    str = start.data.substring(startOffset)+end.data.substring(0, endOffset);
                    textNode = document.createTextNode(str);
                    element = createLink(inlineHref, inlineTarget);
                    element.appendChild(textNode);
                    start.parentNode.insertBefore(element, end);
                    start.data = start.data.substring(0, startOffset);
                    end.data = end.data.substring(endOffset);
                    start = end = textNode;
                    startOffset = 0;
                    endOffset = textNode.data.length;
                } else {
                    var array = new Array(),
                        nodeList = start.parentNode.childNodes,
                        len = nodeList.length,
                        flag = false;
                    for (var i = 0; i < len; i++) {
                        if (nodeList[i] == start) {
                        flag = true;
                        }
                        if (flag && nodeList[i] != start && nodeList[i] != end) {
                            array.push(nodeList[i]);
                        } else if (flag) {
                            array.push(nodeList[i].cloneNode(true));
                        }
                        if (nodeList[i] == end) {
                            break;
                        }
                    }
                    element = createLink(inlineHref, inlineTarget);
                    len = array.length;
                    start.data = start.data.substring(0, startOffset);
                    end.data = end.data.substring(endOffset);
                    array[0].data = array[0].data.substring(startOffset);
                    array[len - 1].data = array[len - 1].data.substring(0, endOffset);
                    for (var i = 0; i < len; i++) {
                        element.appendChild(array[i]);
                    }
                    start.parentNode.insertBefore(element, end);
                    start = array[0];
                    end = array[len - 1];
                    startOffset = 0;
                    endOffset = array[len -1].length;
                }
            }
        } else {
            var sParent = jQ(start).parentsUntil('.content-text'),
                eParent = jQ(end).parentsUntil('.content-text'),
                sLen = sParent.length,
                eLen = eParent.length,
                general,
                flag = true;
            for (var i = 0; i < sLen; i++) {
                if (flag) {
                    for (var j = 0; j < eLen; j++) {
                        if (sParent[i] == eParent[j]) {
                            general = sParent[i];
                            flag = false;
                            break;
                        }
                    }
                } else {
                    break;
                }
            }
            if (!general) {
                general = jQ(start).closest('.content-text')[0];
            }
            var array = new Array();
            flag = false;
            var newStart = start;
            for (var i = 0; i < sLen; i++) {
                var list = sParent[i].childNodes,
                    len = list.length;
                if (sParent[i] != general) {
                    for (var j = 0; j < len; j++) {
                        if (flag && list[j] != end) {
                            array.push(list[j])
                        }
                        if (list[j] == newStart) {
                            newStart = sParent[i];
                            flag = true;
                        }
                    }
                    flag = false;
                }
            }
            var aLen = array.length,
                lastArray = new Array();
            var a;
            for (var i = 0; i < aLen; i++) {
                if (jQ.inArray(array[i].parentNode, lastArray) < 0) {
                    lastArray.push(array[i].parentNode);
                    a = createLink(inlineHref, inlineTarget);
                    array[i].parentNode.insertBefore(a, array[i])
                    a.appendChild(array[i]);
                } else {
                    a.appendChild(array[i])
                }

            }
            array = [];
            var newEnd = end;
            for (var i = 0; i < eLen; i++) {
                var list = eParent[i].childNodes,
                    len = list.length;
                if (eParent[i] != general) {
                    for (var j = 0; j < len; j++) {
                        if (list[j] == newEnd) {
                            newEnd = eParent[i];
                            break;
                        }
                        array.push(list[j]);
                    }
                }
            }
            aLen = array.length;
            lastArray = [];
            var a;
            for (var i = 0; i < aLen; i++) {
                if (jQ.inArray(array[i].parentNode, lastArray) < 0) {
                    lastArray.push(array[i].parentNode);
                    a = createLink(inlineHref, inlineTarget);
                    array[i].parentNode.insertBefore(a, array[i])
                    a.appendChild(array[i]);
                } else {
                    a.appendChild(array[i])
                }

            }
            var list = general.children,
                len = list.length;
            flag = false;
            array = []
            for (var i = 0; i < len; i++) {
                if (list[i] == newEnd) {
                    break;
                }
                if (flag) {
                    array.push(list[i])
                }
                if (list[i] == newStart) {
                    flag = true;
                }
            }
            aLen = array.length;
            for (var i = 0; i < aLen; i++) {
                a = createLink(inlineHref, inlineTarget);
                jQ(array[i]).wrapInner(a)
            }
            if (startOffset === 0) {
                a = createLink(inlineHref, inlineTarget);
                start.parentNode.insertBefore(a, start);
                a.appendChild(start)
            } else {
                a = createLink(inlineHref, inlineTarget);
                start.parentNode.insertBefore(a, start.nextSibling);
                var textNode = document.createTextNode(start.data.substring(startOffset, start.data.length));
                a.appendChild(textNode);
                start.data = start.data.substring(0, startOffset)
                startOffset = 0;
                start = textNode;
            }
            if (endOffset === end.data.length) {
                a = createLink(inlineHref, inlineTarget);
                end.parentNode.insertBefore(a, end);
                a.appendChild(end);
            } else {
                a = createLink(inlineHref, inlineTarget);
                end.parentNode.insertBefore(a, end);
                var textNode = document.createTextNode(end.data.substring(0, endOffset));
                a.appendChild(textNode);
                end.data = end.data.substring(endOffset);
                end = textNode;
            }
        }
        recreateRange(start, startOffset, end, endOffset);
    }
    
    function createLink(inlineHref, inlineTarget)
    {
        var link = document.createElement('a');
        link.href = inlineHref;
        link.target = inlineTarget;
        
        return link;
    }
    
    jQ('.inline-tag').on('change', function(event){
        event.stopPropagation();
        event.preventDefault();
        sel = window.getSelection();
        var tag = this.value,
            range = sel.getRangeAt(0),
            endOffset = range.endOffset,
            startOffset = range.startOffset,
            start = range.startContainer,
            end = range.endContainer,
            startContainer = jQ(start).parentsUntil('.content-text'),
            endContainer = jQ(end).parentsUntil('.content-text'),
            startLength = startContainer.length -1,
            endLength = endContainer.length -1;
        if (jQ(sel.anchorNode).closest('.content-text').length > 0) {
            if (startContainer[startLength] == endContainer[endLength]) {
                var selAParent = jQ(sel.anchorNode).parentsUntil('.content-text');
                selAParent = selAParent[selAParent.length - 1];
                tag = document.createElement(tag);
                var len = selAParent.childNodes.length;
                for (var i = 0; i < len; i++) {
                    var childNode = selAParent.childNodes[0];
                    if (childNode.localName == 'li') {
                        var localLen = childNode.childNodes.length;
                        for (var j = 0; j < localLen; j++) {
                            tag.appendChild(childNode.childNodes[0]);
                        }
                        selAParent.removeChild(childNode)
                    } else {
                        tag.appendChild(childNode);
                    }
                }
                jQ(selAParent).replaceWith(tag);
                jQ(tag).attr('style', jQ(selAParent).attr('style'));
            } else {
                var textArea = endContainer.parent(),
                    flag = false,
                    array = new Array();
                textArea.children().each(function(){
                    if (!flag) {
                        if (jQ(this)[0] == startContainer[startContainer.length - 1]) {
                            flag = true;
                        }
                    }
                    if (flag) {
                        array.push(this);
                        if (jQ(this)[0] == endContainer[endContainer.length - 1]) {
                            return false;
                        }
                    }
                });
                var len = array.length;
                for (var i = 0; i < len; i++) {
                    var nodeList = array[i].childNodes,
                        newTag = document.createElement(tag),
                        newLen = nodeList.length;
                    for (var j = 0; j < newLen; j++) {
                        newTag.appendChild(nodeList[0]);
                    }
                    jQ(array[i]).replaceWith(newTag);
                    jQ(newTag).attr('style', jQ(array[i]).attr('style'));
                }
            }
            recreateRange(start, startOffset, end, endOffset);
            jQ('.ba-inline-editor').trigger(eventInline)
        }
    });
    
    jQ('.inline-font-style').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        sel = window.getSelection();
        var range = sel.getRangeAt(0);
        if (jQ(sel.anchorNode).closest('.content-text').length > 0) {
            var start = range.startContainer,
                end = range.endContainer,
                endOffset = range.endOffset,
                startOffset = range.startOffset,
                link = findTag(start, end, 'em');
            if (link.length === 0) {
                if (start.parentNode == end.parentNode) {
                    var str,
                        textNode,
                        element;
                    if (start == end && startOffset === 0 && start.data.length === endOffset) {
                        element = document.createElement('em');
                        element.appendChild(start);
                        range.insertNode(element);
                    } else if (start == end && startOffset === 0) {
                        var textData = start.data;
                        str = textData.substring(0, endOffset);
                        textNode = document.createTextNode(str);
                        element = document.createElement('em');
                        element.appendChild(textNode);
                        range.insertNode(element);
                        var next = element.nextSibling;
                        next.data = textData.substring(endOffset);
                        start = end = textNode;
                    } else if (start == end && start.data.length === endOffset) {
                        var textData = start.data;
                        str = textData.substring(startOffset);
                        textNode = document.createTextNode(str);
                        element = document.createElement('em');
                        element.appendChild(textNode);
                        var next = start.nextSibling;
                        start.parentNode.insertBefore(element, next);
                        element.previousSibling.data = textData.substring(0, startOffset);
                        start = end = textNode;
                        startOffset = 0;
                        endOffset = textNode.data.length;
                    } else if (start == end) {
                        var textData = start.data;
                        str = textData.substring(startOffset, endOffset);
                        textNode = document.createTextNode(str);
                        element = document.createElement('em');
                        element.appendChild(textNode);
                        start.parentNode.insertBefore(element, start);
                        str = textData.substring(0, startOffset);
                        var prevText = document.createTextNode(str);
                        start.parentNode.insertBefore(prevText, element);
                        start.data = textData.substring(endOffset);
                        start = end = textNode;
                        startOffset = 0;
                        endOffset = textNode.data.length
                    } else {
                        if (start.nextSibling == end && startOffset === 0 && endOffset === end.data.length) {
                            str = start.data+end.data;
                            textNode = document.createTextNode(str);
                            element = document.createElement('em');
                            element.appendChild(textNode);
                            start.parentNode.insertBefore(element, start);
                            start.parentNode.removeChild(start);
                            end.parentNode.removeChild(end);
                            start = end = textNode;
                            startOffset = 0;
                            endOffset = textNode.data.length;
                        } else if (start.nextSibling == end && startOffset === 0) {
                            str = start.data+end.data.substring(0, endOffset);
                            textNode = document.createTextNode(str);
                            element = document.createElement('em');
                            element.appendChild(textNode);
                            start.parentNode.insertBefore(element, start);
                            start.parentNode.removeChild(start);
                            end.data = end.data.substring(endOffset);
                            start = end = textNode;
                            startOffset = 0;
                            endOffset = textNode.data.length;
                        } else if (start.nextSibling == end && endOffset === end.data.length) {
                            str = start.data.substring(startOffset)+end.data;
                            textNode = document.createTextNode(str);
                            element = document.createElement('em');
                            element.appendChild(textNode);
                            start.parentNode.insertBefore(element, end);
                            start.parentNode.removeChild(end);
                            start.data = start.data.substring(0, startOffset);
                            start = end = textNode;
                            startOffset = 0;
                            endOffset = textNode.data.length;
                        } else if (start.nextSibling == end) {
                            str = start.data.substring(startOffset)+end.data.substring(0, endOffset);
                            textNode = document.createTextNode(str);
                            element = document.createElement('em');
                            element.appendChild(textNode);
                            start.parentNode.insertBefore(element, end);
                            start.data = start.data.substring(0, startOffset);
                            end.data = end.data.substring(endOffset);
                            start = end = textNode;
                            startOffset = 0;
                            endOffset = textNode.data.length;
                        } else {
                            var array = new Array(),
                                nodeList = start.parentNode.childNodes,
                                len = nodeList.length,
                                flag = false;
                            for (var i = 0; i < len; i++) {
                                if (nodeList[i] == start) {
                                flag = true;
                                }
                                if (flag && nodeList[i] != start && nodeList[i] != end) {
                                    array.push(nodeList[i]);
                                } else if (flag) {
                                    array.push(nodeList[i].cloneNode(true));
                                }
                                if (nodeList[i] == end) {
                                    break;
                                }
                            }
                            element = document.createElement('em');
                            len = array.length;
                            start.data = start.data.substring(0, startOffset);
                            end.data = end.data.substring(endOffset);
                            array[0].data = array[0].data.substring(startOffset);
                            array[len - 1].data = array[len - 1].data.substring(0, endOffset);
                            for (var i = 0; i < len; i++) {
                                element.appendChild(array[i]);
                            }
                            start.parentNode.insertBefore(element, end);
                            start = array[0];
                            end = array[len - 1];
                            startOffset = 0;
                            endOffset = array[len -1].length;
                        }
                    }
                } else {
                    var sParent = jQ(start).parentsUntil('.content-text'),
                        eParent = jQ(end).parentsUntil('.content-text'),
                        sLen = sParent.length,
                        eLen = eParent.length,
                        general,
                        flag = true;
                    for (var i = 0; i < sLen; i++) {
                        if (flag) {
                            for (var j = 0; j < eLen; j++) {
                                if (sParent[i] == eParent[j]) {
                                    general = sParent[i];
                                    flag = false;
                                    break;
                                }
                            }
                        } else {
                            break;
                        }
                    }
                    if (!general) {
                        general = jQ(start).closest('.content-text')[0];
                    }
                    var array = new Array();
                    flag = false;
                    var newStart = start;
                    for (var i = 0; i < sLen; i++) {
                        var list = sParent[i].childNodes,
                            len = list.length;
                        if (sParent[i] != general) {
                            for (var j = 0; j < len; j++) {
                                if (flag && list[j] != end) {
                                    array.push(list[j])
                                }
                                if (list[j] == newStart) {
                                    newStart = sParent[i];
                                    flag = true;
                                }
                            }
                            flag = false;
                        }
                    }
                    var aLen = array.length,
                        lastArray = new Array(),
                        a;
                    for (var i = 0; i < aLen; i++) {
                        if (jQ.inArray(array[i].parentNode, lastArray) < 0) {
                            lastArray.push(array[i].parentNode);
                            a = document.createElement('em');
                            array[i].parentNode.insertBefore(a, array[i])
                            a.appendChild(array[i]);
                        } else {
                            a.appendChild(array[i])
                        }

                    }
                    array = [];
                    var newEnd = end;
                    for (var i = 0; i < eLen; i++) {
                        var list = eParent[i].childNodes,
                            len = list.length;
                        if (eParent[i] != general) {
                            for (var j = 0; j < len; j++) {
                                if (list[j] == newEnd) {
                                    newEnd = eParent[i];
                                    break;
                                }
                                array.push(list[j]);
                            }
                        }
                    }
                    aLen = array.length;
                    lastArray = [];
                    var a;
                    for (var i = 0; i < aLen; i++) {
                        if (jQ.inArray(array[i].parentNode, lastArray) < 0) {
                            lastArray.push(array[i].parentNode);
                            a = document.createElement('em');
                            array[i].parentNode.insertBefore(a, array[i])
                            a.appendChild(array[i]);
                        } else {
                            a.appendChild(array[i])
                        }
                    }
                    var list = general.children,
                        len = list.length;
                    flag = false;
                    array = []
                    for (var i = 0; i < len; i++) {
                        if (list[i] == newEnd) {
                            break;
                        }
                        if (flag) {
                            array.push(list[i])
                        }
                        if (list[i] == newStart) {
                            flag = true;
                        }
                    }
                    aLen = array.length;
                    for (var i = 0; i < aLen; i++) {
                        a = document.createElement('em');
                        jQ(array[i]).wrapInner(a)
                    }
                    if (startOffset === 0) {
                        a = document.createElement('em');
                        start.parentNode.insertBefore(a, start);
                        a.appendChild(start)
                    } else {
                        a = document.createElement('em');
                        start.parentNode.insertBefore(a, start.nextSibling);
                        var textNode = document.createTextNode(start.data.substring(startOffset, start.data.length));
                        a.appendChild(textNode);
                        start.data = start.data.substring(0, startOffset)
                        startOffset = 0;
                        start = textNode;
                    }
                    if (endOffset === end.data.length) {
                        a = document.createElement('em');
                        end.parentNode.insertBefore(a, end);
                        a.appendChild(end)
                    } else {
                        a = document.createElement('em');
                        end.parentNode.insertBefore(a, end);
                        var textNode = document.createTextNode(end.data.substring(0, endOffset));
                        a.appendChild(textNode);
                        end.data = end.data.substring(endOffset);
                        end = textNode;
                    }
                }
                jQ('.inline-font-style').addClass('active');
            } else {
                var sParent = jQ(start).parentsUntil('.content-text'),
                    eParent = jQ(end).parentsUntil('.content-text'),
                    sLen = sParent.length,
                    eLen = eParent.length,
                    general,
                    flag = true,
                    array = new Array(),
                    a = document.createElement('em')
                if (start.parentNode != jQ(start).closest('em')[0]) {
                    var par = jQ(start).closest('em')[0],
                        pos = jQ.inArray(par, sParent);
                    array = [];
                    while (pos >= 0) {
                        var parList = sParent[pos].childNodes,
                            parLength = parList.length;
                        for (var j = 0; j < parLength; j++) {
                            a = document.createElement('em');
                            a.appendChild(parList[0]);
                            if (sParent[pos].localName == 'em') {
                                sParent[pos].parentNode.insertBefore(a, sParent[pos]);
                            } else {
                                sParent[pos].appendChild(a);
                            }
                        }
                        if (sParent[pos].localName == 'em') {
                            sParent[pos].parentNode.removeChild(sParent[pos]);
                        } else {
                            if (sParent[pos].parentNode.localName == 'em') {
                                array.push(sParent[pos].parentNode)
                                sParent[pos].parentNode.parentNode.insertBefore(sParent[pos], sParent[pos].parentNode);
                            }
                        }
                        pos--;
                    }
                    len = array.length;
                    for (var i = 0; i < len; i++) {
                        array[i].parentNode.removeChild(array[i]);
                    }
                    
                }
                if (end.parentNode != jQ(end).closest('em')[0]) {
                    var par = jQ(end).closest('em')[0];
                    var pos = jQ.inArray(par, eParent);
                    array = [];
                    while (pos >= 0) {
                        var parList = eParent[pos].childNodes,
                            parLength = parList.length;
                        for (var j = 0; j < parLength; j++) {
                            a = document.createElement('em');
                            a.appendChild(parList[0]);
                            if (eParent[pos].localName == 'em') {
                                eParent[pos].parentNode.insertBefore(a, eParent[pos]);
                            } else {
                                eParent[pos].appendChild(a);
                            }
                        }
                        if (eParent[pos].localName == 'em') {
                            eParent[pos].parentNode.removeChild(eParent[pos]);
                        } else {
                            if (eParent[pos].parentNode.localName == 'em') {
                                array.push(eParent[pos].parentNode);
                                eParent[pos].parentNode.parentNode.insertBefore(eParent[pos], eParent[pos].parentNode);
                            }
                        }
                        pos--;
                    }
                    len = array.length;
                    for (var i = 0; i < len; i++) {
                        array[i].parentNode.removeChild(array[i]);
                    }
                }
                sParent = jQ(start).parentsUntil('.content-text');
                eParent = jQ(end).parentsUntil('.content-text');
                sLen = sParent.length;
                eLen = eParent.length;
                for (var i = 0; i < sLen; i++) {
                    if (flag) {
                        for (var j = 0; j < eLen; j++) {
                            if (sParent[i] == eParent[j]) {
                                general = sParent[i];
                                flag = false;
                                break;
                            }
                        }
                    } else {
                        break;
                    }
                }
                if (!general) {
                    general = jQ(start).closest('.content-text')[0];
                }
                var array = new Array(),
                    newStart = start;
                flag = false;
                for (var i = 0; i < sLen; i++) {
                    var list = sParent[i].childNodes,
                        len = list.length;
                    if (sParent[i] != general) {
                        for (var j = 0; j < len; j++) {
                            if (flag && list[j] != end) {
                                array.push(list[j])
                            }
                            if (list[j] == newStart) {
                                newStart = sParent[i];
                                flag = true;
                            }
                        }
                        flag = false;
                    } else {
                        break;
                    }
                }
                var len = array.length;
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('em').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'em') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                array = [];
                var newEnd = end;
                for (var i = 0; i < eLen; i++) {
                    var list = eParent[i].childNodes,
                        len = list.length;
                    if (eParent[i] != general) {
                        for (var j = 0; j < len; j++) {
                            
                            if (list[j] == newEnd) {
                                newEnd = eParent[i];
                                break;
                            }
                            array.push(list[j]);
                        }
                    } else {
                        break;
                    }
                }
                len = array.length;
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('em').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'em') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                flag = false;
                array = [];
                var list = general.childNodes;
                len = list.length
                for (var i = 0; i < len; i++) {
                    if (list[i] == newEnd) {
                        break;
                    }
                    if (flag) {
                        array.push(list[i])
                    }
                    if (list[i] == newStart) {
                        flag = true;
                    }
                }
                len = array.length;
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('em').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'em') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                if (start == end) {
                    var parent = end.parentNode,
                        list = parent.childNodes,
                        len = list.length,
                        strong = document.createElement('em');
                    for (var i = 0; i < len; i++) {
                        if (list[0] == end) {
                            var textN = document.createTextNode(end.data.substring(startOffset, endOffset)),
                                textS = document.createTextNode(end.data.substring(0, startOffset));
                            strong.appendChild(textS);
                            parent.parentNode.insertBefore(strong, parent);
                            parent.parentNode.insertBefore(textN, strong.nextSibling);
                            strong = document.createElement('em');
                            parent.parentNode.insertBefore(strong, parent);
                            end.data = end.data.substring(endOffset);
                            startOffset = 0;
                            endOffset = textN.data.length;
                            start = end = textN;
                        }
                        strong.appendChild(list[0])
                    }
                    parent.parentNode.removeChild(parent)
                    if (strong.firstChild.data == '') {
                        strong.removeChild(strong.firstChild)
                    }
                    if (strong.childNodes.length == 0) {
                        strong.parentNode.removeChild(strong);
                    }
                    if (end.previousSibling.lastChild.data == '') {
                        end.previousSibling.removeChild(end.previousSibling.lastChild)
                    }
                    if (end.previousSibling.childNodes.length == 0) {
                        end.parentNode.removeChild(end.previousSibling)
                    }
                } else {
                    if (end.parentNode == start.parentNode && end.parentNode.localName == 'em') {
                        var parent = end.parentNode,
                            list = parent.childNodes,
                            len = list.length,
                            number = 0,
                            textN,
                            flag = true,
                            strong = document.createElement('em');
                        for (var i = 0; i < len; i++) {
                            if (!flag) {
                                strong.appendChild(list[number]);
                            }
                            if (list[number] == end) {
                                var eText = document.createTextNode(end.data.substring(0, endOffset));
                                end.data = end.data.substring(endOffset);
                                parent.parentNode.insertBefore(eText, textN.nextSibling);
                                parent.parentNode.insertBefore(strong, eText.nextSibling);
                                strong.appendChild(list[number]);
                                end = eText;
                                flag = false;
                            }
                            if (number > 0 && flag) {
                                var item = list[number];
                                parent.parentNode.insertBefore(list[number], textN.nextSibling);
                                textN = item;
                            }
                            if (list[i] == start) {
                                textN = document.createTextNode(start.data.substring(startOffset));
                                start.data = start.data.substring(0, startOffset);
                                start = textN;
                                startOffset = 0;
                                parent.parentNode.insertBefore(textN, parent.nextSibling);
                                number = i + 1;
                            }
                        }
                        if (list[number - 1].data == '') {
                            parent.removeChild(list[number - 1])
                        }
                        if (list.length == 0) {
                            parent.parentNode.removeChild(parent);
                        }
                        if (strong.firstChild.data == '') {
                            strong.removeChild(strong.firstChild)
                        }
                        if (strong.childNodes.length == 0) {
                            strong.parentNode.removeChild(strong)
                        }
                    } else if (end.parentNode == start.parentNode) {
                        var parent = end.parentNode,
                            list = parent.childNodes,
                            len = list.length,
                            number = 0,
                            flag = false,
                            array = new Array();
                        for (var i = 0; i < len; i++) {
                            if (list[i] == end) {
                                break;
                            }
                            if (list[i].localName == 'em' && flag) {
                                var newList = list[i].childNodes,
                                    newLen = newList.length;
                                for (var j = 0; j < newLen; j++) {
                                    parent.insertBefore(newLen[0], list[i]);
                                }
                                array.push(list[i])
                            }
                            if (start == list[i]) {
                                flag = true
                            }
                        }
                        len = array.length;
                        for (var i = 0; i < len; i++) {
                            parent.removeChild(array[i])
                        }
                    } else {
                        var textN = document.createTextNode(start.data.substring(startOffset));
                        if (start.parentNode.localName == 'em') {
                            start.data = start.data.substring(0, startOffset);
                            start.parentNode.parentNode.insertBefore(textN, start.parentNode.nextSibling);
                            if (startOffset === 0) {
                                start.parentNode.parentNode.removeChild(start.parentNode)
                            }
                            start = textN;
                            startOffset = 0;
                        }
                        if (end.parentNode.localName == 'em') {
                            list = end.parentNode.childNodes;
                            len = list.length;
                            for (var i = 0; i < len; i++) {
                                if (list[0] == end) {
                                    break;
                                }
                                end.parentNode.parentNode.insertBefore(list[0], end.parentNode);
                            }
                            textN = document.createTextNode(end.data.substring(0, endOffset));
                            end.parentNode.parentNode.insertBefore(textN, end.parentNode);
                            if (endOffset === end.data.length) {
                                end.parentNode.parentNode.removeChild(end.parentNode)
                            }
                            end.data = end.data.substring(endOffset);
                            end = textN;
                        }
                    }
                }
                jQ('.inline-font-style').removeClass('active');
            }
            recreateRange(start, startOffset, end, endOffset);
            jQ('.ba-inline-editor').trigger(eventInline)
        }
    });
    
    jQ('.inline-weight').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        sel = window.getSelection();
        var range = sel.getRangeAt(0);
        if (jQ(sel.anchorNode).closest('.content-text').length > 0) {
            var start = range.startContainer,
                end = range.endContainer,
                endOffset = range.endOffset,
                startOffset = range.startOffset,
                link = findTag(start, end, 'strong');
            if (link.length === 0) {
                if (start.parentNode == end.parentNode) {
                    var str,
                        textNode,
                        element;
                    if (start == end && startOffset === 0 && start.data.length === endOffset) {
                        element = document.createElement('strong');
                        element.appendChild(start);
                        range.insertNode(element);
                    } else if (start == end && startOffset === 0) {
                        var textData = start.data;
                        str = textData.substring(0, endOffset);
                        textNode = document.createTextNode(str);
                        element = document.createElement('strong');
                        element.appendChild(textNode);
                        range.insertNode(element);
                        var next = element.nextSibling;
                        next.data = textData.substring(endOffset);
                        start = end = textNode;
                    } else if (start == end && start.data.length === endOffset) {
                        var textData = start.data;
                        str = textData.substring(startOffset);
                        textNode = document.createTextNode(str);
                        element = document.createElement('strong');
                        element.appendChild(textNode);
                        var next = start.nextSibling;
                        start.parentNode.insertBefore(element, next);
                        element.previousSibling.data = textData.substring(0, startOffset);
                        start = end = textNode;
                        startOffset = 0;
                        endOffset = textNode.data.length;
                    } else if (start == end) {
                        var textData = start.data;
                        str = textData.substring(startOffset, endOffset);
                        textNode = document.createTextNode(str);
                        element = document.createElement('strong');
                        element.appendChild(textNode);
                        start.parentNode.insertBefore(element, start);
                        str = textData.substring(0, startOffset);
                        var prevText = document.createTextNode(str);
                        start.parentNode.insertBefore(prevText, element);
                        start.data = textData.substring(endOffset);
                        start = end = textNode;
                        startOffset = 0;
                        endOffset = textNode.data.length
                    } else {
                        if (start.nextSibling == end && startOffset === 0 && endOffset === end.data.length) {
                            str = start.data+end.data;
                            textNode = document.createTextNode(str);
                            element = document.createElement('strong');
                            element.appendChild(textNode);
                            start.parentNode.insertBefore(element, start);
                            start.parentNode.removeChild(start);
                            end.parentNode.removeChild(end);
                            start = end = textNode;
                            startOffset = 0;
                            endOffset = textNode.data.length;
                        } else if (start.nextSibling == end && startOffset === 0) {
                            str = start.data+end.data.substring(0, endOffset);
                            textNode = document.createTextNode(str);
                            element = document.createElement('strong');
                            element.appendChild(textNode);
                            start.parentNode.insertBefore(element, start);
                            start.parentNode.removeChild(start);
                            end.data = end.data.substring(endOffset);
                            start = end = textNode;
                            startOffset = 0;
                            endOffset = textNode.data.length;
                        } else if (start.nextSibling == end && endOffset === end.data.length) {
                            str = start.data.substring(startOffset)+end.data;
                            textNode = document.createTextNode(str);
                            element = document.createElement('strong');
                            element.appendChild(textNode);
                            start.parentNode.insertBefore(element, end);
                            start.parentNode.removeChild(end);
                            start.data = start.data.substring(0, startOffset);
                            start = end = textNode;
                            startOffset = 0;
                            endOffset = textNode.data.length;
                        } else if (start.nextSibling == end) {
                            str = start.data.substring(startOffset)+end.data.substring(0, endOffset);
                            textNode = document.createTextNode(str);
                            element = document.createElement('strong');
                            element.appendChild(textNode);
                            start.parentNode.insertBefore(element, end);
                            start.data = start.data.substring(0, startOffset);
                            end.data = end.data.substring(endOffset);
                            start = end = textNode;
                            startOffset = 0;
                            endOffset = textNode.data.length;
                        } else {
                            var array = new Array(),
                                nodeList = start.parentNode.childNodes,
                                len = nodeList.length,
                                flag = false;
                            for (var i = 0; i < len; i++) {
                                if (nodeList[i] == start) {
                                flag = true;
                                }
                                if (flag && nodeList[i] != start && nodeList[i] != end) {
                                    array.push(nodeList[i]);
                                } else if (flag) {
                                    array.push(nodeList[i].cloneNode(true));
                                }
                                if (nodeList[i] == end) {
                                    break;
                                }
                            }
                            element = document.createElement('strong');
                            len = array.length;
                            start.data = start.data.substring(0, startOffset);
                            end.data = end.data.substring(endOffset);
                            array[0].data = array[0].data.substring(startOffset);
                            array[len - 1].data = array[len - 1].data.substring(0, endOffset);
                            for (var i = 0; i < len; i++) {
                                element.appendChild(array[i]);
                            }
                            start.parentNode.insertBefore(element, end);
                            start = array[0];
                            end = array[len - 1];
                            startOffset = 0;
                            endOffset = array[len -1].length;
                        }
                    }
                } else {
                    var sParent = jQ(start).parentsUntil('.content-text'),
                        eParent = jQ(end).parentsUntil('.content-text'),
                        sLen = sParent.length,
                        eLen = eParent.length,
                        general,
                        flag = true;
                    for (var i = 0; i < sLen; i++) {
                        if (flag) {
                            for (var j = 0; j < eLen; j++) {
                                if (sParent[i] == eParent[j]) {
                                    general = sParent[i];
                                    flag = false;
                                    break;
                                }
                            }
                        } else {
                            break;
                        }
                    }
                    if (!general) {
                        general = jQ(start).closest('.content-text')[0];
                    }
                    var array = new Array();
                    flag = false;
                    var newStart = start;
                    for (var i = 0; i < sLen; i++) {
                        var list = sParent[i].childNodes,
                            len = list.length;
                        if (sParent[i] != general) {
                            for (var j = 0; j < len; j++) {
                                if (flag && list[j] != end) {
                                    array.push(list[j])
                                }
                                if (list[j] == newStart) {
                                    newStart = sParent[i];
                                    flag = true;
                                }
                            }
                            flag = false;
                        }
                    }
                    var aLen = array.length,
                        lastArray = new Array();
                    var a;
                    for (var i = 0; i < aLen; i++) {
                        if (jQ.inArray(array[i].parentNode, lastArray) < 0) {
                            lastArray.push(array[i].parentNode);
                            a = document.createElement('strong');
                            array[i].parentNode.insertBefore(a, array[i])
                            a.appendChild(array[i]);
                        } else {
                            a.appendChild(array[i])
                        }

                    }
                    array = [];
                    var newEnd = end;
                    for (var i = 0; i < eLen; i++) {
                        var list = eParent[i].childNodes,
                            len = list.length;
                        if (eParent[i] != general) {
                            for (var j = 0; j < len; j++) {
                                if (list[j] == newEnd) {
                                    newEnd = eParent[i];
                                    break;
                                }
                                array.push(list[j]);
                            }
                        }
                    }
                    aLen = array.length;
                    lastArray = [];
                    var a;
                    for (var i = 0; i < aLen; i++) {
                        if (jQ.inArray(array[i].parentNode, lastArray) < 0) {
                            lastArray.push(array[i].parentNode);
                            a = document.createElement('strong');
                            array[i].parentNode.insertBefore(a, array[i])
                            a.appendChild(array[i]);
                        } else {
                            a.appendChild(array[i])
                        }

                    }
                    var list = general.children,
                        len = list.length;
                    flag = false;
                    array = []
                    for (var i = 0; i < len; i++) {
                        if (list[i] == newEnd) {
                            break;
                        }
                        if (flag) {
                            array.push(list[i])
                        }
                        if (list[i] == newStart) {
                            flag = true;
                        }
                    }
                    aLen = array.length;
                    for (var i = 0; i < aLen; i++) {
                        a = document.createElement('strong');
                        jQ(array[i]).wrapInner(a)
                    }
                    if (startOffset === 0) {
                        a = document.createElement('strong');
                        start.parentNode.insertBefore(a, start);
                        a.appendChild(start)
                    } else {
                        a = document.createElement('strong');
                        start.parentNode.insertBefore(a, start.nextSibling);
                        var textNode = document.createTextNode(start.data.substring(startOffset, start.data.length));
                        a.appendChild(textNode);
                        start.data = start.data.substring(0, startOffset)
                        startOffset = 0;
                        start = textNode;
                    }
                    if (endOffset === end.data.length) {
                        a = document.createElement('strong');
                        end.parentNode.insertBefore(a, end);
                        a.appendChild(end)
                    } else {
                        a = document.createElement('strong');
                        end.parentNode.insertBefore(a, end);
                        var textNode = document.createTextNode(end.data.substring(0, endOffset));
                        a.appendChild(textNode);
                        end.data = end.data.substring(endOffset);
                        end = textNode;
                    }
                }
                jQ('.inline-weight').addClass('active');
            } else {
                var sParent = jQ(start).parentsUntil('.content-text'),
                    eParent = jQ(end).parentsUntil('.content-text'),
                    sLen = sParent.length,
                    eLen = eParent.length,
                    general,
                    flag = true,
                    array = new Array(),
                    a = document.createElement('strong')
                if (start.parentNode != jQ(start).closest('strong')[0]) {
                    var par = jQ(start).closest('strong')[0],
                        pos = jQ.inArray(par, sParent);
                    array = [];
                    while (pos >= 0) {
                        var parList = sParent[pos].childNodes,
                            parLength = parList.length;
                        for (var j = 0; j < parLength; j++) {
                            a = document.createElement('strong');
                            a.appendChild(parList[0]);
                            if (sParent[pos].localName == 'strong') {
                                sParent[pos].parentNode.insertBefore(a, sParent[pos]);
                            } else {
                                sParent[pos].appendChild(a);
                            }
                        }
                        if (sParent[pos].localName == 'strong') {
                            sParent[pos].parentNode.removeChild(sParent[pos]);
                        } else {
                            if (sParent[pos].parentNode.localName == 'strong') {
                                array.push(sParent[pos].parentNode)
                                sParent[pos].parentNode.parentNode.insertBefore(sParent[pos], sParent[pos].parentNode);
                            }
                        }
                        pos--;
                    }
                    len = array.length;
                    for (var i = 0; i < len; i++) {
                        array[i].parentNode.removeChild(array[i]);
                    }
                    
                }
                if (end.parentNode != jQ(end).closest('strong')[0]) {
                    var par = jQ(end).closest('strong')[0],
                        pos = jQ.inArray(par, eParent);
                    array = [];
                    while (pos >= 0) {
                        var parList = eParent[pos].childNodes,
                            parLength = parList.length;
                        for (var j = 0; j < parLength; j++) {
                            a = document.createElement('strong');
                            a.appendChild(parList[0]);
                            if (eParent[pos].localName == 'strong') {
                                eParent[pos].parentNode.insertBefore(a, eParent[pos]);
                            } else {
                                eParent[pos].appendChild(a);
                            }
                        }
                        if (eParent[pos].localName == 'strong') {
                            eParent[pos].parentNode.removeChild(eParent[pos]);
                        } else {
                            if (eParent[pos].parentNode.localName == 'strong') {
                                array.push(eParent[pos].parentNode);
                                eParent[pos].parentNode.parentNode.insertBefore(eParent[pos], eParent[pos].parentNode);
                            }
                        }
                        pos--;
                    }
                    len = array.length;
                    for (var i = 0; i < len; i++) {
                        array[i].parentNode.removeChild(array[i]);
                    }
                }
                sParent = jQ(start).parentsUntil('.content-text');
                eParent = jQ(end).parentsUntil('.content-text');
                sLen = sParent.length;
                eLen = eParent.length;
                for (var i = 0; i < sLen; i++) {
                    if (flag) {
                        for (var j = 0; j < eLen; j++) {
                            if (sParent[i] == eParent[j]) {
                                general = sParent[i];
                                flag = false;
                                break;
                            }
                        }
                    } else {
                        break;
                    }
                }
                if (!general) {
                    general = jQ(start).closest('.content-text')[0];
                }
                var array = new Array(),
                    newStart = start;
                flag = false;
                for (var i = 0; i < sLen; i++) {
                    var list = sParent[i].childNodes,
                        len = list.length;
                    if (sParent[i] != general) {
                        for (var j = 0; j < len; j++) {
                            if (flag && list[j] != end) {
                                array.push(list[j])
                            }
                            if (list[j] == newStart) {
                                newStart = sParent[i];
                                flag = true;
                            }
                        }
                        flag = false;
                    } else {
                        break;
                    }
                }
                var len = array.length;
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('strong').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'strong') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                array = [];
                var newEnd = end;
                for (var i = 0; i < eLen; i++) {
                    var list = eParent[i].childNodes,
                        len = list.length;
                    if (eParent[i] != general) {
                        for (var j = 0; j < len; j++) {
                            
                            if (list[j] == newEnd) {
                                newEnd = eParent[i];
                                break;
                            }
                            array.push(list[j]);
                        }
                    } else {
                        break;
                    }
                }
                len = array.length;
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('strong').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'strong') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                flag = false;
                array = [];
                var list = general.childNodes;
                len = list.length
                for (var i = 0; i < len; i++) {
                    if (list[i] == newEnd) {
                        break;
                    }
                    if (flag) {
                        array.push(list[i])
                    }
                    if (list[i] == newStart) {
                        flag = true;
                    }
                }
                len = array.length;
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('strong').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'strong') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                if (start == end) {
                    var parent = end.parentNode,
                        list = parent.childNodes,
                        len = list.length,
                        strong = document.createElement('strong');
                    for (var i = 0; i < len; i++) {
                        if (list[0] == end) {
                            var textN = document.createTextNode(end.data.substring(startOffset, endOffset)),
                                textS = document.createTextNode(end.data.substring(0, startOffset));
                            strong.appendChild(textS);
                            parent.parentNode.insertBefore(strong, parent);
                            parent.parentNode.insertBefore(textN, strong.nextSibling);
                            strong = document.createElement('strong');
                            parent.parentNode.insertBefore(strong, parent);
                            end.data = end.data.substring(endOffset);
                            startOffset = 0;
                            endOffset = textN.data.length;
                            start = end = textN;
                        }
                        strong.appendChild(list[0])
                    }
                    parent.parentNode.removeChild(parent)
                    if (strong.firstChild.data == '') {
                        strong.removeChild(strong.firstChild)
                    }
                    if (strong.childNodes.length == 0) {
                        strong.parentNode.removeChild(strong);
                    }
                    if (end.previousSibling.lastChild.data == '') {
                        end.previousSibling.removeChild(end.previousSibling.lastChild)
                    }
                    if (end.previousSibling.childNodes.length == 0) {
                        end.parentNode.removeChild(end.previousSibling)
                    }
                } else {
                    if (end.parentNode == start.parentNode && end.parentNode.localName == 'strong') {
                        var parent = end.parentNode,
                            list = parent.childNodes,
                            len = list.length,
                            number = 0,
                            textN,
                            flag = true,
                            strong = document.createElement('strong');
                        for (var i = 0; i < len; i++) {
                            if (!flag) {
                                strong.appendChild(list[number]);
                            }
                            if (list[number] == end) {
                                var eText = document.createTextNode(end.data.substring(0, endOffset));
                                end.data = end.data.substring(endOffset);
                                parent.parentNode.insertBefore(eText, textN.nextSibling);
                                parent.parentNode.insertBefore(strong, eText.nextSibling);
                                strong.appendChild(list[number]);
                                end = eText;
                                flag = false;
                            }
                            if (number > 0 && flag) {
                                var item = list[number];
                                parent.parentNode.insertBefore(list[number], textN.nextSibling);
                                textN = item;
                            }
                            if (list[i] == start) {
                                textN = document.createTextNode(start.data.substring(startOffset));
                                start.data = start.data.substring(0, startOffset);
                                start = textN;
                                startOffset = 0;
                                parent.parentNode.insertBefore(textN, parent.nextSibling);
                                number = i + 1;
                            }
                        }
                        if (list[number - 1].data == '') {
                            parent.removeChild(list[number - 1])
                        }
                        if (list.length == 0) {
                            parent.parentNode.removeChild(parent);
                        }
                        if (strong.firstChild.data == '') {
                            strong.removeChild(strong.firstChild)
                        }
                        if (strong.childNodes.length == 0) {
                            strong.parentNode.removeChild(strong)
                        }
                    } else if (end.parentNode == start.parentNode) {
                        var parent = end.parentNode,
                            list = parent.childNodes,
                            len = list.length,
                            number = 0,
                            flag = false,
                            array = new Array();
                        for (var i = 0; i < len; i++) {
                            if (list[i] == end) {
                                break;
                            }
                            if (list[i].localName == 'strong' && flag) {
                                var newList = list[i].childNodes,
                                    newLen = newList.length;
                                for (var j = 0; j < newLen; j++) {
                                    parent.insertBefore(newLen[0], list[i]);
                                }
                                array.push(list[i])
                            }
                            if (start == list[i]) {
                                flag = true
                            }
                        }
                        len = array.length;
                        for (var i = 0; i < len; i++) {
                            parent.removeChild(array[i])
                        }
                    } else {
                        var textN = document.createTextNode(start.data.substring(startOffset));
                        if (start.parentNode.localName == 'strong') {
                            start.data = start.data.substring(0, startOffset);
                            start.parentNode.parentNode.insertBefore(textN, start.parentNode.nextSibling);
                            if (startOffset === 0) {
                                start.parentNode.parentNode.removeChild(start.parentNode)
                            }
                            start = textN;
                            startOffset = 0;
                        }
                        if (end.parentNode.localName == 'strong') {
                            list = end.parentNode.childNodes;
                            len = list.length;
                            for (var i = 0; i < len; i++) {
                                if (list[0] == end) {
                                    break;
                                }
                                end.parentNode.parentNode.insertBefore(list[0], end.parentNode);
                            }
                            textN = document.createTextNode(end.data.substring(0, endOffset));
                            end.parentNode.parentNode.insertBefore(textN, end.parentNode);
                            if (endOffset === end.data.length) {
                                end.parentNode.parentNode.removeChild(end.parentNode);
                            }
                            end.data = end.data.substring(endOffset);
                            end = textN;
                        }
                    }
                    
                }
                jQ('.inline-weight').removeClass('active');
            }
            recreateRange(start, startOffset, end, endOffset);
            jQ('.ba-inline-editor').trigger(eventInline)
        }
    });
    
    jQ('.inline-apply-link').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        var rng = document.createRange();
        rng.setStart(inlineStart, inlineStartOffset);
        rng.setEnd(inlineEnd, inlineEndOffset);
        sel.removeAllRanges();
        sel.addRange(rng);
        var inlineHref = jQ('.inline-link-href').val(),
            inlineTarget = jQ('.inline-link-target').val();
        addInlineLink(inlineHref, inlineTarget);
        jQ('.ba-inline-edit-area').show();
        jQ('.inline-link-area').hide();
        jQ('.inline-link').addClass('active');
        jQ('.ba-inline-editor').trigger(eventInline)
    });
    
    jQ('.inline-close-link').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        var rng = document.createRange();
        rng.setStart(inlineStart, inlineStartOffset);
        rng.setEnd(inlineEnd, inlineEndOffset);
        sel.removeAllRanges();
        sel.addRange(rng);
        jQ('.ba-inline-edit-area').show();
        jQ('.inline-link-area').hide();
    });
    
    jQ('.inline-link').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        sel = window.getSelection();
        var range = sel.getRangeAt(0);
        if (jQ(sel.anchorNode).closest('.content-text').length > 0) {
            var start = range.startContainer,
                end = range.endContainer,
                endOffset = range.endOffset,
                startOffset = range.startOffset,
                link = findTag(start, end, 'a');
            if (link.length === 0) {
                inlineStart = start,
                inlineEnd = end,
                inlineStartOffset = startOffset,
                inlineEndOffset = endOffset;
                jQ('.inline-link-href').val('');
                jQ('.ba-inline-edit-area').hide();
                jQ('.inline-link-area').show();
            } else {
                var sParent = jQ(start).parentsUntil('.content-text'),
                    eParent = jQ(end).parentsUntil('.content-text'),
                    sLen = sParent.length,
                    eLen = eParent.length,
                    general,
                    len,
                    flag = true,
                    array = new Array(),
                    a;
                if (start.parentNode != jQ(start).closest('a')[0]) {
                    var par = jQ(start).closest('a')[0],
                        pos = jQ.inArray(par, sParent);
                    array = [];
                    while (pos >= 0) {
                        var parList = sParent[pos].childNodes,
                            parLength = parList.length,
                            inlineHref = par.href,
                            inlineTarget = par.target;
                        for (var j = 0; j < parLength; j++) {
                            a = createLink(inlineHref, inlineTarget);
                            a.appendChild(parList[0]);
                            if (sParent[pos].localName == 'a') {
                                sParent[pos].parentNode.insertBefore(a, sParent[pos]);
                            } else {
                                sParent[pos].appendChild(a);
                            }
                        }
                        if (sParent[pos].localName == 'a') {
                            sParent[pos].parentNode.removeChild(sParent[pos]);
                        } else {
                            if (sParent[pos].parentNode.localName == 'a') {
                                array.push(sParent[pos].parentNode)
                                sParent[pos].parentNode.parentNode.insertBefore(sParent[pos], sParent[pos].parentNode);
                            }
                        }
                        pos--;
                    }
                    len = array.length;
                    for (var i = 0; i < len; i++) {
                        array[i].parentNode.removeChild(array[i]);
                    }
                    
                }
                if (end.parentNode != jQ(end).closest('a')[0]) {
                    var par = jQ(end).closest('a')[0],
                        pos = jQ.inArray(par, eParent);
                    array = [];
                    while (pos >= 0) {
                        var parList = eParent[pos].childNodes,
                            parLength = parList.length,
                            inlineHref = par.href,
                            inlineTarget = par.target;
                        for (var j = 0; j < parLength; j++) {
                            a = createLink(inlineHref, inlineTarget);;
                            a.appendChild(parList[0]);
                            if (eParent[pos].localName == 'a') {
                                eParent[pos].parentNode.insertBefore(a, eParent[pos]);
                            } else {
                                eParent[pos].appendChild(a);
                            }
                        }
                        if (eParent[pos].localName == 'a') {
                            eParent[pos].parentNode.removeChild(eParent[pos]);
                        } else {
                            if (eParent[pos].parentNode.localName == 'a') {
                                array.push(eParent[pos].parentNode);
                                eParent[pos].parentNode.parentNode.insertBefore(eParent[pos], eParent[pos].parentNode);
                            }
                        }
                        pos--;
                    }
                    len = array.length;
                    for (var i = 0; i < len; i++) {
                        array[i].parentNode.removeChild(array[i]);
                    }
                }
                sParent = jQ(start).parentsUntil('.content-text');
                eParent = jQ(end).parentsUntil('.content-text');
                sLen = sParent.length;
                eLen = eParent.length;
                for (var i = 0; i < sLen; i++) {
                    if (flag) {
                        for (var j = 0; j < eLen; j++) {
                            if (sParent[i] == eParent[j]) {
                                general = sParent[i];
                                flag = false;
                                break;
                            }
                        }
                    } else {
                        break;
                    }
                }
                if (!general) {
                    general = jQ(start).closest('.content-text')[0];
                }
                var array = new Array();
                flag = false;
                var newStart = start;
                for (var i = 0; i < sLen; i++) {
                    var list = sParent[i].childNodes,
                        len = list.length;
                    if (sParent[i] != general) {
                        for (var j = 0; j < len; j++) {
                            if (flag && list[j] != end) {
                                array.push(list[j])
                            }
                            if (list[j] == newStart) {
                                newStart = sParent[i];
                                flag = true;
                            }
                        }
                        flag = false;
                    } else {
                        break;
                    }
                }
                var len = array.length;
                
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('a').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'a') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                array = [];
                var newEnd = end;
                for (var i = 0; i < eLen; i++) {
                    var list = eParent[i].childNodes,
                        len = list.length;
                    if (eParent[i] != general) {
                        for (var j = 0; j < len; j++) {
                            
                            if (list[j] == newEnd) {
                                newEnd = eParent[i];
                                break;
                            }
                            array.push(list[j]);
                        }
                    } else {
                        break;
                    }
                }
                len = array.length;
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('a').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'a') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                flag = false;
                array = [];
                var list = general.childNodes;
                len = list.length
                for (var i = 0; i < len; i++) {
                    if (list[i] == newEnd) {
                        break;
                    }
                    if (flag) {
                        array.push(list[i])
                    }
                    if (list[i] == newStart) {
                        flag = true;
                    }
                }
                len = array.length;
                for (var i = 0; i < len; i++) {
                    jQ(array[i]).find('a').each(function(){
                        var parent = this.parentNode,
                            childs = this.childNodes,
                            childLen = childs.length;
                        for (var j = 0; j < childLen; j++) {
                            parent.insertBefore(childs[j], this);
                        }
                        parent.removeChild(this);
                    });
                    if (array[i].localName == 'a') {
                        var childs = array[i].childNodes,
                            leng = childs.length;
                        for (var j = 0; j < leng; j++) {
                            array[i].parentNode.insertBefore(childs[0], array[i]);
                        }
                        array[i].parentNode.removeChild(array[i])
                    }
                }
                if (start == end) {
                    var parent = end.parentNode,
                        list = parent.childNodes,
                        len = list.length,
                        inlineHref = end.parentNode.href,
                        inlineTarget = end.parentNode.target,
                        strong = createLink(inlineHref, inlineTarget);
                    for (var i = 0; i < len; i++) {
                        if (list[0] == end) {
                            var textN = document.createTextNode(end.data.substring(startOffset, endOffset)),
                                textS = document.createTextNode(end.data.substring(0, startOffset));
                            strong.appendChild(textS);
                            parent.parentNode.insertBefore(strong, parent);
                            parent.parentNode.insertBefore(textN, strong.nextSibling);
                            strong = createLink(inlineHref, inlineTarget);
                            parent.parentNode.insertBefore(strong, parent);
                            end.data = end.data.substring(endOffset);
                            startOffset = 0;
                            endOffset = textN.data.length;
                            start = end = textN;
                        }
                        strong.appendChild(list[0])
                    }
                    parent.parentNode.removeChild(parent)
                    if (strong.firstChild.data == '') {
                        strong.removeChild(strong.firstChild)
                    }
                    if (strong.childNodes.length == 0) {
                        strong.parentNode.removeChild(strong);
                    }
                    if (end.previousSibling.lastChild.data == '') {
                        end.previousSibling.removeChild(end.previousSibling.lastChild)
                    }
                    if (end.previousSibling.childNodes.length == 0) {
                        end.parentNode.removeChild(end.previousSibling)
                    }
                } else {
                    if (end.parentNode == start.parentNode && end.parentNode.localName == 'a') {
                        var parent = end.parentNode,
                            list = parent.childNodes,
                            len = list.length,
                            number = 0,
                            textN,
                            flag = true,
                            inlineHref = end.parentNode.href,
                            inlineTarget = end.parentNode.target,
                            strong = createLink(inlineHref, inlineTarget);
                        for (var i = 0; i < len; i++) {
                            if (!flag) {
                                strong.appendChild(list[number]);
                            }
                            if (list[number] == end) {
                                var eText = document.createTextNode(end.data.substring(0, endOffset));
                                end.data = end.data.substring(endOffset);
                                parent.parentNode.insertBefore(eText, textN.nextSibling);
                                parent.parentNode.insertBefore(strong, eText.nextSibling);
                                strong.appendChild(list[number]);
                                end = eText;
                                flag = false;
                            }
                            if (number > 0 && flag) {
                                var item = list[number];
                                parent.parentNode.insertBefore(list[number], textN.nextSibling);
                                textN = item;
                            }
                            if (list[i] == start) {
                                textN = document.createTextNode(start.data.substring(startOffset));
                                start.data = start.data.substring(0, startOffset);
                                start = textN;
                                startOffset = 0;
                                parent.parentNode.insertBefore(textN, parent.nextSibling);
                                number = i + 1;
                            }
                        }
                        if (list[number - 1].data == '') {
                            parent.removeChild(list[number - 1])
                        }
                        if (list.length == 0) {
                            parent.parentNode.removeChild(parent);
                        }
                        if (strong.firstChild.data == '') {
                            strong.removeChild(strong.firstChild)
                        }
                        if (strong.childNodes.length == 0) {
                            strong.parentNode.removeChild(strong)
                        }
                    } else if (end.parentNode == start.parentNode) {
                        var parent = end.parentNode,
                            list = parent.childNodes,
                            len = list.length,
                            number = 0,
                            flag = false,
                            array = new Array();
                        for (var i = 0; i < len; i++) {
                            if (list[i] == end) {
                                break;
                            }
                            if (list[i].localName == 'a' && flag) {
                                var newList = list[i].childNodes,
                                    newLen = newList.length;
                                for (var j = 0; j < newLen; j++) {
                                    parent.insertBefore(newLen[0], list[i]);
                                }
                                array.push(list[i])
                            }
                            if (start == list[i]) {
                                flag = true
                            }
                        }
                        len = array.length;
                        for (var i = 0; i < len; i++) {
                            parent.removeChild(array[i])
                        }
                    } else {
                        var textN = document.createTextNode(start.data.substring(startOffset));
                        if (start.parentNode.localName == 'a') {
                            start.data = start.data.substring(0, startOffset);
                            start.parentNode.parentNode.insertBefore(textN, start.parentNode.nextSibling);
                            if (startOffset === 0) {
                                start.parentNode.parentNode.removeChild(start.parentNode)
                            }
                            start = textN;
                            startOffset = 0;
                        }
                        if (end.parentNode.localName == 'a') {
                            list = end.parentNode.childNodes;
                            len = list.length;
                            for (var i = 0; i < len; i++) {
                                if (list[0] == end) {
                                    break;
                                }
                                end.parentNode.parentNode.insertBefore(list[0], end.parentNode);
                            }
                            textN = document.createTextNode(end.data.substring(0, endOffset));
                            end.parentNode.parentNode.insertBefore(textN, end.parentNode);
                            if (endOffset === end.data.length) {
                                end.parentNode.parentNode.removeChild(end.parentNode)
                            }
                            end.data = end.data.substring(endOffset);
                            end = textN;
                        }
                    }
                }
                jQ('.inline-link').removeClass('active');
                recreateRange(start, startOffset, end, endOffset);
                jQ('.ba-inline-editor').trigger(eventInline)
            }
        }
    });
    
    jQ('.inline-list').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        sel = window.getSelection();
        var range = sel.getRangeAt(0);
        if (jQ(sel.anchorNode).closest('.content-text').length > 0) {
            var endOffset = range.endOffset,
                start = range.startContainer,
                end = range.endContainer,
                startOffset = range.startOffset,
                startContainer = jQ(start).parentsUntil('.content-text'),
                endContainer = jQ(end).parentsUntil('.content-text'),
                startLength = startContainer.length -1,
                endLength = endContainer.length -1;
            if (startContainer[startLength] == endContainer[endLength]) {
                if (startContainer[startLength].localName != 'ul') {
                    jQ(this).addClass('active');
                    var selAParent = jQ(sel.anchorNode).parentsUntil('.content-text');
                    selAParent = selAParent[selAParent.length - 1];
                    preListTag = selAParent.localName;
                    tag = document.createElement('li');
                    var len = selAParent.childNodes.length;
                    for (var i = 0; i < len; i++) {
                        tag.appendChild(selAParent.childNodes[0]);
                    }
                    jQ(selAParent).replaceWith(tag);
                    jQ(tag).wrap('<ul></ul>');
                } else {
                    jQ(this).removeClass('active');
                    var selAParent = jQ(sel.anchorNode).parentsUntil('.content-text');
                    selAParent = selAParent[selAParent.length - 1];
                    var nodeList = selAParent.childNodes,
                        len = nodeList.length,
                        tag;
                    for (var i = 0; i < len; i++) {
                        tag =  document.createElement(preListTag);
                        var leng = nodeList[i].childNodes.length;
                        for (var j = 0; j < leng; j++) {
                            tag.appendChild(nodeList[i].childNodes[0]);
                        }
                        jQ(nodeList[i]).replaceWith(tag);
                    }
                    jQ(tag).unwrap();
                }
            } else {
                if (startContainer[startLength].localName != 'ul') {
                    jQ(this).addClass('active');
                    var textArea = endContainer.parent(),
                        array = new Array(),
                        flag = false;
                    textArea.children().each(function(){
                        if (!flag) {
                            if (jQ(this)[0] == startContainer[startContainer.length - 1]) {
                                preListTag = this.localName;
                                flag = true;
                            }
                        }
                        if (flag) {
                            array.push(this);
                            if (jQ(this)[0] == endContainer[endContainer.length - 1]) {
                                return false;
                            }
                        }
                    });
                    var len = array.length,
                        tag,
                        ul = document.createElement('ul');
                    jQ(array[0]).before(ul)
                    for (var i = 0; i < len; i++) {
                        var nodeList = array[i].childNodes;
                        tag = document.createElement('li');
                        var newLen = nodeList.length
                        for (var j = 0; j < newLen; j++) {
                            
                            tag.appendChild(nodeList[0]);
                        }
                        jQ(array[i]).replaceWith(tag);
                        ul.appendChild(tag)
                    }
                }  else {
                    jQ(this).removeClass('active');
                    var selAParent = jQ(sel.anchorNode).parentsUntil('.content-text');
                    selAParent = selAParent[selAParent.length - 1];
                    var nodeList = selAParent.childNodes,
                        len = nodeList.length,
                        tag;
                    for (var i = 0; i < len; i++) {
                        tag =  document.createElement(preListTag);
                        var leng = nodeList[i].childNodes.length;
                        for (var j = 0; j < leng; j++) {
                            tag.appendChild(nodeList[i].childNodes[0]);
                        }
                        jQ(nodeList[i]).replaceWith(tag);
                    }
                    jQ(tag).unwrap();
                }
            }
            recreateRange(start, startOffset, end, endOffset)
            jQ('.ba-inline-editor').trigger(eventInline)
        }
    });
    
    jQ('.inline-text-align').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        sel = window.getSelection();
        jQ('.inline-text-align.active').removeClass('active');
        jQ(this).addClass('active');
        var align = jQ(this).attr('data-value'),
            range = sel.getRangeAt(0);
        if (jQ(sel.anchorNode).closest('.content-text').length > 0) {
            if (sel.anchorNode == sel.focusNode) {
                var selAParent = jQ(sel.anchorNode).parentsUntil('.content-text');
                selAParent = selAParent[selAParent.length - 1];
                jQ(selAParent).css('text-align', align);
            } else {
                var startContainer = jQ(range.startContainer).parentsUntil('.content-text'),
                    endContainer = jQ(range.endContainer).parentsUntil('.content-text'),
                    textArea = endContainer.parent(),
                    flag = false,
                    array = new Array(),
                    countLength;
                textArea.children().each(function(){
                    if (!flag) {
                        if (jQ(this)[0] == startContainer[startContainer.length - 1]) {
                            flag = true;
                        }
                    }
                    if (flag) {
                        array.push(jQ(this));
                        if (jQ(this)[0] == endContainer[endContainer.length - 1]) {
                            return false;
                        }
                    }
                });
                countLength = array.length-1;
                if (array[0] != array[countLength]) {
                    array.forEach(function(el, i, arr) {
                        jQ(el).css('text-align', align);
                    });
                } else {
                    array[0].css('text-align', align);
                }
            }
            jQ('.ba-inline-editor').trigger(eventInline)
        }
    });
});