/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

!function ($) {
    
    var ba_slideset = function (element, options) {
        this.parent = $(element).find('.slideset-content');
        this.dots = this.parent.find('.ba-slideset-dots');
        this.options = options;
        this.currentIndex = 0;
        this.childrens = this.parent.children();
        this.allowSlide = true;
        if (this.options.mode == 'set') {
            this.childCount = Math.floor(this.childrens.length / this.options.count);
            if (this.childCount < this.childrens.length / this.options.count) {
                this.childCount++;
            }
        } else {
            this.lastActive = new Array();
            this.childCount = this.childrens.length;
            this.parent.parent().addClass('single');
        }
        if (this.parent.parent().hasClass('slideset-gutter')) {
            this.left = (this.parent.width() - ((this.options.count - 1) * 30)) / this.options.count;
            this.left = this.left + 30;
        } else {
            this.left = this.parent.width() / this.options.count;
        }
        this.parent.find('.active').removeClass('active');
        for (var i = 0; i < this.options.count; i++) {
            $(this.childrens[i]).addClass('active');
        }
        this.parent.find('.active').first();
        $('.ba-slideset-dots .active').removeClass('active');
        this.clearAnimation();
        $('.ba-slideset-dots [data-ba-slide-to="'+this.currentIndex+'"]').addClass('active');
        this.setLeft(this.left);
        this.setHeight();
    }
    
    ba_slideset.prototype = {
        cycle: function (event) {
            if (this.options.autoplay == 1) {
                if (this.interval) {
                    clearInterval(this.interval);
                }
                this.interval = setInterval($.proxy(this.slide, this), this.options.interval);
                return this;
            }
        },
        delete: function(){
            if (this.interval) {
                clearInterval(this.interval);
            }
            this.parent.parent().removeClass(this.options.effect).removeClass('single');
            this.interval = null;
            this.parent.parent().find('[data-slide]').off('click.ba_slideset');
            this.parent.parent().find('[data-ba-slide-to]').off('click.ba_slideset');
            this.parent.parent().off();
        },
        to: function (pos) {
            pos = pos*1;
            if (pos != this.currentIndex) {
                if (this.interval) {
                    clearInterval(this.interval);
                }
                this.clearAnimation();
                if (this.options.mode == 'set') {
                    var flag,
                        nFlag;
                    if (this.currentIndex == 0 && pos == this.childCount - 1) {
                            flag = 'left-animation';
                            nFlag = 'prev-animation';
                        } else if (this.currentIndex == this.childCount - 1 && pos == 0) {
                            flag = 'right-animation';
                            nFlag = 'next-animation';
                        } else if (this.currentIndex < pos) {
                            flag = 'right-animation';
                            nFlag = 'next-animation';
                        } else {
                            flag = 'left-animation';
                            nFlag = 'prev-animation';
                        }
                    this.parent.parent().find('.ba-slideset-dots .active').removeClass('active');
                    this.parent.find('.active').removeClass('active').addClass(nFlag);
                    for (var i = pos*this.options.count; i < pos*this.options.count + this.options.count; i++) {
                        $(this.childrens[i]).addClass('active').addClass(flag);
                    }
                    this.setLeft(this.left);
                } else {
                    this.parent.parent().find('.ba-slideset-dots .active').removeClass('active');
                    this.lastActive = this.parent.find('.active');
                    this.parent.find('.active').removeClass('active');
                    if (this.childCount - pos < this.options.count) {
                        var left = 0;
                        for (var i = pos; i < this.childCount; i++) {
                            $(this.childrens[i]).addClass('active').css('left', left);
                            left += this.left;
                        }
                        for (var i = 0; i < this.options.count - (this.childCount - pos); i++) {
                            $(this.childrens[i]).addClass('active').css('left', left);
                            left += this.left;
                        }
                    } else {
                        for (var i = pos; i < pos + this.options.count; i++) {
                            $(this.childrens[i]).addClass('active');
                            this.setLeft(this.left)
                        }
                    }
                    var array = this.parent.find('.active');
                    for (var i = 0; i < this.lastActive.length; i++) {
                        if ($.inArray(this.lastActive[i], array) < 0) {
                            if (this.currentIndex == 0 && pos == this.childCount - 1) {
                                $(this.lastActive[i]).addClass('left-animation');
                            } else if (this.currentIndex == this.childCount - 1 && pos == 0) {
                                $(this.lastActive[i]).addClass('right-animation');
                            } else if (this.currentIndex < pos) {
                                $(this.lastActive[i]).addClass('right-animation');
                            } else {
                                $(this.lastActive[i]).addClass('left-animation');
                            }
                        }
                        if ($.inArray(array[i], this.lastActive) < 0) {
                            if (this.currentIndex == 0 && pos == this.childCount - 1) {
                                $(array[i]).addClass('prev-animation');
                            } else if (this.currentIndex == this.childCount - 1 && pos == 0) {
                                $(array[i]).addClass('next-animation');
                            } else if (this.currentIndex < pos) {
                                $(array[i]).addClass('next-animation');
                            } else {
                                $(array[i]).addClass('prev-animation');
                            }
                        }
                    }
                }
                var parent = this.parent,
                    that = this;
                setTimeout(function(){
                    that.clearAnimation();
                    that.allowSlide = true;
                }, 700);
                this.setHeight();
                this.currentIndex = pos;
                this.parent.parent().find('.ba-slideset-dots [data-ba-slide-to="'+this.currentIndex+'"]').addClass('active');
                this.cycle();
            }
        },
        clearAnimation: function(){
            this.parent.find('.left-animation').removeClass('left-animation');
            this.parent.find('.right-animation').removeClass('right-animation');
            this.parent.find('.prev-animation').removeClass('prev-animation');
            this.parent.find('.next-animation').removeClass('next-animation');
        },
        setHeight: function(){
            var height = 0;
            this.parent.find('.active').each(function(){
                if (jQuery(this).height() > height) {
                    height = jQuery(this).height();
                }
            });
            this.parent.height(height);
        },
        next : function() {
            if (this.allowSlide) {
                var pos = this.currentIndex + 1;
                if (pos > this.childCount -1) {
                    pos = 0;
                }
                this.to(pos);
                this.allowSlide = false;
            }
        },
        prev : function(){
            if (this.allowSlide) {
                var pos = this.currentIndex - 1;
                if (pos < 0) {
                    pos = this.childCount - 1;
                }
                this.to(pos);
                this.allowSlide = false;
            }
        },
        setLeft: function(left){
            this.parent.find('.active').each(function(ind, el){
                $(this).css({
                    'left' : left*ind
                });
            });
        },
        slide: function () {
            var pos = this.currentIndex + 1;
            if (pos > this.childCount -1) {
                pos = 0;
            }
            this.to(pos);
        }
    }
    
    $.fn.ba_slideset = function (option) {
        return this.each(function () {
            var $this = $(this),
                data = $this.data('ba_slideset'),
                options = $.extend({}, $.fn.ba_slideset.defaults, typeof option == 'object' && option);
            if (!data) {
                $this.data('ba_slideset', (data = new ba_slideset(this, options)));
            }
            if (option == 'delete') {
                data.delete('ba_slideset');
                $this.removeData();
            } else {
                $this.addClass(options.effect)
                data.cycle();
                $this.find('[data-ba-slide-to]').on('click.ba_slideset', function (event) {
                    event.preventDefault();
                    var index = $(this).attr('data-ba-slide-to');
                    data.to(index);
                });
                $this.find('[data-slide]').on('click.ba_slideset',  function (event) {
                    event.preventDefault();
                    var action = $(this).attr('data-slide');
                    data[action]();
                });
            }
        });
    }
    
    $.fn.ba_slideset.defaults = {
        interval: 3000,
        autoplay: 1,
        effect: '',
        mode : 'set',
        count : 3
    }
}(window.jQ ? window.jQ : window.jQuery);