/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

!function ($) {
    
    var ba_social = function (element, options) {
        this.parent = $(element);
        this.options = options;
        this.desc = $('meta[name="description"]').attr('content');
        if (!this.desc) {
            this.desc = '';
        }
        this.desc = encodeURIComponent(this.desc);
    }
    social = {
        facebook : {
            counterUrl : 'https://graph.facebook.com/?id={url}&callback=?',
            getNumber : function(data){
                if (data.share === undefined) {
                    return 0;
                } else {
                    return data.share.share_count;
                }
            },
            popupUrl : 'https://www.facebook.com/sharer/sharer.php?u={url}'
        },
        twitter: {
            popupUrl: 'https://twitter.com/intent/tweet?text='+encodeURIComponent($('title').text())+'&url={url}'
        },
        google : {
            counterUrl: location.protocol + '//share.yandex.ru/gpp.xml?url={url}&callback=?',
            getNumber: function(number) {
                return parseInt(number.replace(/\D/g, ''), 10);
            },
            popupUrl: 'https://plus.google.com/share?url={url}'
        },
        pinterest: {
            counterUrl: location.protocol + '//api.pinterest.com/v1/urls/count.json?url={url}&callback=?',
            getNumber: function(data) {
                return data.count;
            },
            popupUrl: 'https://pinterest.com/pin/create/button/?url={url}&description='+
                        encodeURIComponent($('title').text())+'&media='
        },
        vk: {
            counterUrl: 'https://vk.com/share.php?act=count&index=1&url={url}&callback=?',
            getNumber: function(data) {
                
            },
            popupUrl: 'http://vk.com/share.php?url={url}&title='+
                encodeURIComponent($('title').text())+'&description='
        },
        linkedin : {
            counterUrl : 'https://www.linkedin.com/countserv/count/share?url={url}&callback=?',
            getNumber: function(data) {
                return data.count;
            },
            popupUrl: 'http://www.linkedin.com/shareArticle?url={url}'
                    + '&text='+ encodeURIComponent($('title').text())
        }
    };
    
    ba_social.prototype = {
        init : function(){
            var parent = this.parent,
                options = this.options,
                selector;
            for(var key in social) {
                if (this.options.counters == 1) {
                    if (options[key] == 1 && key != 'twitter') {
                        this.setCounters(key);
                    }
                }
                if (key != 'google') {
                    selector = '.'+key;
                } else {
                    selector = '.google-plus';
                }
                this.click(selector, key)
            }
        },
        click :function(selector, key){
            var that = this;
            this.parent.find(selector).on('click.ba_social', function(){
                var url = social[key].popupUrl.replace('{url}', encodeURIComponent(window.location.href));
                if (key == 'pinterest') {
                    url += that.options.image;
                } else if (key == 'vk') {
                    url += that.desc+'&image='+that.options.image;
                }
                var win = window.open(url, 'sharer', 'toolbar=0, status=0, width=626, height=436');
                if (key != 'twitter' && that.options.counters == 1) {
                    var interval = setInterval(function(){
                        if (win.closed) {
                            clearInterval(interval);
                            that.setCounters(key);
                        }
                    }, 500);
                }
            });
        },
        delete : function(){
            this.parent.find('.facebook, .twitter, .google-plus, .pinterest, .linkedin, .vk').off('click.ba_social');
        },
        setCounters : function(key){
            var parent = this.parent,
                options = this.options
            var url = social[key].counterUrl.replace('{url}', encodeURIComponent(window.location.href));
            if (key == 'vk' && !window.VK) {
                VK = {};
                VK.Share = {
                    count: function(index, count) {
                        $('.vk .social-counter').text(count);
                    }
                };
            }
            $.getJSON(url, function(data){
                var number = social[key].getNumber(data);
                if (!number) {
                    number = 0;
                }
                if (key != 'google') {
                    parent.find('.'+key+' .social-counter').text(number);
                } else {
                    parent.find('.google-plus .social-counter').text(number);
                }
            });
        }
    }
    
    $.fn.ba_social = function (option) {
        return this.each(function () {
            var $this = $(this),
                data = $this.data('ba_social'),
                options = $.extend({}, $.fn.ba_social.defaults, typeof option == 'object' && option);
            if (!data) {
                $this.data('ba_social', (data = new ba_social(this, options)));
            }
            if (option == 'delete') {
                data.delete('ba_social');
                $this.removeData();
            } else {
                data.init();
            }
        });
    }
    
    $.fn.ba_social.defaults = {
        counters : 1,
        facebook : 1,
        twitter : 1,
        google : 1,
        linkedin : 1,
        pinterest : 1,
        vk : 1,
        image : ''
    }
    
}(window.jQ ? window.jQ : window.jQuery);