/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/


!function ($) {

    var ba_weather = function (element, options) {
        this.parent = $(element);
        this.options = options;
        this.query;
    }
    
    ba_weather.prototype = {
        init : function(){
            var src,
                $this = this;
            src = $this.makeYQL();
            $.getJSON(src, function(data) {
                if (data.query.results) {
                    var query = data.query.results.channel;
                    $this.query = {
                        code : query.item.condition.code,
                        temp : query.item.condition.temp,
                        humidity : query.atmosphere.humidity,
                        pressure : query.atmosphere.pressure,
                        sunrise : query.astronomy.sunrise,
                        sunset : query.astronomy.sunset,
                        direction : query.wind.direction,
                        speed : query.wind.speed,
                        forecast : query.item.forecast
                    }
                    $this.create();
                }
            });
        },
        lang : {
            en : {
                'wind' : 'Wind',
                'humidity' : 'Humidity',
                'pressure' : 'Pressure',
                'sunrise' : 'Sunrise',
                'sunset' : 'Sunset',
                'mon' : 'Mon',
                'tue' : 'Tue',
                'wed' : 'Wed',
                'thu' : 'Thu',
                'fri' : 'Fri',
                'sat' : 'Sat',
                'sun' : 'Sun',
                '0' : 'Jan.',
                '1' : 'Feb.',
                '2' : 'Mar.',
                '3' : 'Apr.',
                '4' : 'May',
                '5' : 'June',
                '6' : 'July',
                '7' : 'Aug.',
                '8' : 'Sept.',
                '9' : 'Oct.',
                '10' : 'Nov.',
                '11' : 'Dec.'
            },
            fr : {
                'wind' : 'Vent',
                'humidity' : 'Humidité',
                'pressure' : 'Pression',
                'sunrise' : 'lever du soleil',
                'sunset' : 'Le coucher du soleil',
                'mon' : 'Lu',
                'tue' : 'Ma',
                'wed' : 'Me',
                'thu' : 'Je',
                'fri' : 'Ve',
                'sat' : 'Sa',
                'sun' : 'Di',
                '0' : 'janv.',
                '1' : 'févr.',
                '2' : 'mars',
                '3' : 'avril',
                '4' : 'mai',
                '5' : 'juin',
                '6' : 'juil.',
                '7' : 'août',
                '8' : 'sept.',
                '9' : 'oct.',
                '10' : 'nov.',
                '11' : 'déc.'
            },
            de : {
                'wind' : 'Wind',
                'humidity' : 'Feuchtigkeit',
                'pressure' : 'Druck',
                'sunrise' : 'Sonnenaufgang',
                'sunset' : 'Sonnenuntergang',
                'mon' : 'Mo',
                'tue' : 'Di',
                'wed' : 'Mi',
                'thu' : 'Do',
                'fri' : 'Fr',
                'sat' : 'Sa',
                'sun' : 'So',
                '0' : 'Jan.',
                '1' : 'Feb.',
                '2' : 'März',
                '3' : 'Apr.',
                '4' : 'Mai',
                '5' : 'Juni',
                '6' : 'Juli',
                '7' : 'Aug.',
                '8' : 'Sept.',
                '9' : 'Okt.',
                '10' : 'Nov.',
                '11' : 'Dez.'
            },
            it : {
                'wind' : 'Vento',
                'humidity' : 'Umidità',
                'pressure' : 'Pressione',
                'sunrise' : 'Alba',
                'sunset' : 'Tramonto',
                'mon' : 'Lu',
                'tue' : 'Ma',
                'wed' : 'Me',
                'thu' : 'Gi',
                'fri' : 'Ve',
                'sat' : 'Sa',
                'sun' : 'Do',
                '0' : 'genn.',
                '1' : 'febbr.',
                '2' : 'mar.',
                '3' : 'apr.',
                '4' : 'magg.',
                '5' : 'giugno',
                '6' : 'luglio',
                '7' : 'ag.',
                '8' : 'sett.',
                '9' : 'ott.',
                '10' : 'nov.',
                '11' : 'dic.'
            },
            ru : {
                'wind' : 'Ветер',
                'humidity' : 'Влажность',
                'pressure' : 'Давление',
                'sunrise' : 'Восход',
                'sunset' : 'Закат',
                'mon' : 'Пн',
                'tue' : 'Вт',
                'wed' : 'Ср',
                'thu' : 'Чт',
                'fri' : 'Пт',
                'sat' : 'Сб',
                'sun' : 'Вс',
                '0' : 'Янв.',
                '1' : 'Фев.',
                '2' : 'Мар.',
                '3' : 'Апр.',
                '4' : 'Май',
                '5' : 'Июн.',
                '6' : 'Июл.',
                '7' : 'Авг.',
                '8' : 'Сен.',
                '9' : 'Окт.',
                '10' : 'Ноя.',
                '11' : 'Дек.'
            },
            es : {
                'wind' : 'Viento',
                'humidity' : 'Humedad',
                'pressure' : 'Presión',
                'sunrise' : 'Amanecer',
                'sunset' : 'La puesta del sol',
                'mon' : 'Lu',
                'tue' : 'Ma',
                'wed' : 'Mi',
                'thu' : 'Ju',
                'fri' : 'Vi',
                'sat' : 'Sá',
                'sun' : 'Do',
                '0' : 'enero',
                '1' : 'feb.',
                '2' : 'marzo',
                '3' : 'abr.',
                '4' : 'mayo',
                '5' : 'jun.',
                '6' : 'jul.',
                '7' : 'agosto',
                '8' : 'sept.',
                '9' : 'oct.',
                '10' : 'nov.',
                '11' : 'dic.'
            },
            no : {
                'wind' : 'Vind',
                'humidity' : 'Luftfuktighet',
                'pressure' : 'Lufttrykk',
                'sunrise' : 'Soloppgang',
                'sunset' : 'Solnedgang',
                'mon' : 'Man',
                'tue' : 'Tir',
                'wed' : 'Ons',
                'thu' : 'Tor',
                'fri' : 'Fre',
                'sat' : 'Lør',
                'sun' : 'Søn',
                '0' : 'Jan.',
                '1' : 'Feb.',
                '2' : 'Mar.',
                '3' : 'Apr.',
                '4' : 'Mai',
                '5' : 'Juni',
                '6' : 'Juli',
                '7' : 'Aug.',
                '8' : 'Sept.',
                '9' : 'Okt.',
                '10' : 'Nov.',
                '11' : 'Des.'
            },
            po : {
                'wind' : 'Wiatr',
                'humidity' : 'Wilgotność',
                'pressure' : 'Ciśnienie',
                'sunrise' : 'Wschód słońca',
                'sunset' : 'Zachód słońca',
                'mon' : 'Pon',
                'tue' : 'Wt',
                'wed' : 'Śr',
                'thu' : 'Czw',
                'fri' : 'Pt',
                'sat' : 'Sob',
                'sun' : 'Ndz',
                '0' : 'Sty.',
                '1' : 'Lut.',
                '2' : 'Mar.',
                '3' : 'Kwi.',
                '4' : 'Maj',
                '5' : 'Cze.',
                '6' : 'Lip.',
                '7' : 'Sie.',
                '8' : 'Wrz.',
                '9' : 'Paź.',
                '10' : 'Lis.',
                '11' : 'Gru.'
            },
            fa : {
                'wind' : 'باد',
                'humidity' : 'رطوبت',
                'pressure' : 'فشار',
                'sunrise' : 'طلوع خورشید',
                'sunset' : 'غروب خورشید',
                'mon' : 'دوشنبه',
                'tue' : 'سه شنبه',
                'wed' : 'چهارشنبه',
                'thu' : 'پنج شنبه',
                'fri' : 'جمعه',
                'sat' : 'شنبه',
                'sun' : 'یکشنبه',
                '0' : 'ژانویه.',
                '1' : 'فوریه.',
                '2' : 'مارس.',
                '3' : 'آپریل.',
                '4' : 'می',
                '5' : 'ژوئن',
                '6' : 'جولای',
                '7' : 'آگوست.',
                '8' : 'سپتامبر.',
                '9' : 'اکتبر.',
                '10' : 'نوامبر.',
                '11' : 'دسامبر.'
            }
        },
        addStyle : function(){
            var options = this.options.style;
            if (options.length > 0 ) {
                if (!options[48]) {
                    options[48] = 0;
                }
                if (!options[49]) {
                    options[49] = 0;
                }
                if (!options[50]) {
                    options[50] = 0;
                }
                if (!options[51]) {
                    options[51] = 0;
                }
                this.parent.find('.weather .city').css({
                    'letter-spacing' : options[48]+'px',
                    'text-align' : options[12],
                    'font-family': options[13].replace(new RegExp('\\+','g'), ' '),
                    'font-weight': options[14],
                    'color' : options[15],
                    'font-size' : options[16]+'px',
                    'line-height' : options[17]+'px',
                    'text-decoration' : options[18],
                    'text-transform' : options[19],
                    'font-style' : options[20]
                });
                this.parent.find('.weather .condition').css({
                    'letter-spacing' : options[49]+'px',
                    'text-align' : options[21],
                    'font-family': options[22].replace(new RegExp('\\+','g'), ' '),
                    'font-weight': options[23],
                    'color' : options[24],
                    'font-size' : options[25]+'px',
                    'line-height' : options[26]+'px',
                    'text-decoration' : options[27],
                    'text-transform' : options[28],
                    'font-style' : options[29],
                });
                this.parent.find('.weather .date, .weather-info > div').css({
                    'letter-spacing' : options[50]+'px',
                    'text-align' : options[30],
                    'font-family': options[31].replace(new RegExp('\\+','g'), ' '),
                    'font-weight': options[32],
                    'color' : options[33],
                    'font-size' : options[34]+'px',
                    'line-height' : options[35]+'px',
                    'text-decoration' : options[36],
                    'text-transform' : options[37],
                    'font-style' : options[38],
                });
                this.parent.find('[class^="forecast-"] span').css({
                    'letter-spacing' : options[51]+'px',
                    'text-align' : options[39],
                    'font-family': options[40].replace(new RegExp('\\+','g'), ' '),
                    'font-weight': options[41],
                    'color' : options[42],
                    'font-size' : options[43]+'px',
                    'line-height' : options[44]+'px',
                    'text-decoration' : options[45],
                    'text-transform' : options[46],
                    'font-style' : options[47],
                });
                if (options[8] == 1) {
                    this.parent.find('.weather-info .wind').show();
                } else {
                    this.parent.find('.weather-info .wind').hide();
                }
                if (options[9] == 1) {
                    this.parent.find('.weather-info .humidity').show();
                } else {
                    this.parent.find('.weather-info .humidity').hide();
                }
                if (options[10] == 1) {
                    this.parent.find('.weather-info .pressure').show();
                } else {
                    this.parent.find('.weather-info .pressure').hide();
                }
                if (options[11] == 1) {
                    this.parent.find('.weather-info .sunrise').show();
                } else {
                    this.parent.find('.weather-info .sunrise').hide();
                }
            }
        },
        create : function() {
            var div = '<div class="weather"><span class="city">',
                lang = this.options.lang,
                date = new Date();
            div += this.options.location+'</span><span class="date">';
            div += date.getDate()+' '+this.lang[lang][date.getMonth()];
            div += ' '+date.getFullYear()+'</span><span class="condition"><span class="icon">';
            div += this.icons[this.query.code]+'</span><span class="temp">';
            div += this.query.temp+'°'+this.options.unit.toUpperCase()+'</span></span>';
            div += '</div><div class="weather-info"><div><span class="wind">'+this.lang[lang].wind+': ';
            div += this.query.speed+' km/h</span></div><div><span class="humidity">'+this.lang[lang].humidity+': ';
            div += this.query.humidity+'%</span><span class="pressure">'+this.lang[lang].pressure+': ';
            div += this.query.pressure+'</span></div><div class=sunrise><span>'+this.lang[lang].sunrise+': ';
            div += this.query.sunrise+'</span><span>'+this.lang[lang].sunset+': ';
            div += this.query.sunset+'</span></div></div>';
            div += '<div class="forecast-'+this.options.layout+'">';
            for (var i = 0; i < this.options.days; i++) {
                div += '<div><span>'+this.lang[lang][this.query.forecast[i].day.toLowerCase()];
                div += '</span><span class="icon">';
                div += this.icons[this.query.forecast[i].code];
                div += '</span><span class="day">'+this.query.forecast[i].high;
                div += '°'+this.options.unit.toUpperCase();
                div += '</span><span class="night">'+this.query.forecast[i].low;
                div += '°'+this.options.unit.toUpperCase()+'</span></div>'
            }
            div += '</div>';
            this.parent.html(div);
            this.addStyle();
        },
        makeYQL : function(){
            var query = 'select * from weather.forecast where woeid in (select woeid from geo.places(1)',
                src = 'https://query.yahooapis.com/v1/public/yql?q=';
            query += ' where text="'+this.options.location+'") and u="'+this.options.unit+'"';
            src += encodeURIComponent(query);
            src += '&format=json';
            return src;
        },
        icons : {
            '0' : '<i class="wi wi-tornado"></i>',
            '1' : '<i class="wi wi-storm-showers"></i>',
            '2' : '<i class="wi wi-tornado"></i>',
            '3' : '<i class="wi wi-thunderstorm"></i>',
            '4' : '<i class="wi wi-thunderstorm"></i>',
            '5' : '<i class="wi wi-snow"></i>',
            '6' : '<i class="wi wi-rain-mix"></i>',
            '7' : '<i class="wi wi-rain-mix"></i>',
            '8' : '<i class="wi wi-sprinkle"></i>',
            '9' : '<i class="wi wi-sprinkle"></i>',
            '10' : '<i class="wi wi-hail"></i>',
            '11' : '<i class="wi wi-showers"></i>',
            '12' : '<i class="wi wi-showers"></i>',
            '13' : '<i class="wi wi-snow"></i>',
            '14' : '<i class="wi wi-storm-showers"></i>',
            '15' : '<i class="wi wi-snow"></i>',
            '16' : '<i class="wi wi-snow"></i>',
            '17' : '<i class="wi wi-hail"></i>',
            '18' : '<i class="wi wi-hail"></i>',
            '19' : '<i class="wi wi-cloudy-gusts"></i>',
            '20' : '<i class="wi wi-fog"></i>',
            '21' : '<i class="wi wi-fog"></i>',
            '22' : '<i class="wi wi-fog"></i>',
            '23' : '<i class="wi wi-cloudy-gusts"></i>',
            '24' : '<i class="wi wi-cloudy-windy"></i>',
            '25' : '<i class="wi wi-thermometer"></i>',
            '26' : '<i class="wi wi-cloudy"></i>',
            '27' : '<i class="wi wi-night-cloudy"></i>',
            '28' : '<i class="wi wi-day-cloudy"></i>',
            '29' : '<i class="wi wi-night-cloudy"></i>',
            '30' : '<i class="wi wi-day-cloudy"></i>',
            '31' : '<i class="wi wi-night-clear"></i>',
            '32' : '<i class="wi wi-day-sunny"></i>',
            '33' : '<i class="wi wi-night-clear"></i>',
            '34' : '<i class="wi wi-day-sunny-overcast"></i>',
            '35' : '<i class="wi wi-hail"></i>',
            '36' : '<i class="wi wi-day-sunny"></i>',
            '37' : '<i class="wi wi-thunderstorm"></i>',
            '38' : '<i class="wi wi-thunderstorm"></i>',
            '39' : '<i class="wi wi-thunderstorm"></i>',
            '40' : '<i class="wi wi-storm-showers"></i>',
            '41' : '<i class="wi wi-snow"></i>',
            '42' : '<i class="wi wi-snow"></i>',
            '43' : '<i class="wi wi-snow"></i>',
            '44' : '<i class="wi wi-cloudy"></i>',
            '45' : '<i class="wi wi-lightning"></i>',
            '46' : '<i class="wi wi-snow"></i>',
            '47' : '<i class="wi wi-thunderstorm"></i>',
            '3200' : '<i class="wi wi-cloud"></i>',
        }
    }
    
    $.fn.ba_weather = function (option) {
        return this.each(function () {
            var $this = $(this),
                data = $this.data('ba_weather'),
                options = $.extend({}, $.fn.ba_weather.defaults, typeof option == 'object' && option);
            if (!data) {
                $this.data('ba_weather', (data = new ba_weather(this, options)));
            }
            if (option == 'delete') {
                $this.removeData();
            } else {
                data.init();
            }
        });
    }
    
    $.fn.ba_weather.defaults = {
        location : 'New York, NY, United States',
        unit : 'c',
        days : 7,
        layout : 'block',
        style : new Array(),
        lang : 'en'
    }
    
    $.fn.ba_weather.Constructor = ba_weather;
}(window.jQ ? window.jQ : window.jQuery);