/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.blog-options-options').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-options-cell').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    jQ('.blog-category option').each(function(){
        var val = jQ(this).val();
        if (jQ(this).val() != options[3]) {
            jQ(this).removeAttr('selected');
        } else {
            jQ(this).attr('selected', true);
        }
    });
    jQ('.blog-layout option').each(function(){
        if (jQ(this).val() == options[4]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.blog-read-more').val(options[14]);
    jQ('.blog-newer-posts').val(options[15]);
    jQ('.blog-older-posts').val(options[16]);
    if (options[4] == 'list' || options[4] == 'standard') {
        jQ('.blog-image-height').show().prev().show();
    } else {
        jQ('.blog-image-height').hide().prev().hide();
    }
    jQ('.blog-image-height').val(options[5]);
    jQ('.blog-number-of-columns').val(options[6]);
    jQ('.blog-items-per-page').val(options[7]);
    jQ('.blog-pagination option').each(function(){
        if (jQ(this).val() == options[8]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[9] == 1) {
        jQ('.enable-blog-image').attr('checked', true);
    } else {
        jQ('.enable-blog-image').removeAttr('checked');
    }
    if (options[10] == 1) {
        jQ('.enable-blog-title').attr('checked', true);
    } else {
        jQ('.enable-blog-title').removeAttr('checked');
    }
    if (options[11] == 1) {
        jQ('.enable-blog-info').attr('checked', true);
    } else {
        jQ('.enable-blog-info').removeAttr('checked');
    }
    if (options[12] == 1) {
        jQ('.enable-blog-description').attr('checked', true);
    } else {
        jQ('.enable-blog-description').removeAttr('checked');
    }
    if (options[13] == 1) {
        jQ('.enable-blog-button').attr('checked', true);
    } else {
        jQ('.enable-blog-button').removeAttr('checked');
    }
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.blog-read-more').on('keyup', function(){
    var value = jQ(this).val();
    setValue('.ba-blog-options', 14, value);
    currentItem.find('.ba-blog-btn a').text(value);
});
jQ('.blog-newer-posts').on('keyup', function(){
    var value = jQ(this).val();
    setValue('.ba-blog-options', 15, value);
    currentItem.find('.ba-blog-paginator .newer-posts').text(value);
});
jQ('.blog-older-posts').on('keyup', function(){
    var value = jQ(this).val();
    setValue('.ba-blog-options', 16, value);
    currentItem.find('.ba-blog-paginator .older-posts').text(value);
});
jQ('.blog-pagination').on('change', function (){
    setValue('.ba-blog-options', 8, jQ(this).val());
    drawBlogPaginator(currentItem);
    addPostsStyle(currentItem);
});
jQ('.blog-category').on('change', function(){
    setValue('.ba-blog-options', 3, jQ(this).val());
    drawPosts(currentItem);
});
jQ('.blog-layout').on('change', function(){
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    currentItem.find('.ba-blog').removeClass(options[4]);
    options[4] = jQ(this).val();
    if (options[4] == 'list' || options[4] == 'standard') {
        jQ('.blog-image-height').show().prev().show();
    } else {
        jQ('.blog-image-height').hide().prev().hide();
    }
    currentItem.find('.ba-blog').addClass(options[4]);
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    drawPosts(currentItem);
});
jQ('.blog-image-height').on('keyup click', function(){
    setValue('.ba-blog-options', 5, jQ(this).val(), 'height', '.ba-blog-image', 'px');
    addPostsStyle(currentItem);
});
jQ('.blog-number-of-columns').on('keyup click', function(){
    var value = jQ(this).val(),
        percent = Math.floor(currentItem.find('.ba-blog').outerWidth() / value);
    if (jQ.trim(value) == '') {
        value = 1;
        percent = Math.floor(currentItem.find('.ba-blog').outerWidth());
    }
    setValue('.ba-blog-options', 6, value);
    currentItem.find('.ba-blog-item').css('width', percent+'px');
    addPostsStyle(currentItem);
});
jQ('.blog-items-per-page').on('keyup click', function(){
    var value = jQ(this).val();
    if (jQ.trim(value) == '') {
        value = 10;
    }
    setValue('.ba-blog-options', 7, value);
    drawPosts(currentItem);
});
jQ('.enable-blog-image').on('click', function(){
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[9] = 1;
        currentItem.find('.ba-blog-image').show();
        currentItem.find('.ba-blog-post').addClass('hidden-image');
    } else {
        options[9] = 0;
        currentItem.find('.ba-blog-image').hide();
        currentItem.find('.ba-blog-post').removeClass('hidden-image');
    }
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addPostsStyle(currentItem);
});
jQ('.enable-blog-title').on('click', function(){
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[10] = 1;
        currentItem.find('.ba-blog-title').show();
    } else {
        options[10] = 0;
        currentItem.find('.ba-blog-title').hide();
    }
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addPostsStyle(currentItem);
});
jQ('.enable-blog-info').on('click', function(){
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[11] = 1;
        currentItem.find('.ba-blog-data, .ba-blog-category').show();
    } else {
        options[11] = 0;
        currentItem.find('.ba-blog-data, .ba-blog-category').hide();
    }
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addPostsStyle(currentItem);
});
jQ('.enable-blog-description').on('click', function(){
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[12] = 1;
        currentItem.find('.ba-blog-intro-text').show();
    } else {
        options[12] = 0;
        currentItem.find('.ba-blog-intro-text').hide();
    }
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addPostsStyle(currentItem);
});
jQ('.enable-blog-button').on('click', function(){
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[13] = 1;
        currentItem.find('.ba-blog-btn').show();
    } else {
        options[13] = 0;
        currentItem.find('.ba-blog-btn').hide();
    }
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addPostsStyle(currentItem);
});
jQ('.blog-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-style-options').addClass('ba-in').removeClass('.ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-blog-style').show().addClass('ba-active-options');
});
jQ('.nav-blog-style').on('click', function(){
    jQ('.ba-gb-options.ba-fade').removeClass('ba-fade');
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-style-options').addClass('ba-in').removeClass('.ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options').hide();
    jQ('.nav-blog-style').show().addClass('ba-active-options');
});
jQ('.blog-title-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-blog-style-title').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    jQ('.blog-title-align').each(function(){
        if (jQ(this).val() == options[17]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.blog-title-font-family').val(options[18].replace(new RegExp('\\+','g'), ' ')+' '+options[19]);
    color = rgb2hex(options[20]);
    jQ('.blog-title-text-color').minicolors('value', color[0]);
    jQ('.blog-title-text-color').minicolors('opacity', color[1]);
    jQ('.blog-title-font-size').val(options[21]);
    jQ('.blog-title-font-size-number').val(options[21]);
    jQ('.blog-title-line-height').val(options[22]);
    jQ('.blog-title-line-height-number').val(options[22]);
    jQ('.blog-title-margin-bottom').val(options[23]);
    jQ('.blog-title-margin-bottom-number').val(options[23]);
    jQ('.blog-title-font-style').each(function(){
        if (jQ(this).val() == 'underline' && options[24] != 'none') {
            jQ(this).closest('label').addClass('active');
        } else if (jQ(this).val() == 'uppercase' && options[25] != 'none') {
            jQ(this).closest('label').addClass('active');
        } else if (jQ(this).val() == 'italic' && options[26] != 'normal') {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-title').show().addClass('ba-active-options');
});
jQ('.blog-title-margin-bottom').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 23, inputValue, 'margin-bottom', '.ba-blog-title', 'px');
            jQ('.blog-title-margin-bottom-number').val(inputValue);
        }, 12);
    jQ('.blog-title-margin-bottom').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-title-margin-bottom-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 23, value, 'margin-bottom', '.ba-blog-title', 'px');
    jQ('.blog-title-margin-bottom').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.select-blog-title-family').on('click', function(){
    uploadMode = 'blogTitle';
    jQ('#fonts-modal').modal();
});
jQ('.blog-title-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-blog-options', 17, jQ(this).val(), 'text-align', '.ba-blog-title', '');
    addHistory();
});
jQ('.blog-title-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-blog-options', 20, hex, 'color', '.ba-blog-title a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-title-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 21, inputValue, 'font-size', '.ba-blog-title a', 'px');
            jQ('.blog-title-font-size-number').val(inputValue);
        }, 12);
    jQ('.blog-title-font-size').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-title-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 21, value, 'font-size', '.ba-blog-title a', 'px');
    jQ('.blog-title-font-size').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-title-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-blog-options', 22, inputValue, 'line-height', '.ba-blog-title a', 'px');
        jQ('.blog-title-line-height-number').val(inputValue);
    }, 12);
    jQ('.blog-title-line-height').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-title-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 22, value, 'line-height', '.ba-blog-title a', 'px');
    jQ('.blog-title-line-height').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-title-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[24] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[24] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[24] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[25] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[25] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[25] = 'none';
        }
    } else {
        if (options[26] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[26] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[26] = 'normal';
        }
    }
    currentItem.find('.ba-blog-title a').css({
        'text-decoration' : options[24],
        'text-transform' : options[25],
        'font-style' : options[26]
    });
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});
jQ('.blog-info-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-blog-style-info').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    jQ('.blog-info-align').each(function(){
        if (jQ(this).val() == options[27]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.blog-info-font-family').val(options[28].replace(new RegExp('\\+','g'), ' ')+' '+options[29]);
    color = rgb2hex(options[30]);
    jQ('.blog-info-text-color').minicolors('value', color[0]);
    jQ('.blog-info-text-color').minicolors('opacity', color[1]);
    jQ('.blog-info-font-size').val(options[31]);
    jQ('.blog-info-font-size-number').val(options[31]);
    jQ('.blog-info-line-height').val(options[32]);
    jQ('.blog-info-line-height-number').val(options[32]);
    jQ('.blog-info-font-style').each(function(){
        if (jQ(this).val() == 'underline' && options[33] != 'none') {
            jQ(this).closest('label').addClass('active');
        } else if (jQ(this).val() == 'uppercase' && options[34] != 'none') {
            jQ(this).closest('label').addClass('active');
        } else if (jQ(this).val() == 'italic' && options[35] != 'normal') {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-weather-info').show().addClass('ba-active-options');
});
jQ('.select-blog-info-family').on('click', function(){
    uploadMode = 'blogInfo';
    jQ('#fonts-modal').modal();
});
jQ('.blog-info-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-blog-options', 27, jQ(this).val(), 'text-align', '.ba-blog-info', '');
    addHistory();
});
jQ('.blog-info-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-blog-options', 30, hex, 'color', '.ba-blog-data, .ba-blog-category', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-info-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 31, inputValue, 'font-size', '.ba-blog-data, .ba-blog-category', 'px');
            jQ('.blog-info-font-size-number').val(inputValue);
        }, 12);
    jQ('.blog-info-font-size').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-info-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 31, value, 'font-size', '.ba-blog-data, .ba-blog-category', 'px');
    jQ('.blog-info-font-size').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-info-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-blog-options', 32, inputValue, 'line-height', '.ba-blog-data, .ba-blog-category', 'px');
        jQ('.blog-info-line-height-number').val(inputValue);
    }, 12);
    jQ('.blog-info-line-height').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-info-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 32, value, 'line-height', '.ba-blog-data, .ba-blog-category', 'px');
    jQ('.blog-info-line-height').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-info-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[33] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[33] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[33] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[34] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[34] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[34] = 'none';
        }
    } else {
        if (options[35] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[35] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[35] = 'normal';
        }
    }
    currentItem.find('.ba-blog-data, .ba-blog-category').css({
        'text-decoration' : options[33],
        'text-transform' : options[34],
        'font-style' : options[35]
    });
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});
jQ('.blog-description-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-blog-style-description').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    jQ('.blog-description-align').each(function(){
        if (jQ(this).val() == options[36]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.blog-description-font-family').val(options[37].replace(new RegExp('\\+','g'), ' ')+' '+options[38]);
    color = rgb2hex(options[39]);
    jQ('.blog-description-text-color').minicolors('value', color[0]);
    jQ('.blog-description-text-color').minicolors('opacity', color[1]);
    jQ('.blog-description-font-size').val(options[40]);
    jQ('.blog-description-font-size-number').val(options[40]);
    jQ('.blog-description-line-height').val(options[41]);
    jQ('.blog-description-line-height-number').val(options[41]);
    jQ('.blog-description-margin-top').val(options[45]);
    jQ('.blog-description-margin-top-number').val(options[45]);
    jQ('.blog-description-font-style').each(function(){
        if (jQ(this).val() == 'underline' && options[42] != 'none') {
            jQ(this).closest('label').addClass('active');
        } else if (jQ(this).val() == 'uppercase' && options[43] != 'none') {
            jQ(this).closest('label').addClass('active');
        } else if (jQ(this).val() == 'italic' && options[44] != 'normal') {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-description').show().addClass('ba-active-options');
});
jQ('.select-blog-description-family').on('click', function(){
    uploadMode = 'blogDescription';
    jQ('#fonts-modal').modal();
});
jQ('.blog-description-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    var value = jQ(this).val();
    setValue('.ba-blog-options', 36, value, 'text-align', '.ba-blog-intro-text', '');
    addHistory();
});
jQ('.blog-description-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-blog-options', 39, hex, 'color', '.ba-blog-intro-text', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-description-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 40, inputValue, 'font-size', '.ba-blog-intro-text', 'px');
            jQ('.blog-description-font-size-number').val(inputValue);
        }, 12);
    jQ('.blog-description-font-size').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-description-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 40, value, 'font-size', '.ba-blog-intro-text', 'px');
    jQ('.blog-description-font-size').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-description-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-blog-options', 41, inputValue, 'line-height', '.ba-blog-intro-text', 'px');
        jQ('.blog-description-line-height-number').val(inputValue);
    }, 12);
    jQ('.blog-description-line-height').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-description-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 41, value, 'line-height', '.ba-blog-intro-text', 'px');
    jQ('.blog-description-line-height').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-description-margin-top').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 45, inputValue, 'margin-top', '.ba-blog-intro-text', 'px');
            jQ('.blog-description-margin-top-number').val(inputValue);
        }, 12);
    jQ('.blog-description-margin-top').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-description-margin-top-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 45, value, 'margin-top', '.ba-blog-intro-text', 'px');
    jQ('.blog-description-margin-top').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-description-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[42] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[42] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[42] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[43] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[43] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[43] = 'none';
        }
    } else {
        if (options[44] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[44] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[44] = 'normal';
        }
    }
    currentItem.find('.ba-blog-intro-text').css({
        'text-decoration' : options[42],
        'text-transform' : options[43],
        'font-style' : options[44]
    });
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});
jQ('.blog-button-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-style-button-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-blog-button').show().addClass('ba-active-options');
});
jQ('.nav-blog-button').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-element-options .ba-fade').removeClass('ba-fade');
    jQ('.blog-style-button-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-blog-button').show().addClass('ba-active-options');
    jQ('.nav-blog-button ~ a').hide();
});
jQ('.blog-button-font').on('click', function(){
    jQ('.blog-style-button-options').removeClass('ba-in');
    jQ('.blog-button-font-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-font').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    jQ('.blog-button-align').each(function(){
        if (jQ(this).val() == options[46]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.blog-button-font-family').val(options[47].replace(new RegExp('\\+','g'), ' ')+' '+options[48]);
    color = rgb2hex(options[49]);
    jQ('.blog-button-bg-color').minicolors('value', color[0]);
    jQ('.blog-button-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[50]);
    jQ('.blog-button-text-color').minicolors('value', color[0]);
    jQ('.blog-button-text-color').minicolors('opacity', color[1]);
    jQ('.blog-button-font-size').val(options[51]);
    jQ('.blog-button-font-size-number').val(options[51]);
    jQ('.blog-button-font-style').each(function(){
        var value = jQ(this).val();
        if (jQ(this).val() == 'underline') {
            if (options[52] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        } else if (jQ(this).val() == 'uppercase') {
            if (options[53] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        } else {
            if (options[54] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.blog-button-align').on('click', function(){
    jQ('.button-alignment').removeClass('active');
    jQ(this).closest('.button-alignment').addClass('active');
    setValue('.ba-blog-options', 46, jQ(this).val(), 'text-align', '.ba-blog-btn', '');
    addHistory();
});
jQ('.select-blog-button-family').on('click', function(){
    uploadMode = 'blogButton';
    jQ('#fonts-modal').modal();
});
jQ('.blog-button-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != ''){
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-blog-options', 49, hex, 'background-color', '.ba-blog-btn a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-button-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-blog-options', 50, hex, 'color', '.ba-blog-btn a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-button-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 51, inputValue, 'font-size', '.ba-blog-btn a', 'px');
            jQ('.blog-button-font-size-number').val(inputValue);
        }, 12);
    jQ('.blog-button-font-size').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-button-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 51, value, 'font-size', '.ba-blog-btn a', 'px');
    jQ('.blog-button-font-size').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-button-font-style').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (jQ(this).val() == 'underline') {
        if (options[52] != value) {
            jQ(this).closest('label').addClass('active');
            options[52] = value;

        } else {
            jQ(this).closest('label').removeClass('active');
            options[52] = 'none';
        }
    } else if (jQ(this).val() == 'uppercase') {
        if (options[53] != value) {
            jQ(this).closest('label').addClass('active');
            options[53] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[53] = 'none';
        }
    } else {
        if (options[54] != value) {
            jQ(this).closest('label').addClass('active');
            options[54] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[54] = 'normal';
        }
    }
    currentItem.find('.ba-blog-btn a').css({
        'text-decoration' : options[52],
        'text-transform' : options[53],
        'font-style' : options[54]
    });
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});
jQ('.blog-button-border').on('click', function(){
    jQ('.blog-style-button-options').removeClass('ba-in');
    jQ('.blog-button-border-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    jQ('.blog-button-border-radius').val(options[55]);
    jQ('.blog-button-border-radius-number').val(options[55]);
    color = rgb2hex(options[56]);
    jQ('.blog-button-border-color').minicolors('value', color[0]);
    jQ('.blog-button-border-color').minicolors('opacity', color[1]);
    jQ('.blog-button-border-width').val(options[57]);
    jQ('.blog-button-border-width-number').val(options[57]);
});
jQ('.blog-button-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 55, inputValue, 'border-radius', '.ba-blog-btn a', 'px');
            jQ('.blog-button-border-radius-number').val(inputValue);
        }, 12);
    jQ('.blog-button-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.blog-button-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 55, value, 'border-radius', '.ba-blog-btn a', 'px');
    jQ('.blog-button-border-radius').val(value);
    addHistory();
});
jQ('.blog-button-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-blog-options').val();
            options = options.split(';');
            options[56] = jQ(this).minicolors('rgbaString');
            currentItem.find('.ba-blog-btn a').css('border', options[57]+'px solid '+options[56]);
            options = options.join(';')
            currentItem.find('.ba-blog-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-button-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-blog-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[57] = inputValue;
            currentItem.find('.ba-blog-btn a').css('border', options[57]+'px solid '+options[56]);
            options = options.join(';');
            currentItem.find('.ba-blog-options').val(options);
            jQ('.blog-button-border-width-number').val(inputValue);
        }, 12);
    jQ('.blog-button-border-width').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-button-border-width-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    options[57] = value;
    currentItem.find('.ba-blog-btn a').css('border', options[57]+'px solid '+options[56]);
    options = options.join(';');
    jQ('.blog-button-border-width').val(value);
    currentItem.find('.ba-blog-options').val(options);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-button-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-button-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    jQ('.margin-top-blog-button').val(options[63]);
    jQ('.margin-top-blog-button-number').val(options[63]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-blog-button').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 63, inputValue, 'margin-top', '.ba-blog-btn', 'px');
            jQ('.margin-top-blog-button-number').val(inputValue);
        }, 12);
    jQ('.margin-top-blog-button').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.margin-top-blog-button-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 63, value, 'margin-top', '.ba-blog-btn', 'px');
    jQ('.margin-top-blog-button').val(value);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-button-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-button-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    jQ('.blog-button-padding-vertical').val(options[61]);
    jQ('.blog-button-padding-vertical-number').val(options[61]);
    jQ('.blog-button-padding-horizontal').val(options[62]);
    jQ('.blog-button-padding-horizontal-number').val(options[62]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.blog-button-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            var options = currentItem.find('.ba-blog-options').val();
            inputValue = input.val();
            options = paddingAction(currentItem.find('.ba-blog-btn a'), options, inputValue, 61, 61, 62, 61, 62);
            currentItem.find('.ba-blog-options').val(options);
            jQ('.blog-button-padding-vertical-number').val(inputValue);
        }, 12);
    jQ('.blog-button-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-button-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-blog-options').val();
    options = paddingAction(currentItem.find('.ba-blog-btn a'), options, value, 61, 61, 62, 61, 62);
    jQ('.blog-button-padding-vertical').val(value);
    currentItem.find('.ba-blog-options').val(options);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-button-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-blog-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-blog-btn a'), options, inputValue, 62, 61, 62, 61, 62);
        currentItem.find('.ba-blog-options').val(options);
        jQ('.blog-button-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.blog-button-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addPostsStyle(currentItem);
        addHistory();
    });
});
jQ('.blog-button-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-blog-options').val();
    options = paddingAction(currentItem.find('.ba-blog-btn a'), options, value, 62, 61, 62, 61, 62);
    jQ('.blog-button-padding-horizontal').val(value);
    currentItem.find('.ba-blog-options').val(options);
    addPostsStyle(currentItem);
    addHistory();
});
jQ('.blog-button-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-button-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[58]);
    jQ('.blog-button-text-color-hover').minicolors('value', color[0]);
    jQ('.blog-button-text-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[59]);
    jQ('.blog-button-bg-color-hover').minicolors('value', color[0]);
    jQ('.blog-button-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[60]);
    jQ('.blog-button-border-color-hover').minicolors('value', color[0]);
    jQ('.blog-button-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.blog-button-text-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-blog-options', 58, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-button-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-blog-options', 59, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-button-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-blog-options', 60, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-pagination-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-style-paginator-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-blog-paginator').show().addClass('ba-active-options');
});
jQ('.nav-blog-paginator').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-element-options .ba-fade').removeClass('ba-fade');
    jQ('.blog-style-paginator-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-blog-paginator').show().addClass('ba-active-options');
    jQ('.nav-blog-paginator ~ a').hide();
});
jQ('.blog-paginator-font').on('click', function(){
    jQ('.blog-style-paginator-options').removeClass('ba-in');
    jQ('.blog-paginator-font-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-font').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    jQ('.blog-paginator-align').each(function(){
        if (jQ(this).val() == options[64]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.blog-paginator-font-family').val(options[65].replace(new RegExp('\\+','g'), ' ')+' '+options[66]);
    color = rgb2hex(options[67]);
    jQ('.blog-paginator-bg-color').minicolors('value', color[0]);
    jQ('.blog-paginator-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[68]);
    jQ('.blog-paginator-text-color').minicolors('value', color[0]);
    jQ('.blog-paginator-text-color').minicolors('opacity', color[1]);
    jQ('.blog-paginator-font-size').val(options[69]);
    jQ('.blog-paginator-font-size-number').val(options[69]);
    jQ('.blog-paginator-font-style').each(function(){
        var value = jQ(this).val();
        if (jQ(this).val() == 'underline') {
            if (options[70] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        } else if (jQ(this).val() == 'uppercase') {
            if (options[71] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        } else {
            if (options[72] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.blog-paginator-align').on('click', function(){
    jQ('.button-alignment').removeClass('active');
    jQ(this).closest('.button-alignment').addClass('active');
    setValue('.ba-blog-options', 64, jQ(this).val(), 'text-align', '.ba-blog-paginator', '');
    addHistory();
});
jQ('.select-blog-paginator-family').on('click', function(){
    uploadMode = 'blogPagination';
    jQ('#fonts-modal').modal();
});
jQ('.blog-paginator-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != ''){
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-blog-options', 67, hex, 'background-color', '.ba-blog-paginator a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-paginator-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-blog-options', 68, hex, 'color', '.ba-blog-paginator a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-paginator-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 69, inputValue, 'font-size', '.ba-blog-paginator a', 'px');
            jQ('.blog-paginator-font-size-number').val(inputValue);
        }, 12);
    jQ('.blog-paginator-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.blog-paginator-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 69, value, 'font-size', '.ba-blog-paginator a', 'px');
    jQ('.blog-paginator-font-size').val(value);
    addHistory();
});
jQ('.blog-paginator-font-style').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    if (jQ(this).val() == 'underline') {
        if (options[70] != value) {
            jQ(this).closest('label').addClass('active');
            options[70] = value;

        } else {
            jQ(this).closest('label').removeClass('active');
            options[70] = 'none';
        }
    } else if (jQ(this).val() == 'uppercase') {
        if (options[71] != value) {
            jQ(this).closest('label').addClass('active');
            options[71] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[71] = 'none';
        }
    } else {
        if (options[72] != value) {
            jQ(this).closest('label').addClass('active');
            options[72] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[72] = 'normal';
        }
    }
    currentItem.find('.ba-blog-paginator a').css({
        'text-decoration' : options[70],
        'text-transform' : options[71],
        'font-style' : options[72]
    });
    options = options.join(';');
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});
jQ('.blog-paginator-border').on('click', function(){
    jQ('.blog-style-paginator-options').removeClass('ba-in');
    jQ('.blog-paginator-border-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    jQ('.blog-paginator-border-radius').val(options[73]);
    jQ('.blog-paginator-border-radius-number').val(options[73]);
    color = rgb2hex(options[74]);
    jQ('.blog-paginator-border-color').minicolors('value', color[0]);
    jQ('.blog-paginator-border-color').minicolors('opacity', color[1]);
    jQ('.blog-paginator-border-width').val(options[75]);
    jQ('.blog-paginator-border-width-number').val(options[75]);
});
jQ('.blog-paginator-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 73, inputValue, 'border-radius', '.ba-blog-paginator a', 'px');
            jQ('.blog-paginator-border-radius-number').val(inputValue);
        }, 12);
    jQ('.blog-paginator-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.blog-paginator-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 73, value, 'border-radius', '.ba-blog-paginator a', 'px');
    jQ('.blog-paginator-border-radius').val(value);
    addHistory();
});
jQ('.blog-paginator-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-blog-options').val();
            options = options.split(';');
            options[74] = jQ(this).minicolors('rgbaString');
            currentItem.find('.ba-blog-paginator a').css('border', options[75]+'px solid '+options[74]);
            options = options.join(';')
            currentItem.find('.ba-blog-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-paginator-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-blog-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[75] = inputValue;
            currentItem.find('.ba-blog-paginator a').css('border', options[75]+'px solid '+options[74]);
            options = options.join(';');
            currentItem.find('.ba-blog-options').val(options);
            jQ('.blog-paginator-border-width-number').val(inputValue);
        }, 12);
    jQ('.blog-paginator-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.blog-paginator-border-width-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    options[75] = value;
    currentItem.find('.ba-blog-paginator a').css('border', options[75]+'px solid '+options[74]);
    options = options.join(';');
    jQ('.blog-paginator-border-width').val(value);
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});
jQ('.blog-paginator-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-paginator-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    jQ('.margin-top-blog-paginator').val(options[81]);
    jQ('.margin-top-blog-paginator-number').val(options[81]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-blog-paginator').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-blog-options', 81, inputValue, 'margin-top', '.ba-blog-paginator', 'px');
            jQ('.margin-top-blog-paginator-number').val(inputValue);
        }, 12);
    jQ('.margin-top-blog-paginator').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-blog-paginator-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-blog-options', 81, value, 'margin-top', '.ba-blog-paginator', 'px');
    jQ('.margin-top-blog-paginator').val(value);
    addHistory();
});
jQ('.blog-paginator-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-paginator-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    jQ('.blog-paginator-padding-vertical').val(options[79]);
    jQ('.blog-paginator-padding-vertical-number').val(options[79]);
    jQ('.blog-paginator-padding-horizontal').val(options[80]);
    jQ('.blog-paginator-padding-horizontal-number').val(options[80]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.blog-paginator-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            var options = currentItem.find('.ba-blog-options').val();
            inputValue = input.val();
            options = paddingAction(currentItem.find('.ba-blog-paginator a'), options, inputValue, 79, 79, 80, 79, 80);
            currentItem.find('.ba-blog-options').val(options);
            jQ('.blog-paginator-padding-vertical-number').val(inputValue);
        }, 12);
    jQ('.blog-paginator-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.blog-paginator-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-blog-options').val();
    options = paddingAction(currentItem.find('.ba-blog-paginator a'), options, value, 79, 79, 80, 79, 80);
    jQ('.blog-paginator-padding-vertical').val(value);
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});
jQ('.blog-paginator-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-blog-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-blog-paginator a'), options, inputValue, 80, 79, 80, 79, 80);
        currentItem.find('.ba-blog-options').val(options);
        jQ('.blog-paginator-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.blog-paginator-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.blog-paginator-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-blog-options').val();
    options = paddingAction(currentItem.find('.ba-blog-paginator a'), options, value, 80, 79, 80, 79, 80);
    jQ('.blog-paginator-padding-horizontal').val(value);
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});
jQ('.blog-paginator-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-paginator-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[76]);
    jQ('.blog-paginator-text-color-hover').minicolors('value', color[0]);
    jQ('.blog-paginator-text-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[77]);
    jQ('.blog-paginator-bg-color-hover').minicolors('value', color[0]);
    jQ('.blog-paginator-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[78]);
    jQ('.blog-paginator-border-color-hover').minicolors('value', color[0]);
    jQ('.blog-paginator-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.blog-paginator-text-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-blog-options', 76, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-paginator-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-blog-options', 77, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-paginator-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-blog-options', 78, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.blog-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    jQ('.margin-top-blog').val(options[1]);
    jQ('.margin-top-blog-number').val(options[1]);
    jQ('.margin-bottom-blog').val(options[2]);
    jQ('.margin-bottom-blog-number').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-blog').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-blog-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 1, 2);
        currentItem.find('.ba-blog-options').val(options);
        jQ('.margin-top-blog-number').val(inputValue);
    }, 12);
    jQ('.margin-top-blog').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-blog').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-blog-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 2, 1, 2);
        currentItem.find('.ba-blog-options').val(options);
        jQ('.margin-bottom-blog-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-blog').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-blog-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-blog-options').val();
    options = marginAction(currentItem, options, value, 1, 1, 2);
    currentItem.find('.ba-blog-options').val(options);
    jQ('.margin-top-blog').val(value);
    addHistory();
});
jQ('.margin-bottom-blog-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-blog-options').val();
    options = marginAction(currentItem, options, value, 2, 1, 2);
    currentItem.find('.ba-blog-options').val(options);
    jQ('.margin-bottom-blog').val(value);
    addHistory();
});
jQ('.blog-css').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.blog-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-blog-options').val();
    options = options.split(';');
    jQ('.custom-suffix-weather').val(options[0]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-blog').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-blog-options').val(), jQ(this).val(), 0);
    currentItem.find('.ba-blog-options').val(options);
    addHistory();
});