/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

var link = document.createElement('link');
link.rel = 'stylesheet';
link.href = sitePath+'media/editors/codemirror/lib/codemirror.min.css';
document.getElementsByTagName('head')[0].appendChild(link);
link.onload = function(){
    var dark = document.createElement('link');
    dark.rel = 'stylesheet';
    dark.href = sitePath+'media/editors/codemirror/theme/base16-dark.css';
    document.getElementsByTagName('head')[0].appendChild(dark);
}

var script = document.createElement('script');
script.src = sitePath+'media/editors/codemirror/lib/codemirror.min.js';
document.getElementsByTagName('head')[0].appendChild(script);
myTextarea = document.getElementById('css-rules');
globalTextarea = document.getElementById('global-rules');
headerJsArea = document.getElementById('header-js-area');
bodyJsArea = document.getElementById('body-js-area');
customHtmlArea = document.getElementById('custom-html-area');
customCssArea = document.getElementById('custom-css-area');
script.onload = function(){
    var hints = document.createElement('script');
    hints.src = sitePath+'media/editors/codemirror/addon/hint/show-hint.min.js';
    document.getElementsByTagName('head')[0].appendChild(hints);
    hints = document.createElement('script');
    hints.src = sitePath+'media/editors/codemirror/addon/hint/css-hint.min.js';
    document.getElementsByTagName('head')[0].appendChild(hints);
    hints = document.createElement('script');
    hints.src = sitePath+'media/editors/codemirror/addon/hint/xml-hint.min.js';
    document.getElementsByTagName('head')[0].appendChild(hints);
    hints = document.createElement('script');
    hints.src = sitePath+'media/editors/codemirror/addon/hint/html-hint.min.js';
    document.getElementsByTagName('head')[0].appendChild(hints);
    hints = document.createElement('script');
    hints.src = sitePath+'media/editors/codemirror/addon/hint/javascript-hint.min.js';
    document.getElementsByTagName('head')[0].appendChild(hints);
    var script = document.createElement('script');
    script.src = sitePath+'media/editors/codemirror/mode/css/css.min.js';
    document.getElementsByTagName('head')[0].appendChild(script);
    script.onload = function(){
        globalEditor = CodeMirror.fromTextArea(globalTextarea, {
            lineNumbers: true,
            theme: 'base16-dark',
            lineWrapping: true,
            mode: "css"
        });
        customCssEditor = CodeMirror.fromTextArea(customCssArea, {
            lineNumbers: true,
            lineWrapping: true,
            mode: "css"
        });
        if (globalParams.custom && globalParams.custom.css) {
            globalEditor.setValue(globalParams.custom.css);
        }
        globalEditor.on("inputRead", function (cm, event) {
        	if (!cm.state.completionActive && event.text[0] != ':' && event.text[0] != ';'
                && event.text[0] != '{' && jQ.trim(event.text[0]) != '' && event.origin != 'paste') {
        		CodeMirror.commands.autocomplete(cm, null, {completeSingle: false});
            }
        });
        globalEditor.on('change', function (from, too) {
            clearTimeout(delay);
            setHitsTop(globalEditor);
            delay = setTimeout(function(){
                var rule = globalEditor.getValue(),
                    realStyle = rule;
                rule = rule.replace(new RegExp("\\n",'g'), ' ');
                if (rule.match(/^([^{]+)\{(.*)\}\s*$/) || rule == '') {
                    if (!globalParams.custom) {
                        globalParams.custom = {};
                    }
                    globalParams.custom.css = realStyle;
                    globalCustomStyle.html(realStyle)
                    addHistory();
                }
            }, 500);
        });
        customCssEditor.on("inputRead", function (cm, event) {
        	if (!cm.state.completionActive && event.text[0] != ':' && event.text[0] != ';'
                && event.text[0] != '{' && jQ.trim(event.text[0]) != '' && event.origin != 'paste') {
                CodeMirror.commands.autocomplete(cm, null, {completeSingle: false});
            }
        });
        customCssEditor.on('change', function(){
            setHitsTop(customCssEditor);
            clearTimeout(delay);
            delay = setTimeout(function(){
                customHtmlApply();
            }, 500);
        });
    }
    var script = document.createElement('script');
    script.src = sitePath+'media/editors/codemirror/mode/xml/xml.min.js';
    document.getElementsByTagName('head')[0].appendChild(script);
    script.onload = function () {
        var script = document.createElement('script');
        script.src = sitePath+'media/editors/codemirror/mode/htmlmixed/htmlmixed.min.js';
        document.getElementsByTagName('head')[0].appendChild(script);
        script.onload = function(){
            customHtmlEditor = CodeMirror.fromTextArea(customHtmlArea, {
                lineNumbers: true,
                lineWrapping: true,
                mode: "htmlmixed"
            });
            customHtmlEditor.on("inputRead", function (cm, event) {
                if (!cm.state.completionActive && event.text[0] != ':' && event.text[0] != ';'
                    && event.text[0] != '{' && jQ.trim(event.text[0]) != '' && event.origin != 'paste') {
                    CodeMirror.commands.autocomplete(cm, null, {completeSingle: false});
                }
            });
            customHtmlEditor.on('change', function(){
                setHitsTop(customHtmlEditor);
                clearTimeout(delay);
                delay = setTimeout(function(){
                    customHtmlApply();
                }, 500);
            });
        }
    }
    var script = document.createElement('script');
    script.src = sitePath+'media/editors/codemirror/mode/javascript/javascript.min.js';
    document.getElementsByTagName('head')[0].appendChild(script);
    script.onload = function(){
        headerJs = CodeMirror.fromTextArea(headerJsArea, {
            lineNumbers: true,
            theme: 'base16-dark',
            lineWrapping: true,
            mode: "javascript"
        });
        bodyJs = CodeMirror.fromTextArea(bodyJsArea, {
            lineNumbers: true,
            theme: 'base16-dark',
            lineWrapping: true,
            mode: "javascript"
        });
        if (globalParams.headerJs) {
            headerJs.setValue(globalParams.headerJs.replace(new RegExp("_-t-_",'g'), '\t').replace(new RegExp("_-n-_",'g'), '\n'));
        }
        headerJs.on("inputRead", function (cm, event) {
            if (!cm.state.completionActive && event.text[0] != ':' && event.text[0] != ';'
                && event.text[0] != '{' && jQ.trim(event.text[0]) != '' && event.origin != 'paste') {
                CodeMirror.commands.autocomplete(cm, null, {completeSingle: false});
            }
        });
        headerJs.on('change', function(from, too){
            var js =  headerJs.getValue();
            globalParams.headerJs = js;
            addHistory();
            setHitsTop(headerJs);
        });
        if (globalParams.bodyJs) {
            bodyJs.setValue(globalParams.bodyJs.replace(new RegExp("_-t-_",'g'), '\t').replace(new RegExp("_-n-_",'g'), '\n'));
        }
        bodyJs.on("inputRead", function (cm, event) {
            if (!cm.state.completionActive && event.text[0] != ':' && event.text[0] != ';'
                && event.text[0] != '{' && jQ.trim(event.text[0]) != '' && event.origin != 'paste') {
                CodeMirror.commands.autocomplete(cm, null, {completeSingle: false});
            }
        });
        bodyJs.on('change', function(from, too){
            var js =  bodyJs.getValue();
            globalParams.bodyJs = js;
            addHistory();
            setHitsTop(bodyJs);
        });
    }
}

function setHitsTop(cm) {
    setTimeout(function(){
        var cursor = cm.display.cursorDiv.children[0],
            bot = cursor.getBoundingClientRect().bottom;
        jQ('.CodeMirror-hints').css('top', bot+'px').addClass('ba-autocomplete');
    }, 100);
}