/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

var script = document.createElement('script'),
    setupScript = document.createElement('script'),
    styleLink = document.createElement('link');
script.src = sitePath+'media/system/js/calendar.js';
styleLink.rel = 'stylesheet';
styleLink.href = sitePath+'media/system/css/calendar-jos.css';
document.getElementsByTagName('head')[0].appendChild(styleLink);
document.getElementsByTagName('head')[0].appendChild(script);
script.onload = function(){
    setupScript.src = sitePath+'media/system/js/calendar-setup.js';
    document.getElementsByTagName('head')[0].appendChild(setupScript);
    setupScript.onload = function(){
        createCalendar();
    }
}

function createCalendar()
{
    Calendar._DN = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday",
                    "Saturday","Sunday"];
    Calendar._SDN = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat","Sun"];
    Calendar._FD = 0;
    Calendar._MN = CalendarMonth;
    Calendar._SMN = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep",
                     "Oct","Nov","Dec"];
    var about = "DHTML Date\/Time Selector\n(c) dynarch.com 2002-2005 \/ ";
    about += "Author: Mihai Bazon.";
    var aboutTime = "\n\nTime selection:\n- Click on any of the time parts to increase ";
    aboutTime += "it\n- or Shift-click to decrease it\n- or click and drag for faster selection.";
    Calendar._TT = {"INFO" : "About the Calendar",
                    "ABOUT":about,
                    "ABOUT_TIME":aboutTime,
                    "PREV_YEAR":"Click to move to the previous year. Click and hold for a list of years.",
                    "PREV_MONTH":"Click to move to the previous month. Click and hold for a list of the months.",
                    "GO_TODAY":"Go to today",
                    "NEXT_MONTH":"Click to move to the next month. Click and hold for a list of the months.",
                    "SEL_DATE":"Select a date.","DRAG_TO_MOVE":"Drag to move",
                    "PART_TODAY":" Today ",
                    "DAY_FIRST":"Display %s first",
                    "WEEKEND":"0,6","CLOSE":"Close","TODAY":"Today","TIME_PART":"(Shift-)Click or Drag to change the value.",
                    "DEF_DATE_FORMAT":"%Y-%m-%d","TT_DATE_FORMAT":"%a, %b %e","WK":"wk","TIME":"Time:"};
    Calendar.setup({
        inputField: 'countdown-date',
        ifFormat: "%d %B %Y",
        button: 'countdown-date_img',
        align: "Tl",
        singleClick: true,
        firstDay: 0
    });
    jQ('#countdown-date_img').on('click', function(){
        setTimeout(function(){
            var calendar = jQ('body > .calendar').last();
            calendar.on('click', function(event){
                event.stopPropagation();
            });
            calendar.find('tbody').on('click', function(){
                var val = jQ('#countdown-date').val(),
                    options = currentItem.find('.ba-countdown-options').val();
                options = options.split(';');
                options[4] = val;
                var endTime = makeDate(options[4], options[5]),
                self = currentItem[0],
                mode = options[6];
                clearInterval(countdownArray[options[9]]);
                makecountdown(endTime, self, mode, options[9])
                countdownArray[options[9]] = setInterval(function(){
                    makecountdown(endTime, self, mode, options[9])
                }, 1000);
                options = options.join(';');
                currentItem.find('.ba-countdown-options').val(options);
            });
        }, 600);
    });
}

jQ('.countdown-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.countdown-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-countdown-options').val(),
        days = currentItem.find('.days .countdown-label').text(),
        hours = currentItem.find('.hours .countdown-label').text(),
        minutes = currentItem.find('.minutes .countdown-label').text(),
        seconds = currentItem.find('.seconds .countdown-label').text();
    options = options.split(';');
    jQ('.countdown-days').val(days);
    jQ('.countdown-hours').val(hours);
    jQ('.countdown-minutes').val(minutes);
    jQ('.countdown-seconds').val(seconds);
    jQ('.countdown-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('#countdown-date').val(options[4]);
    jQ('.countdown-time option').each(function(){
        if (jQ(this).val() == options[5]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.countdown-display option').each(function(){
        if (jQ(this).val() == options[6]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[8] == 1) {
        jQ('.countdown-hide').attr('checked', true);
    } else {
        jQ('.countdown-hide').removeAttr('checked');
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.countdown-days').on('keyup', function(){
    var val = jQ(this).val();
    currentItem.find('.days .countdown-label').text(val)
});
jQ('.countdown-hours').on('keyup', function(){
    var val = jQ(this).val();
    currentItem.find('.hours .countdown-label').text(val)
});
jQ('.countdown-minutes').on('keyup', function(){
    var val = jQ(this).val();
    currentItem.find('.minutes .countdown-label').text(val)
});
jQ('.countdown-seconds').on('keyup', function(){
    var val = jQ(this).val();
    currentItem.find('.seconds .countdown-label').text(val)
});
jQ('.countdown-align').on('click', function(){
    var options = currentItem.find('.ba-countdown-options').val(),
        val = jQ(this).val();
    options = options.split(';');
    options[3] = val;
    options = options.join(';');
    currentItem.find('.ba-countdown-options').val(options);
    currentItem.find('.ba-countdown').css('text-align', val);
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
});
jQ('.countdown-time').on('change', function(){
    var val = jQ(this).val(),
        options = currentItem.find('.ba-countdown-options').val();
    options = options.split(';');
    options[5] = val;
    var endTime = makeDate(options[4], options[5]),
    self = currentItem[0],
    mode = options[6];
    clearInterval(countdownArray[options[9]]);
    makecountdown(endTime, self, mode, options[9])
    countdownArray[options[9]] = setInterval(function(){
        makecountdown(endTime, self, mode, options[9])
    }, 1000);
    options = options.join(';');
    currentItem.find('.ba-countdown-options').val(options);
});
jQ('.countdown-display').on('change', function(){
    var val = jQ(this).val(),
        options = currentItem.find('.ba-countdown-options').val();
    options = options.split(';');
    options[6] = val;
    var endTime = makeDate(options[4], options[5]),
    self = currentItem[0],
    mode = options[6];
    clearInterval(countdownArray[options[9]]);
    makecountdown(endTime, self, mode, options[9])
    countdownArray[options[9]] = setInterval(function(){
        makecountdown(endTime, self, mode, options[9])
    }, 1000);
    options = options.join(';');
    currentItem.find('.ba-countdown-options').val(options);
    if (val == 'full') {
        currentItem.find('.days').show();
        currentItem.find('.hours').show();
    }
    if (val == 'hours') {
        currentItem.find('.days').hide();
        currentItem.find('.hours').show();
    }
    if (val == 'minutes') {
        currentItem.find('.days').hide();
        currentItem.find('.hours').hide();
    }
});
jQ('.countdown-hide').on('click', function(){
    var options = currentItem.find('.ba-countdown-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[8] = 1;
    } else {
        options[8] = 0;
    }
    options = options.join(';');
    currentItem.find('.ba-countdown-options').val(options);
});
jQ('.countdown-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.countdown-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-countdown').show().addClass('ba-active-options');
});
jQ('.nav-style-countdown').on('click', function(){
    jQ('.ba-gb-options.ba-fade').removeClass('ba-fade');
    jQ('.countdown-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-countdown ~ a').hide()
    jQ('.nav-style-countdown').show().addClass('ba-active-options');
});
jQ('.countdown-counter').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.countdown-counter-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-counter').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-countdown-options').val(),
        color;
    options = options.split(';');
    if (!options[29]) {
        options[29] = 0;
    }
    jQ('.countdown-letter-spacing').val(options[29]);
    jQ('.countdown-letter-spacing-number').val(options[29]);
    jQ('.countdown-font-family').val(options[10].replace(new RegExp('\\+','g'), ' ')+' '+options[11]);
    color = rgb2hex(options[12]);
    jQ('.countdown-text-color').minicolors('value', color[0]);
    jQ('.countdown-text-color').minicolors('opacity', color[1]);
    jQ('.countdown-font-size').val(options[13]);
    jQ('.countdown-font-size-number').val(options[13]);
    jQ('.countdown-line-height').val(options[14]);
    jQ('.countdown-line-height-number').val(options[14]);
    jQ('.countdown-font-style').each(function(){
        if (jQ(this).val() == 'underline') {
            if (options[27] == 'underline') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'uppercase') {
            if (options[15] == 'uppercase') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'italic') {
            if (options[16] == 'italic') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.select-countdown-family').on('click', function(){
    uploadMode = 'countdownFamily';
    jQ('#fonts-modal').modal();
});
jQ('.countdown-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-countdown-options', 29, inputValue, 'letter-spacing', '.countdown-time', 'px');
            jQ('.countdown-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.countdown-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.countdown-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-countdown-options', 29, value, 'letter-spacing', '.countdown-time', 'px');
    jQ('.countdown-letter-spacing').val(value);
    addHistory();
});
jQ('.countdown-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-countdown-options', 12 , hex, 'color', '.countdown-time', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.countdown-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-countdown-options', 13 , inputValue, 'font-size', '.countdown-time', 'px');
        jQ('.countdown-font-size-number').val(inputValue);
    }, 12);
    jQ('.countdown-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.countdown-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-countdown-options', 13 , value, 'font-size', '.countdown-time', 'px');
    jQ('.countdown-font-size').val(value);
    addHistory();
});
jQ('.countdown-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-countdown-options', 14 , inputValue, 'line-height', '.countdown-time', 'px');
        jQ('.countdown-line-height-number').val(inputValue);
    }, 12);
    jQ('.countdown-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.countdown-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-countdown-options', 14 , value, 'line-height', '.countdown-time', 'px');
    jQ('.countdown-line-height').val(value);
    addHistory();
});
jQ('.countdown-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-countdown-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[27] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[27] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[27] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[15] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[15] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[15] = 'none';
        }
    } else {
        if (options[16] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[16] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[16] = 'normal';
        }
    }
    currentItem.find('.countdown-time').css({
        'text-decoration' : options[27],
        'text-transform' : options[15],
        'font-style' : options[16]
    });
    options = options.join(';');
    currentItem.find('.ba-countdown-options').val(options);
    addHistory();
});
jQ('.countdown-label').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.countdown-label-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-label').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-countdown-options').val(),
        color;
    options = options.split(';');
    if (!options[30]) {
        options[30] = 0;
    }
    jQ('.countdown-label-letter-spacing').val(options[30]);
    jQ('.countdown-label-letter-spacing-number').val(options[30]);
    jQ('.countdown-label-font-family').val(options[17].replace(new RegExp('\\+','g'), ' ')+' '+options[18]);
    color = rgb2hex(options[19]);
    jQ('.countdown-label-text-color').minicolors('value', color[0]);
    jQ('.countdown-label-text-color').minicolors('opacity', color[1]);
    jQ('.countdown-label-font-size').val(options[20]);
    jQ('.countdown-label-font-size-number').val(options[20]);
    jQ('.countdown-label-line-height').val(options[21]);
    jQ('.countdown-label-line-height-number').val(options[21]);
    jQ('.countdown-label-font-style').each(function(){
        if (jQ(this).val() == 'underline') {
            if (options[28] == 'underline') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'uppercase') {
            if (options[22] == 'uppercase') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'italic') {
            if (options[23] == 'italic') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.select-countdown-label-family').on('click', function(){
    uploadMode = 'countdownLabelFamily';
    jQ('#fonts-modal').modal();
});
jQ('.countdown-label-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-countdown-options', 30, inputValue, 'letter-spacing', '.countdown-label', 'px');
            jQ('.countdown-label-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.countdown-label-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.countdown-label-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-countdown-options', 30, value, 'letter-spacing', '.countdown-label', 'px');
    jQ('.countdown-label-letter-spacing').val(value);
    addHistory();
});
jQ('.countdown-label-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString'),
            setValue('.ba-countdown-options', 19 , hex, 'color', '.countdown-label', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.countdown-label-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-countdown-options', 20, inputValue, 'font-size', '.countdown-label', 'px');
        jQ('.countdown-label-font-size-number').val(inputValue);
    }, 12);
    jQ('.countdown-label-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.countdown-label-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-countdown-options', 20, value, 'font-size', '.countdown-label', 'px');
    jQ('.countdown-label-font-size').val(value);
    addHistory();
});
jQ('.countdown-label-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-countdown-options', 21, inputValue, 'line-height', '.countdown-label', 'px');
        jQ('.countdown-label-line-height-number').val(inputValue);
    }, 12);
    jQ('.countdown-label-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.countdown-label-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-countdown-options', 21, value, 'line-height', '.countdown-label', 'px');
    jQ('.countdown-label-line-height').val(value);
    addHistory();
});
jQ('.countdown-label-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-countdown-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[28] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[28] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[28] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[22] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[22] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[22] = 'none';
        }
    } else {
        if (options[23] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[23] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[23] = 'normal';
        }
    }
    currentItem.find('.countdown-label').css({
        'text-decoration' : options[28],
        'text-transform' : options[22],
        'font-style' : options[23]
    });
    options = options.join(';');
    currentItem.find('.ba-countdown-options').val(options);
    addHistory();
});
jQ('.countdown-background').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.countdown-background-options').addClass('ba-fade');
    var options = currentItem.find('.ba-countdown-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[24]);
    jQ('.countdown-bg-color').minicolors('value', color[0]);
    jQ('.countdown-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[25]);
    jQ('.countdown-border-color').minicolors('value', color[0]);
    jQ('.countdown-border-color').minicolors('opacity', color[1]);
    jQ('.countdown-border-radius').val(options[26]);
    jQ('.countdown-border-radius-number').val(options[26]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-background').show().addClass('ba-active-options');
});
jQ('.countdown-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-countdown-options', 24, hex, 'background-color', '.ba-countdown > span', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.countdown-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-countdown-options', 25, hex);
            currentItem.find('.ba-countdown > span').css('border', '1px solid '+hex);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.countdown-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-countdown-options', 26, inputValue, 'border-radius', '.ba-countdown > span', 'px');
        jQ('.countdown-border-radius-number').val(inputValue);
    }, 12);
    jQ('.countdown-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.countdown-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-countdown-options', 26, value, 'border-radius', '.ba-countdown > span', 'px');
    jQ('.countdown-border-radius').val(value);
    addHistory();
});
jQ('.countdown-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.countdown-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-countdown-options').val();
    options = options.split(';');
    jQ('.margin-top-countdown').val(options[0]);
    jQ('.margin-top-countdown-number').val(options[0]);
    jQ('.margin-bottom-countdown').val(options[1]);
    jQ('.margin-bottom-countdown-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-countdown').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-countdown-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-countdown-options').val(options);
        jQ('.margin-top-countdown-number').val(inputValue);
    }, 12);
    jQ('.margin-top-countdown').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-countdown').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-countdown-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-countdown-options').val(options);
        jQ('.margin-bottom-countdown-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-countdown').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-countdown-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-countdown-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-countdown-options').val(options);
    jQ('.margin-top-countdown').val(value);
    addHistory();
});
jQ('.margin-bottom-countdown-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-countdown-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-countdown-options').val(options);
    jQ('.margin-bottom-countdown').val(value);
    addHistory();
});
jQ('.countdown-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.countdown-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-countdown-options').val();
    options = options.split(';');
    jQ('.custom-suffix-countdown').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-countdown').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-countdown-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-countdown-options').val(options);
    addHistory();
});