/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.image-button').on('click', function(){
    var options = currentItem.find('.ba-image-options').val(),
        width = currentItem.find('img').width(),
        color;
    options = options.split(';');
    jQ('.ba-width-image').val(width);
    jQ('.ba-width-number-image').val(width);
    jQ('.image-alt').val(options[2]);
    jQ('.image-link').val(options[3]);
    jQ('.image-target option').each(function(){
        if (jQ(this).val() == options[4]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (!options[12]) {
        options[12] = 'rgba(0, 0, 0, 0.5)';
    }
    color = rgb2hex(options[12]);
    jQ('.lightbox-bg').minicolors('value', color[0]);
    jQ('.lightbox-bg').minicolors('opacity', color[1]);
    if (options[11] == 1) {
        jQ('.enable-lightbox').attr('checked', true);
        jQ('.lightbox-bg').removeAttr('disabled');
        jQ('.image-link').attr('disabled', true);
        jQ('.image-target').attr('disabled', true);
    } else {
        jQ('.enable-lightbox').removeAttr('checked');
        jQ('.lightbox-bg').attr('disabled', true);
        jQ('.image-link').removeAttr('disabled');
        jQ('.image-target').removeAttr('disabled');
    }
    jQ('.image-align').each(function(){
        if (jQ(this).val() == options[10]) {
            jQ(this).attr('checked', true);
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).removeAttr('checked', true);
            jQ(this).closest('label').removeClass('active');
        }
    });
    if (options[9] == 1) {
        jQ('.image-hover').attr('checked', true);
    } else {
        jQ('.image-hover').removeAttr('checked');
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.image-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-image-options').show().addClass('ba-active-options');
});
jQ('.enable-lightbox').on('click', function(){
    var options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[11] = 1;
        jQ('.enable-lightbox').attr('checked', true);
        jQ('.lightbox-bg').removeAttr('disabled');
        jQ('.image-link').attr('disabled', true);
        jQ('.image-target').attr('disabled', true);
        currentItem.addClass('ba-lightbox-item-image');
    } else {
        options[11] = 0;
        jQ('.enable-lightbox').removeAttr('checked');
        jQ('.lightbox-bg').attr('disabled', true);
        jQ('.image-link').removeAttr('disabled');
        jQ('.image-target').removeAttr('disabled');
        currentItem.removeClass('ba-lightbox-item-image');
    }
    initialImageLightbox();
    options = options.join(';');
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.lightbox-bg').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-image-options').val();
            options = options.split(';');
            options[12] = jQ(this).minicolors('rgbaString');
            options = options.join(';')
            currentItem.find('.ba-image-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.reselect-image').on('click', function(){
    uploadMode = 'reselectImage';
    jQ('#uploader-modal').modal();
});
jQ('.image-align').on('click', function(){
    var options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    options[10] = jQ(this).val();
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active')
    options = options.join(';');
    currentItem.find('.ba-image-options').val(options);
    currentItem.css('text-align', jQ(this).val());
    addHistory();
});
jQ('.ba-width-image').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        currentItem.find('img').width(inputValue);
        jQ('.ba-width-number-image').val(inputValue);
    }, 12);
    jQ('.ba-width-image').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.ba-width-number-image').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    currentItem.find('img').width(value);
    jQ('.ba-width-image').val(value);
    addHistory();
});
jQ('.image-alt').on('keyup', function(){
    var options  = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    options[2] = jQ(this).val();
    currentItem.find('img').attr('alt', options[2]);
    options = options.join(';');
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.image-link').on('keyup', function(){
    var link = jQ(this).val(),
        options  = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    options[3] = link;
    if (link != '') {
        if (currentItem.find('img').parent().hasClass('ba-item-image')) {
            currentItem.find('img').wrap('<a href="'+link+'" target="'+options[4]+'"></a>');
        } else {
            currentItem.find('img').parent().attr('href', link);
        }
        currentItem.find('a[href="'+link+'"]').on('click', function(){
            return false;
        })
    } else if (!currentItem.find('img').parent().hasClass('ba-item-image')) {
        currentItem.find('img').unwrap()
    }
    options = options.join(';');
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.image-target').on('change', function(){
    var target = jQ(this).val(),
        options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    options[4] = target;
    if (!currentItem.find('img').parent().hasClass('ba-item-image')) {
        currentItem.find('img').parent().attr('target', target);
    }
    options = options.join(';');
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.image-margin-button').on('click', function(){
    var options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    jQ('.margin-top-image').val(options[0]);
    jQ('.margin-bottom-image').val(options[1]);
    jQ('.margin-top-number-image').val(options[0]);
    jQ('.margin-bottom-number-image').val(options[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.image-margin-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-image').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-image-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-image-options').val(options);
        jQ('.margin-top-number-image').val(inputValue);
    }, 12);
    jQ('.margin-top-image').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-image').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-image-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-image-options').val(options);
        jQ('.margin-bottom-number-image').val(inputValue);
    }, 12);
    jQ('.margin-bottom-image').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-number-image').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-image-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    jQ('.margin-top-image').val(value);
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.margin-bottom-number-image').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-image-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    jQ('.margin-bottom-image').val(value);
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.image-css-button').on('click', function(){
    var options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    jQ('.custom-suffix-img').val(options[5]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.image-css-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-img').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-image-options').val(), jQ(this).val(), 5);
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.image-border-button').on('click', function(){
    var options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    jQ('.image-border-radius').val(options[6]);
    jQ('.image-border-radius-number').val(options[6]);
    var color = rgb2hex(options[7]);
    jQ('.image-border-color').minicolors('value', color[0]);
    jQ('.image-border-color').minicolors('opacity', color[1]);
    jQ('.image-border-width').val(options[8]);
    jQ('.image-border-width-number').val(options[8]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.image-border-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
});
jQ('.image-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-image-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[6] = inputValue;
            options = options.join(';');
            currentItem.find('img').css('border-radius', inputValue+'px')
            currentItem.find('.ba-image-options').val(options);
            jQ('.image-border-radius-number').val(inputValue);
        }, 12);
    jQ('.image-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.image-border-radius-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    options[6] = value;
    options = options.join(';');
    currentItem.find('img').css('border-radius', value+'px');
    jQ('.image-border-radius').val(value);
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.image-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-image-options').val();
            options = options.split(';');
            options[7] = jQ(this).minicolors('rgbaString');
            currentItem.find('img').css('border', options[8]+'px solid '+options[7]);
            options = options.join(';')
            currentItem.find('.ba-image-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.image-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-image-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[8] = inputValue;
            currentItem.find('img').css('border', options[8]+'px solid '+options[7]);
            options = options.join(';');
            currentItem.find('.ba-image-options').val(options);
            jQ('.image-border-width-number').val(inputValue);
        }, 12);
    jQ('.image-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.image-border-width-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    options[8] = value;
    currentItem.find('img').css('border', options[8]+'px solid '+options[7]);
    options = options.join(';');
    jQ('.image-border-width').val(value);
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});
jQ('.image-hover').on('click', function(){
    var options = currentItem.find('.ba-image-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[9] = 1;
        currentItem.addClass('img-hover');
    } else {
        options[9] = 0;
        currentItem.removeClass('img-hover');
    }
    options = options.join(';');
    currentItem.find('.ba-image-options').val(options);
    addHistory();
});