/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.map-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-map-options-cell').addClass('ba-fade');
    var options = currentItem.find('.ba-map-options').val();
    options = options.split(';');
    jQ('.map-height').val(options[3]);
    if (options[4] == 1) {
        jQ('.map-controls').attr('checked', true);
    } else {
        jQ('.map-controls').removeAttr('checked');
    }
    if (options[5] == 1) {
        jQ('.display-infobox').attr('checked', true);
    } else {
        jQ('.display-infobox').removeAttr('checked');
    }
    if (options[6] == 1) {
        jQ('.scroll-zooming').attr('checked', true);
    } else {
        jQ('.scroll-zooming').removeAttr('checked');
    }
    if (options[7] == 1) {
        jQ('.draggable-map').attr('checked', true);
    } else {
        jQ('.draggable-map').removeAttr('checked');
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-map-options').show().addClass('ba-active-options');
});
jQ('.select-api-key').on('click', function(){
    jQ('#google-maps-integration-modal').modal();
});
jQ('.apply-google-maps-api-key').on('click', function(){
    google_maps_apikey = jQ('#google_maps_apikey').val();
    clearTimeout(delay);
    delete(window.google)
    jQ(mapScript).remove();
    mapScript = document.createElement('script');
    jQ('body').append(mapScript);
    mapScript.src = 'https://maps.google.com/maps/api/js?libraries=places&callback=initMap&key='+google_maps_apikey;
    jQ('#google-maps-integration-modal').modal('hide');
});
jQ('#google-maps-integration-modal .modal-body a').on('click', function(){
    window.open(this.href);
})
jQ('.map-height').on('keyup', function(){
    var height = jQ(this).val();
    if (height == 0) {
        height = 10;
    }
    setValue('.ba-map-options', 3, height, 'height', '.ba-grid-map', 'px');
    mapOptionsRecreate(currentItem);
    addHistory();
});
jQ('.choose-location').on('click', function(){
    var options = currentItem.find('.ba-map-options').val(),
        image = false,
        mapOption = JSON.stringify(mapOptions);
    mapOption = JSON.parse(mapOption);
    jQ('#location-dialog').modal();
    jQ('#place').val('');
    mapOption.mapTypeId = 'roadmap';
    options = options.split(';');
    if (options[0] != '') {
        options[0] = options[0].replace(new RegExp('\\n', 'g'),'\\n');
        options[0] = JSON.parse(options[0]);
        mapOption.center = {
            lat : options[0].center.nb*1,
            lng : options[0].center.ob*1
        };
        mapOption.zoom = options[0].zoom;
        mapOption.mapTypeId = options[0].mapTypeId;
        mapLocation.marker = options[0].marker;
        options[0].description = options[0].description.replace(new RegExp("-_-", 'g'), ';');
        options[0].description = options[0].description.replace(new RegExp("---", 'g'), '"');
        jQ('#mark-description').val(options[0].description);
    } else {
        var center = mapOption.center.split(',');
        mapOption.center = {
            lat : center[0]*1,
            lng : center[1]*1
        };
        jQ('#mark-description').val('');
    }
    if (options[8] != '') {
        image = true;
    }
    mapLocation.center = mapOption.center;
    mapLocation.zoom = mapOption.zoom;
    mapLocation.mapTypeId = mapOption.mapTypeId;
    mapOption.scrollwheel = true;
    mapOption.navigationControl = true;
    mapOption.mapTypeControl = true;
    mapOption.scaleControl = true;
    mapOption.draggable = true;
    mapOption.zoomControl = true;
    var map = new google.maps.Map(document.getElementById('location-map'), mapOption),
        input = document.getElementById('place'),
        autocomplete = new google.maps.places.Autocomplete(input),
        marker = '';
    if (options[0].marker != '' && options[0].marker) {
        var marker = options[0].marker;
        var keys = [];
        for (var key in marker) {
            keys.push(key);
        }
        marker = new google.maps.Marker({
            position: {
                lat : marker[keys[0]]*1,
                lng : marker[keys[1]]*1
            },
            map: map,
            icon : options[8]
        });
    }
    map.addListener('maptypeid_changed',function(event){
        var flag = 0;
        mapLocation.center = {};
        mapLocation.zoom = map.getZoom();
        mapLocation.mapTypeId = map.getMapTypeId();
        jQ.each(map.getCenter(), function (i, val) {
            if (flag == 0) {
                mapLocation.center.nb = val();
            } else if (flag == 1) {
                mapLocation.center.ob = val();
            }
            flag++;
        });
    });
    map.addListener('idle',function(event){
        var flag = 0;
        mapLocation.center = {};
        mapLocation.zoom = map.getZoom();
        mapLocation.mapTypeId = map.getMapTypeId();
        jQ.each(map.getCenter(), function (i, val) {
            if (flag == 0) {
                mapLocation.center.nb = val();
            } else if (flag == 1) {
                mapLocation.center.ob = val();
            }
            flag++;
        });
    });
    autocomplete.addListener('place_changed', function() {
        var place = autocomplete.getPlace();
        if (place.geometry.viewport) {
            map.fitBounds(place.geometry.viewport);
        } else {
            map.setCenter(place.geometry.location);
        }
    });
    map.addListener('click', function(event) {
        if (marker != '') {
            marker.setMap(null);
        }
        marker = new google.maps.Marker({
            position: event.latLng,
            map: map,
            icon : options[8]
        });
        mapLocation.marker = {
            lat: event.latLng.lat(),
            lng: event.latLng.lng(),
        };
    });
});
jQ('#aply-location').on('click', function(event){
    event.stopPropagation();
    event.preventDefault();
    mapLocation.description = jQ('#mark-description').val();
    mapLocation.description = mapLocation.description.replace(new RegExp(";", 'g'), '-_-');
    mapLocation.description = mapLocation.description.replace(new RegExp('"', 'g'), '---');
    var options = currentItem.find('.ba-map-options').val();
    options = options.split(';');
    options[0] = JSON.stringify(mapLocation);
    options = options.join(';');
    currentItem.find('.ba-map-options').val(options);
    mapOptionsRecreate(currentItem);
    addHistory();
    jQ('#location-dialog').modal('hide');
});
jQ('.uload-marker').on('click', function(){
    uploadMode = 'marker';
    jQ('#uploader-modal').modal();
});
jQ('.clear-marker').on('click', function(){
    setValue('.ba-map-options', 8, '');
    mapOptionsRecreate(currentItem);
    addHistory();
});
jQ('.display-infobox').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
    } else {
        value = 0;
    }
    setValue('.ba-map-options', 5, value);
    mapOptionsRecreate(currentItem);
    addHistory();
});
jQ('.map-controls').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
    } else {
        value = 0;
    }
    setValue('.ba-map-options', 4, value);
    mapOptionsRecreate(currentItem);
    addHistory();
});
jQ('.scroll-zooming').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
    } else {
        value = 0;
    }
    setValue('.ba-map-options', 6, value);
    mapOptionsRecreate(currentItem);
    addHistory();
});
jQ('.draggable-map').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
    } else {
        value = 0;
    }
    setValue('.ba-map-options', 7, value);
    mapOptionsRecreate(currentItem);
    addHistory();
});
jQ('.map-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.map-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-map-options').val();
    options = options.split(';');
    jQ('.margin-top-map').val(options[1]);
    jQ('.margin-top-map-number').val(options[1]);
    jQ('.margin-bottom-map').val(options[2]);
    jQ('.margin-bottom-map-number').val(options[2]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-map').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-map-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 1, 2);
        currentItem.find('.ba-map-options').val(options);
        jQ('.margin-top-map-number').val(inputValue);
    }, 12);
    jQ('.margin-top-map').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-map').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-map-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 2, 1, 2);
        currentItem.find('.ba-map-options').val(options);
        jQ('.margin-bottom-map-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-map').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-map-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-map-options').val();
    options = marginAction(currentItem, options, value, 1, 1, 2);
    currentItem.find('.ba-map-options').val(options);
    jQ('.margin-top-map').val(value);
});
jQ('.margin-bottom-map-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-map-options').val();
    options = marginAction(currentItem, options, value, 2, 1, 2);
    currentItem.find('.ba-map-options').val(options);
    jQ('.margin-bottom-map').val(value);
});
jQ('.map-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.map-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-map-options').val();
    options = options.split(';');
    jQ('.custom-suffix-map').val(options[8]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-map').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-map-options').val(), jQ(this).val(), 8);
    currentItem.find('.ba-map-options').val(options);
    addHistory();
});