/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.page-tags-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.page-tags-style-options').addClass('ba-fade');
    var options = currentItem.find('.ba-page-tags-options').val();
    options = options.split(';');
    jQ('.page-tags-font-family').val(options[4].replace(new RegExp('\\+','g'), ' ')+' '+options[5]);
    jQ('.page-tags-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).attr('checked', true);
            jQ(this).closest('.button-alignment').addClass('active');
        } else {
            jQ(this).removeAttr('checked');
            jQ(this).closest('.button-alignment').removeClass('active');
        }
    });
    var color = rgb2hex(options[6]);
    jQ('.page-tags-bg-color').minicolors('value', color[0]);
    jQ('.page-tags-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[7]);
    jQ('.page-tags-text-color').minicolors('value', color[0]);
    jQ('.page-tags-text-color').minicolors('opacity', color[1]);
    jQ('.page-tags-font-size').val(options[19]);
    jQ('.page-tags-font-size-number').val(options[19]);
    if (options[8] == 'underline') {
        jQ('.page-tags-font-style[value=underline]').closest('.ba-btn').addClass('active');
        jQ('.page-tags-font-style[value=underline]').attr('checked', true);
    } else {
        jQ('.page-tags-font-style[value=underline]').closest('.ba-btn').removeClass('active');
        jQ('.page-tags-font-style[value=underline]').removeAttr('checked', true);
    }
    if (options[9] == 'uppercase') {
        jQ('.page-tags-font-style[value=uppercase]').closest('.ba-btn').addClass('active');
        jQ('.page-tags-font-style[value=uppercase]').attr('checked', true);
    } else {
        jQ('.page-tags-font-style[value=uppercase]').closest('.ba-btn').removeClass('active');
        jQ('.page-tags-font-style[value=uppercase]').removeAttr('checked', true);
    }
    if (options[10] == 'italic') {
        jQ('.button-font-style[value=italic]').closest('.ba-btn').addClass('active');
        jQ('.button-font-style[value=italic]').attr('checked', true);
    } else {
        jQ('.button-font-style[value=italic]').closest('.ba-btn').removeClass('active');
        jQ('.button-font-style[value=italic]').removeAttr('checked', true);
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-button').show().addClass('ba-active-options');
});
jQ('.select-page-tags-family').on('click', function(){
    uploadMode = 'pageTagsFontUpload';
    jQ('#fonts-modal').modal();
});
jQ('.page-tags-align').on('click', function(){
    jQ('.button-alignment').removeClass('active');
    jQ(this).closest('.button-alignment').addClass('active');
    setValue('.ba-page-tags-options', 3, jQ(this).val(), 'text-align', currentItem, '');
    addHistory();
});
jQ('.page-tags-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != ''){
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-page-tags-options', 6, hex, 'background-color', '.ba-page-tags a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.page-tags-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-page-tags-options', 7, hex, 'color', '.ba-page-tags a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.page-tags-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-page-tags-options', 19, inputValue, 'font-size', '.ba-page-tags a', 'px');
            jQ('.page-tags-font-size-number').val(inputValue);
        }, 12);
    jQ('.page-tags-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.page-tags-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-page-tags-options', 19, value, 'font-size', '.ba-page-tags a', 'px');
    jQ('.page-tags-font-size').val(value);
    addHistory();
});
jQ('.page-tags-font-style').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-page-tags-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-page-tags a').css('text-decoration', value);
            options[8] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-page-tags a').css('text-decoration', 'none');
            options[8] = 'none';
        }
    } else if (value == 'uppercase') {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-page-tags a').css('text-transform', value);
            options[9] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-page-tags a').css('text-transform', 'none');
            options[9] = 'none';
        }
    } else {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-page-tags a').css('font-style', value);
            options[10] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-page-tags a').css('font-style', 'normal');
            options[10] = 'normal';
        }
    }
    options = options.join(';');
    currentItem.find('.ba-page-tags-options').val(options);
    addHistory();
});
jQ('.page-tags-border').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.page-tags-border-options').addClass('ba-fade');
    var options = currentItem.find('.ba-page-tags-options').val();
    options = options.split(';');
    jQ('.page-tags-border-radius').val(options[11]);
    jQ('.page-tags-border-radius-number').val(options[11]);
    var color = rgb2hex(options[12]);
    jQ('.page-tags-border-color').minicolors('value', color[0]);
    jQ('.page-tags-border-color').minicolors('opacity', color[1]);
    jQ('.page-tags-border-width').val(options[13]);
    jQ('.page-tags-border-width-number').val(options[13]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
});
jQ('.page-tags-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-page-tags-options', 11, inputValue, 'border-radius', '.ba-page-tags a', 'px');
            jQ('.page-tags-border-radius-number').val(inputValue);
        }, 12);
    jQ('.page-tags-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.page-tags-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-page-tags-options', 11, value, 'border-radius', '.ba-page-tags a', 'px');
    jQ('.page-tags-border-radius').val(value);
    addHistory();
});
jQ('.page-tags-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-page-tags-options').val();
            options = options.split(';');
            options[12] = jQ(this).minicolors('rgbaString');
            currentItem.find('.ba-page-tags a').css('border', options[13]+'px solid '+options[12]);
            options = options.join(';')
            currentItem.find('.ba-page-tags-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.page-tags-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-page-tags-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[13] = inputValue;
            currentItem.find('.ba-page-tags a').css('border', options[13]+'px solid '+options[12]);
            options = options.join(';');
            currentItem.find('.ba-page-tags-options').val(options);
            jQ('.page-tags-border-width-number').val(inputValue);
        }, 12);
    jQ('.page-tags-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.page-tags-border-width-number').on('click keyup', function(){
    var value = jQ(this).val();
    var options = currentItem.find('.ba-page-tags-options').val();
    options = options.split(';');
    options[13] = value;
    currentItem.find('.ba-page-tags a').css('border', options[13]+'px solid '+options[12]);
    options = options.join(';');
    jQ('.page-tags-border-width').val(value);
    currentItem.find('.ba-page-tags-options').val(options);
    addHistory();
});
jQ('.page-tags-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.page-tags-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-page-tags-options').val();
    options = options.split(';');
    var color = rgb2hex(options[14]);
    jQ('.page-tags-text-color-hover').minicolors('value', color[0]);
    jQ('.page-tags-text-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[15]);
    jQ('.page-tags-bg-color-hover').minicolors('value', color[0]);
    jQ('.page-tags-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[16]);
    jQ('.page-tags-border-color-hover').minicolors('value', color[0]);
    jQ('.page-tags-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.page-tags-text-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-page-tags-options', 14, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.page-tags-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-page-tags-options', 15, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.page-tags-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-page-tags-options', 16, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.page-tags-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.page-tags-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-page-tags-options').val();
    options = options.split(';');
    jQ('.page-tags-padding-vertical').val(options[17]);
    jQ('.page-tags-padding-vertical-number').val(options[17]);
    jQ('.page-tags-padding-horizontal').val(options[18]);
    jQ('.page-tags-padding-horizontal-number').val(options[18]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.page-tags-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-page-tags-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-page-tags a'), options, inputValue, 17, 17, 18, 17, 18);
        currentItem.find('.ba-page-tags-options').val(options);
        jQ('.page-tags-padding-vertical-number').val(inputValue);
    }, 12);
    jQ('.page-tags-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.page-tags-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-page-tags-options').val();
    options = paddingAction(currentItem.find('.ba-page-tags a'), options, value, 17, 17, 18, 17, 18);
    jQ('.page-tags-padding-vertical').val(value);
    currentItem.find('.ba-page-tags-options').val(options);
    addHistory();
});
jQ('.page-tags-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-page-tags-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-page-tags a'), options, inputValue, 18, 17, 18, 17, 18);
        currentItem.find('.ba-page-tags-options').val(options);
        jQ('.page-tags-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.page-tags-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.page-tags-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-page-tags-options').val();
    options = paddingAction(currentItem.find('.ba-page-tags a'), options, value, 18, 17, 18, 17, 18);
    jQ('.page-tags-padding-horizontal').val(value);
    currentItem.find('.ba-page-tags-options').val(options);
    addHistory();
});
jQ('.page-tags-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.page-tags-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-page-tags-options').val();
    options = options.split(';');
    jQ('.margin-top-page-tags').val(options[1]);
    jQ('.margin-top-page-tags-number').val(options[1]);
    jQ('.margin-bottom-page-tags').val(options[2]);
    jQ('.margin-bottom-page-tags-number').val(options[2]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-page-tags').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-page-tags-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 1, 2);
        currentItem.find('.ba-page-tags-options').val(options);
        jQ('.margin-top-page-tags-number').val(inputValue);
    }, 12);
    jQ('.margin-top-page-tags').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-page-tags-number').on('click keyup', function(){
    var value = jQ(this).val();
    var options = currentItem.find('.ba-page-tags-options').val();
    options = marginAction(currentItem, options, value, 1, 1, 2);
    jQ('.margin-top-page-tags').val(value);
    currentItem.find('.ba-page-tags-options').val(options);
    addHistory();
});
jQ('.margin-bottom-page-tags').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-page-tags-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 2, 1, 2);
        currentItem.find('.ba-page-tags-options').val(options);
        jQ('.margin-bottom-page-tags-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-page-tags').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-page-tags-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-page-tags-options').val();
    options = marginAction(currentItem.find('.ba-page-tags'), options, value, 2, 1, 2);
    jQ('.margin-bottom-page-tags').val(value);
    currentItem.find('.ba-page-tags-options').val(options);
    addHistory();
});
jQ('.page-tags-css').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.page-tags-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-page-tags-options').val();
    options = options.split(';');
    jQ('.custom-suffix-page-tags').val(options[0]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-page-tags').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-page-tags-options').val(), jQ(this).val(), 0);
    currentItem.find('.ba-page-tags-options').val(options);
    addHistory();
});