/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.scroll-to-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-options').val(),
        label = currentItem.find('> a span').text();
    options = options.split(';');
    jQ('.scroll-to-icon-position option').each(function(){
        if (jQ(this).val() == options[21]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.scroll-to-speed').val(options[12]);
    jQ('.scroll-to-animation option').each(function(){
        if (jQ(this).val() == options[13]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (!label) {
        label = '';
    }
    jQ('.ba-scroll-to-label').val(label)
    jQ('.scroll-to-offset').val(options[6]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.ba-scroll-to-label').on('keyup', function(){
    var label = jQ(this).val();
    if (currentItem.find('> a span').length == 0) {
        if (currentItem.find('> a i.zmdi')) {
            currentItem.find('> a i.zmdi').before('<span></span>');
        } else {
            currentItem.find('> a').append('<span></span>');
        }
    }
    currentItem.find('> a span').text(label);
    if (label == '') {
        currentItem.find('> a span').remove()
    }
});
jQ('.scroll-to-speed').on('keyup', function() {
    setValue('.ba-scroll-to-options', 12, jQ(this).val());
    initScrollTo(currentItem);
    addHistory();
});
jQ('.scroll-to-animation').on('change', function() {
    setValue('.ba-scroll-to-options', 13, jQ(this).val());
    initScrollTo(currentItem);
    addHistory();
});
jQ('.select-end-point').on('click', function(){
    jQ('.select-to-workarea').addClass('visible-area');
    jQ('.ba-workspace').hide();
    jQ('.select-to-workarea').on('click', function(event){
        var pageY = event.clientY,
            pageX = event.clientX,
            rand,
            item = null;
        jQ('.ba-row-wrapper > .ba-row').each(function(){
            var coordinates = this.getBoundingClientRect()
            if (coordinates.top < pageY && coordinates.bottom > pageY
                && coordinates.left < pageX && coordinates.right > pageX) {
                item = this;
                return false;
            }
        });
        if (!item) {
            jQ('.ba-wrapper').not('.overlay-section').find('> .ba-section').each(function(){
                var coordinates = this.getBoundingClientRect()
                if (coordinates.top < pageY && coordinates.bottom > pageY) {
                    item = this;
                    return false;
                }
            });
        }
        if (item) {
            rand = jQ(item).attr('data-scroll-to');
            if (!rand) {
                rand = Math.floor(Math.random() * 1000000);
                rand = pageY * rand;
                jQ(item).attr('data-scroll-to', rand);
            }
            jQ('.select-to-workarea').off('click').removeClass('visible-area');
            jQ('.ba-workspace').show();
            setValue('.ba-scroll-to-options', 6, rand);
            initScrollTo(currentItem);
            addHistory();
        }
    });
});
jQ('.scroll-to-icon-position').on('change', function(){
    var options = currentItem.find('.ba-scroll-to-options').val(),
        value = jQ(this).val();
    options = options.split(';');
    currentItem.removeClass(options[21]);
    options[21] = value;
    if (value != 'before') {
        currentItem.addClass(value)
    }
    options = options.join(';');
    currentItem.find('.ba-scroll-to-options').val(options);
});
jQ('.select-scroll-to').on('click', function(){
    uploadMode = 'reselectScrollTo';
    jQ('#icons-upload-modal').modal();
});
jQ('.clear-scroll-to-icon').on('click', function(){
    currentItem.find('i.zmdi').remove();
})
jQ('.scroll-to-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-style-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-options').val();
    options = options.split(';');
    if (!options[24]) {
        options[24] = 0;
    }
    jQ('.scroll-to-letter-spacing').val(options[24]);
    jQ('.scroll-to-letter-spacing-number').val(options[24]);
    jQ('.scroll-to-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    if (options[18] == 'underline') {
        jQ('.scroll-to-font-style[value=underline]').closest('.ba-btn').addClass('active');
        jQ('.scroll-to-font-style[value=underline]').attr('checked', true);
    } else {
        jQ('.scroll-to-font-style[value=underline]').closest('.ba-btn').removeClass('active');
        jQ('.scroll-to-font-style[value=underline]').removeAttr('checked', true);
    }
    if (options[19] == 'uppercase') {
        jQ('.scroll-to-font-style[value=uppercase]').closest('.ba-btn').addClass('active');
        jQ('.scroll-to-font-style[value=uppercase]').attr('checked', true);
    } else {
        jQ('.scroll-to-font-style[value=uppercase]').closest('.ba-btn').removeClass('active');
        jQ('.scroll-to-font-style[value=uppercase]').removeAttr('checked', true);
    }
    if (options[20] == 'italic') {
        jQ('.scroll-to-font-style[value=italic]').closest('.ba-btn').addClass('active');
        jQ('.scroll-to-font-style[value=italic]').attr('checked', true);
    } else {
        jQ('.scroll-to-font-style[value=italic]').closest('.ba-btn').removeClass('active');
        jQ('.scroll-to-font-style[value=italic]').removeAttr('checked', true);
    }
    jQ('.scroll-to-font-family').val(options[22].replace(new RegExp('\\+','g'), ' ')+' '+options[23]);
    color = rgb2hex(options[8]);
    jQ('.scroll-to-bg-color').minicolors('value', color[0]);
    jQ('.scroll-to-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[4]);
    jQ('.scroll-to-text-color').minicolors('value', color[0]);
    jQ('.scroll-to-text-color').minicolors('opacity', color[1]);
    jQ('.scroll-to-font-size').val(options[5]);
    jQ('.scroll-to-font-size-number').val(options[5]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-scroll').show().addClass('ba-active-options');
});
jQ('.scroll-to-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-scroll-to-options').val();
    options = options.split(';');
    if (jQ(this).val() == 'underline') {
        if (options[18] != value) {
            jQ(this).closest('label').addClass('active');
            options[18] = value;

        } else {
            jQ(this).closest('label').removeClass('active');
            options[18] = 'none';
        }
    } else if (jQ(this).val() == 'uppercase') {
        if (options[19] != value) {
            jQ(this).closest('label').addClass('active');
            options[19] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[19] = 'none';
        }
    } else {
        if (options[20] != value) {
            jQ(this).closest('label').addClass('active');
            options[20] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[20] = 'normal';
        }
    }
    currentItem.find('> a').css({
        'text-decoration' : options[18],
        'text-transform' : options[19],
        'font-style' : options[20]
    });
    options = options.join(';');
    currentItem.find('.ba-scroll-to-options').val(options);
    addHistory();
});
jQ('.select-scroll-to-family').on('click', function(){
    uploadMode = 'scrollToFamily';
    jQ('#fonts-modal').modal();
});
jQ('.scroll-to-align').on('click', function(){
    setValue('.ba-scroll-to-options', 3, jQ(this).val(), 'text-align', currentItem, '');
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    addHistory()
});
jQ('.scroll-to-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-options', 8, hex, 'background-color', '> a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-options', 4, hex, 'color', '> a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-scroll-to-options', 24, inputValue, 'letter-spacing', '> a', 'px');
            jQ('.scroll-to-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.scroll-to-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-scroll-to-options', 24, value, 'letter-spacing', '> a', 'px');
    jQ('.scroll-to-letter-spacing').val(value);
    addHistory();
});
jQ('.scroll-to-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-scroll-to-options', 5, inputValue, 'font-size', '> a', 'px');
        currentItem.find('i.zmdi').css({
            'width' : inputValue+'px',
            'height' : inputValue+'px'
        });
        jQ('.scroll-to-font-size-number').val(inputValue);
    }, 12);
    jQ('.scroll-to-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-scroll-to-options', 5, value, 'font-size', '> a', 'px');
    currentItem.find('i.zmdi').css({
        'width' : value+'px',
        'height' : value+'px'
    });
    jQ('.scroll-to-font-size').val(value);
    addHistory();
});
jQ('.scroll-to-border').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-border-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-options').val();
    options = options.split(';');
    var color = rgb2hex(options[9]);
    jQ('.scroll-to-border-color').minicolors('value', color[0]);
    jQ('.scroll-to-border-color').minicolors('opacity', color[1]);
    jQ('.scroll-to-border-radius').val(options[10]);
    jQ('.scroll-to-border-radius-number').val(options[10]);
    jQ('.scroll-to-border-width').val(options[11]);
    jQ('.scroll-to-border-width-number').val(options[11]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
});
jQ('.scroll-to-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-scroll-to-options', 10, inputValue, 'border-radius', '> a', 'px');
        jQ('.scroll-to-border-radius-number').val(inputValue);
    }, 12);
    jQ('.scroll-to-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-scroll-to-options', 10, value, 'border-radius', '> a', 'px');
    jQ('.scroll-to-border-radius').val(value);
    addHistory();
});
jQ('.scroll-to-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            var value = jQ(this).minicolors('rgbaString'),
                options = currentItem.find('.ba-scroll-to-options').val();
            options = options.split(';');
            options[9] = value;
            currentItem.find('> a').css('border', options[11]+'px solid '+value);
            options = options.join(';');
            currentItem.find('.ba-scroll-to-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-scroll-to-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[11] = inputValue;
            currentItem.find('> a').css('border', options[11]+'px solid '+options[9]);
            options = options.join(';');
            currentItem.find('.ba-scroll-to-options').val(options);
            jQ('.scroll-to-border-width-number').val(inputValue);
        }, 12);
    jQ('.scroll-to-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-border-width-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-scroll-to-options').val();
    options = options.split(';');
    options[11] = value;
    currentItem.find('> a').css('border', options[11]+'px solid '+options[9]);
    options = options.join(';');
    jQ('.scroll-to-border-width').val(value);
    currentItem.find('.ba-scroll-to-options').val(options);
    addHistory();
});
jQ('.scroll-to-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-options').val();
    options = options.split(';');
    var color = rgb2hex(options[7]);
    jQ('.scroll-to-hover-color').minicolors('value', color[0]);
    jQ('.scroll-to-hover-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[14]);
    jQ('.scroll-to-bg-color-hover').minicolors('value', color[0]);
    jQ('.scroll-to-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[15]);
    jQ('.scroll-to-border-color-hover').minicolors('value', color[0]);
    jQ('.scroll-to-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.scroll-to-hover-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-options', 7, hex);
            scrolltoTopHover(currentItem);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-options', 14, hex);
            scrollToHover(currentItem);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-options', 15, hex);
            scrollToHover(currentItem);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-options').val();
    options = options.split(';');
    jQ('.scroll-to-padding-vertical').val(options[16]);
    jQ('.scroll-to-padding-vertical-number').val(options[16]);
    jQ('.scroll-to-padding-horizontal').val(options[17]);
    jQ('.scroll-to-padding-horizontal-number').val(options[17]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.scroll-to-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-scroll-to-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('> a'), options, inputValue, 16, 16, 17, 16, 17);
        currentItem.find('.ba-scroll-to-options').val(options);
        jQ('.scroll-to-padding-vertical-number').val(inputValue);
    }, 12);
    jQ('.scroll-to-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-scroll-to-options').val();
    options = paddingAction(currentItem.find('> a'), options, value, 16, 16, 17, 16, 17);
    jQ('.scroll-to-padding-vertical').val(value);
    currentItem.find('.ba-scroll-to-options').val(options);
    addHistory();
});
jQ('.scroll-to-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-scroll-to-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('> a'), options, inputValue, 17, 16, 17, 16, 17);
        currentItem.find('.ba-scroll-to-options').val(options);
        jQ('.scroll-to-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.scroll-to-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-scroll-to-options').val();
    options = paddingAction(currentItem.find('> a'), options, value, 17, 16, 17, 16, 17);
    jQ('.padding-horizontal').val(value);
    currentItem.find('.ba-scroll-to-options').val(options);
    addHistory();
});
jQ('.scroll-to-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-options').val();
    options = options.split(';');
    jQ('.margin-top-scroll-to').val(options[0]);
    jQ('.margin-top-scroll-to-number').val(options[0]);
    jQ('.margin-bottom-scroll-to').val(options[1]);
    jQ('.margin-bottom-scroll-to-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-scroll-to').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-scroll-to-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-scroll-to-options').val(options);
        jQ('.margin-top-scroll-to-number').val(inputValue);
    }, 12);
    jQ('.margin-top-scroll-to').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-scroll-to').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-scroll-to-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-scroll-to-options').val(options);
        jQ('.margin-bottom-scroll-to-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-scroll-to').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-scroll-to-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-scroll-to-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-scroll-to-options').val(options);
    jQ('.margin-top-scroll-to').val(value);
    addHistory();
});
jQ('.margin-bottom-scroll-to-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-scroll-to-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-scroll-to-options').val(options);
    jQ('.margin-bottom-scroll-to').val(value);
    addHistory();
});
jQ('.scroll-to-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-options').val();
    options = options.split(';');
    jQ('.custom-suffix-scroll-to').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-scroll-to').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-scroll-to-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-scroll-to-options').val(options);
    addHistory();
});