/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.tabs-options-cell').on('click', function(){
    var options = currentItem.find('.ba-tabs-options').val(),
        color;
    options = options.split(';');
    jQ('.tabs-align').each(function(){
        if (jQ(this).val() == options[6]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.tabs-position option').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    color = rgb2hex(options[4]);
    jQ('.tabs-border').minicolors('value', color[0]);
    jQ('.tabs-border').minicolors('opacity', color[1]);
    jQ('.tabs-border-radius').val(options[5]);
    jQ('.tabs-border-radius-number').val(options[5]);
    jQ('.tabs-animation option').each(function(){
        if (jQ(this).val() == options[20]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected')
        }
    });
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tabs-options-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.tabs-animation').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-tabs-options').val();
    options = options.split(';');
    currentItem.find('.'+options[20]).removeClass(options[20]).addClass(value);
    options[20] = value;
    options = options.join(';');
    currentItem.find('.ba-tabs-options').val(options);
});
jQ('.tabs-position').on('change', function(){
    var options = currentItem.find('.ba-tabs-options').val(),
        value = jQ(this).val();
    options = options.split(';');
    currentItem.find('> ul.nav.nav-tabs').removeClass(options[3]);
    currentItem.find('> ul.nav.nav-tabs').addClass(value);
    options[3] = value;
    options = options.join(';');
    currentItem.find('.ba-tabs-options').val(options);
});
jQ('.tabs-border').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-tabs-options', 4, hex, 'border-color', '> ul.nav.nav-tabs', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tabs-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-tabs-options', 5, inputValue, 'border-radius', '> ul.nav.nav-tabs li a', 'px');
        jQ('.tabs-border-radius-number').val(inputValue);
    }, 12);
    jQ('.tabs-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tabs-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-tabs-options', 5, value, 'border-radius', '> ul.nav.nav-tabs li a', 'px');
    jQ('.tabs-border-radius').val(value);
    addHistory();
});
jQ('.tabs-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tabs-style-list').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-tabs ~ a').hide();
    jQ('.nav-style-tabs').show().addClass('ba-active-options');
});
jQ('.nav-style-tabs').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-workspace .ba-element-options .ba-fade').removeClass('ba-fade');
    jQ('.tabs-style-list').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-tabs ~ a').hide();
    jQ('.nav-style-tabs').show().addClass('ba-active-options');
});
jQ('.tabs-style-typography').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tabs-typography-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-typography-tabs').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-tabs-options').val();
    options = options.split(';');
    if (!options[26]) {
        options[26] = 0;
    }
    jQ('.tabs-letter-spacing').val(options[26]);
    jQ('.tabs-letter-spacing-number').val(options[26]);
    jQ('.tabs-font-family').val(options[10].replace(new RegExp('\\+','g'), ' ')+' '+options[11]);
    var color = rgb2hex(options[7]);
    jQ('.tabs-text-color').minicolors('value', color[0]);
    jQ('.tabs-text-color').minicolors('opacity', color[1]);
    jQ('.tabs-font-size').val(options[8]);
    jQ('.tabs-font-size-number').val(options[8]);
    jQ('.tabs-line-height').val(options[9]);
    jQ('.tabs-line-height-number').val(options[9]);
    jQ('.tabs-font-style').each(function(){
        if (jQ(this).val() == 'underline') {
            if (options[25] == 'underline') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'italic') {
            if (options[13] == 'italic') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'uppercase') {
            if (options[12] == 'uppercase') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.tabs-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-tabs-options', 6, jQ(this).val(), 'text-align', '> ul.nav.nav-tabs', '');
});
jQ('.select-tabs-family').on('click', function(){
    uploadMode = 'tabsFamily';
    jQ('#fonts-modal').modal();
});
jQ('.tabs-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            var value = jQ(this).minicolors('rgbaString'),
                options = currentItem.find('.ba-tabs-options').val();
            options = options.split(';');
            options[7] = value;
            options = options.join(';');
            currentItem.find('.ba-tabs-options').val(options);
            currentItem.find('> ul.nav.nav-tabs li').not('.active').find('a').css('color', value);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tabs-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-tabs-options', 8, inputValue, 'font-size', '> ul.nav.nav-tabs li a', 'px');
        jQ('.tabs-font-size-number').val(inputValue);
    }, 12);
    jQ('.tabs-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tabs-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-tabs-options', 8, value, 'font-size', '> ul.nav.nav-tabs li a', 'px');
    jQ('.tabs-font-size').val(value);
    addHistory();
});
jQ('.tabs-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-tabs-options', 26, inputValue, 'letter-spacing', '> ul.nav.nav-tabs li a', 'px');
        jQ('.tabs-letter-spacing-number').val(inputValue);
    }, 12);
    jQ('.tabs-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tabs-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-tabs-options', 26, value, 'letter-spacing', '> ul.nav.nav-tabs li a', 'px');
    jQ('.tabs-letter-spacing').val(value);
    addHistory();
});
jQ('.tabs-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-tabs-options', 9, inputValue, 'line-height', '> ul.nav.nav-tabs li a', 'px');
        jQ('.tabs-line-height-number').val(inputValue);
    }, 12);
    jQ('.tabs-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tabs-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-tabs-options', 9, value, 'line-height', '> ul.nav.nav-tabs li a', 'px');
    jQ('.tabs-line-height').val(value);
    addHistory();
});
jQ('.tabs-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-tabs-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[25] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[25] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[25] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[12] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[12] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[12] = 'none';
        }
    } else {
        if (options[13] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[13] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[13] = 'normal';
        }
    }
    currentItem.find('.nav.nav-tabs li a').css({
        'text-decoration' : options[25],
        'text-transform' : options[12],
        'font-style' : options[13]
    });
    options = options.join(';');
    currentItem.find('.ba-tabs-options').val(options);
    addHistory();
});
jQ('.tabs-active').on('click', function(){
    jQ('.tabs-style-list').removeClass('ba-in');
    jQ('.tabs-active-options').addClass('ba-fade');
    jQ('.nav-style-tabs').removeClass('ba-active-options');
    jQ('.nav-active-tabs').show();
    jQ('.nav-active-tabs').addClass('ba-active-options');
    var options = currentItem.find('.ba-tabs-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[14]);
    jQ('.tabs-active-color').minicolors('value', color[0]);
    jQ('.tabs-active-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[15]);
    jQ('.tabs-active-bg-color').minicolors('value', color[0]);
    jQ('.tabs-active-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[16]);
    jQ('.tabs-active-border-color').minicolors('value', color[0]);
    jQ('.tabs-active-border-color').minicolors('opacity', color[1]);
});
jQ('.tabs-active-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-tabs-options', 14, hex, 'color', '> ul.nav.nav-tabs li.active a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tabs-active-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-tabs-options', 15, hex, 'background-color', '> ul.nav.nav-tabs li.active a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tabs-active-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-tabs-options', 16, hex, 'border-color', '> ul.nav.nav-tabs li.active a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tabs-hover').on('click', function(){
    jQ('.tabs-style-list').removeClass('ba-in');
    jQ('.tabs-hover-options').addClass('ba-fade');
    jQ('.nav-style-tabs').removeClass('ba-active-options');
    jQ('.nav-hover').show();
    jQ('.nav-hover').addClass('ba-active-options');
    var options = currentItem.find('.ba-tabs-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[17]);
    jQ('.tabs-hover-color').minicolors('value', color[0]);
    jQ('.tabs-hover-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[18]);
    jQ('.tabs-hover-bg-color').minicolors('value', color[0]);
    jQ('.tabs-hover-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[19]);
    jQ('.tabs-hover-border-color').minicolors('value', color[0]);
    jQ('.tabs-hover-border-color').minicolors('opacity', color[1]);
});
jQ('.tabs-hover-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-tabs-options', 17, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tabs-hover-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-tabs-options', 18, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tabs-hover-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-tabs-options', 19, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tabs-tabs').on('click', function(){
    var items = {},
        tab;
    jQ('.tabs-tabs-options .slides-list tbody').empty();
    currentItem.find('ul.nav.nav-tabs > li a').each(function(){
        items.href = jQ(this).attr('href');
        items.title = jQ(this).text();
        items.description = jQ(items.href).html();
        var str = '<tr><td><input type="checkbox" class="tabs-items"';
        str += " value=''>";
        str += '</td><td width="90%">';
        str += items.title+'</td></tr>';
        tab = JSON.stringify(items);
        jQ('.tabs-tabs-options .slides-list tbody').append(str);
        jQ('.tabs-tabs-options .slides-list tbody .tabs-items').last().val(tab)
        items = {};
    });
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tabs-tabs-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-tabs-list').show().addClass('ba-active-options');
});
jQ('.tabs-add').on('click', function(){
    tabMode = 'add';
    jQ('#tabs-add-modal .tabs-mode').show();
    jQ('#tabs-add-modal .accordion-mode').hide();
    jQ('.tab-title').val('New Tab');
    CKEtab.setData('');
    jQ('#tabs-add-modal').modal();
});
jQ('.tabs-edit').on('click', function(){
    var index = 0,
        item;
    jQ('.tabs-items').each(function(){
        if (jQ(this).prop('checked')) {
            item = jQ(this).val();
            index++;
        }
    });
    if (index === 1) {
        item = JSON.parse(item);
        tabMode = 'edit';
        jQ('#tabs-add-modal .tabs-mode').show();
        jQ('#tabs-add-modal .accordion-mode').hide();
        jQ('.tab-title').val(item.title);
        jQ('.tabs-href').val(item.href);
        CKEtab.setData(item.description);
        jQ('#tabs-add-modal').modal();
    } else if (index > 1) {
        jQ('#notification-modal .item-notification').show();
        jQ('#notification-modal .select-item').hide();
        jQ('#notification-modal').modal();
    } else if (index === 0) {
        jQ('#notification-modal .item-notification').hide();
        jQ('#notification-modal .select-item').show();
        jQ('#notification-modal').modal();
    }
});
jQ('.tabs-delete').on('click', function(){
    var index = 0;
    jQ('.tabs-items').each(function(){
        if (jQ(this).prop('checked')) {
            index++;
        }
    });
    if (index > 0) {
        deleteItem = 'tabs';
        jQ('#login-modal').modal();
    }
});
jQ('.tabs-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tabs-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tabs-options').val();
    options = options.split(';');
    jQ('.tabs-padding-top').val(options[21]);
    jQ('.tabs-padding-top-number').val(options[21]);
    jQ('.tabs-padding-right').val(options[22]);
    jQ('.tabs-padding-right-number').val(options[22]);
    jQ('.tabs-padding-bottom').val(options[23]);
    jQ('.tabs-padding-bottom-number').val(options[23]);
    jQ('.tabs-padding-left').val(options[24]);
    jQ('.tabs-padding-left-number').val(options[24]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.tabs-padding-top').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find(' > .ba-tabs-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[21] = inputValue;
        currentItem.find('.tab-content').css({
            'padding' : options[21]+'px '+options[22]+'px '+options[23]+'px '+options[24]+'px'
        })
        options = options.join(';');
        currentItem.find(' > .ba-tabs-options').val(options);
        jQ('.tabs-padding-top-number').val(inputValue);
    }, 12);
    jQ('.tabs-padding-top').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tabs-padding-right').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find(' > .ba-tabs-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[22] = inputValue;
        currentItem.find('.tab-content').css({
            'padding' : options[21]+'px '+options[22]+'px '+options[23]+'px '+options[24]+'px'
        })
        options = options.join(';');
        currentItem.find(' > .ba-tabs-options').val(options);
        jQ('.tabs-padding-right-number').val(inputValue);
    }, 12);
    jQ('.tabs-padding-right').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tabs-padding-bottom').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find(' > .ba-tabs-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[23] = inputValue;
        currentItem.find('.tab-content').css({
            'padding' : options[21]+'px '+options[22]+'px '+options[23]+'px '+options[24]+'px'
        })
        options = options.join(';');
        currentItem.find(' > .ba-tabs-options').val(options);
        jQ('.tabs-padding-bottom-number').val(inputValue);
    }, 12);
    jQ('.tabs-padding-bottom').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tabs-padding-left').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find(' > .ba-tabs-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[24] = inputValue;
        currentItem.find('.tab-content').css({
            'padding' : options[21]+'px '+options[22]+'px '+options[23]+'px '+options[24]+'px'
        })
        options = options.join(';');
        currentItem.find(' > .ba-tabs-options').val(options);
        jQ('.tabs-padding-left-number').val(inputValue);
    }, 12);
    jQ('.tabs-padding-left').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tabs-padding-top-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find(' > .ba-tabs-options').val();
    options = options.split(';');
    options[21] = value;
    currentItem.find('.tab-content').css({
        'padding' : options[21]+'px '+options[22]+'px '+options[23]+'px '+options[24]+'px'
    })
    options = options.join(';');
    currentItem.find(' > .ba-tabs-options').val(options);
    jQ('.tabs-padding-top').val(value);
    addHistory();
});
jQ('.tabs-padding-right-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find(' > .ba-tabs-options').val();
    options = options.split(';');
    options[22] = value;
    currentItem.find('.tab-content').css({
        'padding' : options[21]+'px '+options[22]+'px '+options[23]+'px '+options[24]+'px'
    })
    options = options.join(';');
    currentItem.find(' > .ba-tabs-options').val(options);
    jQ('.tabs-padding-right').val(value);
    addHistory();
});
jQ('.tabs-padding-bottom-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find(' > .ba-tabs-options').val();
    options = options.split(';');
    options[23] = value;
    currentItem.find('.tab-content').css({
        'padding' : options[21]+'px '+options[22]+'px '+options[23]+'px '+options[24]+'px'
    })
    options = options.join(';');
    currentItem.find(' > .ba-tabs-options').val(options);
    jQ('.tabs-padding-bottom').val(value);
    addHistory();
});
jQ('.tabs-padding-left-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find(' > .ba-tabs-options').val();
    options = options.split(';');
    options[24] = value;
    currentItem.find('.tab-content').css({
        'padding' : options[21]+'px '+options[22]+'px '+options[23]+'px '+options[24]+'px'
    });
    options = options.join(';');
    currentItem.find(' > .ba-tabs-options').val(options);
    jQ('.tabs-padding-left').val(value);
    addHistory();
});
jQ('.tabs-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tabs-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tabs-options').val();
    options = options.split(';');
    jQ('.margin-top-tabs').val(options[0]);
    jQ('.margin-top-tabs-number').val(options[0]);
    jQ('.margin-bottom-tabs').val(options[1]);
    jQ('.margin-bottom-tabs-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-tabs').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-tabs-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-tabs-options').val(options);
        jQ('.margin-top-tabs-number').val(inputValue);
    }, 12);
    jQ('.margin-top-tabs').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-tabs').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-tabs-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-tabs-options').val(options);
        jQ('.margin-bottom-tabs-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-tabs').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-tabs-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-tabs-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-tabs-options').val(options);
    jQ('.margin-top-tabs').val(value);
    addHistory();
});
jQ('.margin-bottom-tabs-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-tabs-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-tabs-options').val(options);
    jQ('.margin-bottom-tabs').val(value);
    addHistory();
});
jQ('.tabs-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tabs-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tabs-options').val();
    options = options.split(';');
    jQ('.custom-suffix-tabs').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-tabs').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-tabs-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-tabs-options').val(options);
    addHistory();
});