/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.tag-cloud-options-options').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tag-cloud-options-cell').addClass('ba-fade');
    var options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    jQ('.tag-cloud-tag-limit').val(options[20]);
    jQ('.tag-cloud-tag-limit-number').val(options[20]);
    jQ('.tag-cloud-sort-by option').each(function(){
        if (jQ(this).val() == options[21]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.tag-cloud-sort-by').on('change', function(){
    setValue('.ba-tag-cloud-options', 21, jQ(this).val());
    getTagCloud();
    addHistory();
});
jQ('.tag-cloud-tag-limit').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-tag-cloud-options', 20, inputValue);
            jQ('.tag-cloud-tag-limit-number').val(inputValue);
        }, 12);
    jQ('.tag-cloud-tag-limit').on('mouseup', function(){
        clearInterval(interval);
        getTagCloud();
        addHistory();
    });
});
jQ('.tag-cloud-tag-limit-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-tag-cloud-options', 20, value);
    jQ('.tag-cloud-tag-limit').val(value);
    getTagCloud();
    addHistory();
});
jQ('.tag-cloud-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tag-cloud-style-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    jQ('.tag-cloud-font-family').val(options[4].replace(new RegExp('\\+','g'), ' ')+' '+options[5]);
    jQ('.tag-cloud-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).attr('checked', true);
            jQ(this).closest('.button-alignment').addClass('active');
        } else {
            jQ(this).removeAttr('checked');
            jQ(this).closest('.button-alignment').removeClass('active');
        }
    });
    var color = rgb2hex(options[6]);
    jQ('.tag-cloud-bg-color').minicolors('value', color[0]);
    jQ('.tag-cloud-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[7]);
    jQ('.tag-cloud-text-color').minicolors('value', color[0]);
    jQ('.tag-cloud-text-color').minicolors('opacity', color[1]);
    jQ('.tag-cloud-font-size').val(options[19]);
    jQ('.tag-cloud-font-size-number').val(options[19]);
    if (options[8] == 'underline') {
        jQ('.tag-cloud-font-style[value=underline]').closest('.ba-btn').addClass('active');
        jQ('.tag-cloud-font-style[value=underline]').attr('checked', true);
    } else {
        jQ('.tag-cloud-font-style[value=underline]').closest('.ba-btn').removeClass('active');
        jQ('.tag-cloud-font-style[value=underline]').removeAttr('checked', true);
    }
    if (options[9] == 'uppercase') {
        jQ('.tag-cloud-font-style[value=uppercase]').closest('.ba-btn').addClass('active');
        jQ('.tag-cloud-font-style[value=uppercase]').attr('checked', true);
    } else {
        jQ('.tag-cloud-font-style[value=uppercase]').closest('.ba-btn').removeClass('active');
        jQ('.tag-cloud-font-style[value=uppercase]').removeAttr('checked', true);
    }
    if (options[10] == 'italic') {
        jQ('.button-font-style[value=italic]').closest('.ba-btn').addClass('active');
        jQ('.button-font-style[value=italic]').attr('checked', true);
    } else {
        jQ('.button-font-style[value=italic]').closest('.ba-btn').removeClass('active');
        jQ('.button-font-style[value=italic]').removeAttr('checked', true);
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-button').show().addClass('ba-active-options');
});
jQ('.select-tag-cloud-family').on('click', function(){
    uploadMode = 'tagCloudFontUpload';
    jQ('#fonts-modal').modal();
});
jQ('.tag-cloud-align').on('click', function(){
    jQ('.button-alignment').removeClass('active');
    jQ(this).closest('.button-alignment').addClass('active');
    setValue('.ba-tag-cloud-options', 3, jQ(this).val(), 'text-align', currentItem, '');
    addHistory();
});
jQ('.tag-cloud-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != ''){
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-tag-cloud-options', 6, hex, 'background-color', '.ba-tag-cloud a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tag-cloud-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-tag-cloud-options', 7, hex, 'color', '.ba-tag-cloud a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tag-cloud-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-tag-cloud-options', 19, inputValue, 'font-size', '.ba-tag-cloud a', 'px');
            jQ('.tag-cloud-font-size-number').val(inputValue);
        }, 12);
    jQ('.tag-cloud-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tag-cloud-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-tag-cloud-options', 19, value, 'font-size', '.ba-tag-cloud a', 'px');
    jQ('.tag-cloud-font-size').val(value);
    addHistory();
});
jQ('.tag-cloud-font-style').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-tag-cloud a').css('text-decoration', value);
            options[8] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-tag-cloud a').css('text-decoration', 'none');
            options[8] = 'none';
        }
    } else if (value == 'uppercase') {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-tag-cloud a').css('text-transform', value);
            options[9] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-tag-cloud a').css('text-transform', 'none');
            options[9] = 'none';
        }
    } else {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-tag-cloud a').css('font-style', value);
            options[10] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-tag-cloud a').css('font-style', 'normal');
            options[10] = 'normal';
        }
    }
    options = options.join(';');
    currentItem.find('.ba-tag-cloud-options').val(options);
    addHistory();
});
jQ('.tag-cloud-border').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tag-cloud-border-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    jQ('.tag-cloud-border-radius').val(options[11]);
    jQ('.tag-cloud-border-radius-number').val(options[11]);
    var color = rgb2hex(options[12]);
    jQ('.tag-cloud-border-color').minicolors('value', color[0]);
    jQ('.tag-cloud-border-color').minicolors('opacity', color[1]);
    jQ('.tag-cloud-border-width').val(options[13]);
    jQ('.tag-cloud-border-width-number').val(options[13]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
});
jQ('.tag-cloud-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-tag-cloud-options', 11, inputValue, 'border-radius', '.ba-tag-cloud a', 'px');
            jQ('.tag-cloud-border-radius-number').val(inputValue);
        }, 12);
    jQ('.tag-cloud-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tag-cloud-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-tag-cloud-options', 11, value, 'border-radius', '.ba-tag-cloud a', 'px');
    jQ('.tag-cloud-border-radius').val(value);
    addHistory();
});
jQ('.tag-cloud-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-tag-cloud-options').val();
            options = options.split(';');
            options[12] = jQ(this).minicolors('rgbaString');
            currentItem.find('.ba-tag-cloud a').css('border', options[13]+'px solid '+options[12]);
            options = options.join(';')
            currentItem.find('.ba-tag-cloud-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tag-cloud-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-tag-cloud-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[13] = inputValue;
            currentItem.find('.ba-tag-cloud a').css('border', options[13]+'px solid '+options[12]);
            options = options.join(';');
            currentItem.find('.ba-tag-cloud-options').val(options);
            jQ('.tag-cloud-border-width-number').val(inputValue);
        }, 12);
    jQ('.tag-cloud-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tag-cloud-border-width-number').on('click keyup', function(){
    var value = jQ(this).val();
    var options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    options[13] = value;
    currentItem.find('.ba-tag-cloud a').css('border', options[13]+'px solid '+options[12]);
    options = options.join(';');
    jQ('.tag-cloud-border-width').val(value);
    currentItem.find('.ba-tag-cloud-options').val(options);
    addHistory();
});
jQ('.tag-cloud-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tag-cloud-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    var color = rgb2hex(options[14]);
    jQ('.tag-cloud-text-color-hover').minicolors('value', color[0]);
    jQ('.tag-cloud-text-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[15]);
    jQ('.tag-cloud-bg-color-hover').minicolors('value', color[0]);
    jQ('.tag-cloud-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[16]);
    jQ('.tag-cloud-border-color-hover').minicolors('value', color[0]);
    jQ('.tag-cloud-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.tag-cloud-text-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-tag-cloud-options', 14, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tag-cloud-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-tag-cloud-options', 15, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tag-cloud-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-tag-cloud-options', 16, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.tag-cloud-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tag-cloud-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    jQ('.tag-cloud-padding-vertical').val(options[17]);
    jQ('.tag-cloud-padding-vertical-number').val(options[17]);
    jQ('.tag-cloud-padding-horizontal').val(options[18]);
    jQ('.tag-cloud-padding-horizontal-number').val(options[18]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.tag-cloud-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-tag-cloud-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-tag-cloud a'), options, inputValue, 17, 17, 18, 17, 18);
        currentItem.find('.ba-tag-cloud-options').val(options);
        jQ('.tag-cloud-padding-vertical-number').val(inputValue);
    }, 12);
    jQ('.tag-cloud-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tag-cloud-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-tag-cloud-options').val();
    options = paddingAction(currentItem.find('.ba-tag-cloud a'), options, value, 17, 17, 18, 17, 18);
    jQ('.tag-cloud-padding-vertical').val(value);
    currentItem.find('.ba-tag-cloud-options').val(options);
    addHistory();
});
jQ('.tag-cloud-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-tag-cloud-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-tag-cloud a'), options, inputValue, 18, 17, 18, 17, 18);
        currentItem.find('.ba-tag-cloud-options').val(options);
        jQ('.tag-cloud-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.tag-cloud-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.tag-cloud-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-tag-cloud-options').val();
    options = paddingAction(currentItem.find('.ba-tag-cloud a'), options, value, 18, 17, 18, 17, 18);
    jQ('.tag-cloud-padding-horizontal').val(value);
    currentItem.find('.ba-tag-cloud-options').val(options);
    addHistory();
});
jQ('.tag-cloud-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tag-cloud-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    jQ('.margin-top-tag-cloud').val(options[1]);
    jQ('.margin-top-tag-cloud-number').val(options[1]);
    jQ('.margin-bottom-tag-cloud').val(options[2]);
    jQ('.margin-bottom-tag-cloud-number').val(options[2]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-tag-cloud').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-tag-cloud-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 1, 2);
        currentItem.find('.ba-tag-cloud-options').val(options);
        jQ('.margin-top-tag-cloud-number').val(inputValue);
    }, 12);
    jQ('.margin-top-tag-cloud').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-tag-cloud-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-tag-cloud-options').val();
    options = marginAction(currentItem, options, value, 1, 1, 2);
    jQ('.margin-top-tag-cloud').val(value);
    currentItem.find('.ba-tag-cloud-options').val(options);
    addHistory();
});
jQ('.margin-bottom-tag-cloud').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-tag-cloud-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 2, 1, 2);
        currentItem.find('.ba-tag-cloud-options').val(options);
        jQ('.margin-bottom-tag-cloud-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-tag-cloud').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-tag-cloud-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-tag-cloud-options').val();
    options = marginAction(currentItem, options, value, 2, 1, 2);
    jQ('.margin-bottom-tag-cloud').val(value);
    currentItem.find('.ba-tag-cloud-options').val(options);
    addHistory();
});
jQ('.tag-cloud-css').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.tag-cloud-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-tag-cloud-options').val();
    options = options.split(';');
    jQ('.custom-suffix-tag-cloud').val(options[0]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-tag-cloud').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-tag-cloud-options').val(), jQ(this).val(), 0);
    currentItem.find('.ba-tag-cloud-options').val(options);
    addHistory();
});