<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

class bagridModelBagrid extends JModelItem
{
    public function getTable($type = 'Bagrids', $prefix = 'BagridTable', $config = array()) 
    {
        return JTable::getInstance($type, $prefix, $config);
    }

    public function setMapsKey($key)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->update('`#__bagrid_api`')
            ->set('`key` = '.$db->quote($key))
            ->where('`service` = '.$db->quote('google_maps'));
        $db->setQuery($query);
        $db->setQuery($query)
            ->execute();
    }
    
    public function save()
    {
        $this->setMapsKey($_POST['google_maps_apikey']);
        $id = $_POST['grid_id'];
        $content = $_POST['grid_content'];
        $content = stripcslashes($content);
        $theme = $_POST['page_theme'];
        $table = $this->getTable();
        $table->load($id);
        $table->bind(array('params' => $content, 'theme' => $theme));
        $this->saveGlobal($theme);
        if ($table->store()) {
            return true;
        } else {
            return false;
        }
    }
    
    public function getCategories()
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('id, title')
            ->from('#__bagrid_categories')
            ->where('`published` = 1');
        $db->setQuery($query);
        
        return $db->loadObjectList();
    }

    public function getMenus()
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('id, title')
            ->from('#__modules')
            ->where('client_id = 0')
            ->where('published = 1')
            ->where('module = '.$db->quote('mod_menu'));
        $db->setQuery($query);
        
        return $db->loadObjectList();
    }

    public function getPlugins()
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('*')
            ->from('#__bagrid_plugins');
        $db->setQuery($query);
        
        return $db->loadObjectList();
    }
    
    public function saveGlobal($theme)
    {
        if ($theme != 'empty') {
            $global = $_POST['global_style'];
            if (empty($global)) {
                $global = '{}';
            } else {
                $obj = json_decode($global);
                if (empty($obj)) {
                    $obj = json_decode(stripcslashes($global));
                }
                $obj->footer = stripcslashes($_POST['ba_footer']);
                $obj->header = stripcslashes($_POST['ba_header']);
                $global = json_encode($obj);
            }
            $db = $this->getDbo();
            $query = $db->getQuery(true);
            $fields = array(
                $db->quoteName('params') . ' = ' . $db->quote($global)
            );
            $conditions = array(
                $db->quoteName('id') . ' = ' .$db->quote($theme), 
                $db->quoteName('template') . ' = ' . $db->quote('gridboxcore')
            );
            $query->update($db->quoteName('#__template_styles'))
                ->set($fields)
                ->where($conditions);
            $db->setQuery($query)
                ->execute();
        }
    }
    
    public function getThemes()
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('id, title, params, home')
            ->from('#__template_styles')
            ->where('`template`=' .$db->quote('gridboxcore'));
        $db->setQuery($query);
        $themes = $db->loadObjectList();
        foreach ($themes as $key=> $theme) {
            if (empty($theme->params)) {
                $theme->params = "{}";
            }
            $params = json_decode($theme->params);
            if (!isset($params->image)) {
                $params->image = JUri::root().'components/com_bagrid/assets/images/default-theme.png';
            }
            unset($themes[$key]->params);
            $themes[$key]->image = $params->image;
        }
        
        return $themes;
    }
    
    public function getItem($id = null)
    {
        $input = JFactory::getApplication()->input;
        $db = $this->getDbo();
        $table = $this->getTable();
        $title = $input->get('ba-title');
        $id = 0;
        if (isset($_GET['id'])) {
            $id = $_GET['id'];
        }
        if (empty($id)) {
            $id = 0;
        } elseif (!is_numeric($id)) {
            if (strpos($id, '?') !== false) {
                $id = explode('?', $id);
                $id = $id[0];
            }
        }
        if (isset($title)) {
            $title = strip_tags($_POST['ba-title']);
            $theme = $_POST['page_theme'];
            jimport('joomla.filter.output');
            $alias = JFilterOutput::stringURLSafe($title);
            $date = JFactory::getDate();
            $nowDate = $date->toSql();
            $table->bind(array('title' => $title, 'page_alias' => $alias,
                               'theme' => $theme, 'created' => $nowDate));
            if (!$table->check()){
                $alias = $this->getNewAlias($alias);
                $table->page_alias = $alias;
            }
            $table->store();
            $id = $table->id;
        }
        $query = $db->getQuery(true);
        $query->select('*')
            ->from('`#__bagrid_bagrids`')
            ->where('`id`=' .$id*1);
        
        $db->setQuery($query);
        $this->_item = $db->loadObject();
        if (!$this->_item) {
            $this->_item = new stdClass();
        }
        if (isset($this->_item->theme)) {
            $this->_item->globalParams = $this->getGlobal();
        }
        return $this->_item;
    }

    protected function getNewAlias($alias)
    {
        $table = $this->getTable();
        while ($table->load(array('page_alias' => $alias)))
        {
            $alias = JString::increment($alias);
        }

        return $alias;
    }
    
    public function getGlobal()
    {
        $id = $this->_item->theme;
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('`params`')
            ->from('`#__template_styles`')
            ->where('`template` = ' .$db->quote('gridboxcore'))
            ->where('`id` = ' .$db->Quote($id));
        $db->setQuery($query);
        $items = $db->loadObject();
        if (!isset($items)) {
            $query = $db->getQuery(true);
            $query->select('id, params')
                ->from('`#__template_styles`')
                ->where('`template` = ' .$db->quote('gridboxcore'))
                ->where('`home` = ' .$db->Quote(1));
            $db->setQuery($query);
            $items = $db->loadObject();
            $table = $this->getTable();
            $table->load($this->_item->id);
            $table->bind(array('theme' => $items->id));
            $table->store();
            $this->_item->theme = $items->id;
        }
        
        return $items->params;
    }
    
    public function getForm()
    {
        $form = JForm::getInstance('bagrid', JPATH_COMPONENT.'/models/forms/bagrid.xml');
        
        return $form;
    }
    
    public function getModules()
    {
        $input = JFactory::getApplication()->input;
        $search = $input->get('filter_search');
        $position = $input->get('filter_position');
        $module = $input->get('filter_module');
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('title, position, module')
            ->from('`#__modules`')
            ->where('`published`=1')
            ->where('`client_id`=0');
        if ($search) {
            $search = $db->quote('%' . $db->escape($search, true) . '%', false);
            $query->where('`title` LIKE ' . $search);
        }
        if ($position) {
            $query->where('`position`=' .$db->quote($position));
        }
        if ($module) {
            $query->where('`module`=' .$db->quote($module));
        }
        $db->setQuery($query);
        $modules = $db->loadObjectList();
        
        return $modules;
    }
    
    public function getStates()
    {
        $input = JFactory::getApplication()->input;
        $search = $input->get('filter_search');
        $position = $input->get('filter_position');
        $module = $input->get('filter_module');
        $state = new stdClass;
        $state->search = $search;
        $state->position = $position;
        $state->type = $module;
        return $state;
    }
    
    public function getFilters()
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('position, module')
            ->from('`#__modules`')
            ->where('`published`=1')
            ->where('`client_id`=0');
        $db->setQuery($query);
        $filters = $db->loadObjectList();
        
        return $filters;
    }
    
    public function getCom_Ba()
    {
        $db = $this->getDbo();
        $results = array();
        $query = $db->getQuery(true);
        $query->select('enabled')
            ->from('`#__extensions`')
            ->where('`element`=' .$db->quote('com_bagallery'))
            ->where('`type`=' .$db->quote('component'));
        $db->setQuery($query);
        $results[0] = $db->loadResult();
        $query = $db->getQuery(true);
        $query->select('enabled')
            ->from('`#__extensions`')
            ->where('`element`=' .$db->quote('com_baforms'))
            ->where('`type`=' .$db->quote('component'));
        $db->setQuery($query);
        $results[1] = $db->loadResult();
        
        return $results;
    }
    
    public function getBaforms()
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('title, id')
            ->from('`#__baforms_forms`')
            ->where('`published`=1');
        $db->setQuery($query);
        $result = $db->loadObjectList();
        
        return $result;
    }
    
    public function getBagallery()
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('title, id')
            ->from('`#__bagallery_galleries`')
            ->where('`published`=1');
        $db->setQuery($query);
        $result = $db->loadObjectList();
        
        return $result;
    }
}
