<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

class bagridModelFonts extends JModelItem
{
    public function getTable($type = 'Fonts', $prefix = 'BagridTable', $config = array()) 
    {
        return JTable::getInstance($type, $prefix, $config);
    }
    
    public function getItem($id = null)
    {
        $input = JFactory::getApplication()->input;
        $search = $input->get('filter_search');
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('font, styles, id')
            ->from('`#__bagrid_fonts`')
            ->order($db->quoteName('font') . ' ASC');;
        $db->setQuery($query);
        $this->_item = $db->loadObjectList();
        
        return $this->_item;
    }
    
    public function delete()
    {
        $cid = JFactory::getApplication()->input->get('ba-items', array(), 'array');
        $db = JFactory::getDbo();
        foreach ($cid as $id) {
            $db->setQuery("DELETE FROM `#__bagrid_fonts` WHERE `id`=". $id);
            $db->execute();
        }
        
        return true;
    }
    
    public function addFont()
    {
        $input = JFactory::getApplication()->input;
        $font = $_POST['new_font'];
        $style = $input->get('font_style');
        if (empty($style)) {
            $style = 400;
        }
        $url = 'http://fonts.googleapis.com/css?family=';
        $font = trim($font);
        $font = str_replace(' ', '+', $font);
        $http = JHttpFactory::getHttp();
		$response = $http->get($url.$font. ":" .$style);
        if ($response->code != 400) {
            if ($this->checkFont($font, $style)) {
                $table = $this->getTable();
                $table->bind(array('font' => $font, 'styles' => $style));
                if ($table->store()) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    public function checkFont($font, $style)
    {
        $db = $this->getDbo();
        $query = $db->getQuery(true);
        $query->select('id')
            ->from('#__bagrid_fonts')
            ->where('`font` = ' .$db->Quote($font))
            ->where('`styles` = ' .$db->Quote($style));
        $db->setQuery($query);
        $id = $db->loadResult();
        if (empty($id)) {
            return true;
        } else {
            return false;
        }
    }
}
