<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

$positions = array();
$types = array();
$state = $this->state;
foreach ($this->filters as $filter) {
    if (!in_array($filter->position, $positions) && !empty($filter->position)) {
        $positions[] = $filter->position;
    }
    if (!in_array($filter->module, $types)) {
        $types[] = $filter->module;
    }
}
?>
<form method="post" action="<?php echo JUri::base(). "index.php?option=com_bagrid&layout=modules&tmpl=component" ?>">
            <div class="search-bar">
                <input type="text" id="filter_search" name="filter_search"
                       class="search-field" value="<?php echo $state->search; ?>"
                       placeholder="<?php echo JText::_('ENTER_MODULE_NAME'); ?>">
                <button type="submit" class="ba-btn ">
                    <i class="icon-search"></i>
                </button>
                <button type="button" class="ba-btn"
                        onclick="document.getElementById('filter_search').value='';this.form.submit()">
                    <i class="icon-remove"></i>
                </button>
                <div class="filter-position">
                    <select name="filter_position" onchange="this.form.submit()">
                        <option value="">Select Position</option>
                        <?php foreach ($positions as $position) { ?>
                            <option value="<?php echo $position; ?>"
                                    <?php if ($position == $state->position) { ?>
                                        selected
                                    <?php }?>
                                    ><?php echo $position; ?></option>
                        <?php } ?>
                    </select>
                </div>
                <div class="filter-type">
                    <select name="filter_module" onchange="this.form.submit()">
                        <option value="">Select Type</option>
                        <?php foreach ($types as $type) { ?>
                            <option value="<?php echo $type; ?>"
                                    <?php if ($type == $state->type) { ?>
                                        selected
                                    <?php }?>
                                    ><?php echo $type  == 'mod_custom' ? 'Custom HTML' : $type; ?></option>
                        <?php } ?>
                    </select>
                </div>
            </div>
        
    
    <div class="bagrid-table">
        <table class="bagrid-list">
            <tbody>
                <?php foreach($this->modules as $module) {?>
                <tr>
                    <th class="bagrid-title">
                        <a class="send-message"><?php echo $module->title; ?></a>
                    </th>
                    <td class="bagrid-type">
                        <?php echo $module->module == 'mod_custom' ? 'Custom HTML' : $module->module; ?>
                    </td>
                    <td class="bagrid-position">
                        <?php echo $module->position; ?>
                    </td>
                </tr>  
                <?php } ?>
            </tbody>
        </table>
    </div>
</form>