<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

class bagridViewbagrid extends JViewLegacy
{
    protected $item;
    protected $form;
    protected $modules;
    protected $filters;
    protected $state;
    protected $save;
    protected $components;
    protected $baforms;
    protected $bagallery;
    protected $plugins;
    protected $categories;
    protected $menus;
    protected $maps_key;
    
    public function display($tpl = null)
    {
        $app = JFactory::getApplication();
        $input = $app->input;
        if (!isset($_GET['id']) && $input->get('layout') != 'modules') {
            return JError::raiseError(404, JText::_('NOT_FOUND'));
        }
        $doc = JFactory::getDocument();
        $doc->setTitle('Gridbox Editor');
        $doc->addScript(JUri::root(true) . '/media/jui/js/jquery.min.js');
        $doc->addStyleSheet(JURI::root() . 'components/com_bagrid/assets/css/ba-style.css');
        header("Cache-Control: no-cache, must-revalidate");
        header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");
        if (isset($_POST['ba-username'])) {
            $name = $_POST['ba-username'];
            $pass = $_POST['ba-password'];
            if (!empty($name) && !empty($pass)) {
                $credentials = array('username' => $name,
                                     'password' => $pass);
                JFactory::getApplication()->login($credentials);
                $doc->addScriptDeclaration("
                    window.location.href = window.location.href;
                ");
            }
        }
        if (!JFactory::getUser()->authorise('core.edit', 'com_bagrid')) {
            $this->setLayout('login');
            parent::display($tpl);
            return;
        } else {
            $item = $this->get('Item');
            if (empty($item->title) && $input->get('layout') != 'modules') {
                $this->setLayout('title');
                parent::display($tpl);
                return;
            }
        }
        $this->item = $item;
        $this->plugins = $this->get('Plugins');
        $this->categories = $this->get('Categories');
        $this->save = $input->get('save');
        if (!empty($this->save)) {
            $loc = JUri::root(). 'index.php?option=com_bagrid&view=bagrid&id='.$item->id;
            $doc->addScriptDeclaration("
                    window.history.pushState(null, null, '$loc');
                ");
        }
        if ($input->get('layout') == 'modules') {
            $modules = $this->get('Modules');
            $filters = $this->get('Filters');
            $this->filters = $filters;
            $this->modules = $modules;
            $state = $this->get('States');
            $this->state = $state;
            $this->setLayout('modules');
            $doc->addScript(JURI::root() . 'components/com_bagrid/assets/js/ba-modules.js');
        } else {
            $this->item->params = bagridHelper::checkMOdules($this->item->params);
            $id = $input->get('id');
            if (empty($id)) {
                $doc->addScriptDeclaration("
                    window.location.href = window.location.href+$item->id;
                    window.history.pushState(null, null, location.href+$item->id);
                    window.parent.postMessage($item->id, '*')
                ");
            }
        }
        $this->components = $this->get('Com_Ba');
        if ($this->components[0]) {
            $this->bagallery = $this->get('Bagallery');
        }
        $this->maps_key = bagridHelper::getMapsKey();
        if ($this->components[1]) {
            $this->baforms = $this->get('Baforms');
        }
        $this->menus = $this->get('Menus');
        $this->form = $this->get('Form');
        if (!empty($this->item->intro_image)) {
            $doc->setMetaData('og:image:url', JUri::root().$this->item->intro_image);
        }
        
        parent::display($tpl);
    }
}