<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

class bagridViewPage extends JViewLegacy
{
    protected $item;
    
    public function display($tpl = null)
    {
        $input = JFactory::getApplication()->input;
        $id = $input->get('id');
        $application = JFactory::getApplication();
        if (empty($id)) {
            return JError::raiseError(404, JText::_('NOT_FOUND'));
        }
        $item = $this->get('Item');
        $this->item = $item;
        if (!empty($this->item)) {
            $flag = true;
            if (!empty($this->item->page_category)) {
                $flag = bagridHelper::checkCategory($this->item->page_category);
            }
            if ($flag) {
                $flag = $this->item->published * 1;
            }
        }
        if (empty($this->item) || $flag != 1) {
            return JError::raiseError(404, JText::_('NOT_FOUND'));
        }
        $this->get('Hits');
        $user = JFactory::getUser();
        $groups = $user->getAuthorisedViewLevels();
        $catAccess = $this->getCategoryAccess();
        if (!$catAccess && !in_array($this->item->page_access, $groups)) {
            JError::raiseWarning(403, JText::_('JERROR_ALERTNOAUTHOR'));
            return;
        }
        $this->item->params = bagridHelper::checkMOdules($this->item->params);
        $this->item->params = bagridHelper::getBlog($this->item->params);
        $this->prepareDocument();
        parent::display($tpl);
    }

    public function getCategoryAccess()
    {
        $id = $this->item->page_category;
        if (!empty($id)) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('access')
                ->from('#__bagrid_categories')
                ->where('`id` = '.$id);
            $db->setQuery($query);
            $access = $db->loadResult();
            $user = JFactory::getUser();
            $groups = $user->getAuthorisedViewLevels();
            $access = in_array($access, $groups);
            return $access;
        } else {
            return false;
        }
    }

    public function prepareDocument()
    {
        $doc = JFactory::getDocument();
        $doc->addScript(JUri::root(true) . '/media/jui/js/jquery.min.js');
        $doc->addScript(JUri::root(true) . '/media/jui/js/bootstrap.min.js');
        bagridHelper::checkMoreScripts($this->item->params);
        $app = JFactory::getApplication();
        $menus = $app->getMenu();
        $menu = $menus->getActive();
        $title  = $this->item->meta_title;
        $desc = $this->item->meta_description;
        $keywords = $this->item->meta_keywords;
        if (isset($menu)) {
            $params  = $menus->getParams($menu->id);
            $page_title = $params->get('page_title');
            $page_desc = $params->get('menu-meta_description');
            $page_key = $params->get('menu-meta_keywords');
        } else {
            $page_title = '';
            $page_desc = '';
            $page_key = '';
        }
        if (!empty($page_title)) {
            $title = $page_title;
        }
        if (!empty($page_desc)) {
            $desc = $page_desc;
        }
        if (!empty($page_key)) {
            $keywords = $page_key;
        }
        $doc->setTitle($title);
        $doc->setDescription($desc);
        $doc->setMetaData('keywords', $keywords);
        $doc->setMetaData('og:title', $title);
        $doc->setMetaData('og:description', $desc);
        $doc->setMetaData('og:url', $doc->getBase());
        $doc->setMetaData('og:type', 'website');
        $doc->setMetaData('og:image:url', JUri::root().$this->item->intro_image);
        if (!empty($this->item->intro_image)) {
            $img = JPATH_ROOT.'/'.$this->item->intro_image;
            $image = new JImage($img);
            $doc->setMetaData('og:image:width', $image->getWidth());
            $doc->setMetaData('og:image:height', $image->getHeight());
        }
    }
}