<?php
/**
* @package   Gridbox template
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

$app = JFactory::getApplication();
if ($app->input->get('option') == 'com_bagrid') {
    $bagridId = $app->input->get('id');
    $this->params = bagridHelper::checkParams($bagridId, $this->params);
}
$params = $this->params->get('params');

function checkLetter($obj)
{
    if (!isset($obj->letter) || empty($obj->letter)) {
        $obj->letter = 0;
    }

    return $obj->letter;
}

if (isset($params->typography)) {
    if (!isset($params->typography->footerh1)) {
        $params->typography->footerh1 = $params->typography->footerh;
        $params->typography->footerh2 = $params->typography->footerh;
        $params->typography->footerh3 = $params->typography->footerh;
        $params->typography->footerh4 = $params->typography->footerh;
        $params->typography->footerh5 = $params->typography->footerh;
        $params->typography->footerh6 = $params->typography->footerh;
    }
    $url = '';
    $array = array();
    foreach ($params->typography as $fonts) {
        if (isset($fonts->family)) {
            if (!in_array($fonts->family, $array)) {
                $url .= $fonts->family;
                $styles = '';
                foreach ($params->typography as $style) {
                    if (isset($style->family)) {
                        if ($style->family == $fonts->family) {
                            if (is_numeric($style->weight)) {
                                if (!in_array($fonts->family, $array)) {
                                    $styles .= ':'.$style->weight;
                                    $array[] = $fonts->family;
                                } else {
                                    if (!empty($styles)) {
                                        if (!strpos($styles, $style->weight)) {
                                            $styles .= ','.$style->weight;
                                        }
                                    } else {
                                        $styles .= ':'.$style->weight;
                                    }
                                }
                            } else {
                                if (!in_array($fonts->family, $array)) {
                                    $array[] = $fonts->family;
                                }
                            }
                        }
                    }
                }
                foreach ($params->typography->button->fontFamily as $key => $family) {
                    if ($key == $fonts->family) {
                        $property = explode(',', $family);
                        foreach ($property as $prop) {
                            if (!strpos($styles, $prop)) {
                                $styles .= ',' .$prop;
                            }
                        }
                        break;
                    }
                }
                $url .= $styles. '%7C';
                $styles = '';
            }
        }
    }
    foreach ($params->typography->button->fontFamily as $key => $family) {
        if (!in_array($key, $array)) {
            $url .= $key.':'.$family. '%7C';
            $array[] = $key;
        }
    }

    $pos = strripos($url, '%7C');
    $url = substr($url, 0, $pos);
    $url .= '&subset=latin,cyrillic,greek,latin-ext,greek-ext,vietnamese,cyrillic-ext';
?>
<link rel="stylesheet" href="//fonts.googleapis.com/css?family=<?php echo $url; ?>" type="text/css" id="google-fonts">
<?php } else { ?>
<link rel="stylesheet" type="text/css" href="//fonts.googleapis.com/css?family=Roboto:700,500,400" id="google-fonts">
<?php } ?>
<style type="text/css">
    <?php
if (isset($params->background)) {
    if (isset($params->background->type)) {
        if ($params->background->type == 'color') {
            ?>
        	body {
    	        background-color: <?php echo $params->background->color; ?>;
        	}
            <?php
        } else if ($params->background->type == 'image') { ?>
            body {
                background: transparent;
                background-image: url('<?php echo $params->background->image; ?>');
                background-position: center center;
                background-size: cover;
                background-repeat: no-repeat;
                background-attachment: <?php echo $params->background->atach; ?>;
            }
<?php   } 
    } else {
         ?>
            body {
                background: transparent;
            }
<?php 
    }
    ?>
<?php } else { ?>
    body {
        background:#ffffff;
    }
    <?php
       } ?>
    <?php
if (isset($params->padding)) { ?>
    body {
        padding-top: <?php echo $params->padding->top. 'px'; ?>;
        padding-right: <?php echo $params->padding->right. 'px'; ?>;
        padding-bottom: <?php echo $params->padding->bottom. 'px'; ?>;
        padding-left: <?php echo $params->padding->left. 'px'; ?>;
    }
    <?php } else { ?>
    body {
        padding-top: 0px;
        padding-right: 0px;
        padding-bottom: 0px;
        padding-left: 0px;
    }
    <?php } ?>
    <?php
if (isset($params->typography)) {
    if (isset($params->typography->p)) {
        if (!isset($params->typography->p->letter)) {
            $params->typography->p->letter = 0;
        }
    ?>
    p,
    li {
        text-align: <?php echo $params->typography->p->align; ?>;
        letter-spacing: <?php echo $params->typography->p->letter.'px'; ?>;
        font-size: <?php echo $params->typography->p->size. 'px'; ?>;
        line-height: <?php echo $params->typography->p->line. 'px'; ?>;
        color: <?php echo $params->typography->p->color; ?>;
        font-weight: <?php echo $params->typography->p->weight; ?>;
        text-transform: <?php echo $params->typography->p->transform; ?>;
        font-style: <?php echo $params->typography->p->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->p->family); ?>;
        text-decoration: <?php echo isset($params->typography->p->decoration) ? $params->typography->p->decoration : 'none'; ?>;
    }
    <?php
    }
    if (isset($params->typography->h1)) {
        if (!isset($params->typography->h1->letter)) {
            $params->typography->h1->letter = 0;
        }
    ?>
    h1 {
        text-align: <?php echo $params->typography->h1->align; ?>;
        letter-spacing: <?php echo $params->typography->h1->letter.'px'; ?>;
        font-size: <?php echo $params->typography->h1->size. 'px'; ?>;
        line-height: <?php echo $params->typography->h1->line. 'px'; ?>;
        color: <?php echo $params->typography->h1->color; ?>;
        font-weight: <?php echo $params->typography->h1->weight; ?>;
        text-transform: <?php echo $params->typography->h1->transform; ?>;
        font-style: <?php echo $params->typography->h1->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->h1->family); ?>;
        text-decoration: <?php echo isset($params->typography->h1->decoration) ? $params->typography->h1->decoration : 'none'; ?>;
    }
    <?php
    }
    if (isset($params->typography->h2)) {
        if (!isset($params->typography->h2->letter)) {
            $params->typography->h2->letter = 0;
        }
    ?>
    h2 {
        text-align: <?php echo $params->typography->h2->align; ?>;
        letter-spacing: <?php echo $params->typography->h2->letter.'px'; ?>;
        font-size: <?php echo $params->typography->h2->size. 'px'; ?>;
        line-height: <?php echo $params->typography->h2->line. 'px'; ?>;
        color: <?php echo $params->typography->h2->color; ?>;
        font-weight: <?php echo $params->typography->h2->weight; ?>;
        text-transform: <?php echo $params->typography->h2->transform; ?>;
        font-style: <?php echo $params->typography->h2->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->h2->family); ?>;
        text-decoration: <?php echo isset($params->typography->h2->decoration) ? $params->typography->h2->decoration : 'none'; ?>;
    }
    <?php
    }
    if (isset($params->typography->h3)) {
        if (!isset($params->typography->h3->letter)) {
            $params->typography->h3->letter = 0;
        }
    ?>
    h3 {
        text-align: <?php echo $params->typography->h3->align; ?>;
        letter-spacing: <?php echo $params->typography->h3->letter.'px'; ?>;
        font-size: <?php echo $params->typography->h3->size. 'px'; ?>;
        line-height: <?php echo $params->typography->h3->line. 'px'; ?>;
        color: <?php echo $params->typography->h3->color; ?>;
        font-weight: <?php echo $params->typography->h3->weight; ?>;
        text-transform: <?php echo $params->typography->h3->transform; ?>;
        font-style: <?php echo $params->typography->h3->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->h3->family); ?>;
        text-decoration: <?php echo isset($params->typography->h3->decoration) ? $params->typography->h3->decoration : 'none'; ?>;
    }
    <?php
    }
    if (isset($params->typography->h4)) {
        if (!isset($params->typography->h4->letter)) {
            $params->typography->h4->letter = 0;
        }
    ?>
    h4 {
        text-align: <?php echo $params->typography->h4->align; ?>;
        letter-spacing: <?php echo $params->typography->h4->letter.'px'; ?>;
        font-size: <?php echo $params->typography->h4->size. 'px'; ?>;
        line-height: <?php echo $params->typography->h4->line. 'px'; ?>;
        color: <?php echo $params->typography->h4->color; ?>;
        font-weight: <?php echo $params->typography->h4->weight; ?>;
        text-transform: <?php echo $params->typography->h4->transform; ?>;
        font-style: <?php echo $params->typography->h4->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->h4->family); ?>;
        text-decoration: <?php echo isset($params->typography->h4->decoration) ? $params->typography->h4->decoration : 'none'; ?>;
    }
    <?php
    }
    if (isset($params->typography->h5)) {
        if (!isset($params->typography->h5->letter)) {
            $params->typography->h5->letter = 0;
        }
    ?>
    h5 {
        text-align: <?php echo $params->typography->h5->align; ?>;
        letter-spacing: <?php echo $params->typography->h5->letter.'px'; ?>;
        font-size: <?php echo $params->typography->h5->size. 'px'; ?>;
        line-height: <?php echo $params->typography->h5->line. 'px'; ?>;
        color: <?php echo $params->typography->h5->color; ?>;
        font-weight: <?php echo $params->typography->h5->weight; ?>;
        text-transform: <?php echo $params->typography->h5->transform; ?>;
        font-style: <?php echo $params->typography->h5->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->h5->family); ?>;
        text-decoration: <?php echo isset($params->typography->h5->decoration) ? $params->typography->h5->decoration : 'none'; ?>;
    }
    <?php
    }
    if (isset($params->typography->h6)) {
        if (!isset($params->typography->h6->letter)) {
            $params->typography->h6->letter = 0;
        }
    ?>
    h6 {
        text-align: <?php echo $params->typography->h6->align; ?>;
        letter-spacing: <?php echo $params->typography->h6->letter.'px'; ?>;
        font-size: <?php echo $params->typography->h6->size. 'px'; ?>;
        line-height: <?php echo $params->typography->h6->line. 'px'; ?>;
        color: <?php echo $params->typography->h6->color; ?>;
        font-weight: <?php echo $params->typography->h6->weight; ?>;
        text-transform: <?php echo $params->typography->h6->transform; ?>;
        font-style: <?php echo $params->typography->h6->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->h6->family); ?>;
        text-decoration: <?php echo isset($params->typography->h6->decoration) ? $params->typography->h6->decoration : 'none'; ?>;
    }
    <?php
    }
    if (isset($params->typography->links)) { ?>
    body a {
        color: <?php echo $params->typography->links->color; ?>;
    }
    body a:hover {
        color: <?php echo $params->typography->links->hoverColor; ?>;
    }
    <?php
    }
} else { ?>
    p,
    li {
        text-align: left;
        letter-spacing: 0;
        font-size: 16px;
        line-height: 32px;
        color: #999999;
        font-weight: 300;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    h1 {
        text-align: center;
        letter-spacing: 0;
        font-size: 46px;
        line-height: 85px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    h2 {
        text-align: center;
        letter-spacing: 0;
        font-size: 38px;
        line-height: 80px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    h3 {
        text-align: left;
        letter-spacing: 0;
        font-size: 26px;
        line-height: 65px;
        color: rgb(10, 10, 10);
        font-weight: 700;
        text-transform: uppercase;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    h4 {
        text-align: left;
        letter-spacing: 0;
        font-size: 18px;
        line-height: 60px;
        color: rgb(10, 10, 10);
        font-weight: 700;
        text-transform: uppercase;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    h5 {
        text-align: left;
        letter-spacing: 0;
        font-size: 14px;
        line-height: 45px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    h6 {
        text-align: left;
        letter-spacing: 0;
        font-size: 12px;
        line-height: 25px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    body a {
        color: #429bff;
    }
    body a:hover {
        color: #3987DE;
    }
    <?php
       } ?>
    <?php if (isset($params->navigation)) {
        $navColor = $params->typography->nav->color;
        if (!isset($params->typography->nav->letter)) {
            $params->typography->nav->letter = 0;
        }
        if (!isset($params->typography->sub->letter)) {
            $params->typography->sub->letter = 0;
        }
     ?>
    .header .main-menu li a,
    .header .main-menu li span {
        letter-spacing: <?php echo $params->typography->nav->letter. 'px'; ?>;
        font-size: <?php echo $params->typography->nav->size. 'px'; ?>;
        line-height: <?php echo $params->typography->nav->line. 'px'; ?>;
        color: <?php echo $params->typography->nav->color; ?>;
        font-weight: <?php echo $params->typography->nav->weight; ?>;
        text-transform: <?php echo $params->typography->nav->transform; ?>;
        font-style: <?php echo $params->typography->nav->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->nav->family); ?>;
        text-decoration: <?php echo isset($params->typography->nav->decoration) ? $params->typography->nav->decoration : 'none'; ?>;
    }
    body .header .main-menu li a:hover {
        background-color: <?php echo $params->navigation->nav->hoverBg; ?>;
        color: <?php echo $params->navigation->nav->hoverColor; ?>;
    }
    .header .main-menu li.active > a {
        background-color: <?php echo $params->navigation->nav->activeBg; ?>;
        color: <?php echo $params->navigation->nav->activeColor; ?>;
    }
    .header .main-menu ul.nav-child {
        background-color: <?php echo $params->navigation->sub->bgColor; ?>;
        <?php if ($params->navigation->sub->borderTop) { ?>
        border-top: 1px solid <?php echo $params->navigation->sub->borderColor; } ?>;
        <?php if ($params->navigation->sub->borderRight) { ?>
        border-right: 1px solid <?php echo $params->navigation->sub->borderColor; } ?>;
        <?php if ($params->navigation->sub->borderBottom) { ?>
        border-bottom: 1px solid <?php echo $params->navigation->sub->borderColor; } ?>;
        <?php if ($params->navigation->sub->borderLeft) { ?>
        border-left: 1px solid <?php echo $params->navigation->sub->borderColor; } ?>;
    }
    .header .main-menu .nav-child li a,
    .header .main-menu .nav-child li span {
        text-align:<?php echo $params->typography->sub->align ?>;
        padding-top: <?php echo $params->navigation->sub->paddingTop ?>px;
        padding-right: <?php echo $params->navigation->sub->paddingRight ?>px;
        padding-bottom: <?php echo $params->navigation->sub->paddingBottom ?>px;
        padding-left: <?php echo $params->navigation->sub->paddingLeft ?>px;
        letter-spacing: <?php echo $params->typography->sub->letter. 'px'; ?>;
        font-size: <?php echo $params->typography->sub->size. 'px'; ?>;
        line-height: <?php echo $params->typography->sub->line. 'px'; ?>;
        color: <?php echo $params->typography->sub->color; ?>;
        font-weight: <?php echo $params->typography->sub->weight; ?>;
        text-transform: <?php echo $params->typography->sub->transform; ?>;
        font-style: <?php echo $params->typography->sub->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->sub->family); ?>;
        text-decoration: <?php echo isset($params->typography->sub->decoration) ? $params->typography->sub->decoration : 'none'; ?>;
    }
    body .header .nav-child li a:hover {
        background-color: <?php echo $params->navigation->sub->hoverBg; ?>;
        color: <?php echo $params->navigation->sub->hoverColor; ?>;
    }
    .header .nav-child li.active > a {
        background-color: <?php echo $params->navigation->sub->activeBg; ?>;
        color: <?php echo $params->navigation->sub->activeColor; ?>;
    }
    .header .main-menu .nav.menu {
        text-align: <?php echo $params->navigation->nav->align; ?>;
    }
    <?php } else {
        $navColor = '#333333';
     ?>
    .header .main-menu li a {
        font-size: 14px;
        letter-spacing: 0;
        line-height: 28px;
        color: #333333;
        font-weight: 500;
        text-transform: uppercase;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    body .header .main-menu li a:hover {
        background-color: #02adea;
        color: #ffffff;
    }
    .header .main-menu li.active > a {
        background-color: #02adea;
        color: #ffffff;
    }
    .header .main-menu ul.nav-child {
        background-color: #ffffff;
        border-top: 1px solid #f3f3f3;
        border-right: 1px solid #f3f3f3;
        border-bottom: 1px solid #f3f3f3;
        border-left: 1px solid #f3f3f3;
    }
    .header .main-menu .nav-child li a {
        text-align: left;
        padding-top: 15px;
        padding-right: 20px;
        padding-bottom: 15px;
        padding-left: 20px;
        letter-spacing: 0;
        font-size: 12px;
        line-height: 24px;
        color: #333333;
        font-weight: 500;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    body .header .main-menu .nav-child li a:hover {
        background-color: #02adea;
        color: #ffffff;
    }
    .header .nav-child .main-menu li.active > a {
        background-color: #02adea;
        color: #ffffff;
    }
    .header .main-menu .nav.menu {
        text-align: center;
    }
    <?php } ?>
    <?php if (isset($params->typography)) {
        if (!isset($params->typography->footerp->letter)) {
            $params->typography->footerp->letter = 0;
        }
        if (!isset($params->typography->footerh1->letter)) {
            $params->typography->footerh1->letter = 0;
        }
        if (!isset($params->typography->footerh2->letter)) {
            $params->typography->footerh2->letter = 0;
        }
        if (!isset($params->typography->footerh3->letter)) {
            $params->typography->footerh3->letter = 0;
        }
        if (!isset($params->typography->footerh4->letter)) {
            $params->typography->footerh4->letter = 0;
        }
        if (!isset($params->typography->footerh5->letter)) {
            $params->typography->footerh5->letter = 0;
        }
        if (!isset($params->typography->footerh6->letter)) {
            $params->typography->footerh6->letter = 0;
        }
    ?>
    footer.footer p,
    footer.footer a {
        text-align: <?php echo $params->typography->footerp->align ?>;
        letter-spacing: <?php echo $params->typography->footerp->letter ?>px;
        font-size: <?php echo $params->typography->footerp->size ?>px;
        line-height: <?php echo $params->typography->footerp->line ?>px;
        color: <?php echo $params->typography->footerp->color ?>;
        font-weight: <?php echo $params->typography->footerp->weight ?>;
        text-transform: <?php echo $params->typography->footerp->transform ?>;
        font-style: <?php echo $params->typography->footerp->style ?>;
        font-family: '<?php echo str_replace("+", " ", $params->typography->footerp->family) ?>';
        text-decoration: <?php echo isset($params->typography->footerp->decoration) ? $params->typography->footerp->decoration : 'none'; ?>;
    }
    footer.footer h1 {
        text-align: <?php echo $params->typography->footerh1->align ?>;
        letter-spacing: <?php echo $params->typography->footerh1->letter ?>px;
        font-size: <?php echo $params->typography->footerh1->size ?>px;
        line-height: <?php echo $params->typography->footerh1->line ?>px;
        color: <?php echo $params->typography->footerh1->color ?>;
        font-weight: <?php echo $params->typography->footerh1->weight ?>;
        text-transform: <?php echo $params->typography->footerh1->transform ?>;
        font-style: <?php echo $params->typography->footerh1->style ?>;
        font-family: '<?php echo str_replace("+", " ", $params->typography->footerh1->family) ?>';
        text-decoration: <?php echo isset($params->typography->footerh1->decoration) ? $params->typography->footerh1->decoration : 'none'; ?>;
    }
    footer.footer a {
        color: <?php echo $params->typography->footerLinks->color ?>;
    }
    footer.footer a:hover {
        color: <?php echo $params->typography->footerLinks->hoverColor ?>;
    }
    <?php } else { ?>
    footer.footer p,
    footer.footer a {
        text-align: left;
        letter-spacing: 0;
        font-size: 18px;
        line-height: 36px;
        color: #999999;
        font-weight: normal;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    footer.footer h1 {
        text-align: center;
        letter-spacing: 0;
        font-size: 46px;
        line-height: 52px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    footer.footer a {
        color: #429bff;
    }
    footer.footer a:hover {
        color: #3987DE;
    }
    <?php } ?>
    <?php if (isset($params->typography)) { ?>
    body {
        color: <?php echo $params->typography->p->color; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->p->family); ?>;
    }
    a {
        text-align: <?php echo $params->typography->p->align; ?>;
        color: <?php echo $params->typography->p->color; ?>;
        text-transform: <?php echo $params->typography->p->transform; ?>;
        font-style: <?php echo $params->typography->p->style; ?>;
        font-family: <?php echo str_replace('+', ' ', $params->typography->p->family); ?>;
    }
    footer.footer h2 {
        text-align: <?php echo $params->typography->footerh2->align ?>;
        letter-spacing: <?php echo $params->typography->footerh2->letter ?>px;
        font-size: <?php echo $params->typography->footerh2->size ?>px;
        line-height: <?php echo $params->typography->footerh2->line ?>px;
        color: <?php echo $params->typography->footerh2->color ?>;
        font-weight: <?php echo $params->typography->footerh2->weight ?>;
        text-transform: <?php echo $params->typography->footerh2->transform ?>;
        font-style: <?php echo $params->typography->footerh2->style ?>;
        font-family: '<?php echo str_replace("+", " ", $params->typography->footerh2->family) ?>';
        text-decoration: <?php echo isset($params->typography->footerh2->decoration) ? $params->typography->footerh2->decoration : 'none'; ?>;
    }
    footer.footer h3 {
        text-align: <?php echo $params->typography->footerh3->align ?>;
        letter-spacing: <?php echo $params->typography->footerh3->letter ?>px;
        font-size: <?php echo $params->typography->footerh3->size ?>px;
        line-height: <?php echo $params->typography->footerh3->line ?>px;
        color: <?php echo $params->typography->footerh3->color ?>;
        font-weight: <?php echo $params->typography->footerh3->weight ?>;
        text-transform: <?php echo $params->typography->footerh3->transform ?>;
        font-style: <?php echo $params->typography->footerh3->style ?>;
        font-family: '<?php echo str_replace("+", " ", $params->typography->footerh3->family) ?>';
        text-decoration: <?php echo isset($params->typography->footerh3->decoration) ? $params->typography->footerh3->decoration : 'none'; ?>;
    }
    footer.footer h4 {
        text-align: <?php echo $params->typography->footerh4->align ?>;
        letter-spacing: <?php echo $params->typography->footerh4->letter ?>px;
        font-size: <?php echo $params->typography->footerh4->size ?>px;
        line-height: <?php echo $params->typography->footerh4->line ?>px;
        color: <?php echo $params->typography->footerh4->color ?>;
        font-weight: <?php echo $params->typography->footerh4->weight ?>;
        text-transform: <?php echo $params->typography->footerh4->transform ?>;
        font-style: <?php echo $params->typography->footerh4->style ?>;
        font-family: '<?php echo str_replace("+", " ", $params->typography->footerh4->family) ?>';
        text-decoration: <?php echo isset($params->typography->footerh4->decoration) ? $params->typography->footerh4->decoration : 'none'; ?>;
    }
    footer.footer h5 {
        text-align: <?php echo $params->typography->footerh5->align ?>;
        letter-spacing: <?php echo $params->typography->footerh5->letter ?>px;
        font-size: <?php echo $params->typography->footerh5->size ?>px;
        line-height: <?php echo $params->typography->footerh5->line ?>px;
        color: <?php echo $params->typography->footerh5->color ?>;
        font-weight: <?php echo $params->typography->footerh5->weight ?>;
        text-transform: <?php echo $params->typography->footerh5->transform ?>;
        font-style: <?php echo $params->typography->footerh5->style ?>;
        font-family: '<?php echo str_replace("+", " ", $params->typography->footerh5->family) ?>';
        text-decoration: <?php echo isset($params->typography->footerh5->decoration) ? $params->typography->footerh5->decoration : 'none'; ?>;
    }
    footer.footer h6 {
        text-align: <?php echo $params->typography->footerh6->align ?>;
        letter-spacing: <?php echo $params->typography->footerh6->letter ?>px;
        font-size: <?php echo $params->typography->footerh6->size ?>px;
        line-height: <?php echo $params->typography->footerh6->line ?>px;
        color: <?php echo $params->typography->footerh6->color ?>;
        font-weight: <?php echo $params->typography->footerh6->weight ?>;
        text-transform: <?php echo $params->typography->footerh6->transform ?>;
        font-style: <?php echo $params->typography->footerh6->style ?>;
        font-family: '<?php echo str_replace("+", " ", $params->typography->footerh6->family) ?>';
        text-decoration: <?php echo isset($params->typography->footerh6->decoration) ? $params->typography->footerh6->decoration : 'none'; ?>;
    }
    <?php } else { ?>
    body {
        color: #999999;
        font-family: 'Roboto';
    }
    a {
        text-align: left;
        color: #999999;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
    }
    footer.footer h2 {
        text-align: center;
        letter-spacing: 0;
        font-size: 46px;
        line-height: 52px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    footer.footer h3 {
        text-align: center;
        letter-spacing: 0;
        font-size: 46px;
        line-height: 52px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    footer.footer h4 {
        text-align: center;
        letter-spacing: 0;
        font-size: 46px;
        line-height: 52px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    footer.footer h5 {
        text-align: center;
        letter-spacing: 0;
        font-size: 46px;
        line-height: 52px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    footer.footer h6 {
        text-align: center;
        letter-spacing: 0;
        font-size: 46px;
        line-height: 52px;
        color: rgb(10, 10, 10);
        font-weight: bold;
        text-transform: none;
        font-style: normal;
        font-family: 'Roboto';
        text-decoration: 'none';
    }
    <?php }
        if (!isset($params->tablet) || !isset($params->tablet->layout)) {
            $params->tablet = new stdClass();
            $params->tablet->layout = '#ffffff';
            $params->tablet->navFont = new stdClass();
            $params->tablet->navFont->size = '14';
            $params->tablet->navFont->line = '28';
            $params->tablet->navFont->color = '#1a1a1a';
            $params->tablet->subFont = new stdClass();
            $params->tablet->subFont->size = '14';
            $params->tablet->subFont->line = '14';
            $params->tablet->subFont->color = '#333333';
            $params->tablet->navActive = new stdClass();
            $params->tablet->navActive->bg = '#02adea';
            $params->tablet->navActive->color = '#ffffff';
            $params->tablet->bodyp = new stdClass();
            $params->tablet->bodyp->size = '16';
            $params->tablet->bodyp->line = '32';
            $params->tablet->bodyp->align = 'left';
            $params->tablet->bodyh1 = new stdClass();
            $params->tablet->bodyh1->size = '48';
            $params->tablet->bodyh1->line = '80';
            $params->tablet->bodyh1->align = 'center';
            $params->tablet->bodyh2 = new stdClass();
            $params->tablet->bodyh2->size = '36';
            $params->tablet->bodyh2->line = '60';
            $params->tablet->bodyh2->align = 'center';
            $params->tablet->bodyh3 = new stdClass();
            $params->tablet->bodyh3->size = '30';
            $params->tablet->bodyh3->line = '60';
            $params->tablet->bodyh3->align = 'center';
            $params->tablet->bodyh4 = new stdClass();
            $params->tablet->bodyh4->size = '24';
            $params->tablet->bodyh4->line = '48';
            $params->tablet->bodyh4->align = 'center';
            $params->tablet->bodyh5 = new stdClass();
            $params->tablet->bodyh5->size = '18';
            $params->tablet->bodyh5->line = '36';
            $params->tablet->bodyh5->align = 'center';
            $params->tablet->bodyh6 = new stdClass();
            $params->tablet->bodyh6->size = '14';
            $params->tablet->bodyh6->line = '28';
            $params->tablet->bodyh6->align = 'center';
            $params->tablet->footerp = new stdClass();
            $params->tablet->footerp->size = '16';
            $params->tablet->footerp->line = '32';
            $params->tablet->footerp->align = 'left';
            $params->tablet->footerh1 = new stdClass();
            $params->tablet->footerh1->size = '48';
            $params->tablet->footerh1->line = '80';
            $params->tablet->footerh1->align = 'center';
            $params->tablet->footerh2 = new stdClass();
            $params->tablet->footerh2->size = '36';
            $params->tablet->footerh2->line = '60';
            $params->tablet->footerh2->align = 'center';
            $params->tablet->footerh3 = new stdClass();
            $params->tablet->footerh3->size = '30';
            $params->tablet->footerh3->line = '60';
            $params->tablet->footerh3->align = 'center';
            $params->tablet->footerh4 = new stdClass();
            $params->tablet->footerh4->size = '24';
            $params->tablet->footerh4->line = '48';
            $params->tablet->footerh4->align = 'center';
            $params->tablet->footerh5 = new stdClass();
            $params->tablet->footerh5->size = '18';
            $params->tablet->footerh5->line = '36';
            $params->tablet->footerh5->align = 'center';
            $params->tablet->footerh6 = new stdClass();
            $params->tablet->footerh6->size = '14';
            $params->tablet->footerh6->line = '28';
            $params->tablet->footerh6->align = 'center';
        }
        if (!isset($params->mobile)) {
            $params->mobile = $params->tablet;
        }
        $tablet = $params->tablet;
        $mobile = $params->mobile;
    ?>
    @media (max-width: 768px) {
        .header .open-menu i {
            color : <?php echo $navColor; ?>;
        }
        .header .main-menu .close-menu i {
            color : <?php echo $tablet->navFont->color; ?>;
        }
        .header .main-menu {
            background-color: <?php echo $tablet->layout; ?> !important;
        }
        .header .main-menu li a,
        body .header .main-menu li a:hover {
            letter-spacing: <?php echo checkLetter($tablet->navFont); ?>px;
            font-size: <?php echo $tablet->navFont->size; ?>px;
            line-height: <?php echo $tablet->navFont->line; ?>px;
            color: <?php echo $tablet->navFont->color; ?>;
        }
        .header .main-menu .nav-child li a,
        body .header .main-menu .nav-child li a:hover {
            font-size: <?php echo $tablet->subFont->size; ?>px;
            letter-spacing: <?php echo checkLetter($tablet->subFont); ?>px;
            line-height: <?php echo $tablet->subFont->line; ?>px;
            color: <?php echo $tablet->subFont->color; ?>;
        }
        .header .main-menu li.active > a,
        .header .main-menu .nav-child li.active > a,
        body .header .main-menu li.active > a:hover,
        body .header .main-menu .nav-child li.active > a:hover {
            background-color: <?php echo $tablet->navActive->bg; ?> !important;
            color: <?php echo $tablet->navActive->color; ?> !important;
        }
        p,
        li {
            text-align: <?php echo $tablet->bodyp->align; ?>;
            letter-spacing: <?php echo checkLetter($tablet->bodyp); ?>px;
            font-size: <?php echo $tablet->bodyp->size; ?>px;
            line-height: <?php echo $tablet->bodyp->line; ?>px;
        }
        h1 {
            text-align: <?php echo $tablet->bodyh1->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->bodyh1); ?>px !important;
            font-size: <?php echo $tablet->bodyh1->size; ?>px !important;
            line-height: <?php echo $tablet->bodyh1->line; ?>px !important;
        }
        h2 {
            text-align: <?php echo $tablet->bodyh2->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->bodyh2); ?>px !important;
            font-size: <?php echo $tablet->bodyh2->size; ?>px !important;
            line-height: <?php echo $tablet->bodyh2->line; ?>px !important;
        }
        h3 {
            text-align: <?php echo $tablet->bodyh3->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->bodyh3); ?>px !important;
            font-size: <?php echo $tablet->bodyh3->size; ?>px !important;
            line-height: <?php echo $tablet->bodyh3->line; ?>px !important;
        }
        h4 {
            text-align: <?php echo $tablet->bodyh4->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->bodyh4); ?>px !important;
            font-size: <?php echo $tablet->bodyh4->size; ?>px !important;
            line-height: <?php echo $tablet->bodyh4->line; ?>px !important;
        }
        h5 {
            text-align: <?php echo $tablet->bodyh5->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->bodyh5); ?>px !important;
            font-size: <?php echo $tablet->bodyh5->size; ?>px !important;
            line-height: <?php echo $tablet->bodyh5->line; ?>px !important;
        }
        h6 {
            text-align: <?php echo $tablet->bodyh6->align; ?> !important;
            font-size: <?php echo $tablet->bodyh6->size; ?>px !important;
            letter-spacing: <?php echo checkLetter($tablet->bodyh6); ?>px !important;
            line-height: <?php echo $tablet->bodyh6->line; ?>px !important;
        }
        footer.footer p,
        footer.footer a {
            text-align: <?php echo $tablet->footerp->align; ?>;
            letter-spacing: <?php echo checkLetter($tablet->footerp); ?>px;
            font-size: <?php echo $tablet->footerp->size; ?>px;
            line-height: <?php echo $tablet->footerp->line; ?>px;
        }
        footer.footer h1 {
            text-align: <?php echo $tablet->footerh1->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->footerh1); ?>px !important;
            font-size: <?php echo $tablet->footerh1->size; ?>px !important;
            line-height: <?php echo $tablet->footerh1->line; ?>px !important;
        }
        footer.footer h2 {
            text-align: <?php echo $tablet->footerh2->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->footerh2); ?>px !important;
            font-size: <?php echo $tablet->footerh2->size; ?>px !important;
            line-height: <?php echo $tablet->footerh2->line; ?>px !important;
        }
        footer.footer h3 {
            text-align: <?php echo $tablet->footerh3->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->footerh3); ?>px !important;
            font-size: <?php echo $tablet->footerh3->size; ?>px !important;
            line-height: <?php echo $tablet->footerh3->line; ?>px !important;
        }
        footer.footer h4 {
            text-align: <?php echo $tablet->footerh4->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->footerh4); ?>px !important;
            font-size: <?php echo $tablet->footerh4->size; ?>px !important;
            line-height: <?php echo $tablet->footerh4->line; ?>px !important;
        }
        footer.footer h5 {
            text-align: <?php echo $tablet->footerh5->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->footerh5); ?>px !important;
            font-size: <?php echo $tablet->footerh5->size; ?>px !important;
            line-height: <?php echo $tablet->footerh5->line; ?>px !important;
        }
        footer.footer h6 {
            text-align: <?php echo $tablet->footerh6->align; ?> !important;
            letter-spacing: <?php echo checkLetter($tablet->footerh6); ?>px !important;
            font-size: <?php echo $tablet->footerh6->size; ?>px !important;
            line-height: <?php echo $tablet->footerh6->line; ?>px !important;
        }
    }
    @media (max-width: 480px) {
        .header .open-menu i {
            color : <?php echo $navColor; ?>;
        }
        .header .main-menu .close-menu i {
            color : <?php echo $tablet->navFont->color; ?>;
        }
        .header .main-menu {
            background-color: <?php echo $tablet->layout; ?> !important;
        }
        .header .main-menu li a,
        .header .main-menu li a:hover,
        .header .main-menu li span{
            font-size: <?php echo $tablet->navFont->size; ?>px;
            letter-spacing: <?php echo checkLetter($tablet->navFont); ?>px;
            line-height: <?php echo $tablet->navFont->line; ?>px;
            color: <?php echo $tablet->navFont->color; ?>;
        }
        .header .main-menu .nav-child li a,
        .header .main-menu .nav-child li a:hover,
        .header .main-menu .nav-child li span {
            font-size: <?php echo $tablet->subFont->size; ?>px;
            letter-spacing: <?php echo checkLetter($tablet->subFont); ?>px;
            line-height: <?php echo $tablet->subFont->line; ?>px;
            color: <?php echo $tablet->subFont->color; ?>;
        }
        .header .main-menu li.active > a,
        .header .main-menu .nav-child li.active > a,
        .header .main-menu li.active > a:hover,
        .header .main-menu .nav-child li.active > a:hover {
            background-color: <?php echo $tablet->navActive->bg; ?> !important;
            color: <?php echo $tablet->navActive->color; ?> !important;
        }
        p,
        li {
            text-align: <?php echo $mobile->bodyp->align; ?>;
            letter-spacing: <?php echo checkLetter($mobile->bodyp); ?>px;
            font-size: <?php echo $mobile->bodyp->size; ?>px;
            line-height: <?php echo $mobile->bodyp->line; ?>px;
        }
        h1 {
            text-align: <?php echo $mobile->bodyh1->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->bodyh1); ?>px !important;
            font-size: <?php echo $mobile->bodyh1->size; ?>px !important;
            line-height: <?php echo $mobile->bodyh1->line; ?>px !important;
        }
        h2 {
            text-align: <?php echo $mobile->bodyh2->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->bodyh2); ?>px !important;
            font-size: <?php echo $mobile->bodyh2->size; ?>px !important;
            line-height: <?php echo $mobile->bodyh2->line; ?>px !important;
        }
        h3 {
            text-align: <?php echo $mobile->bodyh3->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->bodyh3); ?>px !important;
            font-size: <?php echo $mobile->bodyh3->size; ?>px !important;
            line-height: <?php echo $mobile->bodyh3->line; ?>px !important;
        }
        h4 {
            text-align: <?php echo $mobile->bodyh4->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->bodyh4); ?>px !important;
            font-size: <?php echo $mobile->bodyh4->size; ?>px !important;
            line-height: <?php echo $mobile->bodyh4->line; ?>px !important;
        }
        h5 {
            text-align: <?php echo $mobile->bodyh5->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->bodyh5); ?>px !important;
            font-size: <?php echo $mobile->bodyh5->size; ?>px !important;
            line-height: <?php echo $mobile->bodyh5->line; ?>px !important;
        }
        h6 {
            text-align: <?php echo $mobile->bodyh6->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->bodyh6); ?>px !important;
            font-size: <?php echo $mobile->bodyh6->size; ?>px !important;
            line-height: <?php echo $mobile->bodyh6->line; ?>px !important;
        }
        footer.footer p,
        footer.footer a {
            text-align: <?php echo $mobile->footerp->align; ?>;
            letter-spacing: <?php echo checkLetter($mobile->footerp); ?>px;
            font-size: <?php echo $mobile->footerp->size; ?>px;
            line-height: <?php echo $mobile->footerp->line; ?>px;
        }
        footer.footer h1 {
            text-align: <?php echo $mobile->footerh1->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->footerh1); ?>px !important;
            font-size: <?php echo $mobile->footerh1->size; ?>px !important;
            line-height: <?php echo $mobile->footerh1->line; ?>px !important;
        }
        footer.footer h2 {
            text-align: <?php echo $mobile->footerh2->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->footerh2); ?>px !important;
            font-size: <?php echo $mobile->footerh2->size; ?>px !important;
            line-height: <?php echo $mobile->footerh2->line; ?>px !important;
        }
        footer.footer h3 {
            text-align: <?php echo $mobile->footerh3->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->footerh3); ?>px !important;
            font-size: <?php echo $mobile->footerh3->size; ?>px !important;
            line-height: <?php echo $mobile->footerh3->line; ?>px !important;
        }
        footer.footer h4 {
            text-align: <?php echo $mobile->footerh4->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->footerh4); ?>px !important;
            font-size: <?php echo $mobile->footerh4->size; ?>px !important;
            line-height: <?php echo $mobile->footerh4->line; ?>px !important;
        }
        footer.footer h5 {
            text-align: <?php echo $mobile->footerh5->align; ?> !important;
            letter-spacing: <?php echo checkLetter($mobile->footerh5); ?>px !important;
            font-size: <?php echo $mobile->footerh5->size; ?>px !important;
            line-height: <?php echo $mobile->footerh5->line; ?>px !important;
        }
        footer.footer h6 {
            text-align: <?php echo $mobile->footerh6->align; ?> !important;
            font-size: <?php echo $mobile->footerh6->size; ?>px !important;
            letter-spacing: <?php echo checkLetter($mobile->footerh6); ?>px !important;
            line-height: <?php echo $mobile->footerh6->line; ?>px !important;
        }
    }
</style>
<style type="text/css">
    <?php if (isset($params->custom)) {
        if (isset($params->custom->css))
            echo $params->custom->css;
    } ?>
</style>